/// <reference types="node" />
import http = require('http');
import { AwsCredentialsConfig } from '../model/awsCredentialsConfig';
import { AwsIamToken } from '../model/awsIamToken';
import { EntityShortRepresentation } from '../model/entityShortRepresentation';
import { Authentication, Interceptor } from '../model/models';
import { ApiKeyAuth } from '../model/models';
export declare enum AWSCredentialsConfigurationApiApiKeys {
    Api = 0
}
export declare class AWSCredentialsConfigurationApi {
    protected _basePath: string;
    protected _defaultHeaders: any;
    protected _useQuerystring: boolean;
    protected authentications: {
        'default': Authentication;
        'Api-Token': ApiKeyAuth;
    };
    protected interceptors: Interceptor[];
    constructor(basePath?: string);
    useQuerystring: boolean;
    basePath: string;
    defaultHeaders: any;
    setDefaultAuthentication(auth: Authentication): void;
    setApiKey(key: AWSCredentialsConfigurationApiApiKeys, value: string): void;
    addInterceptor(interceptor: Interceptor): void;
    createAwsCredentialsConfig(awsCredentialsConfig?: AwsCredentialsConfig, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: EntityShortRepresentation;
    }>;
    createOrUpdateAwsCredentialsConfig(id: string, awsCredentialsConfig?: AwsCredentialsConfig, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: EntityShortRepresentation;
    }>;
    deleteAwsCredentialsConfig(id: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    listAwsCredentials(options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: Array<EntityShortRepresentation>;
    }>;
    readAwsCredentialsConfig(id: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: AwsCredentialsConfig;
    }>;
    readIamExternalIdToken(options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: AwsIamToken;
    }>;
    validateAwsCredentialsConfig(id: string, awsCredentialsConfig?: AwsCredentialsConfig, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    validateAwsCredentialsConfig1(awsCredentialsConfig?: AwsCredentialsConfig, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
}
