/// <reference types="node" />
import http = require('http');
import { AlertingProfile } from '../model/alertingProfile';
import { EntityShortRepresentation } from '../model/entityShortRepresentation';
import { StubList } from '../model/stubList';
import { Authentication, Interceptor } from '../model/models';
import { ApiKeyAuth } from '../model/models';
export declare enum AlertingProfilesApiApiKeys {
    Api = 0
}
export declare class AlertingProfilesApi {
    protected _basePath: string;
    protected _defaultHeaders: any;
    protected _useQuerystring: boolean;
    protected authentications: {
        'default': Authentication;
        'Api-Token': ApiKeyAuth;
    };
    protected interceptors: Interceptor[];
    constructor(basePath?: string);
    useQuerystring: boolean;
    basePath: string;
    defaultHeaders: any;
    setDefaultAuthentication(auth: Authentication): void;
    setApiKey(key: AlertingProfilesApiApiKeys, value: string): void;
    addInterceptor(interceptor: Interceptor): void;
    createAlertingProfile(alertingProfile?: AlertingProfile, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: EntityShortRepresentation;
    }>;
    createOrUpdateAlertingProfile(id: string, alertingProfile?: AlertingProfile, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: EntityShortRepresentation;
    }>;
    deleteAlertingProfile(id: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    getAlertingProfile(id: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: AlertingProfile;
    }>;
    getAlertingProfiles(options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: StubList;
    }>;
    validateCreateAlertingProfile(alertingProfile?: AlertingProfile, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    validateCreateOrUpdateAlertingProfile(id: string, alertingProfile?: AlertingProfile, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
}
