/// <reference types="node" />
import http = require('http');
import { AwsAnomalyDetectionConfig } from '../model/awsAnomalyDetectionConfig';
import { Authentication, Interceptor } from '../model/models';
import { ApiKeyAuth } from '../model/models';
export declare enum AnomalyDetectionAWSApiApiKeys {
    Api = 0
}
export declare class AnomalyDetectionAWSApi {
    protected _basePath: string;
    protected _defaultHeaders: any;
    protected _useQuerystring: boolean;
    protected authentications: {
        'default': Authentication;
        'Api-Token': ApiKeyAuth;
    };
    protected interceptors: Interceptor[];
    constructor(basePath?: string);
    useQuerystring: boolean;
    basePath: string;
    defaultHeaders: any;
    setDefaultAuthentication(auth: Authentication): void;
    setApiKey(key: AnomalyDetectionAWSApiApiKeys, value: string): void;
    addInterceptor(interceptor: Interceptor): void;
    getAwsAnomalyDetectionConfig(options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: AwsAnomalyDetectionConfig;
    }>;
    updateAwsAnomalyDetectionConfig(awsAnomalyDetectionConfig?: AwsAnomalyDetectionConfig, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    validateAwsAnomalyDetectionConfig(awsAnomalyDetectionConfig?: AwsAnomalyDetectionConfig, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
}
