/// <reference types="node" />
import http = require('http');
import { ApplicationAnomalyDetectionConfig } from '../model/applicationAnomalyDetectionConfig';
import { Authentication, Interceptor } from '../model/models';
import { ApiKeyAuth } from '../model/models';
export declare enum AnomalyDetectionApplicationsApiApiKeys {
    Api = 0
}
export declare class AnomalyDetectionApplicationsApi {
    protected _basePath: string;
    protected _defaultHeaders: any;
    protected _useQuerystring: boolean;
    protected authentications: {
        'default': Authentication;
        'Api-Token': ApiKeyAuth;
    };
    protected interceptors: Interceptor[];
    constructor(basePath?: string);
    useQuerystring: boolean;
    basePath: string;
    defaultHeaders: any;
    setDefaultAuthentication(auth: Authentication): void;
    setApiKey(key: AnomalyDetectionApplicationsApiApiKeys, value: string): void;
    addInterceptor(interceptor: Interceptor): void;
    getConfiguration(options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: ApplicationAnomalyDetectionConfig;
    }>;
    updateConfiguration(applicationAnomalyDetectionConfig?: ApplicationAnomalyDetectionConfig, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    validateConfiguration(applicationAnomalyDetectionConfig?: ApplicationAnomalyDetectionConfig, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
}
