/// <reference types="node" />
import http = require('http');
import { DatabaseAnomalyDetectionConfig } from '../model/databaseAnomalyDetectionConfig';
import { Authentication, Interceptor } from '../model/models';
import { ApiKeyAuth } from '../model/models';
export declare enum AnomalyDetectionDatabaseServicesApiApiKeys {
    Api = 0
}
export declare class AnomalyDetectionDatabaseServicesApi {
    protected _basePath: string;
    protected _defaultHeaders: any;
    protected _useQuerystring: boolean;
    protected authentications: {
        'default': Authentication;
        'Api-Token': ApiKeyAuth;
    };
    protected interceptors: Interceptor[];
    constructor(basePath?: string);
    useQuerystring: boolean;
    basePath: string;
    defaultHeaders: any;
    setDefaultAuthentication(auth: Authentication): void;
    setApiKey(key: AnomalyDetectionDatabaseServicesApiApiKeys, value: string): void;
    addInterceptor(interceptor: Interceptor): void;
    getConfiguration1(options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: DatabaseAnomalyDetectionConfig;
    }>;
    updateConfiguration1(databaseAnomalyDetectionConfig?: DatabaseAnomalyDetectionConfig, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    validateConfiguration1(databaseAnomalyDetectionConfig?: DatabaseAnomalyDetectionConfig, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
}
