/// <reference types="node" />
import http = require('http');
import { DiskEventAnomalyDetectionConfig } from '../model/diskEventAnomalyDetectionConfig';
import { EntityShortRepresentation } from '../model/entityShortRepresentation';
import { StubList } from '../model/stubList';
import { Authentication, Interceptor } from '../model/models';
import { ApiKeyAuth } from '../model/models';
export declare enum AnomalyDetectionDiskEventsApiApiKeys {
    Api = 0
}
export declare class AnomalyDetectionDiskEventsApi {
    protected _basePath: string;
    protected _defaultHeaders: any;
    protected _useQuerystring: boolean;
    protected authentications: {
        'default': Authentication;
        'Api-Token': ApiKeyAuth;
    };
    protected interceptors: Interceptor[];
    constructor(basePath?: string);
    useQuerystring: boolean;
    basePath: string;
    defaultHeaders: any;
    setDefaultAuthentication(auth: Authentication): void;
    setApiKey(key: AnomalyDetectionDiskEventsApiApiKeys, value: string): void;
    addInterceptor(interceptor: Interceptor): void;
    createDiskEventConfig(diskEventAnomalyDetectionConfig?: DiskEventAnomalyDetectionConfig, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: EntityShortRepresentation;
    }>;
    deleteDiskEventConfig(id: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    getDiskEventConfig(id: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: DiskEventAnomalyDetectionConfig;
    }>;
    listDiskEventConfigs(options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: StubList;
    }>;
    updateOrCreateDiskEventConfig(id: string, diskEventAnomalyDetectionConfig?: DiskEventAnomalyDetectionConfig, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: EntityShortRepresentation;
    }>;
    validateDiskEventConfig(diskEventAnomalyDetectionConfig?: DiskEventAnomalyDetectionConfig, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    validateDiskEventConfig1(id: string, diskEventAnomalyDetectionConfig?: DiskEventAnomalyDetectionConfig, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
}
