/// <reference types="node" />
import http = require('http');
import { HostsAnomalyDetectionConfig } from '../model/hostsAnomalyDetectionConfig';
import { Authentication, Interceptor } from '../model/models';
import { ApiKeyAuth } from '../model/models';
export declare enum AnomalyDetectionHostsApiApiKeys {
    Api = 0
}
export declare class AnomalyDetectionHostsApi {
    protected _basePath: string;
    protected _defaultHeaders: any;
    protected _useQuerystring: boolean;
    protected authentications: {
        'default': Authentication;
        'Api-Token': ApiKeyAuth;
    };
    protected interceptors: Interceptor[];
    constructor(basePath?: string);
    useQuerystring: boolean;
    basePath: string;
    defaultHeaders: any;
    setDefaultAuthentication(auth: Authentication): void;
    setApiKey(key: AnomalyDetectionHostsApiApiKeys, value: string): void;
    addInterceptor(interceptor: Interceptor): void;
    getHostEventsConfig(options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: HostsAnomalyDetectionConfig;
    }>;
    updateHostEventsConfig(hostsAnomalyDetectionConfig?: HostsAnomalyDetectionConfig, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    validateHostEventsConfig(hostsAnomalyDetectionConfig?: HostsAnomalyDetectionConfig, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
}
