/// <reference types="node" />
import http = require('http');
import { AnomalyDetectionPG } from '../model/anomalyDetectionPG';
import { Authentication, Interceptor } from '../model/models';
import { ApiKeyAuth } from '../model/models';
export declare enum AnomalyDetectionProcessGroupsApiApiKeys {
    Api = 0
}
export declare class AnomalyDetectionProcessGroupsApi {
    protected _basePath: string;
    protected _defaultHeaders: any;
    protected _useQuerystring: boolean;
    protected authentications: {
        'default': Authentication;
        'Api-Token': ApiKeyAuth;
    };
    protected interceptors: Interceptor[];
    constructor(basePath?: string);
    useQuerystring: boolean;
    basePath: string;
    defaultHeaders: any;
    setDefaultAuthentication(auth: Authentication): void;
    setApiKey(key: AnomalyDetectionProcessGroupsApiApiKeys, value: string): void;
    addInterceptor(interceptor: Interceptor): void;
    deleteLocalAvailabilityConfig(id: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    getLocalAvailabilityConfig(id: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: AnomalyDetectionPG;
    }>;
    setLocalAvailabilityConfig(id: string, anomalyDetectionPG?: AnomalyDetectionPG, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    validateLocalPgAvailabilityAlertingEvent(id: string, anomalyDetectionPG?: AnomalyDetectionPG, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
}
