/// <reference types="node" />
import http = require('http');
import { ServiceAnomalyDetectionConfig } from '../model/serviceAnomalyDetectionConfig';
import { Authentication, Interceptor } from '../model/models';
import { ApiKeyAuth } from '../model/models';
export declare enum AnomalyDetectionServicesApiApiKeys {
    Api = 0
}
export declare class AnomalyDetectionServicesApi {
    protected _basePath: string;
    protected _defaultHeaders: any;
    protected _useQuerystring: boolean;
    protected authentications: {
        'default': Authentication;
        'Api-Token': ApiKeyAuth;
    };
    protected interceptors: Interceptor[];
    constructor(basePath?: string);
    useQuerystring: boolean;
    basePath: string;
    defaultHeaders: any;
    setDefaultAuthentication(auth: Authentication): void;
    setApiKey(key: AnomalyDetectionServicesApiApiKeys, value: string): void;
    addInterceptor(interceptor: Interceptor): void;
    getConfiguration2(options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: ServiceAnomalyDetectionConfig;
    }>;
    updateConfiguration2(serviceAnomalyDetectionConfig?: ServiceAnomalyDetectionConfig, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    validateConfiguration2(serviceAnomalyDetectionConfig?: ServiceAnomalyDetectionConfig, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
}
