/// <reference types="node" />
import http = require('http');
import { VMwareAnomalyDetectionConfig } from '../model/vMwareAnomalyDetectionConfig';
import { Authentication, Interceptor } from '../model/models';
import { ApiKeyAuth } from '../model/models';
export declare enum AnomalyDetectionVMwareApiApiKeys {
    Api = 0
}
export declare class AnomalyDetectionVMwareApi {
    protected _basePath: string;
    protected _defaultHeaders: any;
    protected _useQuerystring: boolean;
    protected authentications: {
        'default': Authentication;
        'Api-Token': ApiKeyAuth;
    };
    protected interceptors: Interceptor[];
    constructor(basePath?: string);
    useQuerystring: boolean;
    basePath: string;
    defaultHeaders: any;
    setDefaultAuthentication(auth: Authentication): void;
    setApiKey(key: AnomalyDetectionVMwareApiApiKeys, value: string): void;
    addInterceptor(interceptor: Interceptor): void;
    getVMwareAnomalyDetectionConfig(options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: VMwareAnomalyDetectionConfig;
    }>;
    updateVMwareAnomalyDetectionConfig(vMwareAnomalyDetectionConfig?: VMwareAnomalyDetectionConfig, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    validateVMwareAnomalyDetectionConfig(vMwareAnomalyDetectionConfig?: VMwareAnomalyDetectionConfig, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
}
