/// <reference types="node" />
export * from './aWSCredentialsConfigurationApi';
import { AWSCredentialsConfigurationApi } from './aWSCredentialsConfigurationApi';
export * from './alertingProfilesApi';
import { AlertingProfilesApi } from './alertingProfilesApi';
export * from './anomalyDetectionAWSApi';
import { AnomalyDetectionAWSApi } from './anomalyDetectionAWSApi';
export * from './anomalyDetectionApplicationsApi';
import { AnomalyDetectionApplicationsApi } from './anomalyDetectionApplicationsApi';
export * from './anomalyDetectionDatabaseServicesApi';
import { AnomalyDetectionDatabaseServicesApi } from './anomalyDetectionDatabaseServicesApi';
export * from './anomalyDetectionDiskEventsApi';
import { AnomalyDetectionDiskEventsApi } from './anomalyDetectionDiskEventsApi';
export * from './anomalyDetectionHostsApi';
import { AnomalyDetectionHostsApi } from './anomalyDetectionHostsApi';
export * from './anomalyDetectionMetricEventsApi';
import { AnomalyDetectionMetricEventsApi } from './anomalyDetectionMetricEventsApi';
export * from './anomalyDetectionProcessGroupsApi';
import { AnomalyDetectionProcessGroupsApi } from './anomalyDetectionProcessGroupsApi';
export * from './anomalyDetectionServicesApi';
import { AnomalyDetectionServicesApi } from './anomalyDetectionServicesApi';
export * from './anomalyDetectionVMwareApi';
import { AnomalyDetectionVMwareApi } from './anomalyDetectionVMwareApi';
export * from './applicationDetectionRulesApi';
import { ApplicationDetectionRulesApi } from './applicationDetectionRulesApi';
export * from './automaticallyAppliedTagsApi';
import { AutomaticallyAppliedTagsApi } from './automaticallyAppliedTagsApi';
export * from './azureCredentialsConfigurationApi';
import { AzureCredentialsConfigurationApi } from './azureCredentialsConfigurationApi';
export * from './calculatedMetricsLogMonitoringApi';
import { CalculatedMetricsLogMonitoringApi } from './calculatedMetricsLogMonitoringApi';
export * from './calculatedMetricsMobileCustomApplicationsApi';
import { CalculatedMetricsMobileCustomApplicationsApi } from './calculatedMetricsMobileCustomApplicationsApi';
export * from './calculatedMetricsServicesApi';
import { CalculatedMetricsServicesApi } from './calculatedMetricsServicesApi';
export * from './calculatedMetricsSyntheticApi';
import { CalculatedMetricsSyntheticApi } from './calculatedMetricsSyntheticApi';
export * from './calculatedMetricsWebApplicationsApi';
import { CalculatedMetricsWebApplicationsApi } from './calculatedMetricsWebApplicationsApi';
export * from './cloudFoundryCredentialsConfigurationApi';
import { CloudFoundryCredentialsConfigurationApi } from './cloudFoundryCredentialsConfigurationApi';
export * from './conditionalNamingApi';
import { ConditionalNamingApi } from './conditionalNamingApi';
export * from './credentialVaultApi';
import { CredentialVaultApi } from './credentialVaultApi';
export * from './dashboardsApi';
import { DashboardsApi } from './dashboardsApi';
export * from './dataPrivacyAndSecurityApi';
import { DataPrivacyAndSecurityApi } from './dataPrivacyAndSecurityApi';
export * from './extensionsApi';
import { ExtensionsApi } from './extensionsApi';
export * from './frequentIssueDetectionApi';
import { FrequentIssueDetectionApi } from './frequentIssueDetectionApi';
export * from './kubernetesCredentialsConfigurationApi';
import { KubernetesCredentialsConfigurationApi } from './kubernetesCredentialsConfigurationApi';
export * from './maintenanceWindowsApi';
import { MaintenanceWindowsApi } from './maintenanceWindowsApi';
export * from './managementZonesApi';
import { ManagementZonesApi } from './managementZonesApi';
export * from './mobileDeobfuscationAndSymbolicationApi';
import { MobileDeobfuscationAndSymbolicationApi } from './mobileDeobfuscationAndSymbolicationApi';
export * from './notificationsApi';
import { NotificationsApi } from './notificationsApi';
export * from './pluginsApi';
import { PluginsApi } from './pluginsApi';
export * from './remoteEnvironmentsApi';
import { RemoteEnvironmentsApi } from './remoteEnvironmentsApi';
export * from './reportsApi';
import { ReportsApi } from './reportsApi';
export * from './serviceCustomServicesApi';
import { ServiceCustomServicesApi } from './serviceCustomServicesApi';
export * from './serviceDetectionFullWebRequestApi';
import { ServiceDetectionFullWebRequestApi } from './serviceDetectionFullWebRequestApi';
export * from './serviceDetectionFullWebServiceApi';
import { ServiceDetectionFullWebServiceApi } from './serviceDetectionFullWebServiceApi';
export * from './serviceDetectionOpaqueAndExternalWebRequestApi';
import { ServiceDetectionOpaqueAndExternalWebRequestApi } from './serviceDetectionOpaqueAndExternalWebRequestApi';
export * from './serviceIBMMQTracingApi';
import { ServiceIBMMQTracingApi } from './serviceIBMMQTracingApi';
export * from './serviceRequestAttributesApi';
import { ServiceRequestAttributesApi } from './serviceRequestAttributesApi';
export * from './serviceRequestNamingApi';
import { ServiceRequestNamingApi } from './serviceRequestNamingApi';
export * from './webApplicationConfigurationApi';
import { WebApplicationConfigurationApi } from './webApplicationConfigurationApi';
import * as fs from 'fs';
import * as http from 'http';
export declare class HttpError extends Error {
    response: http.ClientResponse;
    body: any;
    statusCode?: number | undefined;
    constructor(response: http.ClientResponse, body: any, statusCode?: number | undefined);
}
export interface RequestDetailedFile {
    value: Buffer;
    options?: {
        filename?: string;
        contentType?: string;
    };
}
export declare type RequestFile = string | Buffer | fs.ReadStream | RequestDetailedFile;
export declare const APIS: (typeof AWSCredentialsConfigurationApi | typeof AlertingProfilesApi | typeof AnomalyDetectionAWSApi | typeof AnomalyDetectionApplicationsApi | typeof AnomalyDetectionDatabaseServicesApi | typeof AnomalyDetectionDiskEventsApi | typeof AnomalyDetectionHostsApi | typeof AnomalyDetectionMetricEventsApi | typeof AnomalyDetectionProcessGroupsApi | typeof AnomalyDetectionServicesApi | typeof AnomalyDetectionVMwareApi | typeof ApplicationDetectionRulesApi | typeof AutomaticallyAppliedTagsApi | typeof AzureCredentialsConfigurationApi | typeof CalculatedMetricsLogMonitoringApi | typeof CalculatedMetricsMobileCustomApplicationsApi | typeof CalculatedMetricsServicesApi | typeof CalculatedMetricsSyntheticApi | typeof CalculatedMetricsWebApplicationsApi | typeof CloudFoundryCredentialsConfigurationApi | typeof ConditionalNamingApi | typeof CredentialVaultApi | typeof DashboardsApi | typeof DataPrivacyAndSecurityApi | typeof ExtensionsApi | typeof FrequentIssueDetectionApi | typeof KubernetesCredentialsConfigurationApi | typeof MaintenanceWindowsApi | typeof ManagementZonesApi | typeof MobileDeobfuscationAndSymbolicationApi | typeof NotificationsApi | typeof PluginsApi | typeof RemoteEnvironmentsApi | typeof ReportsApi | typeof ServiceCustomServicesApi | typeof ServiceDetectionFullWebRequestApi | typeof ServiceDetectionFullWebServiceApi | typeof ServiceDetectionOpaqueAndExternalWebRequestApi | typeof ServiceIBMMQTracingApi | typeof ServiceRequestAttributesApi | typeof ServiceRequestNamingApi | typeof WebApplicationConfigurationApi)[];
