/// <reference types="node" />
import http = require('http');
import { ApplicationDetectionRuleConfig } from '../model/applicationDetectionRuleConfig';
import { EntityShortRepresentation } from '../model/entityShortRepresentation';
import { StubList } from '../model/stubList';
import { Authentication, Interceptor } from '../model/models';
import { ApiKeyAuth } from '../model/models';
export declare enum ApplicationDetectionRulesApiApiKeys {
    Api = 0
}
export declare class ApplicationDetectionRulesApi {
    protected _basePath: string;
    protected _defaultHeaders: any;
    protected _useQuerystring: boolean;
    protected authentications: {
        'default': Authentication;
        'Api-Token': ApiKeyAuth;
    };
    protected interceptors: Interceptor[];
    constructor(basePath?: string);
    useQuerystring: boolean;
    basePath: string;
    defaultHeaders: any;
    setDefaultAuthentication(auth: Authentication): void;
    setApiKey(key: ApplicationDetectionRulesApiApiKeys, value: string): void;
    addInterceptor(interceptor: Interceptor): void;
    _delete(id: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    getConfig(id: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: ApplicationDetectionRuleConfig;
    }>;
    listConfigurations2(options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: StubList;
    }>;
    postConfig(position?: 'APPEND' | 'PREPEND', applicationDetectionRuleConfig?: ApplicationDetectionRuleConfig, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: EntityShortRepresentation;
    }>;
    putConfig(id: string, applicationDetectionRuleConfig?: ApplicationDetectionRuleConfig, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: EntityShortRepresentation;
    }>;
    reorderList(stubList?: StubList, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    validateConfig(applicationDetectionRuleConfig?: ApplicationDetectionRuleConfig, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    validateConfig1(id: string, applicationDetectionRuleConfig?: ApplicationDetectionRuleConfig, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
}
