/// <reference types="node" />
import http = require('http');
import { AutoTag } from '../model/autoTag';
import { EntityShortRepresentation } from '../model/entityShortRepresentation';
import { StubList } from '../model/stubList';
import { Authentication, Interceptor } from '../model/models';
import { ApiKeyAuth } from '../model/models';
export declare enum AutomaticallyAppliedTagsApiApiKeys {
    Api = 0
}
export declare class AutomaticallyAppliedTagsApi {
    protected _basePath: string;
    protected _defaultHeaders: any;
    protected _useQuerystring: boolean;
    protected authentications: {
        'default': Authentication;
        'Api-Token': ApiKeyAuth;
    };
    protected interceptors: Interceptor[];
    constructor(basePath?: string);
    useQuerystring: boolean;
    basePath: string;
    defaultHeaders: any;
    setDefaultAuthentication(auth: Authentication): void;
    setApiKey(key: AutomaticallyAppliedTagsApiApiKeys, value: string): void;
    addInterceptor(interceptor: Interceptor): void;
    createAutoTag(autoTag?: AutoTag, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: EntityShortRepresentation;
    }>;
    createOrUpdateAutoTag(id: string, autoTag?: AutoTag, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: EntityShortRepresentation;
    }>;
    deleteAutoTag(id: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    getAllAutoTagConfigs(options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: StubList;
    }>;
    getSingleAutoTagConfig(id: string, includeProcessGroupReferences?: boolean, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: AutoTag;
    }>;
    validateAutoTag(autoTag?: AutoTag, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    validateAutoTag1(id: string, autoTag?: AutoTag, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
}
