/// <reference types="node" />
import http = require('http');
import { CalculatedMobileMetric } from '../model/calculatedMobileMetric';
import { CalculatedMobileMetricUpdate } from '../model/calculatedMobileMetricUpdate';
import { EntityShortRepresentation } from '../model/entityShortRepresentation';
import { StubList } from '../model/stubList';
import { Authentication, Interceptor } from '../model/models';
import { ApiKeyAuth } from '../model/models';
export declare enum CalculatedMetricsMobileCustomApplicationsApiApiKeys {
    Api = 0
}
export declare class CalculatedMetricsMobileCustomApplicationsApi {
    protected _basePath: string;
    protected _defaultHeaders: any;
    protected _useQuerystring: boolean;
    protected authentications: {
        'default': Authentication;
        'Api-Token': ApiKeyAuth;
    };
    protected interceptors: Interceptor[];
    constructor(basePath?: string);
    useQuerystring: boolean;
    basePath: string;
    defaultHeaders: any;
    setDefaultAuthentication(auth: Authentication): void;
    setApiKey(key: CalculatedMetricsMobileCustomApplicationsApiApiKeys, value: string): void;
    addInterceptor(interceptor: Interceptor): void;
    create(calculatedMobileMetric?: CalculatedMobileMetric, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: EntityShortRepresentation;
    }>;
    delete2(metricKey: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    getItem1(metricKey: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: CalculatedMobileMetric;
    }>;
    getList1(options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: StubList;
    }>;
    update(metricKey: string, calculatedMobileMetricUpdate?: CalculatedMobileMetricUpdate, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    validateCreateMobileMetric(calculatedMobileMetric?: CalculatedMobileMetric, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    validateUpdateMobileMetric(metricKey: string, calculatedMobileMetricUpdate?: CalculatedMobileMetricUpdate, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
}
