/// <reference types="node" />
import http = require('http');
import { CalculatedSyntheticMetric } from '../model/calculatedSyntheticMetric';
import { EntityShortRepresentation } from '../model/entityShortRepresentation';
import { StubList } from '../model/stubList';
import { SyntheticMetricUpdate } from '../model/syntheticMetricUpdate';
import { Authentication, Interceptor } from '../model/models';
import { ApiKeyAuth } from '../model/models';
export declare enum CalculatedMetricsSyntheticApiApiKeys {
    Api = 0
}
export declare class CalculatedMetricsSyntheticApi {
    protected _basePath: string;
    protected _defaultHeaders: any;
    protected _useQuerystring: boolean;
    protected authentications: {
        'default': Authentication;
        'Api-Token': ApiKeyAuth;
    };
    protected interceptors: Interceptor[];
    constructor(basePath?: string);
    useQuerystring: boolean;
    basePath: string;
    defaultHeaders: any;
    setDefaultAuthentication(auth: Authentication): void;
    setApiKey(key: CalculatedMetricsSyntheticApiApiKeys, value: string): void;
    addInterceptor(interceptor: Interceptor): void;
    create2(calculatedSyntheticMetric?: CalculatedSyntheticMetric, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: EntityShortRepresentation;
    }>;
    delete5(metricKey: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    getItem4(metricKey: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: CalculatedSyntheticMetric;
    }>;
    getList4(options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: StubList;
    }>;
    update2(metricKey: string, syntheticMetricUpdate?: SyntheticMetricUpdate, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    validateCreateSyntheticMetric(calculatedSyntheticMetric?: CalculatedSyntheticMetric, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    validateUpdateSyntheticMetric(metricKey: string, syntheticMetricUpdate?: SyntheticMetricUpdate, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
}
