/// <reference types="node" />
import http = require('http');
import { CloudFoundryCredentials } from '../model/cloudFoundryCredentials';
import { EntityShortRepresentation } from '../model/entityShortRepresentation';
import { StubList } from '../model/stubList';
import { Authentication, Interceptor } from '../model/models';
import { ApiKeyAuth } from '../model/models';
export declare enum CloudFoundryCredentialsConfigurationApiApiKeys {
    Api = 0
}
export declare class CloudFoundryCredentialsConfigurationApi {
    protected _basePath: string;
    protected _defaultHeaders: any;
    protected _useQuerystring: boolean;
    protected authentications: {
        'default': Authentication;
        'Api-Token': ApiKeyAuth;
    };
    protected interceptors: Interceptor[];
    constructor(basePath?: string);
    useQuerystring: boolean;
    basePath: string;
    defaultHeaders: any;
    setDefaultAuthentication(auth: Authentication): void;
    setApiKey(key: CloudFoundryCredentialsConfigurationApiApiKeys, value: string): void;
    addInterceptor(interceptor: Interceptor): void;
    createConfig1(cloudFoundryCredentials: CloudFoundryCredentials, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: EntityShortRepresentation;
    }>;
    deleteConfig1(id: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    getConfig2(id: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: CloudFoundryCredentials;
    }>;
    listConfigs(options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: StubList;
    }>;
    updateConfig(id: string, cloudFoundryCredentials: CloudFoundryCredentials, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: EntityShortRepresentation;
    }>;
    validatePOSTConfig(cloudFoundryCredentials: CloudFoundryCredentials, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    validatePUTConfig(id: string, cloudFoundryCredentials: CloudFoundryCredentials, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
}
