/// <reference types="node" />
import http = require('http');
import { ConditionalNamingRule } from '../model/conditionalNamingRule';
import { EntityShortRepresentation } from '../model/entityShortRepresentation';
import { StubList } from '../model/stubList';
import { Authentication, Interceptor } from '../model/models';
import { ApiKeyAuth } from '../model/models';
export declare enum ConditionalNamingApiApiKeys {
    Api = 0
}
export declare class ConditionalNamingApi {
    protected _basePath: string;
    protected _defaultHeaders: any;
    protected _useQuerystring: boolean;
    protected authentications: {
        'default': Authentication;
        'Api-Token': ApiKeyAuth;
    };
    protected interceptors: Interceptor[];
    constructor(basePath?: string);
    useQuerystring: boolean;
    basePath: string;
    defaultHeaders: any;
    setDefaultAuthentication(auth: Authentication): void;
    setApiKey(key: ConditionalNamingApiApiKeys, value: string): void;
    addInterceptor(interceptor: Interceptor): void;
    createNamingRule(type: 'processGroup', conditionalNamingRule?: ConditionalNamingRule, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: EntityShortRepresentation;
    }>;
    createOrUpdateNamingRule(type: 'processGroup', id: string, conditionalNamingRule?: ConditionalNamingRule, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: EntityShortRepresentation;
    }>;
    deleteNamingRule(type: 'processGroup', id: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    getAllNamingRules(type: 'processGroup', options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: StubList;
    }>;
    getSingleNamingRule(type: 'processGroup', id: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: ConditionalNamingRule;
    }>;
    validateNamingRule(type: 'processGroup', id: string, conditionalNamingRule?: ConditionalNamingRule, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    validateNamingRule1(type: 'processGroup', conditionalNamingRule?: ConditionalNamingRule, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
}
