/// <reference types="node" />
import http = require('http');
import { Credentials } from '../model/credentials';
import { CredentialsList } from '../model/credentialsList';
import { CredentialsResponseElement } from '../model/credentialsResponseElement';
import { Authentication, Interceptor } from '../model/models';
import { ApiKeyAuth } from '../model/models';
export declare enum CredentialVaultApiApiKeys {
    Api = 0
}
export declare class CredentialVaultApi {
    protected _basePath: string;
    protected _defaultHeaders: any;
    protected _useQuerystring: boolean;
    protected authentications: {
        'default': Authentication;
        'Api-Token': ApiKeyAuth;
    };
    protected interceptors: Interceptor[];
    constructor(basePath?: string);
    useQuerystring: boolean;
    basePath: string;
    defaultHeaders: any;
    setDefaultAuthentication(auth: Authentication): void;
    setApiKey(key: CredentialVaultApiApiKeys, value: string): void;
    addInterceptor(interceptor: Interceptor): void;
    addCredentials(credentials?: Credentials, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: CredentialsResponseElement;
    }>;
    getCredentials(type?: 'CERTIFICATE' | 'USERNAME_PASSWORD' | 'TOKEN', options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: CredentialsList;
    }>;
    getCredentials1(id: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: CredentialsResponseElement;
    }>;
    removeCredentials(id: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    updateCredentials(id: string, credentials?: Credentials, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: CredentialsResponseElement;
    }>;
}
