/// <reference types="node" />
import http = require('http');
import { DataPrivacyAndSecurity } from '../model/dataPrivacyAndSecurity';
import { Authentication, Interceptor } from '../model/models';
import { ApiKeyAuth } from '../model/models';
export declare enum DataPrivacyAndSecurityApiApiKeys {
    Api = 0
}
export declare class DataPrivacyAndSecurityApi {
    protected _basePath: string;
    protected _defaultHeaders: any;
    protected _useQuerystring: boolean;
    protected authentications: {
        'default': Authentication;
        'Api-Token': ApiKeyAuth;
    };
    protected interceptors: Interceptor[];
    constructor(basePath?: string);
    useQuerystring: boolean;
    basePath: string;
    defaultHeaders: any;
    setDefaultAuthentication(auth: Authentication): void;
    setApiKey(key: DataPrivacyAndSecurityApiApiKeys, value: string): void;
    addInterceptor(interceptor: Interceptor): void;
    getDataPrivacySettings1(options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: DataPrivacyAndSecurity;
    }>;
    updateDataPrivacySettings1(dataPrivacyAndSecurity: DataPrivacyAndSecurity, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    validateConfiguration7(dataPrivacyAndSecurity: DataPrivacyAndSecurity, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
}
