/// <reference types="node" />
import http = require('http');
import { FrequentIssueDetectionConfig } from '../model/frequentIssueDetectionConfig';
import { Authentication, Interceptor } from '../model/models';
import { ApiKeyAuth } from '../model/models';
export declare enum FrequentIssueDetectionApiApiKeys {
    Api = 0
}
export declare class FrequentIssueDetectionApi {
    protected _basePath: string;
    protected _defaultHeaders: any;
    protected _useQuerystring: boolean;
    protected authentications: {
        'default': Authentication;
        'Api-Token': ApiKeyAuth;
    };
    protected interceptors: Interceptor[];
    constructor(basePath?: string);
    useQuerystring: boolean;
    basePath: string;
    defaultHeaders: any;
    setDefaultAuthentication(auth: Authentication): void;
    setApiKey(key: FrequentIssueDetectionApiApiKeys, value: string): void;
    addInterceptor(interceptor: Interceptor): void;
    getConfiguration6(options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: FrequentIssueDetectionConfig;
    }>;
    updateConfiguration4(frequentIssueDetectionConfig?: FrequentIssueDetectionConfig, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    validateConfiguration8(frequentIssueDetectionConfig?: FrequentIssueDetectionConfig, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
}
