/// <reference types="node" />
import http = require('http');
import { EntityShortRepresentation } from '../model/entityShortRepresentation';
import { KubernetesCredentials } from '../model/kubernetesCredentials';
import { StubList } from '../model/stubList';
import { Authentication, Interceptor } from '../model/models';
import { ApiKeyAuth } from '../model/models';
export declare enum KubernetesCredentialsConfigurationApiApiKeys {
    Api = 0
}
export declare class KubernetesCredentialsConfigurationApi {
    protected _basePath: string;
    protected _defaultHeaders: any;
    protected _useQuerystring: boolean;
    protected authentications: {
        'default': Authentication;
        'Api-Token': ApiKeyAuth;
    };
    protected interceptors: Interceptor[];
    constructor(basePath?: string);
    useQuerystring: boolean;
    basePath: string;
    defaultHeaders: any;
    setDefaultAuthentication(auth: Authentication): void;
    setApiKey(key: KubernetesCredentialsConfigurationApiApiKeys, value: string): void;
    addInterceptor(interceptor: Interceptor): void;
    createConfiguration4(kubernetesCredentials?: KubernetesCredentials, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: EntityShortRepresentation;
    }>;
    deleteConfiguration5(id: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    getConfiguration9(id: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: KubernetesCredentials;
    }>;
    getConfigurations2(options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: StubList;
    }>;
    updateConfiguration6(id: string, kubernetesCredentials?: KubernetesCredentials, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: EntityShortRepresentation;
    }>;
    validateConfiguration14(kubernetesCredentials?: KubernetesCredentials, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    validateConfigurationUpdate1(id: string, kubernetesCredentials?: KubernetesCredentials, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
}
