/// <reference types="node" />
import http = require('http');
import { NotificationConfig } from '../model/notificationConfig';
import { NotificationConfigStub } from '../model/notificationConfigStub';
import { NotificationConfigStubListDto } from '../model/notificationConfigStubListDto';
import { Authentication, Interceptor } from '../model/models';
import { ApiKeyAuth } from '../model/models';
export declare enum NotificationsApiApiKeys {
    Api = 0
}
export declare class NotificationsApi {
    protected _basePath: string;
    protected _defaultHeaders: any;
    protected _useQuerystring: boolean;
    protected authentications: {
        'default': Authentication;
        'Api-Token': ApiKeyAuth;
    };
    protected interceptors: Interceptor[];
    constructor(basePath?: string);
    useQuerystring: boolean;
    basePath: string;
    defaultHeaders: any;
    setDefaultAuthentication(auth: Authentication): void;
    setApiKey(key: NotificationsApiApiKeys, value: string): void;
    addInterceptor(interceptor: Interceptor): void;
    createNotificationConfig(notificationConfig?: NotificationConfig, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    createOrUpdateNotificationConfig(id: string, notificationConfig?: NotificationConfig, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: NotificationConfigStub;
    }>;
    deleteNotificatonConfig(id: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    getNotificationConfig(id: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: NotificationConfig;
    }>;
    returnAllNotificationCofigs(options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: NotificationConfigStubListDto;
    }>;
    validateCreateConfiguration(notificationConfig?: NotificationConfig, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    validateCreateOrUpdateConfiguration(id: string, notificationConfig?: NotificationConfig, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
}
