/// <reference types="node" />
import http = require('http');
import { RemoteEnvironmentConfigDto } from '../model/remoteEnvironmentConfigDto';
import { RemoteEnvironmentConfigListDto } from '../model/remoteEnvironmentConfigListDto';
import { RemoteEnvironmentConfigStub } from '../model/remoteEnvironmentConfigStub';
import { Authentication, Interceptor } from '../model/models';
import { ApiKeyAuth } from '../model/models';
export declare enum RemoteEnvironmentsApiApiKeys {
    Api = 0
}
export declare class RemoteEnvironmentsApi {
    protected _basePath: string;
    protected _defaultHeaders: any;
    protected _useQuerystring: boolean;
    protected authentications: {
        'default': Authentication;
        'Api-Token': ApiKeyAuth;
    };
    protected interceptors: Interceptor[];
    constructor(basePath?: string);
    useQuerystring: boolean;
    basePath: string;
    defaultHeaders: any;
    setDefaultAuthentication(auth: Authentication): void;
    setApiKey(key: RemoteEnvironmentsApiApiKeys, value: string): void;
    addInterceptor(interceptor: Interceptor): void;
    createConfig(remoteEnvironmentConfigDto?: RemoteEnvironmentConfigDto, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: RemoteEnvironmentConfigStub;
    }>;
    createOrUpdateConfig(id: string, remoteEnvironmentConfigDto?: RemoteEnvironmentConfigDto, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: RemoteEnvironmentConfigStub;
    }>;
    deleteConfig(id: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    getConfig1(id: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: RemoteEnvironmentConfigDto;
    }>;
    returnAllConfigs(options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: RemoteEnvironmentConfigListDto;
    }>;
    validateCreateConfiguration1(remoteEnvironmentConfigDto?: RemoteEnvironmentConfigDto, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    validateCreateOrUpdateConfiguration1(id: string, remoteEnvironmentConfigDto?: RemoteEnvironmentConfigDto, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
}
