/// <reference types="node" />
import http = require('http');
import { CustomService } from '../model/customService';
import { EntityShortRepresentation } from '../model/entityShortRepresentation';
import { StubList } from '../model/stubList';
import { Authentication, Interceptor } from '../model/models';
import { ApiKeyAuth } from '../model/models';
export declare enum ServiceCustomServicesApiApiKeys {
    Api = 0
}
export declare class ServiceCustomServicesApi {
    protected _basePath: string;
    protected _defaultHeaders: any;
    protected _useQuerystring: boolean;
    protected authentications: {
        'default': Authentication;
        'Api-Token': ApiKeyAuth;
    };
    protected interceptors: Interceptor[];
    constructor(basePath?: string);
    useQuerystring: boolean;
    basePath: string;
    defaultHeaders: any;
    setDefaultAuthentication(auth: Authentication): void;
    setApiKey(key: ServiceCustomServicesApiApiKeys, value: string): void;
    addInterceptor(interceptor: Interceptor): void;
    delete1(technology: 'dotNet' | 'go' | 'java' | 'nodeJS' | 'php', id: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    getItem(technology: 'dotNet' | 'go' | 'java' | 'nodeJS' | 'php', id: string, includeProcessGroupReferences?: boolean, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: CustomService;
    }>;
    getList(technology: 'dotNet' | 'go' | 'java' | 'nodeJS' | 'php', options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: StubList;
    }>;
    post(technology: 'dotNet' | 'go' | 'java' | 'nodeJS' | 'php', position?: 'APPEND' | 'PREPEND', customService?: CustomService, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: EntityShortRepresentation;
    }>;
    putItem(technology: 'dotNet' | 'go' | 'java' | 'nodeJS' | 'php', id: string, customService?: CustomService, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: EntityShortRepresentation;
    }>;
    reorderList1(technology: 'dotNet' | 'go' | 'java' | 'nodeJS' | 'php', stubList?: StubList, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    validateItem(technology: 'dotNet' | 'go' | 'java' | 'nodeJS' | 'php', customService?: CustomService, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    validateItem1(technology: 'dotNet' | 'go' | 'java' | 'nodeJS' | 'php', id: string, customService?: CustomService, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
}
