/// <reference types="node" />
import http = require('http');
import { EntityShortRepresentation } from '../model/entityShortRepresentation';
import { FullWebRequestRule } from '../model/fullWebRequestRule';
import { StubList } from '../model/stubList';
import { Authentication, Interceptor } from '../model/models';
import { ApiKeyAuth } from '../model/models';
export declare enum ServiceDetectionFullWebRequestApiApiKeys {
    Api = 0
}
export declare class ServiceDetectionFullWebRequestApi {
    protected _basePath: string;
    protected _defaultHeaders: any;
    protected _useQuerystring: boolean;
    protected authentications: {
        'default': Authentication;
        'Api-Token': ApiKeyAuth;
    };
    protected interceptors: Interceptor[];
    constructor(basePath?: string);
    useQuerystring: boolean;
    basePath: string;
    defaultHeaders: any;
    setDefaultAuthentication(auth: Authentication): void;
    setApiKey(key: ServiceDetectionFullWebRequestApiApiKeys, value: string): void;
    addInterceptor(interceptor: Interceptor): void;
    createOrUpdateRule(id: string, fullWebRequestRule?: FullWebRequestRule, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: EntityShortRepresentation;
    }>;
    createRule(position?: 'APPEND' | 'PREPEND', fullWebRequestRule?: FullWebRequestRule, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: EntityShortRepresentation;
    }>;
    deleteRule(id: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    getRule(id: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: FullWebRequestRule;
    }>;
    listRulesSorted(options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: StubList;
    }>;
    reorderList3(stubList?: StubList, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    validatePostConfiguration1(fullWebRequestRule?: FullWebRequestRule, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    validatePutConfiguration1(id: string, fullWebRequestRule?: FullWebRequestRule, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
}
