/// <reference types="node" />
import http = require('http');
import { EntityShortRepresentation } from '../model/entityShortRepresentation';
import { FullWebServiceRule } from '../model/fullWebServiceRule';
import { StubList } from '../model/stubList';
import { Authentication, Interceptor } from '../model/models';
import { ApiKeyAuth } from '../model/models';
export declare enum ServiceDetectionFullWebServiceApiApiKeys {
    Api = 0
}
export declare class ServiceDetectionFullWebServiceApi {
    protected _basePath: string;
    protected _defaultHeaders: any;
    protected _useQuerystring: boolean;
    protected authentications: {
        'default': Authentication;
        'Api-Token': ApiKeyAuth;
    };
    protected interceptors: Interceptor[];
    constructor(basePath?: string);
    useQuerystring: boolean;
    basePath: string;
    defaultHeaders: any;
    setDefaultAuthentication(auth: Authentication): void;
    setApiKey(key: ServiceDetectionFullWebServiceApiApiKeys, value: string): void;
    addInterceptor(interceptor: Interceptor): void;
    createOrUpdateRule1(id: string, fullWebServiceRule?: FullWebServiceRule, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: EntityShortRepresentation;
    }>;
    createRule1(position?: 'APPEND' | 'PREPEND', fullWebServiceRule?: FullWebServiceRule, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: EntityShortRepresentation;
    }>;
    deleteRule1(id: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    getRule1(id: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: FullWebServiceRule;
    }>;
    listRulesSorted1(options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: StubList;
    }>;
    reorderList4(stubList?: StubList, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    validatePostConfiguration2(fullWebServiceRule: FullWebServiceRule, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    validatePutConfiguration2(id: string, fullWebServiceRule: FullWebServiceRule, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
}
