/// <reference types="node" />
import http = require('http');
import { EntityShortRepresentation } from '../model/entityShortRepresentation';
import { OpaqueAndExternalWebRequestRule } from '../model/opaqueAndExternalWebRequestRule';
import { StubList } from '../model/stubList';
import { Authentication, Interceptor } from '../model/models';
import { ApiKeyAuth } from '../model/models';
export declare enum ServiceDetectionOpaqueAndExternalWebRequestApiApiKeys {
    Api = 0
}
export declare class ServiceDetectionOpaqueAndExternalWebRequestApi {
    protected _basePath: string;
    protected _defaultHeaders: any;
    protected _useQuerystring: boolean;
    protected authentications: {
        'default': Authentication;
        'Api-Token': ApiKeyAuth;
    };
    protected interceptors: Interceptor[];
    constructor(basePath?: string);
    useQuerystring: boolean;
    basePath: string;
    defaultHeaders: any;
    setDefaultAuthentication(auth: Authentication): void;
    setApiKey(key: ServiceDetectionOpaqueAndExternalWebRequestApiApiKeys, value: string): void;
    addInterceptor(interceptor: Interceptor): void;
    createOrUpdateRule2(id: string, opaqueAndExternalWebRequestRule?: OpaqueAndExternalWebRequestRule, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: EntityShortRepresentation;
    }>;
    createRule2(position?: 'APPEND' | 'PREPEND', opaqueAndExternalWebRequestRule?: OpaqueAndExternalWebRequestRule, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: EntityShortRepresentation;
    }>;
    deleteRule2(id: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    getRule2(id: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: OpaqueAndExternalWebRequestRule;
    }>;
    listRulesSorted2(options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: StubList;
    }>;
    reorderList5(stubList?: StubList, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    validatePostConfiguration3(opaqueAndExternalWebRequestRule: OpaqueAndExternalWebRequestRule, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    validatePutConfiguration3(id: string, opaqueAndExternalWebRequestRule: OpaqueAndExternalWebRequestRule, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
}
