/// <reference types="node" />
import http = require('http');
import { ApplicationDataPrivacy } from '../model/applicationDataPrivacy';
import { ApplicationDataPrivacyList } from '../model/applicationDataPrivacyList';
import { EntityShortRepresentation } from '../model/entityShortRepresentation';
import { StubList } from '../model/stubList';
import { WebApplicationConfig } from '../model/webApplicationConfig';
import { Authentication, Interceptor } from '../model/models';
import { ApiKeyAuth } from '../model/models';
export declare enum WebApplicationConfigurationApiApiKeys {
    Api = 0
}
export declare class WebApplicationConfigurationApi {
    protected _basePath: string;
    protected _defaultHeaders: any;
    protected _useQuerystring: boolean;
    protected authentications: {
        'default': Authentication;
        'Api-Token': ApiKeyAuth;
    };
    protected interceptors: Interceptor[];
    constructor(basePath?: string);
    useQuerystring: boolean;
    basePath: string;
    defaultHeaders: any;
    setDefaultAuthentication(auth: Authentication): void;
    setApiKey(key: WebApplicationConfigurationApiApiKeys, value: string): void;
    addInterceptor(interceptor: Interceptor): void;
    createConfiguration1(webApplicationConfig?: WebApplicationConfig, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: EntityShortRepresentation;
    }>;
    createOrUpdateConfiguration(id: string, webApplicationConfig?: WebApplicationConfig, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: EntityShortRepresentation;
    }>;
    createOrUpdateDefaultConfiguration(webApplicationConfig?: WebApplicationConfig, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    deleteConfiguration1(id: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    getConfiguration4(id: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: WebApplicationConfig;
    }>;
    getDataPrivacySettings(id: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: ApplicationDataPrivacy;
    }>;
    getDefaultApplication(options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: WebApplicationConfig;
    }>;
    getDefaultApplicationDataPrivacySettings(options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: ApplicationDataPrivacy;
    }>;
    listConfigurations1(options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: StubList;
    }>;
    listDataPrivacySettings(options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body: ApplicationDataPrivacyList;
    }>;
    updateDataPrivacySettings(id: string, applicationDataPrivacy?: ApplicationDataPrivacy, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    updateDefaultApplicationDataPrivacySettings(applicationDataPrivacy?: ApplicationDataPrivacy, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    validateConfiguration5(webApplicationConfig?: WebApplicationConfig, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    validateConfiguration6(id: string, webApplicationConfig?: WebApplicationConfig, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    validateDataPrivacySettings(id: string, applicationDataPrivacy?: ApplicationDataPrivacy, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    validateDefaultApplicationDataPrivacySettings(applicationDataPrivacy?: ApplicationDataPrivacy, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
    validateDefaultConfiguration(webApplicationConfig?: WebApplicationConfig, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.ClientResponse;
        body?: any;
    }>;
}
