import { CalculatedMetricDefinition } from './calculatedMetricDefinition';
import { Condition } from './condition';
import { ConfigurationMetadata } from './configurationMetadata';
import { DimensionDefinition } from './dimensionDefinition';
export declare class CalculatedServiceMetric {
    'metadata'?: ConfigurationMetadata;
    'tsmMetricKey': string;
    'name': string;
    'enabled': boolean;
    'metricDefinition': CalculatedMetricDefinition;
    'unit': CalculatedServiceMetric.UnitEnum;
    'unitDisplayName'?: string;
    'entityId'?: string;
    'managementZones'?: Array<string>;
    'conditions'?: Array<Condition>;
    'dimensionDefinition'?: DimensionDefinition;
    static discriminator: string | undefined;
    static attributeTypeMap: Array<{
        name: string;
        baseName: string;
        type: string;
    }>;
    static getAttributeTypeMap(): {
        name: string;
        baseName: string;
        type: string;
    }[];
}
export declare namespace CalculatedServiceMetric {
    enum UnitEnum {
        BIT,
        BITPERHOUR,
        BITPERMINUTE,
        BITPERSECOND,
        BYTE,
        BYTEPERHOUR,
        BYTEPERMINUTE,
        BYTEPERSECOND,
        CORES,
        COUNT,
        DAY,
        GIBIBYTE,
        GIGA,
        GIGABYTE,
        HOUR,
        KIBIBYTE,
        KIBIBYTEPERHOUR,
        KIBIBYTEPERMINUTE,
        KIBIBYTEPERSECOND,
        KILO,
        KILOBYTE,
        KILOBYTEPERHOUR,
        KILOBYTEPERMINUTE,
        KILOBYTEPERSECOND,
        MEBIBYTE,
        MEBIBYTEPERHOUR,
        MEBIBYTEPERMINUTE,
        MEBIBYTEPERSECOND,
        MEGA,
        MEGABYTE,
        MEGABYTEPERHOUR,
        MEGABYTEPERMINUTE,
        MEGABYTEPERSECOND,
        MICROSECOND,
        MILLICORES,
        MILLISECOND,
        MILLISECONDPERMINUTE,
        MINUTE,
        MONTH,
        NANOSECOND,
        NANOSECONDPERMINUTE,
        NOTAPPLICABLE,
        PERCENT,
        PERHOUR,
        PERMINUTE,
        PERSECOND,
        PIXEL,
        PROMILLE,
        RATIO,
        SECOND,
        STATE,
        UNSPECIFIED,
        WEEK,
        YEAR
    }
}
