import { SyntheticMetricDimension } from './syntheticMetricDimension';
import { SyntheticMetricFilter } from './syntheticMetricFilter';
export declare class CalculatedSyntheticMetric {
    'monitorIdentifier': string;
    'name': string;
    'metricKey': string;
    'enabled': boolean;
    'metric': CalculatedSyntheticMetric.MetricEnum;
    'dimensions'?: Array<SyntheticMetricDimension>;
    'filter'?: SyntheticMetricFilter;
    static discriminator: string | undefined;
    static attributeTypeMap: Array<{
        name: string;
        baseName: string;
        type: string;
    }>;
    static getAttributeTypeMap(): {
        name: string;
        baseName: string;
        type: string;
    }[];
}
export declare namespace CalculatedSyntheticMetric {
    enum MetricEnum {
        ApplicationCache,
        Callback,
        DNSLookup,
        DOMComplete,
        DOMContentLoaded,
        DOMInteractive,
        FailedRequestsResources,
        FirstContentfulPaint,
        FirstInputDelay,
        FirstInputStart,
        FirstPaint,
        HTMLDownloaded,
        HttpErrors,
        JavaScriptErrors,
        LargestContentfulPaint,
        LoadEventEnd,
        LoadEventStart,
        NavigationStart,
        OnDOMContentLoaded,
        OnLoad,
        Processing,
        RedirectTime,
        Request,
        RequestStart,
        ResourceCount,
        Response,
        SecureConnect,
        SpeedIndex,
        TCPConnect,
        TimeToFirstByte,
        TotalDuration,
        TransferSize,
        UserActionDuration,
        VisuallyComplete
    }
}
