export declare class ConditionKey {
    'attribute': ConditionKey.AttributeEnum;
    'type'?: ConditionKey.TypeEnum;
    static discriminator: string | undefined;
    static attributeTypeMap: Array<{
        name: string;
        baseName: string;
        type: string;
    }>;
    static getAttributeTypeMap(): {
        name: string;
        baseName: string;
        type: string;
    }[];
}
export declare namespace ConditionKey {
    enum AttributeEnum {
        APPMONSERVERNAME,
        APPMONSYSTEMPROFILENAME,
        AWSACCOUNTID,
        AWSACCOUNTNAME,
        AWSAPPLICATIONLOADBALANCERNAME,
        AWSAPPLICATIONLOADBALANCERTAGS,
        AWSAUTOSCALINGGROUPNAME,
        AWSAUTOSCALINGGROUPTAGS,
        AWSAVAILABILITYZONENAME,
        AWSCLASSICLOADBALANCERFRONTENDPORTS,
        AWSCLASSICLOADBALANCERNAME,
        AWSCLASSICLOADBALANCERTAGS,
        AWSNETWORKLOADBALANCERNAME,
        AWSNETWORKLOADBALANCERTAGS,
        AWSRELATIONALDATABASESERVICEDBNAME,
        AWSRELATIONALDATABASESERVICEENDPOINT,
        AWSRELATIONALDATABASESERVICEENGINE,
        AWSRELATIONALDATABASESERVICEINSTANCECLASS,
        AWSRELATIONALDATABASESERVICENAME,
        AWSRELATIONALDATABASESERVICEPORT,
        AWSRELATIONALDATABASESERVICETAGS,
        AZUREENTITYNAME,
        AZUREENTITYTAGS,
        AZUREMGMTGROUPNAME,
        AZUREMGMTGROUPUUID,
        AZUREREGIONNAME,
        AZURESCALESETNAME,
        AZURESUBSCRIPTIONNAME,
        AZURESUBSCRIPTIONUUID,
        AZURETENANTNAME,
        AZURETENANTUUID,
        AZUREVMNAME,
        BROWSERMONITORNAME,
        BROWSERMONITORTAGS,
        CLOUDAPPLICATIONLABELS,
        CLOUDAPPLICATIONNAME,
        CLOUDAPPLICATIONNAMESPACELABELS,
        CLOUDAPPLICATIONNAMESPACENAME,
        CLOUDFOUNDRYFOUNDATIONNAME,
        CLOUDFOUNDRYORGNAME,
        CUSTOMAPPLICATIONNAME,
        CUSTOMAPPLICATIONPLATFORM,
        CUSTOMAPPLICATIONTAGS,
        CUSTOMAPPLICATIONTYPE,
        CUSTOMDEVICEDETECTEDNAME,
        CUSTOMDEVICEDNSADDRESS,
        CUSTOMDEVICEGROUPNAME,
        CUSTOMDEVICEGROUPTAGS,
        CUSTOMDEVICEIPADDRESS,
        CUSTOMDEVICEMETADATA,
        CUSTOMDEVICENAME,
        CUSTOMDEVICEPORT,
        CUSTOMDEVICETAGS,
        CUSTOMDEVICETECHNOLOGY,
        DATACENTERSERVICEDECODERTYPE,
        DATACENTERSERVICEIPADDRESS,
        DATACENTERSERVICEMETADATA,
        DATACENTERSERVICENAME,
        DATACENTERSERVICEPORT,
        DATACENTERSERVICETAGS,
        DOCKERCONTAINERNAME,
        DOCKERFULLIMAGENAME,
        DOCKERIMAGEVERSION,
        DOCKERSTRIPPEDIMAGENAME,
        EC2INSTANCEAMIID,
        EC2INSTANCEAWSINSTANCETYPE,
        EC2INSTANCEAWSSECURITYGROUP,
        EC2INSTANCEBEANSTALKENVNAME,
        EC2INSTANCEID,
        EC2INSTANCENAME,
        EC2INSTANCEPRIVATEHOSTNAME,
        EC2INSTANCEPUBLICHOSTNAME,
        EC2INSTANCETAGS,
        ENTERPRISEAPPLICATIONDECODERTYPE,
        ENTERPRISEAPPLICATIONIPADDRESS,
        ENTERPRISEAPPLICATIONMETADATA,
        ENTERPRISEAPPLICATIONNAME,
        ENTERPRISEAPPLICATIONPORT,
        ENTERPRISEAPPLICATIONTAGS,
        ESXIHOSTCLUSTERNAME,
        ESXIHOSTHARDWAREMODEL,
        ESXIHOSTHARDWAREVENDOR,
        ESXIHOSTNAME,
        ESXIHOSTPRODUCTNAME,
        ESXIHOSTPRODUCTVERSION,
        ESXIHOSTTAGS,
        EXTERNALMONITORENGINEDESCRIPTION,
        EXTERNALMONITORENGINENAME,
        EXTERNALMONITORENGINETYPE,
        EXTERNALMONITORNAME,
        EXTERNALMONITORTAGS,
        GEOLOCATIONSITENAME,
        GOOGLECLOUDPLATFORMZONENAME,
        GOOGLECOMPUTEINSTANCEID,
        GOOGLECOMPUTEINSTANCEMACHINETYPE,
        GOOGLECOMPUTEINSTANCENAME,
        GOOGLECOMPUTEINSTANCEPROJECT,
        GOOGLECOMPUTEINSTANCEPROJECTID,
        GOOGLECOMPUTEINSTANCEPUBLICIPADDRESSES,
        HOSTAIXLOGICALCPUCOUNT,
        HOSTAIXSIMULTANEOUSTHREADS,
        HOSTAIXVIRTUALCPUCOUNT,
        HOSTARCHITECTURE,
        HOSTAWSNAMETAG,
        HOSTAZURECOMPUTEMODE,
        HOSTAZURESKU,
        HOSTAZUREWEBAPPLICATIONHOSTNAMES,
        HOSTAZUREWEBAPPLICATIONSITENAMES,
        HOSTBITNESS,
        HOSTBOSHAVAILABILITYZONE,
        HOSTBOSHDEPLOYMENTID,
        HOSTBOSHINSTANCEID,
        HOSTBOSHINSTANCENAME,
        HOSTBOSHNAME,
        HOSTBOSHSTEMCELLVERSION,
        HOSTCLOUDTYPE,
        HOSTCPUCORES,
        HOSTCUSTOMMETADATA,
        HOSTDETECTEDNAME,
        HOSTGROUPID,
        HOSTGROUPNAME,
        HOSTHYPERVISORTYPE,
        HOSTIPADDRESS,
        HOSTKUBERNETESLABELS,
        HOSTLOGICALCPUCORES,
        HOSTNAME,
        HOSTONEAGENTCUSTOMHOSTNAME,
        HOSTOSTYPE,
        HOSTOSVERSION,
        HOSTPAASMEMORYLIMIT,
        HOSTPAASTYPE,
        HOSTTAGS,
        HOSTTECHNOLOGY,
        HTTPMONITORNAME,
        HTTPMONITORTAGS,
        KUBERNETESCLUSTERNAME,
        KUBERNETESNODENAME,
        MOBILEAPPLICATIONNAME,
        MOBILEAPPLICATIONPLATFORM,
        MOBILEAPPLICATIONTAGS,
        NAMEOFCOMPUTENODE,
        OPENSTACKACCOUNTNAME,
        OPENSTACKACCOUNTPROJECTNAME,
        OPENSTACKAVAILABILITYZONENAME,
        OPENSTACKPROJECTNAME,
        OPENSTACKREGIONNAME,
        OPENSTACKVMINSTANCETYPE,
        OPENSTACKVMNAME,
        OPENSTACKVMSECURITYGROUP,
        PROCESSGROUPAZUREHOSTNAME,
        PROCESSGROUPAZURESITENAME,
        PROCESSGROUPCUSTOMMETADATA,
        PROCESSGROUPDETECTEDNAME,
        PROCESSGROUPID,
        PROCESSGROUPLISTENPORT,
        PROCESSGROUPNAME,
        PROCESSGROUPPREDEFINEDMETADATA,
        PROCESSGROUPTAGS,
        PROCESSGROUPTECHNOLOGY,
        PROCESSGROUPTECHNOLOGYEDITION,
        PROCESSGROUPTECHNOLOGYVERSION,
        SERVICEAKKAACTORSYSTEM,
        SERVICECTGSERVICENAME,
        SERVICEDATABASEHOSTNAME,
        SERVICEDATABASENAME,
        SERVICEDATABASETOPOLOGY,
        SERVICEDATABASEVENDOR,
        SERVICEDETECTEDNAME,
        SERVICEESBAPPLICATIONNAME,
        SERVICEIBMCTGGATEWAYURL,
        SERVICEIIBAPPLICATIONNAME,
        SERVICEMESSAGINGLISTENERCLASSNAME,
        SERVICENAME,
        SERVICEPORT,
        SERVICEPUBLICDOMAINNAME,
        SERVICEREMOTEENDPOINT,
        SERVICEREMOTESERVICENAME,
        SERVICETAGS,
        SERVICETECHNOLOGY,
        SERVICETECHNOLOGYEDITION,
        SERVICETECHNOLOGYVERSION,
        SERVICETOPOLOGY,
        SERVICETYPE,
        SERVICEWEBAPPLICATIONID,
        SERVICEWEBCONTEXTROOT,
        SERVICEWEBSERVERENDPOINT,
        SERVICEWEBSERVERNAME,
        SERVICEWEBSERVICENAME,
        SERVICEWEBSERVICENAMESPACE,
        VMWAREDATACENTERNAME,
        VMWAREVMNAME,
        WEBAPPLICATIONNAME,
        WEBAPPLICATIONNAMEPATTERN,
        WEBAPPLICATIONTAGS,
        WEBAPPLICATIONTYPE
    }
    enum TypeEnum {
        HOSTCUSTOMMETADATAKEY,
        PROCESSCUSTOMMETADATAKEY,
        PROCESSPREDEFINEDMETADATAKEY,
        STRING
    }
}
