import { CustomChartingItemMetadataConfig } from './customChartingItemMetadataConfig';
import { CustomFilterChartSeriesConfig } from './customFilterChartSeriesConfig';
export declare class CustomFilterChartConfig {
    'legendShown'?: boolean;
    'type': CustomFilterChartConfig.TypeEnum;
    'series': Array<CustomFilterChartSeriesConfig>;
    'resultMetadata': {
        [key: string]: CustomChartingItemMetadataConfig;
    };
    'axisLimits'?: {
        [key: string]: number;
    };
    'leftAxisCustomUnit'?: CustomFilterChartConfig.LeftAxisCustomUnitEnum;
    'rightAxisCustomUnit'?: CustomFilterChartConfig.RightAxisCustomUnitEnum;
    static discriminator: string | undefined;
    static attributeTypeMap: Array<{
        name: string;
        baseName: string;
        type: string;
    }>;
    static getAttributeTypeMap(): {
        name: string;
        baseName: string;
        type: string;
    }[];
}
export declare namespace CustomFilterChartConfig {
    enum TypeEnum {
        PIE,
        SINGLEVALUE,
        TIMESERIES,
        TOPLIST
    }
    enum LeftAxisCustomUnitEnum {
        Bit,
        BitPerHour,
        BitPerMinute,
        BitPerSecond,
        Byte,
        BytePerHour,
        BytePerMinute,
        BytePerSecond,
        Cores,
        Count,
        Day,
        GibiByte,
        Giga,
        GigaByte,
        Hour,
        KibiByte,
        KibiBytePerHour,
        KibiBytePerMinute,
        KibiBytePerSecond,
        Kilo,
        KiloByte,
        KiloBytePerHour,
        KiloBytePerMinute,
        KiloBytePerSecond,
        MebiByte,
        MebiBytePerHour,
        MebiBytePerMinute,
        MebiBytePerSecond,
        Mega,
        MegaByte,
        MegaBytePerHour,
        MegaBytePerMinute,
        MegaBytePerSecond,
        MicroSecond,
        MilliCores,
        MilliSecond,
        MilliSecondPerMinute,
        Minute,
        Month,
        NanoSecond,
        NanoSecondPerMinute,
        NotApplicable,
        PerHour,
        PerMinute,
        PerSecond,
        Percent,
        Pixel,
        Promille,
        Ratio,
        Second,
        State,
        Unspecified,
        Week,
        Year
    }
    enum RightAxisCustomUnitEnum {
        Bit,
        BitPerHour,
        BitPerMinute,
        BitPerSecond,
        Byte,
        BytePerHour,
        BytePerMinute,
        BytePerSecond,
        Cores,
        Count,
        Day,
        GibiByte,
        Giga,
        GigaByte,
        Hour,
        KibiByte,
        KibiBytePerHour,
        KibiBytePerMinute,
        KibiBytePerSecond,
        Kilo,
        KiloByte,
        KiloBytePerHour,
        KiloBytePerMinute,
        KiloBytePerSecond,
        MebiByte,
        MebiBytePerHour,
        MebiBytePerMinute,
        MebiBytePerSecond,
        Mega,
        MegaByte,
        MegaBytePerHour,
        MegaBytePerMinute,
        MegaBytePerSecond,
        MicroSecond,
        MilliCores,
        MilliSecond,
        MilliSecondPerMinute,
        Minute,
        Month,
        NanoSecond,
        NanoSecondPerMinute,
        NotApplicable,
        PerHour,
        PerMinute,
        PerSecond,
        Percent,
        Pixel,
        Promille,
        Ratio,
        Second,
        State,
        Unspecified,
        Week,
        Year
    }
}
