import { CapturedMethod } from './capturedMethod';
import { ScopeConditions } from './scopeConditions';
import { ValueCondition } from './valueCondition';
import { ValueProcessing } from './valueProcessing';
export declare class DataSource {
    'enabled': boolean;
    'source': DataSource.SourceEnum;
    'valueProcessing'?: ValueProcessing;
    'technology'?: DataSource.TechnologyEnum;
    'sessionAttributeTechnology'?: DataSource.SessionAttributeTechnologyEnum;
    'methods'?: Array<CapturedMethod>;
    'parameterName'?: string;
    'scope'?: ScopeConditions;
    'capturingAndStorageLocation'?: DataSource.CapturingAndStorageLocationEnum;
    'iibNodeType'?: DataSource.IibNodeTypeEnum;
    'iibMethodNodeCondition'?: ValueCondition;
    'cicsSDKMethodNodeCondition'?: ValueCondition;
    'iibLabelMethodNodeCondition'?: ValueCondition;
    static discriminator: string | undefined;
    static attributeTypeMap: Array<{
        name: string;
        baseName: string;
        type: string;
    }>;
    static getAttributeTypeMap(): {
        name: string;
        baseName: string;
        type: string;
    }[];
}
export declare namespace DataSource {
    enum SourceEnum {
        CICSSDK,
        CLIENTIP,
        CUSTOMATTRIBUTE,
        IIBLABEL,
        IIBNODE,
        METHODPARAM,
        POSTPARAMETER,
        QUERYPARAMETER,
        REQUESTHEADER,
        RESPONSEHEADER,
        SESSIONATTRIBUTE,
        URI,
        URIPATH
    }
    enum TechnologyEnum {
        DOTNET,
        JAVA,
        PHP
    }
    enum SessionAttributeTechnologyEnum {
        ASPNET,
        ASPNETCORE,
        JAVA
    }
    enum CapturingAndStorageLocationEnum {
        ANDSTOREONBOTH,
        ANDSTOREONCLIENT,
        ANDSTOREONSERVER,
        ONCLIENTSTOREONSERVER
    }
    enum IibNodeTypeEnum {
        AGGREGATECONTROLNODE,
        AGGREGATEREPLYNODE,
        AGGREGATEREQUESTNODE,
        CALLABLEFLOWREPLYNODE,
        COLLECTORNODE,
        COMPUTENODE,
        DATABASENODE,
        DECISIONSERVICENODE,
        DOTNETCOMPUTENODE,
        FILEREADNODE,
        FILTERNODE,
        FLOWORDERNODE,
        GROUPCOMPLETENODE,
        GROUPGATHERNODE,
        GROUPSCATTERNODE,
        HTTPHEADER,
        JAVACOMPUTENODE,
        JMSCLIENTRECEIVE,
        JMSCLIENTREPLYNODE,
        JMSHEADER,
        MQGETNODE,
        MQOUTPUTNODE,
        PASSTHRUNODE,
        RESETCONTENTDESCRIPTORNODE,
        RESEQUENCENODE,
        ROUTENODE,
        SAPREPLYNODE,
        SCAREPLYNODE,
        SECURITYPEP,
        SEQUENCENODE,
        SOAPEXTRACTNODE,
        SOAPREPLYNODE,
        SOAPWRAPPERNODE,
        SRRETRIEVEENTITYNODE,
        SRRETRIEVEITSERVICENODE,
        THROWNODE,
        TRACENODE,
        TRYCATCHNODE,
        VALIDATENODE,
        WSREPLYNODE,
        XSLMQSINODE
    }
}
