"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var DataSource = (function () {
    function DataSource() {
    }
    DataSource.getAttributeTypeMap = function () {
        return DataSource.attributeTypeMap;
    };
    DataSource.discriminator = undefined;
    DataSource.attributeTypeMap = [
        {
            "name": "enabled",
            "baseName": "enabled",
            "type": "boolean"
        },
        {
            "name": "source",
            "baseName": "source",
            "type": "DataSource.SourceEnum"
        },
        {
            "name": "valueProcessing",
            "baseName": "valueProcessing",
            "type": "ValueProcessing"
        },
        {
            "name": "technology",
            "baseName": "technology",
            "type": "DataSource.TechnologyEnum"
        },
        {
            "name": "sessionAttributeTechnology",
            "baseName": "sessionAttributeTechnology",
            "type": "DataSource.SessionAttributeTechnologyEnum"
        },
        {
            "name": "methods",
            "baseName": "methods",
            "type": "Array<CapturedMethod>"
        },
        {
            "name": "parameterName",
            "baseName": "parameterName",
            "type": "string"
        },
        {
            "name": "scope",
            "baseName": "scope",
            "type": "ScopeConditions"
        },
        {
            "name": "capturingAndStorageLocation",
            "baseName": "capturingAndStorageLocation",
            "type": "DataSource.CapturingAndStorageLocationEnum"
        },
        {
            "name": "iibNodeType",
            "baseName": "iibNodeType",
            "type": "DataSource.IibNodeTypeEnum"
        },
        {
            "name": "iibMethodNodeCondition",
            "baseName": "iibMethodNodeCondition",
            "type": "ValueCondition"
        },
        {
            "name": "cicsSDKMethodNodeCondition",
            "baseName": "cicsSDKMethodNodeCondition",
            "type": "ValueCondition"
        },
        {
            "name": "iibLabelMethodNodeCondition",
            "baseName": "iibLabelMethodNodeCondition",
            "type": "ValueCondition"
        }
    ];
    return DataSource;
}());
exports.DataSource = DataSource;
(function (DataSource) {
    var SourceEnum;
    (function (SourceEnum) {
        SourceEnum[SourceEnum["CICSSDK"] = 'CICS_SDK'] = "CICSSDK";
        SourceEnum[SourceEnum["CLIENTIP"] = 'CLIENT_IP'] = "CLIENTIP";
        SourceEnum[SourceEnum["CUSTOMATTRIBUTE"] = 'CUSTOM_ATTRIBUTE'] = "CUSTOMATTRIBUTE";
        SourceEnum[SourceEnum["IIBLABEL"] = 'IIB_LABEL'] = "IIBLABEL";
        SourceEnum[SourceEnum["IIBNODE"] = 'IIB_NODE'] = "IIBNODE";
        SourceEnum[SourceEnum["METHODPARAM"] = 'METHOD_PARAM'] = "METHODPARAM";
        SourceEnum[SourceEnum["POSTPARAMETER"] = 'POST_PARAMETER'] = "POSTPARAMETER";
        SourceEnum[SourceEnum["QUERYPARAMETER"] = 'QUERY_PARAMETER'] = "QUERYPARAMETER";
        SourceEnum[SourceEnum["REQUESTHEADER"] = 'REQUEST_HEADER'] = "REQUESTHEADER";
        SourceEnum[SourceEnum["RESPONSEHEADER"] = 'RESPONSE_HEADER'] = "RESPONSEHEADER";
        SourceEnum[SourceEnum["SESSIONATTRIBUTE"] = 'SESSION_ATTRIBUTE'] = "SESSIONATTRIBUTE";
        SourceEnum[SourceEnum["URI"] = 'URI'] = "URI";
        SourceEnum[SourceEnum["URIPATH"] = 'URI_PATH'] = "URIPATH";
    })(SourceEnum = DataSource.SourceEnum || (DataSource.SourceEnum = {}));
    var TechnologyEnum;
    (function (TechnologyEnum) {
        TechnologyEnum[TechnologyEnum["DOTNET"] = 'DOTNET'] = "DOTNET";
        TechnologyEnum[TechnologyEnum["JAVA"] = 'JAVA'] = "JAVA";
        TechnologyEnum[TechnologyEnum["PHP"] = 'PHP'] = "PHP";
    })(TechnologyEnum = DataSource.TechnologyEnum || (DataSource.TechnologyEnum = {}));
    var SessionAttributeTechnologyEnum;
    (function (SessionAttributeTechnologyEnum) {
        SessionAttributeTechnologyEnum[SessionAttributeTechnologyEnum["ASPNET"] = 'ASP_NET'] = "ASPNET";
        SessionAttributeTechnologyEnum[SessionAttributeTechnologyEnum["ASPNETCORE"] = 'ASP_NET_CORE'] = "ASPNETCORE";
        SessionAttributeTechnologyEnum[SessionAttributeTechnologyEnum["JAVA"] = 'JAVA'] = "JAVA";
    })(SessionAttributeTechnologyEnum = DataSource.SessionAttributeTechnologyEnum || (DataSource.SessionAttributeTechnologyEnum = {}));
    var CapturingAndStorageLocationEnum;
    (function (CapturingAndStorageLocationEnum) {
        CapturingAndStorageLocationEnum[CapturingAndStorageLocationEnum["ANDSTOREONBOTH"] = 'CAPTURE_AND_STORE_ON_BOTH'] = "ANDSTOREONBOTH";
        CapturingAndStorageLocationEnum[CapturingAndStorageLocationEnum["ANDSTOREONCLIENT"] = 'CAPTURE_AND_STORE_ON_CLIENT'] = "ANDSTOREONCLIENT";
        CapturingAndStorageLocationEnum[CapturingAndStorageLocationEnum["ANDSTOREONSERVER"] = 'CAPTURE_AND_STORE_ON_SERVER'] = "ANDSTOREONSERVER";
        CapturingAndStorageLocationEnum[CapturingAndStorageLocationEnum["ONCLIENTSTOREONSERVER"] = 'CAPTURE_ON_CLIENT_STORE_ON_SERVER'] = "ONCLIENTSTOREONSERVER";
    })(CapturingAndStorageLocationEnum = DataSource.CapturingAndStorageLocationEnum || (DataSource.CapturingAndStorageLocationEnum = {}));
    var IibNodeTypeEnum;
    (function (IibNodeTypeEnum) {
        IibNodeTypeEnum[IibNodeTypeEnum["AGGREGATECONTROLNODE"] = 'AGGREGATE_CONTROL_NODE'] = "AGGREGATECONTROLNODE";
        IibNodeTypeEnum[IibNodeTypeEnum["AGGREGATEREPLYNODE"] = 'AGGREGATE_REPLY_NODE'] = "AGGREGATEREPLYNODE";
        IibNodeTypeEnum[IibNodeTypeEnum["AGGREGATEREQUESTNODE"] = 'AGGREGATE_REQUEST_NODE'] = "AGGREGATEREQUESTNODE";
        IibNodeTypeEnum[IibNodeTypeEnum["CALLABLEFLOWREPLYNODE"] = 'CALLABLE_FLOW_REPLY_NODE'] = "CALLABLEFLOWREPLYNODE";
        IibNodeTypeEnum[IibNodeTypeEnum["COLLECTORNODE"] = 'COLLECTOR_NODE'] = "COLLECTORNODE";
        IibNodeTypeEnum[IibNodeTypeEnum["COMPUTENODE"] = 'COMPUTE_NODE'] = "COMPUTENODE";
        IibNodeTypeEnum[IibNodeTypeEnum["DATABASENODE"] = 'DATABASE_NODE'] = "DATABASENODE";
        IibNodeTypeEnum[IibNodeTypeEnum["DECISIONSERVICENODE"] = 'DECISION_SERVICE_NODE'] = "DECISIONSERVICENODE";
        IibNodeTypeEnum[IibNodeTypeEnum["DOTNETCOMPUTENODE"] = 'DOT_NET_COMPUTE_NODE'] = "DOTNETCOMPUTENODE";
        IibNodeTypeEnum[IibNodeTypeEnum["FILEREADNODE"] = 'FILE_READ_NODE'] = "FILEREADNODE";
        IibNodeTypeEnum[IibNodeTypeEnum["FILTERNODE"] = 'FILTER_NODE'] = "FILTERNODE";
        IibNodeTypeEnum[IibNodeTypeEnum["FLOWORDERNODE"] = 'FLOW_ORDER_NODE'] = "FLOWORDERNODE";
        IibNodeTypeEnum[IibNodeTypeEnum["GROUPCOMPLETENODE"] = 'GROUP_COMPLETE_NODE'] = "GROUPCOMPLETENODE";
        IibNodeTypeEnum[IibNodeTypeEnum["GROUPGATHERNODE"] = 'GROUP_GATHER_NODE'] = "GROUPGATHERNODE";
        IibNodeTypeEnum[IibNodeTypeEnum["GROUPSCATTERNODE"] = 'GROUP_SCATTER_NODE'] = "GROUPSCATTERNODE";
        IibNodeTypeEnum[IibNodeTypeEnum["HTTPHEADER"] = 'HTTP_HEADER'] = "HTTPHEADER";
        IibNodeTypeEnum[IibNodeTypeEnum["JAVACOMPUTENODE"] = 'JAVA_COMPUTE_NODE'] = "JAVACOMPUTENODE";
        IibNodeTypeEnum[IibNodeTypeEnum["JMSCLIENTRECEIVE"] = 'JMS_CLIENT_RECEIVE'] = "JMSCLIENTRECEIVE";
        IibNodeTypeEnum[IibNodeTypeEnum["JMSCLIENTREPLYNODE"] = 'JMS_CLIENT_REPLY_NODE'] = "JMSCLIENTREPLYNODE";
        IibNodeTypeEnum[IibNodeTypeEnum["JMSHEADER"] = 'JMS_HEADER'] = "JMSHEADER";
        IibNodeTypeEnum[IibNodeTypeEnum["MQGETNODE"] = 'MQ_GET_NODE'] = "MQGETNODE";
        IibNodeTypeEnum[IibNodeTypeEnum["MQOUTPUTNODE"] = 'MQ_OUTPUT_NODE'] = "MQOUTPUTNODE";
        IibNodeTypeEnum[IibNodeTypeEnum["PASSTHRUNODE"] = 'PASSTHRU_NODE'] = "PASSTHRUNODE";
        IibNodeTypeEnum[IibNodeTypeEnum["RESETCONTENTDESCRIPTORNODE"] = 'RESET_CONTENT_DESCRIPTOR_NODE'] = "RESETCONTENTDESCRIPTORNODE";
        IibNodeTypeEnum[IibNodeTypeEnum["RESEQUENCENODE"] = 'RE_SEQUENCE_NODE'] = "RESEQUENCENODE";
        IibNodeTypeEnum[IibNodeTypeEnum["ROUTENODE"] = 'ROUTE_NODE'] = "ROUTENODE";
        IibNodeTypeEnum[IibNodeTypeEnum["SAPREPLYNODE"] = 'SAP_REPLY_NODE'] = "SAPREPLYNODE";
        IibNodeTypeEnum[IibNodeTypeEnum["SCAREPLYNODE"] = 'SCA_REPLY_NODE'] = "SCAREPLYNODE";
        IibNodeTypeEnum[IibNodeTypeEnum["SECURITYPEP"] = 'SECURITY_PEP'] = "SECURITYPEP";
        IibNodeTypeEnum[IibNodeTypeEnum["SEQUENCENODE"] = 'SEQUENCE_NODE'] = "SEQUENCENODE";
        IibNodeTypeEnum[IibNodeTypeEnum["SOAPEXTRACTNODE"] = 'SOAP_EXTRACT_NODE'] = "SOAPEXTRACTNODE";
        IibNodeTypeEnum[IibNodeTypeEnum["SOAPREPLYNODE"] = 'SOAP_REPLY_NODE'] = "SOAPREPLYNODE";
        IibNodeTypeEnum[IibNodeTypeEnum["SOAPWRAPPERNODE"] = 'SOAP_WRAPPER_NODE'] = "SOAPWRAPPERNODE";
        IibNodeTypeEnum[IibNodeTypeEnum["SRRETRIEVEENTITYNODE"] = 'SR_RETRIEVE_ENTITY_NODE'] = "SRRETRIEVEENTITYNODE";
        IibNodeTypeEnum[IibNodeTypeEnum["SRRETRIEVEITSERVICENODE"] = 'SR_RETRIEVE_IT_SERVICE_NODE'] = "SRRETRIEVEITSERVICENODE";
        IibNodeTypeEnum[IibNodeTypeEnum["THROWNODE"] = 'THROW_NODE'] = "THROWNODE";
        IibNodeTypeEnum[IibNodeTypeEnum["TRACENODE"] = 'TRACE_NODE'] = "TRACENODE";
        IibNodeTypeEnum[IibNodeTypeEnum["TRYCATCHNODE"] = 'TRY_CATCH_NODE'] = "TRYCATCHNODE";
        IibNodeTypeEnum[IibNodeTypeEnum["VALIDATENODE"] = 'VALIDATE_NODE'] = "VALIDATENODE";
        IibNodeTypeEnum[IibNodeTypeEnum["WSREPLYNODE"] = 'WS_REPLY_NODE'] = "WSREPLYNODE";
        IibNodeTypeEnum[IibNodeTypeEnum["XSLMQSINODE"] = 'XSL_MQSI_NODE'] = "XSLMQSINODE";
    })(IibNodeTypeEnum = DataSource.IibNodeTypeEnum || (DataSource.IibNodeTypeEnum = {}));
})(DataSource = exports.DataSource || (exports.DataSource = {}));
exports.DataSource = DataSource;
//# sourceMappingURL=dataSource.js.map