import { ConfigurationMetadata } from './configurationMetadata';
import { KubernetesEventPattern } from './kubernetesEventPattern';
export declare class KubernetesCredentials {
    'metadata'?: ConfigurationMetadata;
    'id'?: string;
    'active'?: boolean;
    'endpointStatus'?: KubernetesCredentials.EndpointStatusEnum;
    'endpointStatusInfo'?: string;
    'label': string;
    'endpointUrl'?: string;
    'authToken'?: string;
    'eventsIntegrationEnabled'?: boolean;
    'workloadIntegrationEnabled'?: boolean;
    'eventsFieldSelectors'?: Array<KubernetesEventPattern>;
    'certificateCheckEnabled'?: boolean;
    static discriminator: string | undefined;
    static attributeTypeMap: Array<{
        name: string;
        baseName: string;
        type: string;
    }>;
    static getAttributeTypeMap(): {
        name: string;
        baseName: string;
        type: string;
    }[];
}
export declare namespace KubernetesCredentials {
    enum EndpointStatusEnum {
        ASSIGNED,
        DISABLED,
        FASTCHECKAUTHERROR,
        FASTCHECKAUTHLOCKED,
        FASTCHECKINVALIDENDPOINT,
        FASTCHECKNORESPONSE,
        FASTCHECKTLSERROR,
        UNASSIGNED,
        UNKNOWN
    }
}
