import { ColumnDefinition } from './columnDefinition';
import { LogSourceFilter } from './logSourceFilter';
export declare class LogMetricConfig {
    'metricKey': string;
    'active'?: boolean;
    'displayName': string;
    'unit': LogMetricConfig.UnitEnum;
    'unitDisplayName'?: string;
    'searchString': string;
    'metricValueType': LogMetricConfig.MetricValueTypeEnum;
    'columnDefiningValue'?: ColumnDefinition;
    'logSourceFilters': Array<LogSourceFilter>;
    static discriminator: string | undefined;
    static attributeTypeMap: Array<{
        name: string;
        baseName: string;
        type: string;
    }>;
    static getAttributeTypeMap(): {
        name: string;
        baseName: string;
        type: string;
    }[];
}
export declare namespace LogMetricConfig {
    enum UnitEnum {
        BIT,
        BITPERHOUR,
        BITPERMINUTE,
        BITPERSECOND,
        BYTE,
        BYTEPERHOUR,
        BYTEPERMINUTE,
        BYTEPERSECOND,
        CORES,
        COUNT,
        DAY,
        GIBIBYTE,
        GIGA,
        GIGABYTE,
        HOUR,
        KIBIBYTE,
        KIBIBYTEPERHOUR,
        KIBIBYTEPERMINUTE,
        KIBIBYTEPERSECOND,
        KILO,
        KILOBYTE,
        KILOBYTEPERHOUR,
        KILOBYTEPERMINUTE,
        KILOBYTEPERSECOND,
        MEBIBYTE,
        MEBIBYTEPERHOUR,
        MEBIBYTEPERMINUTE,
        MEBIBYTEPERSECOND,
        MEGA,
        MEGABYTE,
        MEGABYTEPERHOUR,
        MEGABYTEPERMINUTE,
        MEGABYTEPERSECOND,
        MICROSECOND,
        MILLICORES,
        MILLISECOND,
        MILLISECONDPERMINUTE,
        MINUTE,
        MONTH,
        NANOSECOND,
        NANOSECONDPERMINUTE,
        NOTAPPLICABLE,
        PERCENT,
        PERHOUR,
        PERMINUTE,
        PERSECOND,
        PIXEL,
        PROMILLE,
        RATIO,
        SECOND,
        STATE,
        UNSPECIFIED,
        WEEK,
        YEAR
    }
    enum MetricValueTypeEnum {
        FPCOLUMNAVG,
        FPCOLUMNCOUNT,
        FPCOLUMNMAX,
        FPCOLUMNMIN,
        FPCOLUMNSUM,
        FPCOLUMNTOPXAVG,
        FPCOLUMNTOPXCOUNT,
        FPCOLUMNTOPXMAX,
        FPCOLUMNTOPXMIN,
        FPCOLUMNTOPXSUM,
        INTCOLUMNAVG,
        INTCOLUMNCOUNT,
        INTCOLUMNMAX,
        INTCOLUMNMIN,
        INTCOLUMNSUM,
        INTCOLUMNTOPXAVG,
        INTCOLUMNTOPXCOUNT,
        INTCOLUMNTOPXMAX,
        INTCOLUMNTOPXMIN,
        INTCOLUMNTOPXSUM,
        OCCURRENCES
    }
}
