export declare class MethodReference {
    'visibility': MethodReference.VisibilityEnum;
    'modifiers': Array<MethodReference.ModifiersEnum>;
    'className'?: string;
    'fileName'?: string;
    'fileNameMatcher'?: MethodReference.FileNameMatcherEnum;
    'methodName': string;
    'argumentTypes': Array<string>;
    'returnType': string;
    static discriminator: string | undefined;
    static attributeTypeMap: Array<{
        name: string;
        baseName: string;
        type: string;
    }>;
    static getAttributeTypeMap(): {
        name: string;
        baseName: string;
        type: string;
    }[];
}
export declare namespace MethodReference {
    enum VisibilityEnum {
        INTERNAL,
        PACKAGEPROTECTED,
        PRIVATE,
        PROTECTED,
        PUBLIC
    }
    enum ModifiersEnum {
        ABSTRACT,
        EXTERN,
        FINAL,
        NATIVE,
        STATIC
    }
    enum FileNameMatcherEnum {
        ENDSWITH,
        EQUALS,
        STARTSWITH
    }
}
