import { ConfigurationMetadata } from './configurationMetadata';
import { MetricEventAlertingScope } from './metricEventAlertingScope';
import { MetricEventDimensions } from './metricEventDimensions';
import { MetricEventMonitoringStrategy } from './metricEventMonitoringStrategy';
export declare class MetricEvent {
    'metadata'?: ConfigurationMetadata;
    'id'?: string;
    'metricId': string;
    'name': string;
    'description': string;
    'aggregationType'?: MetricEvent.AggregationTypeEnum;
    'severity'?: MetricEvent.SeverityEnum;
    'enabled': boolean;
    'disabledReason'?: MetricEvent.DisabledReasonEnum;
    'alertingScope'?: Array<MetricEventAlertingScope>;
    'metricDimensions'?: Array<MetricEventDimensions>;
    'monitoringStrategy'?: MetricEventMonitoringStrategy;
    static discriminator: string | undefined;
    static attributeTypeMap: Array<{
        name: string;
        baseName: string;
        type: string;
    }>;
    static getAttributeTypeMap(): {
        name: string;
        baseName: string;
        type: string;
    }[];
}
export declare namespace MetricEvent {
    enum AggregationTypeEnum {
        AVG,
        COUNT,
        MAX,
        MEDIAN,
        MIN,
        OFINTEREST,
        OFINTERESTRATIO,
        OTHER,
        OTHERRATIO,
        P90,
        SUM,
        VALUE
    }
    enum SeverityEnum {
        AVAILABILITY,
        CUSTOMALERT,
        ERROR,
        INFO,
        PERFORMANCE,
        RESOURCECONTENTION
    }
    enum DisabledReasonEnum {
        NONE,
        TOOMANYDIMS
    }
}
