import { AdvancedJavaScriptTagSettings } from './advancedJavaScriptTagSettings';
import { ContentCapture } from './contentCapture';
import { JavaScriptFrameworkSupport } from './javaScriptFrameworkSupport';
import { JavaScriptInjectionRules } from './javaScriptInjectionRules';
import { WebApplicationConfigBrowserRestrictionSettings } from './webApplicationConfigBrowserRestrictionSettings';
import { WebApplicationConfigIpAddressRestrictionSettings } from './webApplicationConfigIpAddressRestrictionSettings';
export declare class MonitoringSettings {
    'fetchRequests': boolean;
    'xmlHttpRequest': boolean;
    'javaScriptFrameworkSupport': JavaScriptFrameworkSupport;
    'contentCapture': ContentCapture;
    'excludeXhrRegex': string;
    'injectionMode': MonitoringSettings.InjectionModeEnum;
    'addCrossOriginAnonymousAttribute'?: boolean;
    'scriptTagCacheDurationInHours'?: number;
    'libraryFileLocation'?: string;
    'monitoringDataPath'?: string;
    'customConfigurationProperties': string;
    'serverRequestPathId': string;
    'secureCookieAttribute': boolean;
    'cookiePlacementDomain': string;
    'cacheControlHeaderOptimizations': boolean;
    'advancedJavaScriptTagSettings': AdvancedJavaScriptTagSettings;
    'browserRestrictionSettings'?: WebApplicationConfigBrowserRestrictionSettings;
    'ipAddressRestrictionSettings'?: WebApplicationConfigIpAddressRestrictionSettings;
    'javaScriptInjectionRules'?: Array<JavaScriptInjectionRules>;
    static discriminator: string | undefined;
    static attributeTypeMap: Array<{
        name: string;
        baseName: string;
        type: string;
    }>;
    static getAttributeTypeMap(): {
        name: string;
        baseName: string;
        type: string;
    }[];
}
export declare namespace MonitoringSettings {
    enum InjectionModeEnum {
        CODESNIPPET,
        CODESNIPPETASYNC,
        INLINECODE,
        JAVASCRIPTTAG
    }
}
