import { ConfigurationMetadata } from './configurationMetadata';
import { DataSource } from './dataSource';
export declare class RequestAttribute {
    'metadata'?: ConfigurationMetadata;
    'id'?: string;
    'name': string;
    'enabled': boolean;
    'dataType': RequestAttribute.DataTypeEnum;
    'dataSources': Array<DataSource>;
    'normalization': RequestAttribute.NormalizationEnum;
    'aggregation': RequestAttribute.AggregationEnum;
    'confidential': boolean;
    'skipPersonalDataMasking': boolean;
    static discriminator: string | undefined;
    static attributeTypeMap: Array<{
        name: string;
        baseName: string;
        type: string;
    }>;
    static getAttributeTypeMap(): {
        name: string;
        baseName: string;
        type: string;
    }[];
}
export declare namespace RequestAttribute {
    enum DataTypeEnum {
        DOUBLE,
        INTEGER,
        STRING
    }
    enum NormalizationEnum {
        ORIGINAL,
        TOLOWERCASE,
        TOUPPERCASE
    }
    enum AggregationEnum {
        ALLDISTINCTVALUES,
        AVERAGE,
        COUNTDISTINCTVALUES,
        COUNTVALUES,
        FIRST,
        LAST,
        MAXIMUM,
        MINIMUM,
        SUM
    }
}
