import { TileBounds } from './tileBounds';
import { TileFilter } from './tileFilter';
export declare class Tile {
    'name': string;
    'tileType': Tile.TileTypeEnum;
    'configured'?: boolean;
    'bounds': TileBounds;
    'tileFilter'?: TileFilter;
    static discriminator: string | undefined;
    static attributeTypeMap: Array<{
        name: string;
        baseName: string;
        type: string;
    }>;
    static getAttributeTypeMap(): {
        name: string;
        baseName: string;
        type: string;
    }[];
}
export declare namespace Tile {
    enum TileTypeEnum {
        APPLICATION,
        APPLICATIONS,
        APPLICATIONMETHOD,
        APPLICATIONWORLDMAP,
        AWS,
        BOUNCERATE,
        CUSTOMAPPLICATION,
        CUSTOMCHARTING,
        DATABASE,
        DATABASESOVERVIEW,
        DEMKEYUSERACTION,
        DEVICEAPPLICATIONMETHOD,
        DTAQL,
        HOST,
        HOSTS,
        LOGANALYTICS,
        MARKDOWN,
        MOBILEAPPLICATION,
        OPENSTACK,
        OPENSTACKAVZONE,
        OPENSTACKPROJECT,
        PROCESSGROUPSONE,
        RESOURCES,
        SERVICES,
        SERVICEVERSATILE,
        SESSIONMETRICS,
        SYNTHETICHTTPMONITOR,
        SYNTHETICSINGLEEXTTEST,
        SYNTHETICSINGLEWEBCHECK,
        SYNTHETICTESTS,
        THIRDPARTYMOSTACTIVE,
        UEMCONVERSIONSOVERALL,
        UEMCONVERSIONSPERGOAL,
        UEMJSERRORSOVERALL,
        UEMKEYUSERACTIONS,
        USERS,
        VIRTUALIZATION
    }
}
