import { Apdex } from './apdex';
import { ConfigurationMetadata } from './configurationMetadata';
import { ConversionGoal } from './conversionGoal';
import { MetaDataCapturing } from './metaDataCapturing';
import { MonitoringSettings } from './monitoringSettings';
import { SessionReplaySetting } from './sessionReplaySetting';
import { UserActionAndSessionProperties } from './userActionAndSessionProperties';
import { UserActionNamingSettings } from './userActionNamingSettings';
import { UserTag } from './userTag';
import { WaterfallSettings } from './waterfallSettings';
export declare class WebApplicationConfig {
    'metadata'?: ConfigurationMetadata;
    'identifier'?: string;
    'name': string;
    'type'?: WebApplicationConfig.TypeEnum;
    'realUserMonitoringEnabled': boolean;
    'costControlUserSessionPercentage': number;
    'loadActionKeyPerformanceMetric': WebApplicationConfig.LoadActionKeyPerformanceMetricEnum;
    'sessionReplayConfig'?: SessionReplaySetting;
    'xhrActionKeyPerformanceMetric': WebApplicationConfig.XhrActionKeyPerformanceMetricEnum;
    'loadActionApdexSettings': Apdex;
    'xhrActionApdexSettings': Apdex;
    'customActionApdexSettings': Apdex;
    'waterfallSettings': WaterfallSettings;
    'monitoringSettings': MonitoringSettings;
    'userTags'?: Array<UserTag>;
    'userActionAndSessionProperties'?: Array<UserActionAndSessionProperties>;
    'userActionNamingSettings'?: UserActionNamingSettings;
    'metaDataCaptureSettings'?: Array<MetaDataCapturing>;
    'conversionGoals'?: Array<ConversionGoal>;
    'urlInjectionPattern'?: string;
    static discriminator: string | undefined;
    static attributeTypeMap: Array<{
        name: string;
        baseName: string;
        type: string;
    }>;
    static getAttributeTypeMap(): {
        name: string;
        baseName: string;
        type: string;
    }[];
}
export declare namespace WebApplicationConfig {
    enum TypeEnum {
        AUTOINJECTED,
        BROWSEREXTENSIONINJECTED,
        MANUALLYINJECTED
    }
    enum LoadActionKeyPerformanceMetricEnum {
        ACTIONDURATION,
        DOMINTERACTIVE,
        LOADEVENTEND,
        LOADEVENTSTART,
        RESPONSEEND,
        RESPONSESTART,
        SPEEDINDEX,
        VISUALLYCOMPLETE
    }
    enum XhrActionKeyPerformanceMetricEnum {
        ACTIONDURATION,
        RESPONSEEND,
        RESPONSESTART,
        VISUALLYCOMPLETE
    }
}
