"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var WebApplicationConfig = (function () {
    function WebApplicationConfig() {
    }
    WebApplicationConfig.getAttributeTypeMap = function () {
        return WebApplicationConfig.attributeTypeMap;
    };
    WebApplicationConfig.discriminator = undefined;
    WebApplicationConfig.attributeTypeMap = [
        {
            "name": "metadata",
            "baseName": "metadata",
            "type": "ConfigurationMetadata"
        },
        {
            "name": "identifier",
            "baseName": "identifier",
            "type": "string"
        },
        {
            "name": "name",
            "baseName": "name",
            "type": "string"
        },
        {
            "name": "type",
            "baseName": "type",
            "type": "WebApplicationConfig.TypeEnum"
        },
        {
            "name": "realUserMonitoringEnabled",
            "baseName": "realUserMonitoringEnabled",
            "type": "boolean"
        },
        {
            "name": "costControlUserSessionPercentage",
            "baseName": "costControlUserSessionPercentage",
            "type": "number"
        },
        {
            "name": "loadActionKeyPerformanceMetric",
            "baseName": "loadActionKeyPerformanceMetric",
            "type": "WebApplicationConfig.LoadActionKeyPerformanceMetricEnum"
        },
        {
            "name": "sessionReplayConfig",
            "baseName": "sessionReplayConfig",
            "type": "SessionReplaySetting"
        },
        {
            "name": "xhrActionKeyPerformanceMetric",
            "baseName": "xhrActionKeyPerformanceMetric",
            "type": "WebApplicationConfig.XhrActionKeyPerformanceMetricEnum"
        },
        {
            "name": "loadActionApdexSettings",
            "baseName": "loadActionApdexSettings",
            "type": "Apdex"
        },
        {
            "name": "xhrActionApdexSettings",
            "baseName": "xhrActionApdexSettings",
            "type": "Apdex"
        },
        {
            "name": "customActionApdexSettings",
            "baseName": "customActionApdexSettings",
            "type": "Apdex"
        },
        {
            "name": "waterfallSettings",
            "baseName": "waterfallSettings",
            "type": "WaterfallSettings"
        },
        {
            "name": "monitoringSettings",
            "baseName": "monitoringSettings",
            "type": "MonitoringSettings"
        },
        {
            "name": "userTags",
            "baseName": "userTags",
            "type": "Array<UserTag>"
        },
        {
            "name": "userActionAndSessionProperties",
            "baseName": "userActionAndSessionProperties",
            "type": "Array<UserActionAndSessionProperties>"
        },
        {
            "name": "userActionNamingSettings",
            "baseName": "userActionNamingSettings",
            "type": "UserActionNamingSettings"
        },
        {
            "name": "metaDataCaptureSettings",
            "baseName": "metaDataCaptureSettings",
            "type": "Array<MetaDataCapturing>"
        },
        {
            "name": "conversionGoals",
            "baseName": "conversionGoals",
            "type": "Array<ConversionGoal>"
        },
        {
            "name": "urlInjectionPattern",
            "baseName": "urlInjectionPattern",
            "type": "string"
        }
    ];
    return WebApplicationConfig;
}());
exports.WebApplicationConfig = WebApplicationConfig;
(function (WebApplicationConfig) {
    var TypeEnum;
    (function (TypeEnum) {
        TypeEnum[TypeEnum["AUTOINJECTED"] = 'AUTO_INJECTED'] = "AUTOINJECTED";
        TypeEnum[TypeEnum["BROWSEREXTENSIONINJECTED"] = 'BROWSER_EXTENSION_INJECTED'] = "BROWSEREXTENSIONINJECTED";
        TypeEnum[TypeEnum["MANUALLYINJECTED"] = 'MANUALLY_INJECTED'] = "MANUALLYINJECTED";
    })(TypeEnum = WebApplicationConfig.TypeEnum || (WebApplicationConfig.TypeEnum = {}));
    var LoadActionKeyPerformanceMetricEnum;
    (function (LoadActionKeyPerformanceMetricEnum) {
        LoadActionKeyPerformanceMetricEnum[LoadActionKeyPerformanceMetricEnum["ACTIONDURATION"] = 'ACTION_DURATION'] = "ACTIONDURATION";
        LoadActionKeyPerformanceMetricEnum[LoadActionKeyPerformanceMetricEnum["DOMINTERACTIVE"] = 'DOM_INTERACTIVE'] = "DOMINTERACTIVE";
        LoadActionKeyPerformanceMetricEnum[LoadActionKeyPerformanceMetricEnum["LOADEVENTEND"] = 'LOAD_EVENT_END'] = "LOADEVENTEND";
        LoadActionKeyPerformanceMetricEnum[LoadActionKeyPerformanceMetricEnum["LOADEVENTSTART"] = 'LOAD_EVENT_START'] = "LOADEVENTSTART";
        LoadActionKeyPerformanceMetricEnum[LoadActionKeyPerformanceMetricEnum["RESPONSEEND"] = 'RESPONSE_END'] = "RESPONSEEND";
        LoadActionKeyPerformanceMetricEnum[LoadActionKeyPerformanceMetricEnum["RESPONSESTART"] = 'RESPONSE_START'] = "RESPONSESTART";
        LoadActionKeyPerformanceMetricEnum[LoadActionKeyPerformanceMetricEnum["SPEEDINDEX"] = 'SPEED_INDEX'] = "SPEEDINDEX";
        LoadActionKeyPerformanceMetricEnum[LoadActionKeyPerformanceMetricEnum["VISUALLYCOMPLETE"] = 'VISUALLY_COMPLETE'] = "VISUALLYCOMPLETE";
    })(LoadActionKeyPerformanceMetricEnum = WebApplicationConfig.LoadActionKeyPerformanceMetricEnum || (WebApplicationConfig.LoadActionKeyPerformanceMetricEnum = {}));
    var XhrActionKeyPerformanceMetricEnum;
    (function (XhrActionKeyPerformanceMetricEnum) {
        XhrActionKeyPerformanceMetricEnum[XhrActionKeyPerformanceMetricEnum["ACTIONDURATION"] = 'ACTION_DURATION'] = "ACTIONDURATION";
        XhrActionKeyPerformanceMetricEnum[XhrActionKeyPerformanceMetricEnum["RESPONSEEND"] = 'RESPONSE_END'] = "RESPONSEEND";
        XhrActionKeyPerformanceMetricEnum[XhrActionKeyPerformanceMetricEnum["RESPONSESTART"] = 'RESPONSE_START'] = "RESPONSESTART";
        XhrActionKeyPerformanceMetricEnum[XhrActionKeyPerformanceMetricEnum["VISUALLYCOMPLETE"] = 'VISUALLY_COMPLETE'] = "VISUALLYCOMPLETE";
    })(XhrActionKeyPerformanceMetricEnum = WebApplicationConfig.XhrActionKeyPerformanceMetricEnum || (WebApplicationConfig.XhrActionKeyPerformanceMetricEnum = {}));
})(WebApplicationConfig = exports.WebApplicationConfig || (exports.WebApplicationConfig = {}));
exports.WebApplicationConfig = WebApplicationConfig;
//# sourceMappingURL=webApplicationConfig.js.map