/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* Additional event handlers and wrappers.
*/
export class AdditionalEventHandlers {
    /**
    * Use mouseup event for clicks enabled/disabled.
    */
    'userMouseupEventForClicks': boolean;
    /**
    * Click event handler enabled/disabled.
    */
    'clickEventHandler': boolean;
    /**
    * Mouseup event handler enabled/disabled.
    */
    'mouseupEventHandler': boolean;
    /**
    * Blur event handler enabled/disabled.
    */
    'blurEventHandler': boolean;
    /**
    * Change event handler enabled/disabled.
    */
    'changeEventHandler': boolean;
    /**
    * toString method enabled/disabled.
    */
    'toStringMethod': boolean;
    /**
    * Max. number of DOM nodes to instrument. Valid values range from 0 to 100000.
    */
    'maxDomNodesToInstrument': number;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "userMouseupEventForClicks",
            "baseName": "userMouseupEventForClicks",
            "type": "boolean"
        },
        {
            "name": "clickEventHandler",
            "baseName": "clickEventHandler",
            "type": "boolean"
        },
        {
            "name": "mouseupEventHandler",
            "baseName": "mouseupEventHandler",
            "type": "boolean"
        },
        {
            "name": "blurEventHandler",
            "baseName": "blurEventHandler",
            "type": "boolean"
        },
        {
            "name": "changeEventHandler",
            "baseName": "changeEventHandler",
            "type": "boolean"
        },
        {
            "name": "toStringMethod",
            "baseName": "toStringMethod",
            "type": "boolean"
        },
        {
            "name": "maxDomNodesToInstrument",
            "baseName": "maxDomNodesToInstrument",
            "type": "number"
        }    ];

    static getAttributeTypeMap() {
        return AdditionalEventHandlers.attributeTypeMap;
    }
}

