/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { AdditionalEventHandlers } from './additionalEventHandlers';
import { EventWrapperSettings } from './eventWrapperSettings';
import { GlobalEventCaptureSettings } from './globalEventCaptureSettings';

/**
* Advanced JavaScript tag settings.
*/
export class AdvancedJavaScriptTagSettings {
    /**
    * Send the beacon signal as a synchronous XMLHttpRequest using Firefox enabled/disabled.
    */
    'syncBeaconFirefox'?: boolean;
    /**
    * Send the beacon signal as a synchronous XMLHttpRequest using Internet Explorer enabled/disabled.
    */
    'syncBeaconInternetExplorer'?: boolean;
    /**
    * Instrumentation of unsupported Ajax frameworks enabled/disabled.
    */
    'instrumentUnsupportedAjaxFrameworks': boolean;
    /**
    * Additional special characters that are to be escaped using non-alphanumeric characters in HTML escape format.
    */
    'specialCharactersToEscape': string;
    /**
    * Maximum character length for action names. Valid values range from 5 to 10000.
    */
    'maxActionNameLength': number;
    /**
    * Maximum number of errors to be captured per page. Valid values range from 0 to 50.
    */
    'maxErrorsToCapture': number;
    'additionalEventHandlers': AdditionalEventHandlers;
    'eventWrapperSettings': EventWrapperSettings;
    'globalEventCaptureSettings': GlobalEventCaptureSettings;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "syncBeaconFirefox",
            "baseName": "syncBeaconFirefox",
            "type": "boolean"
        },
        {
            "name": "syncBeaconInternetExplorer",
            "baseName": "syncBeaconInternetExplorer",
            "type": "boolean"
        },
        {
            "name": "instrumentUnsupportedAjaxFrameworks",
            "baseName": "instrumentUnsupportedAjaxFrameworks",
            "type": "boolean"
        },
        {
            "name": "specialCharactersToEscape",
            "baseName": "specialCharactersToEscape",
            "type": "string"
        },
        {
            "name": "maxActionNameLength",
            "baseName": "maxActionNameLength",
            "type": "number"
        },
        {
            "name": "maxErrorsToCapture",
            "baseName": "maxErrorsToCapture",
            "type": "number"
        },
        {
            "name": "additionalEventHandlers",
            "baseName": "additionalEventHandlers",
            "type": "AdditionalEventHandlers"
        },
        {
            "name": "eventWrapperSettings",
            "baseName": "eventWrapperSettings",
            "type": "EventWrapperSettings"
        },
        {
            "name": "globalEventCaptureSettings",
            "baseName": "globalEventCaptureSettings",
            "type": "GlobalEventCaptureSettings"
        }    ];

    static getAttributeTypeMap() {
        return AdvancedJavaScriptTagSettings.attributeTypeMap;
    }
}

