/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* Configuration of a matching filter.
*/
export class AlertingCustomTextFilter {
    /**
    * The filter is enabled (`true`) or disabled (`false`).
    */
    'enabled': boolean;
    /**
    * The value to compare to.
    */
    'value': string;
    /**
    * Operator of the comparison.    You can reverse it by setting **negate** to `true`.
    */
    'operator': AlertingCustomTextFilter.OperatorEnum;
    /**
    * Reverses the comparison **operator**. For example it turns the **begins with** into **does not begin with**.
    */
    'negate': boolean;
    /**
    * The condition is case sensitive (`false`) or case insensitive (`true`).    If not set, then `false` is used, making the condition case sensitive.
    */
    'caseInsensitive': boolean;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "enabled",
            "baseName": "enabled",
            "type": "boolean"
        },
        {
            "name": "value",
            "baseName": "value",
            "type": "string"
        },
        {
            "name": "operator",
            "baseName": "operator",
            "type": "AlertingCustomTextFilter.OperatorEnum"
        },
        {
            "name": "negate",
            "baseName": "negate",
            "type": "boolean"
        },
        {
            "name": "caseInsensitive",
            "baseName": "caseInsensitive",
            "type": "boolean"
        }    ];

    static getAttributeTypeMap() {
        return AlertingCustomTextFilter.attributeTypeMap;
    }
}

export namespace AlertingCustomTextFilter {
    export enum OperatorEnum {
        BEGINSWITH = <any> 'BEGINS_WITH',
        CONTAINS = <any> 'CONTAINS',
        CONTAINSREGEX = <any> 'CONTAINS_REGEX',
        ENDSWITH = <any> 'ENDS_WITH',
        EQUALS = <any> 'EQUALS'
    }
}
