/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { AlertingCustomEventFilter } from './alertingCustomEventFilter';
import { AlertingPredefinedEventFilter } from './alertingPredefinedEventFilter';

/**
* Configuration of the event filter for the alerting profile.   You have two mutually exclusive options:  * Select an event type from the list of the predefined events. Specify it in the **predefinedEventFilter** field.  * Set a rule for custom events. Specify it in the **customEventFilter** field.
*/
export class AlertingEventTypeFilter {
    'predefinedEventFilter'?: AlertingPredefinedEventFilter;
    'customEventFilter'?: AlertingCustomEventFilter;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "predefinedEventFilter",
            "baseName": "predefinedEventFilter",
            "type": "AlertingPredefinedEventFilter"
        },
        {
            "name": "customEventFilter",
            "baseName": "customEventFilter",
            "type": "AlertingCustomEventFilter"
        }    ];

    static getAttributeTypeMap() {
        return AlertingEventTypeFilter.attributeTypeMap;
    }
}

