/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* Configuration of a predefined event filter.
*/
export class AlertingPredefinedEventFilter {
    /**
    * The type of the predefined event.
    */
    'eventType': AlertingPredefinedEventFilter.EventTypeEnum;
    /**
    * The alert triggers when the problem of specified severity arises while the specified event **is** happening (`false`) or while the specified event is **not** happening (`true`).    For example, if you chose the Slowdown (`PERFORMANCE`) severity and Unexpected high traffic (`APPLICATION_UNEXPECTED_HIGH_LOAD`) event with **negate** set to `true`, the alerting profile will trigger only when the slowdown problem is raised while there is no unexpected high traffic event.   Consider the following use case as an example. The Slowdown (`PERFORMANCE`) severity rule is set. Depending on the configuration of the event filter (Unexpected high traffic (`APPLICATION_UNEXPECTED_HIGH_LOAD`) event is used as an example), the behavior of the alerting profile is one of the following:* **negate** is set to `false`: The alert triggers when the slowdown problem is raised while unexpected high traffic event is happening.  * **negate** is set to `true`: The alert triggers when the slowdown problem is raised while there is no unexpected high traffic event.   * no event rule is set: The alert triggers when the slowdown problem is raised, regardless of any events.
    */
    'negate': boolean;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "eventType",
            "baseName": "eventType",
            "type": "AlertingPredefinedEventFilter.EventTypeEnum"
        },
        {
            "name": "negate",
            "baseName": "negate",
            "type": "boolean"
        }    ];

    static getAttributeTypeMap() {
        return AlertingPredefinedEventFilter.attributeTypeMap;
    }
}

export namespace AlertingPredefinedEventFilter {
    export enum EventTypeEnum {
        APPLICATIONERRORRATEINCREASED = <any> 'APPLICATION_ERROR_RATE_INCREASED',
        APPLICATIONSLOWDOWN = <any> 'APPLICATION_SLOWDOWN',
        APPLICATIONUNEXPECTEDHIGHLOAD = <any> 'APPLICATION_UNEXPECTED_HIGH_LOAD',
        APPLICATIONUNEXPECTEDLOWLOAD = <any> 'APPLICATION_UNEXPECTED_LOW_LOAD',
        AWSLAMBDAHIGHERRORRATE = <any> 'AWS_LAMBDA_HIGH_ERROR_RATE',
        CUSTOMAPPLICATIONERRORRATEINCREASED = <any> 'CUSTOM_APPLICATION_ERROR_RATE_INCREASED',
        CUSTOMAPPLICATIONSLOWDOWN = <any> 'CUSTOM_APPLICATION_SLOWDOWN',
        CUSTOMAPPLICATIONUNEXPECTEDHIGHLOAD = <any> 'CUSTOM_APPLICATION_UNEXPECTED_HIGH_LOAD',
        CUSTOMAPPLICATIONUNEXPECTEDLOWLOAD = <any> 'CUSTOM_APPLICATION_UNEXPECTED_LOW_LOAD',
        CUSTOMAPPCRASHRATEINCREASED = <any> 'CUSTOM_APP_CRASH_RATE_INCREASED',
        DATABASECONNECTIONFAILURE = <any> 'DATABASE_CONNECTION_FAILURE',
        DATACENTERSERVICEPERFORMANCEDEGRADATION = <any> 'DATA_CENTER_SERVICE_PERFORMANCE_DEGRADATION',
        DATACENTERSERVICEUNAVAILABLE = <any> 'DATA_CENTER_SERVICE_UNAVAILABLE',
        EBSVOLUMEHIGHLATENCY = <any> 'EBS_VOLUME_HIGH_LATENCY',
        EC2HIGHCPU = <any> 'EC2_HIGH_CPU',
        ELBHIGHBACKENDERRORRATE = <any> 'ELB_HIGH_BACKEND_ERROR_RATE',
        ENTERPRICEAPPLICATIONPERFORMANCEDEGRADATION = <any> 'ENTERPRICE_APPLICATION_PERFORMANCE_DEGRADATION',
        ENTERPRISEAPPLICATIONUNAVAILABLE = <any> 'ENTERPRISE_APPLICATION_UNAVAILABLE',
        ESXIGUESTACTIVESWAPWAIT = <any> 'ESXI_GUEST_ACTIVE_SWAP_WAIT',
        ESXIGUESTCPULIMITREACHED = <any> 'ESXI_GUEST_CPU_LIMIT_REACHED',
        ESXIHOSTCPUSATURATION = <any> 'ESXI_HOST_CPU_SATURATION',
        ESXIHOSTDATASTORELOWDISKSPACE = <any> 'ESXI_HOST_DATASTORE_LOW_DISK_SPACE',
        ESXIHOSTDISKQUEUESLOW = <any> 'ESXI_HOST_DISK_QUEUE_SLOW',
        ESXIHOSTDISKSLOW = <any> 'ESXI_HOST_DISK_SLOW',
        ESXIHOSTMEMORYSATURATION = <any> 'ESXI_HOST_MEMORY_SATURATION',
        ESXIHOSTNETWORKPROBLEMS = <any> 'ESXI_HOST_NETWORK_PROBLEMS',
        ESXIHOSTOVERLOADEDSTORAGE = <any> 'ESXI_HOST_OVERLOADED_STORAGE',
        ESXIVMIMPACTHOSTCPUSATURATION = <any> 'ESXI_VM_IMPACT_HOST_CPU_SATURATION',
        ESXIVMIMPACTHOSTMEMORYSATURATION = <any> 'ESXI_VM_IMPACT_HOST_MEMORY_SATURATION',
        EXTERNALSYNTHETICTESTOUTAGE = <any> 'EXTERNAL_SYNTHETIC_TEST_OUTAGE',
        EXTERNALSYNTHETICTESTSLOWDOWN = <any> 'EXTERNAL_SYNTHETIC_TEST_SLOWDOWN',
        HOSTOFSERVICEUNAVAILABLE = <any> 'HOST_OF_SERVICE_UNAVAILABLE',
        HTTPCHECKGLOBALOUTAGE = <any> 'HTTP_CHECK_GLOBAL_OUTAGE',
        HTTPCHECKLOCALOUTAGE = <any> 'HTTP_CHECK_LOCAL_OUTAGE',
        HTTPCHECKTESTLOCATIONSLOWDOWN = <any> 'HTTP_CHECK_TEST_LOCATION_SLOWDOWN',
        MOBILEAPPLICATIONERRORRATEINCREASED = <any> 'MOBILE_APPLICATION_ERROR_RATE_INCREASED',
        MOBILEAPPLICATIONSLOWDOWN = <any> 'MOBILE_APPLICATION_SLOWDOWN',
        MOBILEAPPLICATIONUNEXPECTEDHIGHLOAD = <any> 'MOBILE_APPLICATION_UNEXPECTED_HIGH_LOAD',
        MOBILEAPPLICATIONUNEXPECTEDLOWLOAD = <any> 'MOBILE_APPLICATION_UNEXPECTED_LOW_LOAD',
        MOBILEAPPCRASHRATEINCREASED = <any> 'MOBILE_APP_CRASH_RATE_INCREASED',
        MONITORINGUNAVAILABLE = <any> 'MONITORING_UNAVAILABLE',
        OSIDISKLOWINODES = <any> 'OSI_DISK_LOW_INODES',
        OSIGRACEFULLYSHUTDOWN = <any> 'OSI_GRACEFULLY_SHUTDOWN',
        OSIHIGHCPU = <any> 'OSI_HIGH_CPU',
        OSIHIGHMEMORY = <any> 'OSI_HIGH_MEMORY',
        OSILOWDISKSPACE = <any> 'OSI_LOW_DISK_SPACE',
        OSINICDROPPEDPACKETSHIGH = <any> 'OSI_NIC_DROPPED_PACKETS_HIGH',
        OSINICERRORSHIGH = <any> 'OSI_NIC_ERRORS_HIGH',
        OSINICUTILIZATIONHIGH = <any> 'OSI_NIC_UTILIZATION_HIGH',
        OSISLOWDISK = <any> 'OSI_SLOW_DISK',
        OSIUNEXPECTEDLYUNAVAILABLE = <any> 'OSI_UNEXPECTEDLY_UNAVAILABLE',
        PGIOFSERVICEUNAVAILABLE = <any> 'PGI_OF_SERVICE_UNAVAILABLE',
        PGIUNAVAILABLE = <any> 'PGI_UNAVAILABLE',
        PGLOWINSTANCECOUNT = <any> 'PG_LOW_INSTANCE_COUNT',
        PROCESSCRASHED = <any> 'PROCESS_CRASHED',
        PROCESSHIGHGCACTIVITY = <any> 'PROCESS_HIGH_GC_ACTIVITY',
        PROCESSMEMORYRESOURCEEXHAUSTED = <any> 'PROCESS_MEMORY_RESOURCE_EXHAUSTED',
        PROCESSNAHIGHCONNFAILRATE = <any> 'PROCESS_NA_HIGH_CONN_FAIL_RATE',
        PROCESSNAHIGHLOSSRATE = <any> 'PROCESS_NA_HIGH_LOSS_RATE',
        PROCESSTHREADSRESOURCEEXHAUSTED = <any> 'PROCESS_THREADS_RESOURCE_EXHAUSTED',
        RDSHIGHCPU = <any> 'RDS_HIGH_CPU',
        RDSHIGHLATENCY = <any> 'RDS_HIGH_LATENCY',
        RDSLOWMEMORY = <any> 'RDS_LOW_MEMORY',
        RDSLOWSTORAGESPACE = <any> 'RDS_LOW_STORAGE_SPACE',
        RDSOFSERVICEUNAVAILABLE = <any> 'RDS_OF_SERVICE_UNAVAILABLE',
        RDSRESTARTSEQUENCE = <any> 'RDS_RESTART_SEQUENCE',
        SERVICEERRORRATEINCREASED = <any> 'SERVICE_ERROR_RATE_INCREASED',
        SERVICESLOWDOWN = <any> 'SERVICE_SLOWDOWN',
        SERVICEUNEXPECTEDHIGHLOAD = <any> 'SERVICE_UNEXPECTED_HIGH_LOAD',
        SERVICEUNEXPECTEDLOWLOAD = <any> 'SERVICE_UNEXPECTED_LOW_LOAD',
        SYNTHETICGLOBALOUTAGE = <any> 'SYNTHETIC_GLOBAL_OUTAGE',
        SYNTHETICLOCALOUTAGE = <any> 'SYNTHETIC_LOCAL_OUTAGE',
        SYNTHETICTESTLOCATIONSLOWDOWN = <any> 'SYNTHETIC_TEST_LOCATION_SLOWDOWN'
    }
}
