/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { AlertingEventTypeFilter } from './alertingEventTypeFilter';
import { AlertingProfileSeverityRule } from './alertingProfileSeverityRule';
import { ConfigurationMetadata } from './configurationMetadata';

/**
* Configuration of an alerting profile.
*/
export class AlertingProfile {
    'metadata'?: ConfigurationMetadata;
    /**
    * The ID of the alerting profile.
    */
    'id'?: string;
    /**
    * The name of the alerting profile, displayed in the UI.
    */
    'displayName': string;
    /**
    * A list of severity rules.    The rules are evaluated from top to bottom. The first matching rule applies and further evaluation stops.   If you specify both severity rule and event filter, the AND logic applies.
    */
    'rules'?: Array<AlertingProfileSeverityRule>;
    /**
    * The ID of the management zone to which the alerting profile applies.
    */
    'mzId'?: string;
    /**
    * The list of event filters.   For all filters that are *negated* inside of these event filters, that is all \"Predefined\" as well as \"Custom\" (Title and/or Description) ones the AND logic applies. For all *non-negated* ones the OR logic applies. Between these two groups, negated and non-negated, the AND logic applies.   If you specify both severity rule and event filter, the AND logic applies.
    */
    'eventTypeFilters'?: Array<AlertingEventTypeFilter>;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "metadata",
            "baseName": "metadata",
            "type": "ConfigurationMetadata"
        },
        {
            "name": "id",
            "baseName": "id",
            "type": "string"
        },
        {
            "name": "displayName",
            "baseName": "displayName",
            "type": "string"
        },
        {
            "name": "rules",
            "baseName": "rules",
            "type": "Array<AlertingProfileSeverityRule>"
        },
        {
            "name": "mzId",
            "baseName": "mzId",
            "type": "string"
        },
        {
            "name": "eventTypeFilters",
            "baseName": "eventTypeFilters",
            "type": "Array<AlertingEventTypeFilter>"
        }    ];

    static getAttributeTypeMap() {
        return AlertingProfile.attributeTypeMap;
    }
}

