/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { AlertingProfileTagFilter } from './alertingProfileTagFilter';

/**
* A severity rule of the alerting profile.    A severity rule defines the level of severity that must be met before an alert is sent our for a detected problem. Additionally it restricts the alerting to certain monitored entities.
*/
export class AlertingProfileSeverityRule {
    /**
    * The severity level to trigger the alert.
    */
    'severityLevel': AlertingProfileSeverityRule.SeverityLevelEnum;
    'tagFilter': AlertingProfileTagFilter;
    /**
    * Send a notification if a problem remains open longer than *X* minutes.
    */
    'delayInMinutes': number;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "severityLevel",
            "baseName": "severityLevel",
            "type": "AlertingProfileSeverityRule.SeverityLevelEnum"
        },
        {
            "name": "tagFilter",
            "baseName": "tagFilter",
            "type": "AlertingProfileTagFilter"
        },
        {
            "name": "delayInMinutes",
            "baseName": "delayInMinutes",
            "type": "number"
        }    ];

    static getAttributeTypeMap() {
        return AlertingProfileSeverityRule.attributeTypeMap;
    }
}

export namespace AlertingProfileSeverityRule {
    export enum SeverityLevelEnum {
        AVAILABILITY = <any> 'AVAILABILITY',
        CUSTOMALERT = <any> 'CUSTOM_ALERT',
        ERROR = <any> 'ERROR',
        MONITORINGUNAVAILABLE = <any> 'MONITORING_UNAVAILABLE',
        PERFORMANCE = <any> 'PERFORMANCE',
        RESOURCECONTENTION = <any> 'RESOURCE_CONTENTION'
    }
}
