/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { TagFilter } from './tagFilter';

/**
* Configuration of the tag filtering of the alerting profile.
*/
export class AlertingProfileTagFilter {
    /**
    * The filtering mode:  * `INCLUDE_ANY`: The rule applies to monitored entities that have at least one of the specified tags. You can specify up to 100 tags.  * `INCLUDE_ALL`: The rule applies to monitored entities that have **all** of the specified tags. You can specify up to 10 tags.  * `NONE`: The rule applies to all monitored entities.
    */
    'includeMode': AlertingProfileTagFilter.IncludeModeEnum;
    /**
    * A list of required tags.
    */
    'tagFilters'?: Array<TagFilter>;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "includeMode",
            "baseName": "includeMode",
            "type": "AlertingProfileTagFilter.IncludeModeEnum"
        },
        {
            "name": "tagFilters",
            "baseName": "tagFilters",
            "type": "Array<TagFilter>"
        }    ];

    static getAttributeTypeMap() {
        return AlertingProfileTagFilter.attributeTypeMap;
    }
}

export namespace AlertingProfileTagFilter {
    export enum IncludeModeEnum {
        INCLUDEALL = <any> 'INCLUDE_ALL',
        INCLUDEANY = <any> 'INCLUDE_ANY',
        NONE = <any> 'NONE'
    }
}
