/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

export class AnsibleTowerNotificationConfigAllOf {
    /**
    * The URL of the target Ansible Tower job template.
    */
    'jobTemplateURL'?: string;
    /**
    * Accept any, including self-signed and invalid, SSL certificate (`true`) or only trusted (`false`) certificates.
    */
    'acceptAnyCertificate'?: boolean;
    /**
    * The username of the Ansible Tower account.
    */
    'username'?: string;
    /**
    * The password for the Ansible Tower account.
    */
    'password'?: string;
    /**
    * The ID of the target Ansible Tower job template.
    */
    'jobTemplateID'?: number;
    /**
    * The custom message of the notification.    This message will be displayed in the extra variables **Message** field of your job template.   You can use the following placeholders:  * `{ImpactedEntities}`: Details about the entities impacted by the problem in form of a JSON array.  * `{ImpactedEntity}`: The entity impacted by the problem or *X* impacted entities.  * `{PID}`: The ID of the reported problem.  * `{ProblemDetailsText}`: All problem event details, including root cause, as a text-formatted string.  * `{ProblemID}`: The display number of the reported problem.  * `{ProblemImpact}`: The [impact level](https://www.dynatrace.com/support/help/shortlink/impact-analysis) of the problem. Possible values are `APPLICATION`, `SERVICE`, and `INFRASTRUCTURE`.  * `{ProblemSeverity}`: The [severity level](https://www.dynatrace.com/support/help/shortlink/event-types) of the problem. Possible values are `AVAILABILITY`, `ERROR`, `PERFORMANCE`, `RESOURCE_CONTENTION`, and `CUSTOM_ALERT`.  * `{ProblemTitle}`: A short description of the problem.  * `{ProblemURL}`: The URL of the problem within Dynatrace.  * `{State}`: The state of the problem. Possible values are `OPEN` and `RESOLVED`. If the problem has been merged into another problem, it has the `MERGED` value.  * `{Tags}`: The list of tags that are defined for all impacted entities, separated by commas.  
    */
    'customMessage'?: string;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "jobTemplateURL",
            "baseName": "jobTemplateURL",
            "type": "string"
        },
        {
            "name": "acceptAnyCertificate",
            "baseName": "acceptAnyCertificate",
            "type": "boolean"
        },
        {
            "name": "username",
            "baseName": "username",
            "type": "string"
        },
        {
            "name": "password",
            "baseName": "password",
            "type": "string"
        },
        {
            "name": "jobTemplateID",
            "baseName": "jobTemplateID",
            "type": "number"
        },
        {
            "name": "customMessage",
            "baseName": "customMessage",
            "type": "string"
        }    ];

    static getAttributeTypeMap() {
        return AnsibleTowerNotificationConfigAllOf.attributeTypeMap;
    }
}

