/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* Defines the Apdex settings of an application.
*/
export class Apdex {
    /**
    * Maximal length of an action, in milliseconds, which is considered as satisfied user experience.    You can use values between 100 and 60000.
    */
    'toleratedThreshold'?: number;
    /**
    * Maximal length of an action, in milliseconds, which is considered as tolerable user experience.    You can use values between 100 and 240000.
    */
    'frustratingThreshold'?: number;
    /**
    * Fallback threshold of an XHR action, in milliseconds, defining a satisfied user experience, when the configured KPM is not available.    Values between 100 and 60000 are allowed.
    */
    'toleratedFallbackThreshold'?: number;
    /**
    * Fallback threshold of an XHR action, in milliseconds, defining a tolerable user experience, when the configured KPM is not available.    Values between 100 and 240000 are allowed.
    */
    'frustratingFallbackThreshold'?: number;
    /**
    * Consider JavaScript errors in Apdex calculations enabled/disabled
    */
    'considerJavaScriptErrors': boolean;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "toleratedThreshold",
            "baseName": "toleratedThreshold",
            "type": "number"
        },
        {
            "name": "frustratingThreshold",
            "baseName": "frustratingThreshold",
            "type": "number"
        },
        {
            "name": "toleratedFallbackThreshold",
            "baseName": "toleratedFallbackThreshold",
            "type": "number"
        },
        {
            "name": "frustratingFallbackThreshold",
            "baseName": "frustratingFallbackThreshold",
            "type": "number"
        },
        {
            "name": "considerJavaScriptErrors",
            "baseName": "considerJavaScriptErrors",
            "type": "boolean"
        }    ];

    static getAttributeTypeMap() {
        return Apdex.attributeTypeMap;
    }
}

