/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* The appId, the app version and the bundle id which uniquely identify the app
*/
export class AppIdentifier {
    /**
    * The id where the file belongs to
    */
    'id'?: string;
    /**
    * The version code (Android) / bundle version (iOS) the file belongs to
    */
    'versionCode': string;
    /**
    * The version name (Android) / bundle versions string (iOS) the file belongs to
    */
    'versionName': string;
    /**
    * The bundleId (iOS) or package name (Android) the file belongs to
    */
    'packageName'?: string;
    /**
    * The operating system where the file belongs to
    */
    'os'?: AppIdentifier.OsEnum;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "id",
            "baseName": "id",
            "type": "string"
        },
        {
            "name": "versionCode",
            "baseName": "versionCode",
            "type": "string"
        },
        {
            "name": "versionName",
            "baseName": "versionName",
            "type": "string"
        },
        {
            "name": "packageName",
            "baseName": "packageName",
            "type": "string"
        },
        {
            "name": "os",
            "baseName": "os",
            "type": "AppIdentifier.OsEnum"
        }    ];

    static getAttributeTypeMap() {
        return AppIdentifier.attributeTypeMap;
    }
}

export namespace AppIdentifier {
    export enum OsEnum {
        ANDROID = <any> 'ANDROID',
        IOS = <any> 'IOS',
        TVOS = <any> 'TVOS'
    }
}
