/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { ConfigurationMetadata } from './configurationMetadata';
import { FailureRateIncreaseDetectionConfig } from './failureRateIncreaseDetectionConfig';
import { ResponseTimeDegradationDetectionConfig } from './responseTimeDegradationDetectionConfig';
import { TrafficDropDetectionConfig } from './trafficDropDetectionConfig';
import { TrafficSpikeDetectionConfig } from './trafficSpikeDetectionConfig';

/**
* The configuration of anomaly detection for applications.
*/
export class ApplicationAnomalyDetectionConfig {
    'metadata'?: ConfigurationMetadata;
    'responseTimeDegradation': ResponseTimeDegradationDetectionConfig;
    'trafficDrop': TrafficDropDetectionConfig;
    'trafficSpike': TrafficSpikeDetectionConfig;
    'failureRateIncrease': FailureRateIncreaseDetectionConfig;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "metadata",
            "baseName": "metadata",
            "type": "ConfigurationMetadata"
        },
        {
            "name": "responseTimeDegradation",
            "baseName": "responseTimeDegradation",
            "type": "ResponseTimeDegradationDetectionConfig"
        },
        {
            "name": "trafficDrop",
            "baseName": "trafficDrop",
            "type": "TrafficDropDetectionConfig"
        },
        {
            "name": "trafficSpike",
            "baseName": "trafficSpike",
            "type": "TrafficSpikeDetectionConfig"
        },
        {
            "name": "failureRateIncrease",
            "baseName": "failureRateIncrease",
            "type": "FailureRateIncreaseDetectionConfig"
        }    ];

    static getAttributeTypeMap() {
        return ApplicationAnomalyDetectionConfig.attributeTypeMap;
    }
}

