/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { ConfigurationMetadata } from './configurationMetadata';
import { SessionReplaySettingWithDataPrivacy } from './sessionReplaySettingWithDataPrivacy';

/**
* Data privacy settings of the application.
*/
export class ApplicationDataPrivacy {
    'metadata'?: ConfigurationMetadata;
    /**
    * Dynatrace entity ID of the web application.
    */
    'identifier'?: string;
    /**
    * Set to `true` to disable data capture and cookies until JavaScriptAPI dtrum.enable() is called.
    */
    'dataCaptureOptInEnabled': boolean;
    /**
    * Set to `true` to set persistent cookie in order to recognize returning devices.
    */
    'persistentCookieForUserTracking': boolean;
    /**
    * How to handle browsers\' \"Do Not Track\": `IGNORE_DO_NOT_TRACK`, or `CAPTURE_ANONYMIZED`, or `DO_NOT_CAPTURE`.
    */
    'doNotTrackBehaviour': ApplicationDataPrivacy.DoNotTrackBehaviourEnum;
    'sessionReplayConfig'?: SessionReplaySettingWithDataPrivacy;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "metadata",
            "baseName": "metadata",
            "type": "ConfigurationMetadata"
        },
        {
            "name": "identifier",
            "baseName": "identifier",
            "type": "string"
        },
        {
            "name": "dataCaptureOptInEnabled",
            "baseName": "dataCaptureOptInEnabled",
            "type": "boolean"
        },
        {
            "name": "persistentCookieForUserTracking",
            "baseName": "persistentCookieForUserTracking",
            "type": "boolean"
        },
        {
            "name": "doNotTrackBehaviour",
            "baseName": "doNotTrackBehaviour",
            "type": "ApplicationDataPrivacy.DoNotTrackBehaviourEnum"
        },
        {
            "name": "sessionReplayConfig",
            "baseName": "sessionReplayConfig",
            "type": "SessionReplaySettingWithDataPrivacy"
        }    ];

    static getAttributeTypeMap() {
        return ApplicationDataPrivacy.attributeTypeMap;
    }
}

export namespace ApplicationDataPrivacy {
    export enum DoNotTrackBehaviourEnum {
        CAPTUREANONYMIZED = <any> 'CAPTURE_ANONYMIZED',
        DONOTCAPTURE = <any> 'DO_NOT_CAPTURE',
        IGNOREDONOTTRACK = <any> 'IGNORE_DO_NOT_TRACK'
    }
}
