/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { ApplicationFilter } from './applicationFilter';
import { ConfigurationMetadataDtoImpl } from './configurationMetadataDtoImpl';

/**
* Application detection rule.
*/
export class ApplicationDetectionRuleConfig {
    'metadata'?: ConfigurationMetadataDtoImpl;
    /**
    * The ID of the rule.
    */
    'id'?: string;
    /**
    * The order of the rule in the rules list.   The rules are evaluated from top to bottom. The first matching rule applies.
    */
    'order'?: string;
    /**
    * The Dynatrace entity ID of the application, for example `APPLICATION-4A3B43`.    You must use an existing ID. If you need to create a rule for an application that doesn\'t exist yet, [create an application first](https://www.dynatrace.com/support/help/shortlink/api-config-web-app-post-web-app) and then configure detection rules for it.
    */
    'applicationIdentifier': string;
    'filterConfig': ApplicationFilter;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "metadata",
            "baseName": "metadata",
            "type": "ConfigurationMetadataDtoImpl"
        },
        {
            "name": "id",
            "baseName": "id",
            "type": "string"
        },
        {
            "name": "order",
            "baseName": "order",
            "type": "string"
        },
        {
            "name": "applicationIdentifier",
            "baseName": "applicationIdentifier",
            "type": "string"
        },
        {
            "name": "filterConfig",
            "baseName": "filterConfig",
            "type": "ApplicationFilter"
        }    ];

    static getAttributeTypeMap() {
        return ApplicationDetectionRuleConfig.attributeTypeMap;
    }
}

