/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* The condition of an application detection rule.
*/
export class ApplicationFilter {
    /**
    * The value to look for.
    */
    'pattern': string;
    /**
    * The operator of the matching.
    */
    'applicationMatchType': ApplicationFilter.ApplicationMatchTypeEnum;
    /**
    * Where to look for the the **pattern** value.
    */
    'applicationMatchTarget': ApplicationFilter.ApplicationMatchTargetEnum;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "pattern",
            "baseName": "pattern",
            "type": "string"
        },
        {
            "name": "applicationMatchType",
            "baseName": "applicationMatchType",
            "type": "ApplicationFilter.ApplicationMatchTypeEnum"
        },
        {
            "name": "applicationMatchTarget",
            "baseName": "applicationMatchTarget",
            "type": "ApplicationFilter.ApplicationMatchTargetEnum"
        }    ];

    static getAttributeTypeMap() {
        return ApplicationFilter.attributeTypeMap;
    }
}

export namespace ApplicationFilter {
    export enum ApplicationMatchTypeEnum {
        BEGINSWITH = <any> 'BEGINS_WITH',
        CONTAINS = <any> 'CONTAINS',
        ENDSWITH = <any> 'ENDS_WITH',
        EQUALS = <any> 'EQUALS',
        MATCHES = <any> 'MATCHES'
    }
    export enum ApplicationMatchTargetEnum {
        DOMAIN = <any> 'DOMAIN',
        URL = <any> 'URL'
    }
}
