/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { ApplicationTypeComparisonAllOf } from './applicationTypeComparisonAllOf';
import { ComparisonBasic } from './comparisonBasic';

/**
* Comparison for `APPLICATION_TYPE` attributes.
*/
export class ApplicationTypeComparison extends ComparisonBasic {
    /**
    * Operator of the comparison. You can reverse it by setting **negate** to `true`.   Possible values depend on the **type** of the comparison. Find the list of actual models in the description of the **type** field and check the description of the model you need.
    */
    'operator': ApplicationTypeComparison.OperatorEnum;
    /**
    * The value to compare to.
    */
    'value'?: ApplicationTypeComparison.ValueEnum;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "operator",
            "baseName": "operator",
            "type": "ApplicationTypeComparison.OperatorEnum"
        },
        {
            "name": "value",
            "baseName": "value",
            "type": "ApplicationTypeComparison.ValueEnum"
        }    ];

    static getAttributeTypeMap() {
        return super.getAttributeTypeMap().concat(ApplicationTypeComparison.attributeTypeMap);
    }
}

export namespace ApplicationTypeComparison {
    export enum OperatorEnum {
        EQUALS = <any> 'EQUALS',
        EXISTS = <any> 'EXISTS'
    }
    export enum ValueEnum {
        AGENTLESSMONITORING = <any> 'AGENTLESS_MONITORING',
        AMP = <any> 'AMP',
        AUTOINJECTED = <any> 'AUTO_INJECTED',
        DEFAULT = <any> 'DEFAULT',
        SAASVENDOR = <any> 'SAAS_VENDOR'
    }
}
