/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { AssignedEntitiesWithMetricTileAllOf } from './assignedEntitiesWithMetricTileAllOf';
import { Tile } from './tile';
import { TileBounds } from './tileBounds';
import { TileFilter } from './tileFilter';

/**
* Configuration of a tile with an assigned Dynatrace entity and an assigned metric.   An example is the Worldmap tile, showing the data from an assigned performance or behavior metric of an assigned application.
*/
export class AssignedEntitiesWithMetricTile extends Tile {
    /**
    * The list of Dynatrace entities, assigned to the tile.
    */
    'assignedEntities': Array<string>;
    /**
    * The metric assigned to the tile.
    */
    'metric'?: string;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "assignedEntities",
            "baseName": "assignedEntities",
            "type": "Array<string>"
        },
        {
            "name": "metric",
            "baseName": "metric",
            "type": "string"
        }    ];

    static getAttributeTypeMap() {
        return super.getAttributeTypeMap().concat(AssignedEntitiesWithMetricTile.attributeTypeMap);
    }
}

export namespace AssignedEntitiesWithMetricTile {
}
