/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { AutoTagRule } from './autoTagRule';
import { ConfigurationMetadata } from './configurationMetadata';

/**
* Configuration of an auto-tag. It defines the conditions of tag usage and the tag value.
*/
export class AutoTag {
    'metadata'?: ConfigurationMetadata;
    /**
    * The ID of the auto-tag.
    */
    'id'?: string;
    /**
    * The name of the auto-tag, which is applied to entities.   Additionally you can specify a **valueFormat** in the tag rule. In that case the tag is used in the `name:valueFormat` format.   For example you can extend the `Infrastructure` tag to `Infrastructure:Windows` and `Infrastructure:Linux`.
    */
    'name': string;
    /**
    * The list of rules for tag usage.   When there are multiple rules, the OR logic applies.
    */
    'rules'?: Array<AutoTagRule>;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "metadata",
            "baseName": "metadata",
            "type": "ConfigurationMetadata"
        },
        {
            "name": "id",
            "baseName": "id",
            "type": "string"
        },
        {
            "name": "name",
            "baseName": "name",
            "type": "string"
        },
        {
            "name": "rules",
            "baseName": "rules",
            "type": "Array<AutoTagRule>"
        }    ];

    static getAttributeTypeMap() {
        return AutoTag.attributeTypeMap;
    }
}

