/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* Configuration of the availability monitoring for the process group.
*/
export class AvailabilityMonitoringPG {
    /**
    * How to monitor the availability of the process group:   * `PROCESS_IMPACT`: Alert if any process of the group becomes unavailable.  * `MINIMUM_THRESHOLD`: Alert if the number of active processes in the group falls below the specified threshold.  * `OFF`: Availability monitoring is disabled.
    */
    'method': AvailabilityMonitoringPG.MethodEnum;
    /**
    * Alert if the number of active processes in the group is lower than this value.
    */
    'minimumThreshold'?: number;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "method",
            "baseName": "method",
            "type": "AvailabilityMonitoringPG.MethodEnum"
        },
        {
            "name": "minimumThreshold",
            "baseName": "minimumThreshold",
            "type": "number"
        }    ];

    static getAttributeTypeMap() {
        return AvailabilityMonitoringPG.attributeTypeMap;
    }
}

export namespace AvailabilityMonitoringPG {
    export enum MethodEnum {
        MINIMUMTHRESHOLD = <any> 'MINIMUM_THRESHOLD',
        OFF = <any> 'OFF',
        PROCESSIMPACT = <any> 'PROCESS_IMPACT'
    }
}
