/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { ConfigurationMetadata } from './configurationMetadata';
import { Ec2CandidateCpuSaturationDetectionConfig } from './ec2CandidateCpuSaturationDetectionConfig';
import { ElbHighConnectionErrorsDetectionConfig } from './elbHighConnectionErrorsDetectionConfig';
import { LambdaHighErrorRateDetectionConfig } from './lambdaHighErrorRateDetectionConfig';
import { RdsHighCpuDetectionConfig } from './rdsHighCpuDetectionConfig';
import { RdsHighMemoryDetectionConfig } from './rdsHighMemoryDetectionConfig';
import { RdsHighWriteReadLatencyDetectionConfig } from './rdsHighWriteReadLatencyDetectionConfig';
import { RdsLowStorageDetectionConfig } from './rdsLowStorageDetectionConfig';
import { RdsRestartsSequenceDetectionConfig } from './rdsRestartsSequenceDetectionConfig';

/**
* The configuration of anomaly detection for AWS.
*/
export class AwsAnomalyDetectionConfig {
    'metadata'?: ConfigurationMetadata;
    'rdsHighCpuDetection': RdsHighCpuDetectionConfig;
    'rdsHighWriteReadLatencyDetection': RdsHighWriteReadLatencyDetectionConfig;
    'rdsLowStorageDetection': RdsLowStorageDetectionConfig;
    'rdsHighMemoryDetection': RdsHighMemoryDetectionConfig;
    'elbHighConnectionErrorsDetection': ElbHighConnectionErrorsDetectionConfig;
    'rdsRestartsSequenceDetection': RdsRestartsSequenceDetectionConfig;
    'lambdaHighErrorRateDetection': LambdaHighErrorRateDetectionConfig;
    'ec2CandidateCpuSaturationDetection'?: Ec2CandidateCpuSaturationDetectionConfig;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "metadata",
            "baseName": "metadata",
            "type": "ConfigurationMetadata"
        },
        {
            "name": "rdsHighCpuDetection",
            "baseName": "rdsHighCpuDetection",
            "type": "RdsHighCpuDetectionConfig"
        },
        {
            "name": "rdsHighWriteReadLatencyDetection",
            "baseName": "rdsHighWriteReadLatencyDetection",
            "type": "RdsHighWriteReadLatencyDetectionConfig"
        },
        {
            "name": "rdsLowStorageDetection",
            "baseName": "rdsLowStorageDetection",
            "type": "RdsLowStorageDetectionConfig"
        },
        {
            "name": "rdsHighMemoryDetection",
            "baseName": "rdsHighMemoryDetection",
            "type": "RdsHighMemoryDetectionConfig"
        },
        {
            "name": "elbHighConnectionErrorsDetection",
            "baseName": "elbHighConnectionErrorsDetection",
            "type": "ElbHighConnectionErrorsDetectionConfig"
        },
        {
            "name": "rdsRestartsSequenceDetection",
            "baseName": "rdsRestartsSequenceDetection",
            "type": "RdsRestartsSequenceDetectionConfig"
        },
        {
            "name": "lambdaHighErrorRateDetection",
            "baseName": "lambdaHighErrorRateDetection",
            "type": "LambdaHighErrorRateDetectionConfig"
        },
        {
            "name": "ec2CandidateCpuSaturationDetection",
            "baseName": "ec2CandidateCpuSaturationDetection",
            "type": "Ec2CandidateCpuSaturationDetectionConfig"
        }    ];

    static getAttributeTypeMap() {
        return AwsAnomalyDetectionConfig.attributeTypeMap;
    }
}

