/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { KeyBasedAuthentication } from './keyBasedAuthentication';
import { RoleBasedAuthentication } from './roleBasedAuthentication';

/**
* A credentials for the AWS authentication.
*/
export class AwsAuthenticationData {
    /**
    * The type of the authentication: role-based or key-based.
    */
    'type': AwsAuthenticationData.TypeEnum;
    'keyBasedAuthentication'?: KeyBasedAuthentication;
    'roleBasedAuthentication'?: RoleBasedAuthentication;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "type",
            "baseName": "type",
            "type": "AwsAuthenticationData.TypeEnum"
        },
        {
            "name": "keyBasedAuthentication",
            "baseName": "keyBasedAuthentication",
            "type": "KeyBasedAuthentication"
        },
        {
            "name": "roleBasedAuthentication",
            "baseName": "roleBasedAuthentication",
            "type": "RoleBasedAuthentication"
        }    ];

    static getAttributeTypeMap() {
        return AwsAuthenticationData.attributeTypeMap;
    }
}

export namespace AwsAuthenticationData {
    export enum TypeEnum {
        KEYS = <any> 'KEYS',
        ROLE = <any> 'ROLE'
    }
}
