/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { AwsAuthenticationData } from './awsAuthenticationData';
import { AwsConfigTag } from './awsConfigTag';
import { AwsSupportingServiceConfig } from './awsSupportingServiceConfig';
import { ConfigurationMetadata } from './configurationMetadata';

/**
* Configuration of an AWS credentials.
*/
export class AwsCredentialsConfig {
    'metadata'?: ConfigurationMetadata;
    /**
    * The unique ID of the credentials.
    */
    'id'?: string;
    /**
    * The status of the connection to the AWS environment.    * `CONNECTED`: There was a connection within last 10 minutes.  * `DISCONNECTED`: A problem occurred with establishing connection using these credentials. Check whether the data is correct.  * `UNINITIALIZED`: The successful connection has never been established for these credentials.
    */
    'connectionStatus'?: AwsCredentialsConfig.ConnectionStatusEnum;
    /**
    * The name of the credentials.
    */
    'label': string;
    /**
    * The type of the AWS partition.
    */
    'partitionType': AwsCredentialsConfig.PartitionTypeEnum;
    'authenticationData': AwsAuthenticationData;
    /**
    * Monitor only resources which have specified AWS tags (`true`) or all resources (`false`).
    */
    'taggedOnly': boolean;
    /**
    * A list of AWS tags to be monitored.   You can specify up to 10 tags.   Only applicable when the **taggedOnly** parameter is set to `true`.
    */
    'tagsToMonitor': Array<AwsConfigTag>;
    /**
    * A list of supporting services to be monitored.
    */
    'supportingServicesToMonitor'?: Array<AwsSupportingServiceConfig>;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "metadata",
            "baseName": "metadata",
            "type": "ConfigurationMetadata"
        },
        {
            "name": "id",
            "baseName": "id",
            "type": "string"
        },
        {
            "name": "connectionStatus",
            "baseName": "connectionStatus",
            "type": "AwsCredentialsConfig.ConnectionStatusEnum"
        },
        {
            "name": "label",
            "baseName": "label",
            "type": "string"
        },
        {
            "name": "partitionType",
            "baseName": "partitionType",
            "type": "AwsCredentialsConfig.PartitionTypeEnum"
        },
        {
            "name": "authenticationData",
            "baseName": "authenticationData",
            "type": "AwsAuthenticationData"
        },
        {
            "name": "taggedOnly",
            "baseName": "taggedOnly",
            "type": "boolean"
        },
        {
            "name": "tagsToMonitor",
            "baseName": "tagsToMonitor",
            "type": "Array<AwsConfigTag>"
        },
        {
            "name": "supportingServicesToMonitor",
            "baseName": "supportingServicesToMonitor",
            "type": "Array<AwsSupportingServiceConfig>"
        }    ];

    static getAttributeTypeMap() {
        return AwsCredentialsConfig.attributeTypeMap;
    }
}

export namespace AwsCredentialsConfig {
    export enum ConnectionStatusEnum {
        CONNECTED = <any> 'CONNECTED',
        DISCONNECTED = <any> 'DISCONNECTED',
        UNINITIALIZED = <any> 'UNINITIALIZED'
    }
    export enum PartitionTypeEnum {
        CN = <any> 'AWS_CN',
        DEFAULT = <any> 'AWS_DEFAULT',
        USGOV = <any> 'AWS_US_GOV'
    }
}
