/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* A metric of supporting service to be monitored.
*/
export class AwsSupportingServiceMetric {
    /**
    * The name of the metric of the supporting service.
    */
    'name': string;
    /**
    * The statistic (aggregation) to be used for the metric. AVG_MIN_MAX value is 3 statistics at once: AVERAGE, MINIMUM and MAXIMUM
    */
    'statistic': AwsSupportingServiceMetric.StatisticEnum;
    /**
    * A list of metric\'s dimensions names.
    */
    'dimensions': Array<string>;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "name",
            "baseName": "name",
            "type": "string"
        },
        {
            "name": "statistic",
            "baseName": "statistic",
            "type": "AwsSupportingServiceMetric.StatisticEnum"
        },
        {
            "name": "dimensions",
            "baseName": "dimensions",
            "type": "Array<string>"
        }    ];

    static getAttributeTypeMap() {
        return AwsSupportingServiceMetric.attributeTypeMap;
    }
}

export namespace AwsSupportingServiceMetric {
    export enum StatisticEnum {
        AVERAGE = <any> 'AVERAGE',
        AVGMINMAX = <any> 'AVG_MIN_MAX',
        MAXIMUM = <any> 'MAXIMUM',
        MINIMUM = <any> 'MINIMUM',
        SAMPLECOUNT = <any> 'SAMPLE_COUNT',
        SUM = <any> 'SUM'
    }
}
