/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* The definition of a calculated service metric.
*/
export class CalculatedMetricDefinition {
    /**
    * The metric to be captured.
    */
    'metric': CalculatedMetricDefinition.MetricEnum;
    /**
    * The request attribute to be captured.    Only applicable when the **metric** parameter is set to `REQUEST_ATTRIBUTE`.
    */
    'requestAttribute'?: string;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "metric",
            "baseName": "metric",
            "type": "CalculatedMetricDefinition.MetricEnum"
        },
        {
            "name": "requestAttribute",
            "baseName": "requestAttribute",
            "type": "string"
        }    ];

    static getAttributeTypeMap() {
        return CalculatedMetricDefinition.attributeTypeMap;
    }
}

export namespace CalculatedMetricDefinition {
    export enum MetricEnum {
        CPUTIME = <any> 'CPU_TIME',
        DATABASECHILDCALLCOUNT = <any> 'DATABASE_CHILD_CALL_COUNT',
        DATABASECHILDCALLTIME = <any> 'DATABASE_CHILD_CALL_TIME',
        EXCEPTIONCOUNT = <any> 'EXCEPTION_COUNT',
        FAILEDREQUESTCOUNT = <any> 'FAILED_REQUEST_COUNT',
        FAILEDREQUESTCOUNTCLIENT = <any> 'FAILED_REQUEST_COUNT_CLIENT',
        FAILURERATE = <any> 'FAILURE_RATE',
        FAILURERATECLIENT = <any> 'FAILURE_RATE_CLIENT',
        HTTP4XXERRORCOUNT = <any> 'HTTP_4XX_ERROR_COUNT',
        HTTP4XXERRORCOUNTCLIENT = <any> 'HTTP_4XX_ERROR_COUNT_CLIENT',
        HTTP5XXERRORCOUNT = <any> 'HTTP_5XX_ERROR_COUNT',
        HTTP5XXERRORCOUNTCLIENT = <any> 'HTTP_5XX_ERROR_COUNT_CLIENT',
        IOTIME = <any> 'IO_TIME',
        LOCKTIME = <any> 'LOCK_TIME',
        NONDATABASECHILDCALLCOUNT = <any> 'NON_DATABASE_CHILD_CALL_COUNT',
        NONDATABASECHILDCALLTIME = <any> 'NON_DATABASE_CHILD_CALL_TIME',
        PROCESSINGTIME = <any> 'PROCESSING_TIME',
        REQUESTATTRIBUTE = <any> 'REQUEST_ATTRIBUTE',
        REQUESTCOUNT = <any> 'REQUEST_COUNT',
        RESPONSETIME = <any> 'RESPONSE_TIME',
        RESPONSETIMECLIENT = <any> 'RESPONSE_TIME_CLIENT',
        SUCCESSFULREQUESTCOUNT = <any> 'SUCCESSFUL_REQUEST_COUNT',
        SUCCESSFULREQUESTCOUNTCLIENT = <any> 'SUCCESSFUL_REQUEST_COUNT_CLIENT',
        WAITTIME = <any> 'WAIT_TIME'
    }
}
