/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { CalculatedMobileMetricDimension } from './calculatedMobileMetricDimension';
import { CalculatedMobileMetricUserActionFilter } from './calculatedMobileMetricUserActionFilter';

/**
* Definition of the calculated metric for mobile or custom app.
*/
export class CalculatedMobileMetric {
    /**
    * The Dynatrace entity ID of the application to which the metric belongs.
    */
    'applicationIdentifier': string;
    /**
    * The name of the metric, displayed in the UI.
    */
    'name': string;
    /**
    * The unique key of the metric.    The key must have the `calc:apps` prefix.
    */
    'metricKey': string;
    /**
    * The metric is enabled (`true`) or disabled (`false`).
    */
    'enabled': boolean;
    /**
    * The type of the metric.
    */
    'metricType': CalculatedMobileMetric.MetricTypeEnum;
    /**
    * A list of metric dimensions.
    */
    'dimensions'?: Array<CalculatedMobileMetricDimension>;
    'userActionFilter'?: CalculatedMobileMetricUserActionFilter;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "applicationIdentifier",
            "baseName": "applicationIdentifier",
            "type": "string"
        },
        {
            "name": "name",
            "baseName": "name",
            "type": "string"
        },
        {
            "name": "metricKey",
            "baseName": "metricKey",
            "type": "string"
        },
        {
            "name": "enabled",
            "baseName": "enabled",
            "type": "boolean"
        },
        {
            "name": "metricType",
            "baseName": "metricType",
            "type": "CalculatedMobileMetric.MetricTypeEnum"
        },
        {
            "name": "dimensions",
            "baseName": "dimensions",
            "type": "Array<CalculatedMobileMetricDimension>"
        },
        {
            "name": "userActionFilter",
            "baseName": "userActionFilter",
            "type": "CalculatedMobileMetricUserActionFilter"
        }    ];

    static getAttributeTypeMap() {
        return CalculatedMobileMetric.attributeTypeMap;
    }
}

export namespace CalculatedMobileMetric {
    export enum MetricTypeEnum {
        REPORTEDERRORCOUNT = <any> 'REPORTED_ERROR_COUNT',
        USERACTIONDURATION = <any> 'USER_ACTION_DURATION',
        WEBREQUESTCOUNT = <any> 'WEB_REQUEST_COUNT',
        WEBREQUESTERRORCOUNT = <any> 'WEB_REQUEST_ERROR_COUNT'
    }
}
