/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { SyntheticMetricDimension } from './syntheticMetricDimension';
import { SyntheticMetricFilter } from './syntheticMetricFilter';

/**
* Definition of the calculated synthetic metric.
*/
export class CalculatedSyntheticMetric {
    /**
    * The Dynatrace entity ID of the synthetic monitor to which the metric belongs.
    */
    'monitorIdentifier': string;
    /**
    * The name of the metric, displayed in the UI.
    */
    'name': string;
    /**
    * The unique key of the metric.    The key must have the `calc:synthetic` prefix.
    */
    'metricKey': string;
    /**
    * The metric is enabled (`true`) or disabled (`false`).
    */
    'enabled': boolean;
    /**
    * The type of the synthetic metric.
    */
    'metric': CalculatedSyntheticMetric.MetricEnum;
    /**
    * A list of metric dimensions.
    */
    'dimensions'?: Array<SyntheticMetricDimension>;
    'filter'?: SyntheticMetricFilter;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "monitorIdentifier",
            "baseName": "monitorIdentifier",
            "type": "string"
        },
        {
            "name": "name",
            "baseName": "name",
            "type": "string"
        },
        {
            "name": "metricKey",
            "baseName": "metricKey",
            "type": "string"
        },
        {
            "name": "enabled",
            "baseName": "enabled",
            "type": "boolean"
        },
        {
            "name": "metric",
            "baseName": "metric",
            "type": "CalculatedSyntheticMetric.MetricEnum"
        },
        {
            "name": "dimensions",
            "baseName": "dimensions",
            "type": "Array<SyntheticMetricDimension>"
        },
        {
            "name": "filter",
            "baseName": "filter",
            "type": "SyntheticMetricFilter"
        }    ];

    static getAttributeTypeMap() {
        return CalculatedSyntheticMetric.attributeTypeMap;
    }
}

export namespace CalculatedSyntheticMetric {
    export enum MetricEnum {
        ApplicationCache = <any> 'ApplicationCache',
        Callback = <any> 'Callback',
        DNSLookup = <any> 'DNSLookup',
        DOMComplete = <any> 'DOMComplete',
        DOMContentLoaded = <any> 'DOMContentLoaded',
        DOMInteractive = <any> 'DOMInteractive',
        FailedRequestsResources = <any> 'FailedRequestsResources',
        FirstContentfulPaint = <any> 'FirstContentfulPaint',
        FirstInputDelay = <any> 'FirstInputDelay',
        FirstInputStart = <any> 'FirstInputStart',
        FirstPaint = <any> 'FirstPaint',
        HTMLDownloaded = <any> 'HTMLDownloaded',
        HttpErrors = <any> 'HttpErrors',
        JavaScriptErrors = <any> 'JavaScriptErrors',
        LargestContentfulPaint = <any> 'LargestContentfulPaint',
        LoadEventEnd = <any> 'LoadEventEnd',
        LoadEventStart = <any> 'LoadEventStart',
        NavigationStart = <any> 'NavigationStart',
        OnDOMContentLoaded = <any> 'OnDOMContentLoaded',
        OnLoad = <any> 'OnLoad',
        Processing = <any> 'Processing',
        RedirectTime = <any> 'RedirectTime',
        Request = <any> 'Request',
        RequestStart = <any> 'RequestStart',
        ResourceCount = <any> 'ResourceCount',
        Response = <any> 'Response',
        SecureConnect = <any> 'SecureConnect',
        SpeedIndex = <any> 'SpeedIndex',
        TCPConnect = <any> 'TCPConnect',
        TimeToFirstByte = <any> 'TimeToFirstByte',
        TotalDuration = <any> 'TotalDuration',
        TransferSize = <any> 'TransferSize',
        UserActionDuration = <any> 'UserActionDuration',
        VisuallyComplete = <any> 'VisuallyComplete'
    }
}
