/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { MethodReference } from './methodReference';

export class CapturedMethod {
    'method': MethodReference;
    /**
    * What to capture from the method.
    */
    'capture': CapturedMethod.CaptureEnum;
    /**
    * The index of the argument to capture. Set `0` to capture the return value, `1` or higher to capture a mehtod argument.    Required if the **capture** is set to `ARGUMENT`.   Not applicable in other cases.
    */
    'argumentIndex'?: number;
    /**
    * The getter chain to apply to the captured object. It is required in one of the following cases:   The **capture** is set to `THIS`.    The **capture** is set to `ARGUMENT`, and the argument is not a primitive, a primitive wrapper class, a string, or an array.    Not applicable in other cases.
    */
    'deepObjectAccess'?: string;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "method",
            "baseName": "method",
            "type": "MethodReference"
        },
        {
            "name": "capture",
            "baseName": "capture",
            "type": "CapturedMethod.CaptureEnum"
        },
        {
            "name": "argumentIndex",
            "baseName": "argumentIndex",
            "type": "number"
        },
        {
            "name": "deepObjectAccess",
            "baseName": "deepObjectAccess",
            "type": "string"
        }    ];

    static getAttributeTypeMap() {
        return CapturedMethod.attributeTypeMap;
    }
}

export namespace CapturedMethod {
    export enum CaptureEnum {
        ARGUMENT = <any> 'ARGUMENT',
        CLASSNAME = <any> 'CLASS_NAME',
        METHODNAME = <any> 'METHOD_NAME',
        OCCURRENCES = <any> 'OCCURRENCES',
        SIMPLECLASSNAME = <any> 'SIMPLE_CLASS_NAME',
        THIS = <any> 'THIS'
    }
}
