/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { CertificateCredentialsAllOf } from './certificateCredentialsAllOf';
import { Credentials } from './credentials';

/**
* A credentials set of the `CERTIFICATE` type.
*/
export class CertificateCredentials extends Credentials {
    /**
    * The certificate in the string format.
    */
    'certificate': string;
    /**
    * The password of the credential.
    */
    'password': string;
    /**
    * The certificate format.
    */
    'certificateFormat': CertificateCredentials.CertificateFormatEnum;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "certificate",
            "baseName": "certificate",
            "type": "string"
        },
        {
            "name": "password",
            "baseName": "password",
            "type": "string"
        },
        {
            "name": "certificateFormat",
            "baseName": "certificateFormat",
            "type": "CertificateCredentials.CertificateFormatEnum"
        }    ];

    static getAttributeTypeMap() {
        return super.getAttributeTypeMap().concat(CertificateCredentials.attributeTypeMap);
    }
}

export namespace CertificateCredentials {
    export enum CertificateFormatEnum {
        PEM = <any> 'PEM',
        PKCS12 = <any> 'PKCS12',
        UNKNOWN = <any> 'UNKNOWN'
    }
}
