/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { ConfigurationMetadata } from './configurationMetadata';

/**
* Configuration for specific Cloud Foundry credentials.
*/
export class CloudFoundryCredentials {
    'metadata'?: ConfigurationMetadata;
    /**
    * The ID of the given credentials configuration.
    */
    'id'?: string;
    /**
    * The monitoring is enabled (`true`) or disabled (`false`) for given credentials configuration.   If not set on creation, the `true` value is used.   If the field is omitted during an update, the old value remains unaffected.
    */
    'active'?: boolean;
    /**
    * The status of the configured endpoint.  ASSIGNED: The credentials are assigned to an ActiveGate which is responsible for processing. UNASSIGNED: The credentials are not yet assigned to an ActiveGate so there is currently no processing. DISABLED: The credentials have been disabled by the user. FASTCHECK_AUTH_ERROR: The credentials are invalid. FASTCHECK_TLS_ERROR: The endpoint TLS certificate is invalid. FASTCHECK_NO_RESPONSE: The endpoint did not return a result until the timeout was reached. FASTCHECK_INVALID_ENDPOINT: The endpoint URL was invalid. FASTCHECK_AUTH_LOCKED: The credentials seem to be locked. UNKNOWN: An unknown error occured. 
    */
    'endpointStatus'?: CloudFoundryCredentials.EndpointStatusEnum;
    /**
    * The detailed status info of the configured endpoint.
    */
    'endpointStatusInfo'?: string;
    /**
    * The name of the Cloud Foundry foundation credentials.   Allowed characters are letters, numbers, whitespaces, and the following characters: `.+-_`. Leading or trailing whitespace is not allowed.
    */
    'name': string;
    /**
    * The URL of the Cloud Foundry foundation credentials.   The URL must be valid according to RFC 2396.   Leading or trailing whitespaces are not allowed.
    */
    'apiUrl'?: string;
    /**
    * The login URL of the Cloud Foundry foundation credentials.   The URL must be valid according to RFC 2396.   Leading or trailing whitespaces are not allowed.
    */
    'loginUrl'?: string;
    /**
    * The username of the Cloud Foundry foundation credentials.   Leading and trailing whitespaces are not allowed.
    */
    'username': string;
    /**
    * The password of the Cloud Foundry foundation credentials.
    */
    'password'?: string;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "metadata",
            "baseName": "metadata",
            "type": "ConfigurationMetadata"
        },
        {
            "name": "id",
            "baseName": "id",
            "type": "string"
        },
        {
            "name": "active",
            "baseName": "active",
            "type": "boolean"
        },
        {
            "name": "endpointStatus",
            "baseName": "endpointStatus",
            "type": "CloudFoundryCredentials.EndpointStatusEnum"
        },
        {
            "name": "endpointStatusInfo",
            "baseName": "endpointStatusInfo",
            "type": "string"
        },
        {
            "name": "name",
            "baseName": "name",
            "type": "string"
        },
        {
            "name": "apiUrl",
            "baseName": "apiUrl",
            "type": "string"
        },
        {
            "name": "loginUrl",
            "baseName": "loginUrl",
            "type": "string"
        },
        {
            "name": "username",
            "baseName": "username",
            "type": "string"
        },
        {
            "name": "password",
            "baseName": "password",
            "type": "string"
        }    ];

    static getAttributeTypeMap() {
        return CloudFoundryCredentials.attributeTypeMap;
    }
}

export namespace CloudFoundryCredentials {
    export enum EndpointStatusEnum {
        ASSIGNED = <any> 'ASSIGNED',
        DISABLED = <any> 'DISABLED',
        FASTCHECKAUTHERROR = <any> 'FASTCHECK_AUTH_ERROR',
        FASTCHECKAUTHLOCKED = <any> 'FASTCHECK_AUTH_LOCKED',
        FASTCHECKINVALIDENDPOINT = <any> 'FASTCHECK_INVALID_ENDPOINT',
        FASTCHECKNORESPONSE = <any> 'FASTCHECK_NO_RESPONSE',
        FASTCHECKTLSERROR = <any> 'FASTCHECK_TLS_ERROR',
        UNASSIGNED = <any> 'UNASSIGNED',
        UNKNOWN = <any> 'UNKNOWN'
    }
}
