/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* The condition of the rule.   The actual set of fields depends on the `type` of the condition.
*/
export class CompareOperation {
    /**
    * Defines the actual set of fields depending on the value. See one of the following objects:   * `EQUALS` -> EqualsCompareOperation  * `STRING_CONTAINS` -> StringContainsCompareOperation  * `STARTS_WITH` -> StartsWithCompareOperation  * `ENDS_WITH` -> EndsWithCompareOperation  * `EXISTS` -> ExistsCompareOperation  * `IP_IN_RANGE` -> IpInRangeCompareOperation  * `LESS_THAN` -> LessThanCompareOperation  * `GREATER_THAN` -> GreaterThanCompareOperation  * `INT_EQUALS` -> IntEqualsCompareOperation  * `STRING_EQUALS` -> StringEqualsCompareOperation  * `TAG` -> TagCompareOperation  
    */
    'type': CompareOperation.TypeEnum;

    static discriminator: string | undefined = "type";

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "type",
            "baseName": "type",
            "type": "CompareOperation.TypeEnum"
        }    ];

    static getAttributeTypeMap() {
        return CompareOperation.attributeTypeMap;
    }
}

export namespace CompareOperation {
    export enum TypeEnum {
        ENDSWITH = <any> 'ENDS_WITH',
        EQUALS = <any> 'EQUALS',
        EXISTS = <any> 'EXISTS',
        GREATERTHAN = <any> 'GREATER_THAN',
        INTEQUALS = <any> 'INT_EQUALS',
        IPINRANGE = <any> 'IP_IN_RANGE',
        LESSTHAN = <any> 'LESS_THAN',
        STARTSWITH = <any> 'STARTS_WITH',
        STRINGCONTAINS = <any> 'STRING_CONTAINS',
        STRINGEQUALS = <any> 'STRING_EQUALS',
        TAG = <any> 'TAG'
    }
}
