/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* Defines how the matching is actually performed: what and how are we comparing.   The actual set of fields and possible values of the **operator** field depend on the **type** of the comparison. \\n\\nFind the list of actual models in the description of the **type** field and check the description of the model you need.
*/
export class ComparisonBasic {
    /**
    * Operator of the comparison. You can reverse it by setting **negate** to `true`.   Possible values depend on the **type** of the comparison. Find the list of actual models in the description of the **type** field and check the description of the model you need.
    */
    'operator': object;
    /**
    * The value to compare to.
    */
    'value'?: object;
    /**
    * Reverses the comparison **operator**. For example it turns the **begins with** into **does not begin with**.
    */
    'negate': boolean;
    /**
    * Defines the actual set of fields depending on the value. See one of the following objects:   * `STRING` -> StringComparison  * `INDEXED_NAME` -> IndexedNameComparison  * `INDEXED_STRING` -> IndexedStringComparison  * `INTEGER` -> IntegerComparison  * `SERVICE_TYPE` -> ServiceTypeComparison  * `PAAS_TYPE` -> PaasTypeComparison  * `CLOUD_TYPE` -> CloudTypeComparison  * `AZURE_SKU` -> AzureSkuComparision  * `AZURE_COMPUTE_MODE` -> AzureComputeModeComparison  * `ENTITY_ID` -> EntityIdComparison  * `SIMPLE_TECH` -> SimpleTechComparison  * `SIMPLE_HOST_TECH` -> SimpleHostTechComparison  * `SERVICE_TOPOLOGY` -> ServiceTopologyComparison  * `DATABASE_TOPOLOGY` -> DatabaseTopologyComparison  * `OS_TYPE` -> OsTypeComparison  * `HYPERVISOR_TYPE` -> HypervisorTypeComparision  * `IP_ADDRESS` -> IpAddressComparison  * `OS_ARCHITECTURE` -> OsArchitectureComparison  * `BITNESS` -> BitnessComparision  * `APPLICATION_TYPE` -> ApplicationTypeComparison  * `MOBILE_PLATFORM` -> MobilePlatformComparison  * `CUSTOM_APPLICATION_TYPE` -> CustomApplicationTypeComparison  * `DCRUM_DECODER_TYPE` -> DcrumDecoderComparison  * `SYNTHETIC_ENGINE_TYPE` -> SyntheticEngineTypeComparison  * `TAG` -> TagComparison  * `INDEXED_TAG` -> IndexedTagComparison  
    */
    'type': ComparisonBasic.TypeEnum;

    static discriminator: string | undefined = "type";

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "operator",
            "baseName": "operator",
            "type": "object"
        },
        {
            "name": "value",
            "baseName": "value",
            "type": "object"
        },
        {
            "name": "negate",
            "baseName": "negate",
            "type": "boolean"
        },
        {
            "name": "type",
            "baseName": "type",
            "type": "ComparisonBasic.TypeEnum"
        }    ];

    static getAttributeTypeMap() {
        return ComparisonBasic.attributeTypeMap;
    }
}

export namespace ComparisonBasic {
    export enum TypeEnum {
        APPLICATIONTYPE = <any> 'APPLICATION_TYPE',
        AZURECOMPUTEMODE = <any> 'AZURE_COMPUTE_MODE',
        AZURESKU = <any> 'AZURE_SKU',
        BITNESS = <any> 'BITNESS',
        CLOUDTYPE = <any> 'CLOUD_TYPE',
        CUSTOMAPPLICATIONTYPE = <any> 'CUSTOM_APPLICATION_TYPE',
        DATABASETOPOLOGY = <any> 'DATABASE_TOPOLOGY',
        DCRUMDECODERTYPE = <any> 'DCRUM_DECODER_TYPE',
        ENTITYID = <any> 'ENTITY_ID',
        HYPERVISORTYPE = <any> 'HYPERVISOR_TYPE',
        INDEXEDNAME = <any> 'INDEXED_NAME',
        INDEXEDSTRING = <any> 'INDEXED_STRING',
        INDEXEDTAG = <any> 'INDEXED_TAG',
        INTEGER = <any> 'INTEGER',
        IPADDRESS = <any> 'IP_ADDRESS',
        MOBILEPLATFORM = <any> 'MOBILE_PLATFORM',
        OSARCHITECTURE = <any> 'OS_ARCHITECTURE',
        OSTYPE = <any> 'OS_TYPE',
        PAASTYPE = <any> 'PAAS_TYPE',
        SERVICETOPOLOGY = <any> 'SERVICE_TOPOLOGY',
        SERVICETYPE = <any> 'SERVICE_TYPE',
        SIMPLEHOSTTECH = <any> 'SIMPLE_HOST_TECH',
        SIMPLETECH = <any> 'SIMPLE_TECH',
        STRING = <any> 'STRING',
        SYNTHETICENGINETYPE = <any> 'SYNTHETIC_ENGINE_TYPE',
        TAG = <any> 'TAG'
    }
}
