/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* Type-specific comparison for attributes. The actual set of fields depends on the `type` of the comparison.
*/
export class ComparisonInfo {
    /**
    * Operator of the comparision. You can reverse it by setting **negate** to `true`.
    */
    'comparison': object;
    /**
    * The value to compare to.
    */
    'value'?: object;
    /**
    * Reverse the comparison **operator**. For example, it turns **equals** into **does not equal**.
    */
    'negate': boolean;
    /**
    * Defines the actual set of fields depending on the value. See one of the following objects:   * `STRING` -> StringComparisonInfo  * `NUMBER` -> NumberComparisonInfo  * `BOOLEAN` -> BooleanComparisonInfo  * `HTTP_METHOD` -> HttpMethodComparisonInfo  * `STRING_REQUEST_ATTRIBUTE` -> StringRequestAttributeComparisonInfo  * `NUMBER_REQUEST_ATTRIBUTE` -> NumberRequestAttributeComparisonInfo  * `ZOS_CALL_TYPE` -> ZosComparisonInfo  * `IIB_INPUT_NODE_TYPE` -> IIBInputNodeTypeComparisonInfo  * `ESB_INPUT_NODE_TYPE` -> ESBInputNodeTypeComparisonInfo  * `FAILED_STATE` -> FailedStateComparisonInfo  * `FLAW_STATE` -> FlawStateComparisonInfo  * `FAILURE_REASON` -> FailureReasonComparisonInfo  * `HTTP_STATUS_CLASS` -> HttpStatusClassComparisonInfo  * `TAG` -> TagComparisonInfo  * `FAST_STRING` -> FastStringComparisonInfo  * `SERVICE_TYPE` -> ServiceTypeComparisonInfo  
    */
    'type': ComparisonInfo.TypeEnum;

    static discriminator: string | undefined = "type";

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "comparison",
            "baseName": "comparison",
            "type": "object"
        },
        {
            "name": "value",
            "baseName": "value",
            "type": "object"
        },
        {
            "name": "negate",
            "baseName": "negate",
            "type": "boolean"
        },
        {
            "name": "type",
            "baseName": "type",
            "type": "ComparisonInfo.TypeEnum"
        }    ];

    static getAttributeTypeMap() {
        return ComparisonInfo.attributeTypeMap;
    }
}

export namespace ComparisonInfo {
    export enum TypeEnum {
        BOOLEAN = <any> 'BOOLEAN',
        ESBINPUTNODETYPE = <any> 'ESB_INPUT_NODE_TYPE',
        FAILEDSTATE = <any> 'FAILED_STATE',
        FAILUREREASON = <any> 'FAILURE_REASON',
        FASTSTRING = <any> 'FAST_STRING',
        FLAWSTATE = <any> 'FLAW_STATE',
        HTTPMETHOD = <any> 'HTTP_METHOD',
        HTTPSTATUSCLASS = <any> 'HTTP_STATUS_CLASS',
        IIBINPUTNODETYPE = <any> 'IIB_INPUT_NODE_TYPE',
        NUMBER = <any> 'NUMBER',
        NUMBERREQUESTATTRIBUTE = <any> 'NUMBER_REQUEST_ATTRIBUTE',
        SERVICETYPE = <any> 'SERVICE_TYPE',
        STRING = <any> 'STRING',
        STRINGREQUESTATTRIBUTE = <any> 'STRING_REQUEST_ATTRIBUTE',
        TAG = <any> 'TAG',
        ZOSCALLTYPE = <any> 'ZOS_CALL_TYPE'
    }
}
