/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* The key to identify the data we\'re matching.   The actual set of fields and possible values vary, depending on the **type** of the key.   Find the list of actual objects in the description of the **type** field.
*/
export class ConditionKey {
    /**
    * The attribute to be used for comparision.
    */
    'attribute': ConditionKey.AttributeEnum;
    /**
    * Defines the actual set of fields depending on the value. See one of the following objects:   * `PROCESS_CUSTOM_METADATA_KEY` -> CustomProcessMetadataConditionKey  * `HOST_CUSTOM_METADATA_KEY` -> CustomHostMetadataConditionKey  * `PROCESS_PREDEFINED_METADATA_KEY` -> ProcessMetadataConditionKey  * `STRING` -> StringConditionKey  
    */
    'type'?: ConditionKey.TypeEnum;

    static discriminator: string | undefined = "type";

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "attribute",
            "baseName": "attribute",
            "type": "ConditionKey.AttributeEnum"
        },
        {
            "name": "type",
            "baseName": "type",
            "type": "ConditionKey.TypeEnum"
        }    ];

    static getAttributeTypeMap() {
        return ConditionKey.attributeTypeMap;
    }
}

export namespace ConditionKey {
    export enum AttributeEnum {
        APPMONSERVERNAME = <any> 'APPMON_SERVER_NAME',
        APPMONSYSTEMPROFILENAME = <any> 'APPMON_SYSTEM_PROFILE_NAME',
        AWSACCOUNTID = <any> 'AWS_ACCOUNT_ID',
        AWSACCOUNTNAME = <any> 'AWS_ACCOUNT_NAME',
        AWSAPPLICATIONLOADBALANCERNAME = <any> 'AWS_APPLICATION_LOAD_BALANCER_NAME',
        AWSAPPLICATIONLOADBALANCERTAGS = <any> 'AWS_APPLICATION_LOAD_BALANCER_TAGS',
        AWSAUTOSCALINGGROUPNAME = <any> 'AWS_AUTO_SCALING_GROUP_NAME',
        AWSAUTOSCALINGGROUPTAGS = <any> 'AWS_AUTO_SCALING_GROUP_TAGS',
        AWSAVAILABILITYZONENAME = <any> 'AWS_AVAILABILITY_ZONE_NAME',
        AWSCLASSICLOADBALANCERFRONTENDPORTS = <any> 'AWS_CLASSIC_LOAD_BALANCER_FRONTEND_PORTS',
        AWSCLASSICLOADBALANCERNAME = <any> 'AWS_CLASSIC_LOAD_BALANCER_NAME',
        AWSCLASSICLOADBALANCERTAGS = <any> 'AWS_CLASSIC_LOAD_BALANCER_TAGS',
        AWSNETWORKLOADBALANCERNAME = <any> 'AWS_NETWORK_LOAD_BALANCER_NAME',
        AWSNETWORKLOADBALANCERTAGS = <any> 'AWS_NETWORK_LOAD_BALANCER_TAGS',
        AWSRELATIONALDATABASESERVICEDBNAME = <any> 'AWS_RELATIONAL_DATABASE_SERVICE_DB_NAME',
        AWSRELATIONALDATABASESERVICEENDPOINT = <any> 'AWS_RELATIONAL_DATABASE_SERVICE_ENDPOINT',
        AWSRELATIONALDATABASESERVICEENGINE = <any> 'AWS_RELATIONAL_DATABASE_SERVICE_ENGINE',
        AWSRELATIONALDATABASESERVICEINSTANCECLASS = <any> 'AWS_RELATIONAL_DATABASE_SERVICE_INSTANCE_CLASS',
        AWSRELATIONALDATABASESERVICENAME = <any> 'AWS_RELATIONAL_DATABASE_SERVICE_NAME',
        AWSRELATIONALDATABASESERVICEPORT = <any> 'AWS_RELATIONAL_DATABASE_SERVICE_PORT',
        AWSRELATIONALDATABASESERVICETAGS = <any> 'AWS_RELATIONAL_DATABASE_SERVICE_TAGS',
        AZUREENTITYNAME = <any> 'AZURE_ENTITY_NAME',
        AZUREENTITYTAGS = <any> 'AZURE_ENTITY_TAGS',
        AZUREMGMTGROUPNAME = <any> 'AZURE_MGMT_GROUP_NAME',
        AZUREMGMTGROUPUUID = <any> 'AZURE_MGMT_GROUP_UUID',
        AZUREREGIONNAME = <any> 'AZURE_REGION_NAME',
        AZURESCALESETNAME = <any> 'AZURE_SCALE_SET_NAME',
        AZURESUBSCRIPTIONNAME = <any> 'AZURE_SUBSCRIPTION_NAME',
        AZURESUBSCRIPTIONUUID = <any> 'AZURE_SUBSCRIPTION_UUID',
        AZURETENANTNAME = <any> 'AZURE_TENANT_NAME',
        AZURETENANTUUID = <any> 'AZURE_TENANT_UUID',
        AZUREVMNAME = <any> 'AZURE_VM_NAME',
        BROWSERMONITORNAME = <any> 'BROWSER_MONITOR_NAME',
        BROWSERMONITORTAGS = <any> 'BROWSER_MONITOR_TAGS',
        CLOUDAPPLICATIONLABELS = <any> 'CLOUD_APPLICATION_LABELS',
        CLOUDAPPLICATIONNAME = <any> 'CLOUD_APPLICATION_NAME',
        CLOUDAPPLICATIONNAMESPACELABELS = <any> 'CLOUD_APPLICATION_NAMESPACE_LABELS',
        CLOUDAPPLICATIONNAMESPACENAME = <any> 'CLOUD_APPLICATION_NAMESPACE_NAME',
        CLOUDFOUNDRYFOUNDATIONNAME = <any> 'CLOUD_FOUNDRY_FOUNDATION_NAME',
        CLOUDFOUNDRYORGNAME = <any> 'CLOUD_FOUNDRY_ORG_NAME',
        CUSTOMAPPLICATIONNAME = <any> 'CUSTOM_APPLICATION_NAME',
        CUSTOMAPPLICATIONPLATFORM = <any> 'CUSTOM_APPLICATION_PLATFORM',
        CUSTOMAPPLICATIONTAGS = <any> 'CUSTOM_APPLICATION_TAGS',
        CUSTOMAPPLICATIONTYPE = <any> 'CUSTOM_APPLICATION_TYPE',
        CUSTOMDEVICEDETECTEDNAME = <any> 'CUSTOM_DEVICE_DETECTED_NAME',
        CUSTOMDEVICEDNSADDRESS = <any> 'CUSTOM_DEVICE_DNS_ADDRESS',
        CUSTOMDEVICEGROUPNAME = <any> 'CUSTOM_DEVICE_GROUP_NAME',
        CUSTOMDEVICEGROUPTAGS = <any> 'CUSTOM_DEVICE_GROUP_TAGS',
        CUSTOMDEVICEIPADDRESS = <any> 'CUSTOM_DEVICE_IP_ADDRESS',
        CUSTOMDEVICEMETADATA = <any> 'CUSTOM_DEVICE_METADATA',
        CUSTOMDEVICENAME = <any> 'CUSTOM_DEVICE_NAME',
        CUSTOMDEVICEPORT = <any> 'CUSTOM_DEVICE_PORT',
        CUSTOMDEVICETAGS = <any> 'CUSTOM_DEVICE_TAGS',
        CUSTOMDEVICETECHNOLOGY = <any> 'CUSTOM_DEVICE_TECHNOLOGY',
        DATACENTERSERVICEDECODERTYPE = <any> 'DATA_CENTER_SERVICE_DECODER_TYPE',
        DATACENTERSERVICEIPADDRESS = <any> 'DATA_CENTER_SERVICE_IP_ADDRESS',
        DATACENTERSERVICEMETADATA = <any> 'DATA_CENTER_SERVICE_METADATA',
        DATACENTERSERVICENAME = <any> 'DATA_CENTER_SERVICE_NAME',
        DATACENTERSERVICEPORT = <any> 'DATA_CENTER_SERVICE_PORT',
        DATACENTERSERVICETAGS = <any> 'DATA_CENTER_SERVICE_TAGS',
        DOCKERCONTAINERNAME = <any> 'DOCKER_CONTAINER_NAME',
        DOCKERFULLIMAGENAME = <any> 'DOCKER_FULL_IMAGE_NAME',
        DOCKERIMAGEVERSION = <any> 'DOCKER_IMAGE_VERSION',
        DOCKERSTRIPPEDIMAGENAME = <any> 'DOCKER_STRIPPED_IMAGE_NAME',
        EC2INSTANCEAMIID = <any> 'EC2_INSTANCE_AMI_ID',
        EC2INSTANCEAWSINSTANCETYPE = <any> 'EC2_INSTANCE_AWS_INSTANCE_TYPE',
        EC2INSTANCEAWSSECURITYGROUP = <any> 'EC2_INSTANCE_AWS_SECURITY_GROUP',
        EC2INSTANCEBEANSTALKENVNAME = <any> 'EC2_INSTANCE_BEANSTALK_ENV_NAME',
        EC2INSTANCEID = <any> 'EC2_INSTANCE_ID',
        EC2INSTANCENAME = <any> 'EC2_INSTANCE_NAME',
        EC2INSTANCEPRIVATEHOSTNAME = <any> 'EC2_INSTANCE_PRIVATE_HOST_NAME',
        EC2INSTANCEPUBLICHOSTNAME = <any> 'EC2_INSTANCE_PUBLIC_HOST_NAME',
        EC2INSTANCETAGS = <any> 'EC2_INSTANCE_TAGS',
        ENTERPRISEAPPLICATIONDECODERTYPE = <any> 'ENTERPRISE_APPLICATION_DECODER_TYPE',
        ENTERPRISEAPPLICATIONIPADDRESS = <any> 'ENTERPRISE_APPLICATION_IP_ADDRESS',
        ENTERPRISEAPPLICATIONMETADATA = <any> 'ENTERPRISE_APPLICATION_METADATA',
        ENTERPRISEAPPLICATIONNAME = <any> 'ENTERPRISE_APPLICATION_NAME',
        ENTERPRISEAPPLICATIONPORT = <any> 'ENTERPRISE_APPLICATION_PORT',
        ENTERPRISEAPPLICATIONTAGS = <any> 'ENTERPRISE_APPLICATION_TAGS',
        ESXIHOSTCLUSTERNAME = <any> 'ESXI_HOST_CLUSTER_NAME',
        ESXIHOSTHARDWAREMODEL = <any> 'ESXI_HOST_HARDWARE_MODEL',
        ESXIHOSTHARDWAREVENDOR = <any> 'ESXI_HOST_HARDWARE_VENDOR',
        ESXIHOSTNAME = <any> 'ESXI_HOST_NAME',
        ESXIHOSTPRODUCTNAME = <any> 'ESXI_HOST_PRODUCT_NAME',
        ESXIHOSTPRODUCTVERSION = <any> 'ESXI_HOST_PRODUCT_VERSION',
        ESXIHOSTTAGS = <any> 'ESXI_HOST_TAGS',
        EXTERNALMONITORENGINEDESCRIPTION = <any> 'EXTERNAL_MONITOR_ENGINE_DESCRIPTION',
        EXTERNALMONITORENGINENAME = <any> 'EXTERNAL_MONITOR_ENGINE_NAME',
        EXTERNALMONITORENGINETYPE = <any> 'EXTERNAL_MONITOR_ENGINE_TYPE',
        EXTERNALMONITORNAME = <any> 'EXTERNAL_MONITOR_NAME',
        EXTERNALMONITORTAGS = <any> 'EXTERNAL_MONITOR_TAGS',
        GEOLOCATIONSITENAME = <any> 'GEOLOCATION_SITE_NAME',
        GOOGLECLOUDPLATFORMZONENAME = <any> 'GOOGLE_CLOUD_PLATFORM_ZONE_NAME',
        GOOGLECOMPUTEINSTANCEID = <any> 'GOOGLE_COMPUTE_INSTANCE_ID',
        GOOGLECOMPUTEINSTANCEMACHINETYPE = <any> 'GOOGLE_COMPUTE_INSTANCE_MACHINE_TYPE',
        GOOGLECOMPUTEINSTANCENAME = <any> 'GOOGLE_COMPUTE_INSTANCE_NAME',
        GOOGLECOMPUTEINSTANCEPROJECT = <any> 'GOOGLE_COMPUTE_INSTANCE_PROJECT',
        GOOGLECOMPUTEINSTANCEPROJECTID = <any> 'GOOGLE_COMPUTE_INSTANCE_PROJECT_ID',
        GOOGLECOMPUTEINSTANCEPUBLICIPADDRESSES = <any> 'GOOGLE_COMPUTE_INSTANCE_PUBLIC_IP_ADDRESSES',
        HOSTAIXLOGICALCPUCOUNT = <any> 'HOST_AIX_LOGICAL_CPU_COUNT',
        HOSTAIXSIMULTANEOUSTHREADS = <any> 'HOST_AIX_SIMULTANEOUS_THREADS',
        HOSTAIXVIRTUALCPUCOUNT = <any> 'HOST_AIX_VIRTUAL_CPU_COUNT',
        HOSTARCHITECTURE = <any> 'HOST_ARCHITECTURE',
        HOSTAWSNAMETAG = <any> 'HOST_AWS_NAME_TAG',
        HOSTAZURECOMPUTEMODE = <any> 'HOST_AZURE_COMPUTE_MODE',
        HOSTAZURESKU = <any> 'HOST_AZURE_SKU',
        HOSTAZUREWEBAPPLICATIONHOSTNAMES = <any> 'HOST_AZURE_WEB_APPLICATION_HOST_NAMES',
        HOSTAZUREWEBAPPLICATIONSITENAMES = <any> 'HOST_AZURE_WEB_APPLICATION_SITE_NAMES',
        HOSTBITNESS = <any> 'HOST_BITNESS',
        HOSTBOSHAVAILABILITYZONE = <any> 'HOST_BOSH_AVAILABILITY_ZONE',
        HOSTBOSHDEPLOYMENTID = <any> 'HOST_BOSH_DEPLOYMENT_ID',
        HOSTBOSHINSTANCEID = <any> 'HOST_BOSH_INSTANCE_ID',
        HOSTBOSHINSTANCENAME = <any> 'HOST_BOSH_INSTANCE_NAME',
        HOSTBOSHNAME = <any> 'HOST_BOSH_NAME',
        HOSTBOSHSTEMCELLVERSION = <any> 'HOST_BOSH_STEMCELL_VERSION',
        HOSTCLOUDTYPE = <any> 'HOST_CLOUD_TYPE',
        HOSTCPUCORES = <any> 'HOST_CPU_CORES',
        HOSTCUSTOMMETADATA = <any> 'HOST_CUSTOM_METADATA',
        HOSTDETECTEDNAME = <any> 'HOST_DETECTED_NAME',
        HOSTGROUPID = <any> 'HOST_GROUP_ID',
        HOSTGROUPNAME = <any> 'HOST_GROUP_NAME',
        HOSTHYPERVISORTYPE = <any> 'HOST_HYPERVISOR_TYPE',
        HOSTIPADDRESS = <any> 'HOST_IP_ADDRESS',
        HOSTKUBERNETESLABELS = <any> 'HOST_KUBERNETES_LABELS',
        HOSTLOGICALCPUCORES = <any> 'HOST_LOGICAL_CPU_CORES',
        HOSTNAME = <any> 'HOST_NAME',
        HOSTONEAGENTCUSTOMHOSTNAME = <any> 'HOST_ONEAGENT_CUSTOM_HOST_NAME',
        HOSTOSTYPE = <any> 'HOST_OS_TYPE',
        HOSTOSVERSION = <any> 'HOST_OS_VERSION',
        HOSTPAASMEMORYLIMIT = <any> 'HOST_PAAS_MEMORY_LIMIT',
        HOSTPAASTYPE = <any> 'HOST_PAAS_TYPE',
        HOSTTAGS = <any> 'HOST_TAGS',
        HOSTTECHNOLOGY = <any> 'HOST_TECHNOLOGY',
        HTTPMONITORNAME = <any> 'HTTP_MONITOR_NAME',
        HTTPMONITORTAGS = <any> 'HTTP_MONITOR_TAGS',
        KUBERNETESCLUSTERNAME = <any> 'KUBERNETES_CLUSTER_NAME',
        KUBERNETESNODENAME = <any> 'KUBERNETES_NODE_NAME',
        MOBILEAPPLICATIONNAME = <any> 'MOBILE_APPLICATION_NAME',
        MOBILEAPPLICATIONPLATFORM = <any> 'MOBILE_APPLICATION_PLATFORM',
        MOBILEAPPLICATIONTAGS = <any> 'MOBILE_APPLICATION_TAGS',
        NAMEOFCOMPUTENODE = <any> 'NAME_OF_COMPUTE_NODE',
        OPENSTACKACCOUNTNAME = <any> 'OPENSTACK_ACCOUNT_NAME',
        OPENSTACKACCOUNTPROJECTNAME = <any> 'OPENSTACK_ACCOUNT_PROJECT_NAME',
        OPENSTACKAVAILABILITYZONENAME = <any> 'OPENSTACK_AVAILABILITY_ZONE_NAME',
        OPENSTACKPROJECTNAME = <any> 'OPENSTACK_PROJECT_NAME',
        OPENSTACKREGIONNAME = <any> 'OPENSTACK_REGION_NAME',
        OPENSTACKVMINSTANCETYPE = <any> 'OPENSTACK_VM_INSTANCE_TYPE',
        OPENSTACKVMNAME = <any> 'OPENSTACK_VM_NAME',
        OPENSTACKVMSECURITYGROUP = <any> 'OPENSTACK_VM_SECURITY_GROUP',
        PROCESSGROUPAZUREHOSTNAME = <any> 'PROCESS_GROUP_AZURE_HOST_NAME',
        PROCESSGROUPAZURESITENAME = <any> 'PROCESS_GROUP_AZURE_SITE_NAME',
        PROCESSGROUPCUSTOMMETADATA = <any> 'PROCESS_GROUP_CUSTOM_METADATA',
        PROCESSGROUPDETECTEDNAME = <any> 'PROCESS_GROUP_DETECTED_NAME',
        PROCESSGROUPID = <any> 'PROCESS_GROUP_ID',
        PROCESSGROUPLISTENPORT = <any> 'PROCESS_GROUP_LISTEN_PORT',
        PROCESSGROUPNAME = <any> 'PROCESS_GROUP_NAME',
        PROCESSGROUPPREDEFINEDMETADATA = <any> 'PROCESS_GROUP_PREDEFINED_METADATA',
        PROCESSGROUPTAGS = <any> 'PROCESS_GROUP_TAGS',
        PROCESSGROUPTECHNOLOGY = <any> 'PROCESS_GROUP_TECHNOLOGY',
        PROCESSGROUPTECHNOLOGYEDITION = <any> 'PROCESS_GROUP_TECHNOLOGY_EDITION',
        PROCESSGROUPTECHNOLOGYVERSION = <any> 'PROCESS_GROUP_TECHNOLOGY_VERSION',
        SERVICEAKKAACTORSYSTEM = <any> 'SERVICE_AKKA_ACTOR_SYSTEM',
        SERVICECTGSERVICENAME = <any> 'SERVICE_CTG_SERVICE_NAME',
        SERVICEDATABASEHOSTNAME = <any> 'SERVICE_DATABASE_HOST_NAME',
        SERVICEDATABASENAME = <any> 'SERVICE_DATABASE_NAME',
        SERVICEDATABASETOPOLOGY = <any> 'SERVICE_DATABASE_TOPOLOGY',
        SERVICEDATABASEVENDOR = <any> 'SERVICE_DATABASE_VENDOR',
        SERVICEDETECTEDNAME = <any> 'SERVICE_DETECTED_NAME',
        SERVICEESBAPPLICATIONNAME = <any> 'SERVICE_ESB_APPLICATION_NAME',
        SERVICEIBMCTGGATEWAYURL = <any> 'SERVICE_IBM_CTG_GATEWAY_URL',
        SERVICEIIBAPPLICATIONNAME = <any> 'SERVICE_IIB_APPLICATION_NAME',
        SERVICEMESSAGINGLISTENERCLASSNAME = <any> 'SERVICE_MESSAGING_LISTENER_CLASS_NAME',
        SERVICENAME = <any> 'SERVICE_NAME',
        SERVICEPORT = <any> 'SERVICE_PORT',
        SERVICEPUBLICDOMAINNAME = <any> 'SERVICE_PUBLIC_DOMAIN_NAME',
        SERVICEREMOTEENDPOINT = <any> 'SERVICE_REMOTE_ENDPOINT',
        SERVICEREMOTESERVICENAME = <any> 'SERVICE_REMOTE_SERVICE_NAME',
        SERVICETAGS = <any> 'SERVICE_TAGS',
        SERVICETECHNOLOGY = <any> 'SERVICE_TECHNOLOGY',
        SERVICETECHNOLOGYEDITION = <any> 'SERVICE_TECHNOLOGY_EDITION',
        SERVICETECHNOLOGYVERSION = <any> 'SERVICE_TECHNOLOGY_VERSION',
        SERVICETOPOLOGY = <any> 'SERVICE_TOPOLOGY',
        SERVICETYPE = <any> 'SERVICE_TYPE',
        SERVICEWEBAPPLICATIONID = <any> 'SERVICE_WEB_APPLICATION_ID',
        SERVICEWEBCONTEXTROOT = <any> 'SERVICE_WEB_CONTEXT_ROOT',
        SERVICEWEBSERVERENDPOINT = <any> 'SERVICE_WEB_SERVER_ENDPOINT',
        SERVICEWEBSERVERNAME = <any> 'SERVICE_WEB_SERVER_NAME',
        SERVICEWEBSERVICENAME = <any> 'SERVICE_WEB_SERVICE_NAME',
        SERVICEWEBSERVICENAMESPACE = <any> 'SERVICE_WEB_SERVICE_NAMESPACE',
        VMWAREDATACENTERNAME = <any> 'VMWARE_DATACENTER_NAME',
        VMWAREVMNAME = <any> 'VMWARE_VM_NAME',
        WEBAPPLICATIONNAME = <any> 'WEB_APPLICATION_NAME',
        WEBAPPLICATIONNAMEPATTERN = <any> 'WEB_APPLICATION_NAME_PATTERN',
        WEBAPPLICATIONTAGS = <any> 'WEB_APPLICATION_TAGS',
        WEBAPPLICATIONTYPE = <any> 'WEB_APPLICATION_TYPE'
    }
    export enum TypeEnum {
        HOSTCUSTOMMETADATAKEY = <any> 'HOST_CUSTOM_METADATA_KEY',
        PROCESSCUSTOMMETADATAKEY = <any> 'PROCESS_CUSTOM_METADATA_KEY',
        PROCESSPREDEFINEDMETADATAKEY = <any> 'PROCESS_PREDEFINED_METADATA_KEY',
        STRING = <any> 'STRING'
    }
}
