/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { CompareOperation } from './compareOperation';

/**
* A condition of the service detection rule.
*/
export class ConditionsOpaqueAndExternalWebRequestAttributeTypeDto {
    /**
    * The type of the attribute to be checked.
    */
    'attributeType': ConditionsOpaqueAndExternalWebRequestAttributeTypeDto.AttributeTypeEnum;
    /**
    * A list of conditions for the rule.   If several conditions are specified, the AND logic applies.
    */
    'compareOperations'?: Array<CompareOperation>;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "attributeType",
            "baseName": "attributeType",
            "type": "ConditionsOpaqueAndExternalWebRequestAttributeTypeDto.AttributeTypeEnum"
        },
        {
            "name": "compareOperations",
            "baseName": "compareOperations",
            "type": "Array<CompareOperation>"
        }    ];

    static getAttributeTypeMap() {
        return ConditionsOpaqueAndExternalWebRequestAttributeTypeDto.attributeTypeMap;
    }
}

export namespace ConditionsOpaqueAndExternalWebRequestAttributeTypeDto {
    export enum AttributeTypeEnum {
        IP = <any> 'IP',
        PGTAG = <any> 'PG_TAG',
        TOPLEVELDOMAIN = <any> 'TOP_LEVEL_DOMAIN',
        URL = <any> 'URL',
        URLHOSTNAME = <any> 'URL_HOST_NAME',
        URLPATH = <any> 'URL_PATH',
        URLPORT = <any> 'URL_PORT'
    }
}
