/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { ResourceTimingSettings } from './resourceTimingSettings';
import { TimeoutSettings } from './timeoutSettings';
import { VisuallyComplete2Settings } from './visuallyComplete2Settings';

/**
* Settings for content capture.
*/
export class ContentCapture {
    'resourceTimingSettings': ResourceTimingSettings;
    /**
    * JavaScript errors monitoring enabled/disabled.
    */
    'javaScriptErrors': boolean;
    'timeoutSettings': TimeoutSettings;
    /**
    * Visually complete and Speed index support enabled/disabled.
    */
    'visuallyCompleteAndSpeedIndex': boolean;
    'visuallyComplete2Settings'?: VisuallyComplete2Settings;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "resourceTimingSettings",
            "baseName": "resourceTimingSettings",
            "type": "ResourceTimingSettings"
        },
        {
            "name": "javaScriptErrors",
            "baseName": "javaScriptErrors",
            "type": "boolean"
        },
        {
            "name": "timeoutSettings",
            "baseName": "timeoutSettings",
            "type": "TimeoutSettings"
        },
        {
            "name": "visuallyCompleteAndSpeedIndex",
            "baseName": "visuallyCompleteAndSpeedIndex",
            "type": "boolean"
        },
        {
            "name": "visuallyComplete2Settings",
            "baseName": "visuallyComplete2Settings",
            "type": "VisuallyComplete2Settings"
        }    ];

    static getAttributeTypeMap() {
        return ContentCapture.attributeTypeMap;
    }
}

