/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { ContextRootTransformation } from './contextRootTransformation';

/**
* The contribution to the service ID calculation from the detected context root.    The context root is the first segment of the request URL after server name. For example, in the `www.dynatrace.com/support/help/extend-dynatrace/dynatrace-api/` URL the context root is `support`.   You have two options:  * Keep a part of the detected URL. Specify the number of segments to be kept in the **segmentsToCopyFromUrlPath** field.  * Dynamically transform the detected URL. Specify the transformation parameters in the **transformations** field.   You can use one or both options. If you use both, the transformation applies to the modified URL.
*/
export class ContextRoot {
    /**
    * Transformations to be applied to the detected value.
    */
    'transformations'?: Array<ContextRootTransformation>;
    /**
    * The number of segments of the URL to be kept.   The URL is divided by slashes (`/`), the indexing starts with `1` at context root.   For example, if you specify `2` for the `www.dynatrace.com/support/help/dynatrace-api/` URL, the value of `support/help` is used.
    */
    'segmentsToCopyFromUrlPath'?: number;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "transformations",
            "baseName": "transformations",
            "type": "Array<ContextRootTransformation>"
        },
        {
            "name": "segmentsToCopyFromUrlPath",
            "baseName": "segmentsToCopyFromUrlPath",
            "type": "number"
        }    ];

    static getAttributeTypeMap() {
        return ContextRoot.attributeTypeMap;
    }
}

