/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { DestinationDetails } from './destinationDetails';
import { UserActionDetails } from './userActionDetails';
import { VisitDurationDetails } from './visitDurationDetails';
import { VisitNumActionDetails } from './visitNumActionDetails';

/**
* A conversion goal of the application.
*/
export class ConversionGoal {
    /**
    * The name of the conversion goal.
    */
    'name': string;
    /**
    * The ID of conversion goal.    Omit it while creating a new conversion goal.
    */
    'id'?: string;
    /**
    * The type of the conversion goal.
    */
    'type'?: ConversionGoal.TypeEnum;
    'destinationDetails'?: DestinationDetails;
    'userActionDetails'?: UserActionDetails;
    'visitDurationDetails'?: VisitDurationDetails;
    'visitNumActionDetails'?: VisitNumActionDetails;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "name",
            "baseName": "name",
            "type": "string"
        },
        {
            "name": "id",
            "baseName": "id",
            "type": "string"
        },
        {
            "name": "type",
            "baseName": "type",
            "type": "ConversionGoal.TypeEnum"
        },
        {
            "name": "destinationDetails",
            "baseName": "destinationDetails",
            "type": "DestinationDetails"
        },
        {
            "name": "userActionDetails",
            "baseName": "userActionDetails",
            "type": "UserActionDetails"
        },
        {
            "name": "visitDurationDetails",
            "baseName": "visitDurationDetails",
            "type": "VisitDurationDetails"
        },
        {
            "name": "visitNumActionDetails",
            "baseName": "visitNumActionDetails",
            "type": "VisitNumActionDetails"
        }    ];

    static getAttributeTypeMap() {
        return ConversionGoal.attributeTypeMap;
    }
}

export namespace ConversionGoal {
    export enum TypeEnum {
        Destination = <any> 'Destination',
        UserAction = <any> 'UserAction',
        VisitDuration = <any> 'VisitDuration',
        VisitNumActions = <any> 'VisitNumActions'
    }
}
