/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* A set of credentials for synthetic monitors.
*/
export class Credentials {
    /**
    * The name of the credentials set.
    */
    'name': string;
    /**
    * The ID of the credentials set.
    */
    'id'?: string;
    /**
    * A short description of the credentials set..
    */
    'description': string;
    /**
    * The credentials set is available to every user (`false`) or to owner only (`true`).
    */
    'ownerAccessOnly'?: boolean;
    /**
    * Defines the actual set of fields depending on the value. See one of the following objects:   * `CERTIFICATE` -> CertificateCredentials  * `USERNAME_PASSWORD` -> UserPasswordCredentials  * `TOKEN` -> TokenCredentials  
    */
    'type'?: Credentials.TypeEnum;

    static discriminator: string | undefined = "type";

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "name",
            "baseName": "name",
            "type": "string"
        },
        {
            "name": "id",
            "baseName": "id",
            "type": "string"
        },
        {
            "name": "description",
            "baseName": "description",
            "type": "string"
        },
        {
            "name": "ownerAccessOnly",
            "baseName": "ownerAccessOnly",
            "type": "boolean"
        },
        {
            "name": "type",
            "baseName": "type",
            "type": "Credentials.TypeEnum"
        }    ];

    static getAttributeTypeMap() {
        return Credentials.attributeTypeMap;
    }
}

export namespace Credentials {
    export enum TypeEnum {
        CERTIFICATE = <any> 'CERTIFICATE',
        TOKEN = <any> 'TOKEN',
        USERNAMEPASSWORD = <any> 'USERNAME_PASSWORD'
    }
}
