/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* Metadata of the credentials set.
*/
export class CredentialsResponseElement {
    /**
    * The name of the credentials set.
    */
    'name': string;
    /**
    * The ID of the credentials set.
    */
    'id'?: string;
    /**
    * The type of the credentials set.
    */
    'type': CredentialsResponseElement.TypeEnum;
    /**
    * A short description of the credentials set.
    */
    'description': string;
    /**
    * The owner of the credential.
    */
    'owner': string;
    /**
    * Flag indicating that this credential is visible only to the owner.
    */
    'ownerAccessOnly': boolean;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "name",
            "baseName": "name",
            "type": "string"
        },
        {
            "name": "id",
            "baseName": "id",
            "type": "string"
        },
        {
            "name": "type",
            "baseName": "type",
            "type": "CredentialsResponseElement.TypeEnum"
        },
        {
            "name": "description",
            "baseName": "description",
            "type": "string"
        },
        {
            "name": "owner",
            "baseName": "owner",
            "type": "string"
        },
        {
            "name": "ownerAccessOnly",
            "baseName": "ownerAccessOnly",
            "type": "boolean"
        }    ];

    static getAttributeTypeMap() {
        return CredentialsResponseElement.attributeTypeMap;
    }
}

export namespace CredentialsResponseElement {
    export enum TypeEnum {
        CERTIFICATE = <any> 'CERTIFICATE',
        TOKEN = <any> 'TOKEN',
        UNKNOWN = <any> 'UNKNOWN',
        USERNAMEPASSWORD = <any> 'USERNAME_PASSWORD'
    }
}
