/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { CustomChartingItemMetadataConfig } from './customChartingItemMetadataConfig';
import { CustomFilterChartSeriesConfig } from './customFilterChartSeriesConfig';

/**
* Configuration of a custom chart.
*/
export class CustomFilterChartConfig {
    /**
    * Defines if a legend should be shown.
    */
    'legendShown'?: boolean;
    /**
    * The type of the chart.
    */
    'type': CustomFilterChartConfig.TypeEnum;
    /**
    * A list of charted metrics.
    */
    'series': Array<CustomFilterChartSeriesConfig>;
    /**
    * Additional information about charted metric.
    */
    'resultMetadata': { [key: string]: CustomChartingItemMetadataConfig; };
    /**
    * The optional custom y-axis limits.
    */
    'axisLimits'?: { [key: string]: number; };
    /**
    * The custom unit for the left Y-axis.
    */
    'leftAxisCustomUnit'?: CustomFilterChartConfig.LeftAxisCustomUnitEnum;
    /**
    * The custom unit for the right Y-axis.
    */
    'rightAxisCustomUnit'?: CustomFilterChartConfig.RightAxisCustomUnitEnum;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "legendShown",
            "baseName": "legendShown",
            "type": "boolean"
        },
        {
            "name": "type",
            "baseName": "type",
            "type": "CustomFilterChartConfig.TypeEnum"
        },
        {
            "name": "series",
            "baseName": "series",
            "type": "Array<CustomFilterChartSeriesConfig>"
        },
        {
            "name": "resultMetadata",
            "baseName": "resultMetadata",
            "type": "{ [key: string]: CustomChartingItemMetadataConfig; }"
        },
        {
            "name": "axisLimits",
            "baseName": "axisLimits",
            "type": "{ [key: string]: number; }"
        },
        {
            "name": "leftAxisCustomUnit",
            "baseName": "leftAxisCustomUnit",
            "type": "CustomFilterChartConfig.LeftAxisCustomUnitEnum"
        },
        {
            "name": "rightAxisCustomUnit",
            "baseName": "rightAxisCustomUnit",
            "type": "CustomFilterChartConfig.RightAxisCustomUnitEnum"
        }    ];

    static getAttributeTypeMap() {
        return CustomFilterChartConfig.attributeTypeMap;
    }
}

export namespace CustomFilterChartConfig {
    export enum TypeEnum {
        PIE = <any> 'PIE',
        SINGLEVALUE = <any> 'SINGLE_VALUE',
        TIMESERIES = <any> 'TIMESERIES',
        TOPLIST = <any> 'TOP_LIST'
    }
    export enum LeftAxisCustomUnitEnum {
        Bit = <any> 'Bit',
        BitPerHour = <any> 'BitPerHour',
        BitPerMinute = <any> 'BitPerMinute',
        BitPerSecond = <any> 'BitPerSecond',
        Byte = <any> 'Byte',
        BytePerHour = <any> 'BytePerHour',
        BytePerMinute = <any> 'BytePerMinute',
        BytePerSecond = <any> 'BytePerSecond',
        Cores = <any> 'Cores',
        Count = <any> 'Count',
        Day = <any> 'Day',
        GibiByte = <any> 'GibiByte',
        Giga = <any> 'Giga',
        GigaByte = <any> 'GigaByte',
        Hour = <any> 'Hour',
        KibiByte = <any> 'KibiByte',
        KibiBytePerHour = <any> 'KibiBytePerHour',
        KibiBytePerMinute = <any> 'KibiBytePerMinute',
        KibiBytePerSecond = <any> 'KibiBytePerSecond',
        Kilo = <any> 'Kilo',
        KiloByte = <any> 'KiloByte',
        KiloBytePerHour = <any> 'KiloBytePerHour',
        KiloBytePerMinute = <any> 'KiloBytePerMinute',
        KiloBytePerSecond = <any> 'KiloBytePerSecond',
        MebiByte = <any> 'MebiByte',
        MebiBytePerHour = <any> 'MebiBytePerHour',
        MebiBytePerMinute = <any> 'MebiBytePerMinute',
        MebiBytePerSecond = <any> 'MebiBytePerSecond',
        Mega = <any> 'Mega',
        MegaByte = <any> 'MegaByte',
        MegaBytePerHour = <any> 'MegaBytePerHour',
        MegaBytePerMinute = <any> 'MegaBytePerMinute',
        MegaBytePerSecond = <any> 'MegaBytePerSecond',
        MicroSecond = <any> 'MicroSecond',
        MilliCores = <any> 'MilliCores',
        MilliSecond = <any> 'MilliSecond',
        MilliSecondPerMinute = <any> 'MilliSecondPerMinute',
        Minute = <any> 'Minute',
        Month = <any> 'Month',
        NanoSecond = <any> 'NanoSecond',
        NanoSecondPerMinute = <any> 'NanoSecondPerMinute',
        NotApplicable = <any> 'NotApplicable',
        PerHour = <any> 'PerHour',
        PerMinute = <any> 'PerMinute',
        PerSecond = <any> 'PerSecond',
        Percent = <any> 'Percent',
        Pixel = <any> 'Pixel',
        Promille = <any> 'Promille',
        Ratio = <any> 'Ratio',
        Second = <any> 'Second',
        State = <any> 'State',
        Unspecified = <any> 'Unspecified',
        Week = <any> 'Week',
        Year = <any> 'Year'
    }
    export enum RightAxisCustomUnitEnum {
        Bit = <any> 'Bit',
        BitPerHour = <any> 'BitPerHour',
        BitPerMinute = <any> 'BitPerMinute',
        BitPerSecond = <any> 'BitPerSecond',
        Byte = <any> 'Byte',
        BytePerHour = <any> 'BytePerHour',
        BytePerMinute = <any> 'BytePerMinute',
        BytePerSecond = <any> 'BytePerSecond',
        Cores = <any> 'Cores',
        Count = <any> 'Count',
        Day = <any> 'Day',
        GibiByte = <any> 'GibiByte',
        Giga = <any> 'Giga',
        GigaByte = <any> 'GigaByte',
        Hour = <any> 'Hour',
        KibiByte = <any> 'KibiByte',
        KibiBytePerHour = <any> 'KibiBytePerHour',
        KibiBytePerMinute = <any> 'KibiBytePerMinute',
        KibiBytePerSecond = <any> 'KibiBytePerSecond',
        Kilo = <any> 'Kilo',
        KiloByte = <any> 'KiloByte',
        KiloBytePerHour = <any> 'KiloBytePerHour',
        KiloBytePerMinute = <any> 'KiloBytePerMinute',
        KiloBytePerSecond = <any> 'KiloBytePerSecond',
        MebiByte = <any> 'MebiByte',
        MebiBytePerHour = <any> 'MebiBytePerHour',
        MebiBytePerMinute = <any> 'MebiBytePerMinute',
        MebiBytePerSecond = <any> 'MebiBytePerSecond',
        Mega = <any> 'Mega',
        MegaByte = <any> 'MegaByte',
        MegaBytePerHour = <any> 'MegaBytePerHour',
        MegaBytePerMinute = <any> 'MegaBytePerMinute',
        MegaBytePerSecond = <any> 'MegaBytePerSecond',
        MicroSecond = <any> 'MicroSecond',
        MilliCores = <any> 'MilliCores',
        MilliSecond = <any> 'MilliSecond',
        MilliSecondPerMinute = <any> 'MilliSecondPerMinute',
        Minute = <any> 'Minute',
        Month = <any> 'Month',
        NanoSecond = <any> 'NanoSecond',
        NanoSecondPerMinute = <any> 'NanoSecondPerMinute',
        NotApplicable = <any> 'NotApplicable',
        PerHour = <any> 'PerHour',
        PerMinute = <any> 'PerMinute',
        PerSecond = <any> 'PerSecond',
        Percent = <any> 'Percent',
        Pixel = <any> 'Pixel',
        Promille = <any> 'Promille',
        Ratio = <any> 'Ratio',
        Second = <any> 'Second',
        State = <any> 'State',
        Unspecified = <any> 'Unspecified',
        Week = <any> 'Week',
        Year = <any> 'Year'
    }
}
