/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { CustomFilterChartSeriesDimensionConfig } from './customFilterChartSeriesDimensionConfig';

/**
* Configuration of a charted metric.
*/
export class CustomFilterChartSeriesConfig {
    /**
    * The name of the charted metric.
    */
    'metric': string;
    /**
    * The charted aggregation of the metric.
    */
    'aggregation': CustomFilterChartSeriesConfig.AggregationEnum;
    /**
    * The charted percentile.    Only applicable if the **aggregation** is set to `PERCENTILE`.
    */
    'percentile'?: number;
    /**
    * The visualization of the timeseries chart.
    */
    'type': CustomFilterChartSeriesConfig.TypeEnum;
    /**
    * The type of the Dynatrace entity that delivered the charted metric.
    */
    'entityType': string;
    /**
    * Configuration of the charted metric splitting.
    */
    'dimensions': Array<CustomFilterChartSeriesDimensionConfig>;
    /**
    * Sort ascending (`true`) or descending (`false`). 
    */
    'sortAscending'?: boolean;
    'aggregationRate'?: CustomFilterChartSeriesConfig.AggregationRateEnum;
    'sortColumn'?: boolean;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "metric",
            "baseName": "metric",
            "type": "string"
        },
        {
            "name": "aggregation",
            "baseName": "aggregation",
            "type": "CustomFilterChartSeriesConfig.AggregationEnum"
        },
        {
            "name": "percentile",
            "baseName": "percentile",
            "type": "number"
        },
        {
            "name": "type",
            "baseName": "type",
            "type": "CustomFilterChartSeriesConfig.TypeEnum"
        },
        {
            "name": "entityType",
            "baseName": "entityType",
            "type": "string"
        },
        {
            "name": "dimensions",
            "baseName": "dimensions",
            "type": "Array<CustomFilterChartSeriesDimensionConfig>"
        },
        {
            "name": "sortAscending",
            "baseName": "sortAscending",
            "type": "boolean"
        },
        {
            "name": "aggregationRate",
            "baseName": "aggregationRate",
            "type": "CustomFilterChartSeriesConfig.AggregationRateEnum"
        },
        {
            "name": "sortColumn",
            "baseName": "sortColumn",
            "type": "boolean"
        }    ];

    static getAttributeTypeMap() {
        return CustomFilterChartSeriesConfig.attributeTypeMap;
    }
}

export namespace CustomFilterChartSeriesConfig {
    export enum AggregationEnum {
        AVG = <any> 'AVG',
        COUNT = <any> 'COUNT',
        DISTINCT = <any> 'DISTINCT',
        FASTEST10PERCENT = <any> 'FASTEST10PERCENT',
        MAX = <any> 'MAX',
        MEDIAN = <any> 'MEDIAN',
        MIN = <any> 'MIN',
        NONE = <any> 'NONE',
        OFINTERESTRATIO = <any> 'OF_INTEREST_RATIO',
        OTHERRATIO = <any> 'OTHER_RATIO',
        PERCENTILE = <any> 'PERCENTILE',
        PERMIN = <any> 'PER_MIN',
        SLOWEST10PERCENT = <any> 'SLOWEST10PERCENT',
        SLOWEST5PERCENT = <any> 'SLOWEST5PERCENT',
        SUM = <any> 'SUM',
        SUMDIMENSIONS = <any> 'SUM_DIMENSIONS'
    }
    export enum TypeEnum {
        AREA = <any> 'AREA',
        BAR = <any> 'BAR',
        LINE = <any> 'LINE'
    }
    export enum AggregationRateEnum {
        HOUR = <any> 'HOUR',
        MINUTE = <any> 'MINUTE',
        SECOND = <any> 'SECOND',
        TOTAL = <any> 'TOTAL'
    }
}
