/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { CustomFilterChartConfig } from './customFilterChartConfig';

/**
* Configuration of the custom filter of a tile.
*/
export class CustomFilterConfig {
    /**
    * The type of the filter.    It shows to which entity the filter belongs.    Custom charts have the `MIXED` type.
    */
    'type': CustomFilterConfig.TypeEnum;
    /**
    * The name of the tile, set by user
    */
    'customName': string;
    /**
    * The default name of the tile
    */
    'defaultName': string;
    'chartConfig': CustomFilterChartConfig;
    /**
    * A list of filters, applied to specific entity types.
    */
    'filtersPerEntityType': { [key: string]: { [key: string]: Array<string>; }; };

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "type",
            "baseName": "type",
            "type": "CustomFilterConfig.TypeEnum"
        },
        {
            "name": "customName",
            "baseName": "customName",
            "type": "string"
        },
        {
            "name": "defaultName",
            "baseName": "defaultName",
            "type": "string"
        },
        {
            "name": "chartConfig",
            "baseName": "chartConfig",
            "type": "CustomFilterChartConfig"
        },
        {
            "name": "filtersPerEntityType",
            "baseName": "filtersPerEntityType",
            "type": "{ [key: string]: { [key: string]: Array<string>; }; }"
        }    ];

    static getAttributeTypeMap() {
        return CustomFilterConfig.attributeTypeMap;
    }
}

export namespace CustomFilterConfig {
    export enum TypeEnum {
        ALB = <any> 'ALB',
        APPLICATION = <any> 'APPLICATION',
        APPLICATIONMETHOD = <any> 'APPLICATION_METHOD',
        APPMON = <any> 'APPMON',
        ASG = <any> 'ASG',
        AWSCREDENTIALS = <any> 'AWS_CREDENTIALS',
        AWSCUSTOMSERVICE = <any> 'AWS_CUSTOM_SERVICE',
        AWSLAMBDAFUNCTION = <any> 'AWS_LAMBDA_FUNCTION',
        CLOUDAPPLICATION = <any> 'CLOUD_APPLICATION',
        CLOUDAPPLICATIONNAMESPACE = <any> 'CLOUD_APPLICATION_NAMESPACE',
        CONTAINERGROUPINSTANCE = <any> 'CONTAINER_GROUP_INSTANCE',
        CUSTOMAPPLICATION = <any> 'CUSTOM_APPLICATION',
        CUSTOMDEVICES = <any> 'CUSTOM_DEVICES',
        CUSTOMSERVICES = <any> 'CUSTOM_SERVICES',
        DATABASE = <any> 'DATABASE',
        DATABASEKEYREQUEST = <any> 'DATABASE_KEY_REQUEST',
        DCRUMAPPLICATION = <any> 'DCRUM_APPLICATION',
        DCRUMENTITY = <any> 'DCRUM_ENTITY',
        DYNAMODB = <any> 'DYNAMO_DB',
        EBS = <any> 'EBS',
        EC2 = <any> 'EC2',
        ELB = <any> 'ELB',
        ENVIRONMENT = <any> 'ENVIRONMENT',
        ESXI = <any> 'ESXI',
        EXTERNALSYNTHETICTEST = <any> 'EXTERNAL_SYNTHETIC_TEST',
        GLOBALBACKGROUNDACTIVITY = <any> 'GLOBAL_BACKGROUND_ACTIVITY',
        HOST = <any> 'HOST',
        IOT = <any> 'IOT',
        KUBERNETESCLUSTER = <any> 'KUBERNETES_CLUSTER',
        KUBERNETESNODE = <any> 'KUBERNETES_NODE',
        MDASERVICE = <any> 'MDA_SERVICE',
        MIXED = <any> 'MIXED',
        MOBILEAPPLICATION = <any> 'MOBILE_APPLICATION',
        MONITOREDENTITY = <any> 'MONITORED_ENTITY',
        NLB = <any> 'NLB',
        PGBACKGROUNDACTIVITY = <any> 'PG_BACKGROUND_ACTIVITY',
        PROBLEM = <any> 'PROBLEM',
        PROCESSGROUPINSTANCE = <any> 'PROCESS_GROUP_INSTANCE',
        RDS = <any> 'RDS',
        REMOTEPLUGIN = <any> 'REMOTE_PLUGIN',
        SERVICE = <any> 'SERVICE',
        SERVICEKEYREQUEST = <any> 'SERVICE_KEY_REQUEST',
        SYNTHETICBROWSERMONITOR = <any> 'SYNTHETIC_BROWSER_MONITOR',
        SYNTHETICHTTPCHECK = <any> 'SYNTHETIC_HTTPCHECK',
        SYNTHETICHTTPCHECKSTEP = <any> 'SYNTHETIC_HTTPCHECK_STEP',
        SYNTHETICLOCATION = <any> 'SYNTHETIC_LOCATION',
        SYNTHETICTEST = <any> 'SYNTHETIC_TEST',
        SYNTHETICTESTSTEP = <any> 'SYNTHETIC_TEST_STEP',
        UIENTITY = <any> 'UI_ENTITY',
        VIRTUALMACHINE = <any> 'VIRTUAL_MACHINE',
        WEBCHECK = <any> 'WEB_CHECK'
    }
}
