/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { ConfigurationMetadata } from './configurationMetadata';
import { DetectionRule } from './detectionRule';

export class CustomService {
    'metadata'?: ConfigurationMetadata;
    /**
    * The ID of the custom service.
    */
    'id'?: string;
    /**
    * The name of the custom service, displayed in the UI.
    */
    'name': string;
    /**
    * The order string. Sorting custom services alphabetically by their order string determines their relative ordering.  Typically this is managed by Dynatrace internally and will not be present in GET responses.
    */
    'order'?: string;
    /**
    * Custom service enabled/disabled.
    */
    'enabled': boolean;
    /**
    * The list of rules defining the custom service.
    */
    'rules': Array<DetectionRule>;
    /**
    * The queue entry point flag.   Set to `true` for custom messaging services.
    */
    'queueEntryPoint': boolean;
    /**
    * The queue entry point type..
    */
    'queueEntryPointType'?: CustomService.QueueEntryPointTypeEnum;
    /**
    * The list of process groups the custom service should belong to.
    */
    'processGroups'?: Array<string>;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "metadata",
            "baseName": "metadata",
            "type": "ConfigurationMetadata"
        },
        {
            "name": "id",
            "baseName": "id",
            "type": "string"
        },
        {
            "name": "name",
            "baseName": "name",
            "type": "string"
        },
        {
            "name": "order",
            "baseName": "order",
            "type": "string"
        },
        {
            "name": "enabled",
            "baseName": "enabled",
            "type": "boolean"
        },
        {
            "name": "rules",
            "baseName": "rules",
            "type": "Array<DetectionRule>"
        },
        {
            "name": "queueEntryPoint",
            "baseName": "queueEntryPoint",
            "type": "boolean"
        },
        {
            "name": "queueEntryPointType",
            "baseName": "queueEntryPointType",
            "type": "CustomService.QueueEntryPointTypeEnum"
        },
        {
            "name": "processGroups",
            "baseName": "processGroups",
            "type": "Array<string>"
        }    ];

    static getAttributeTypeMap() {
        return CustomService.attributeTypeMap;
    }
}

export namespace CustomService {
    export enum QueueEntryPointTypeEnum {
        IBMMQ = <any> 'IBM_MQ',
        JMS = <any> 'JMS',
        KAFKA = <any> 'KAFKA',
        MSMQ = <any> 'MSMQ',
        RABBITMQ = <any> 'RABBIT_MQ'
    }
}
