/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { ConfigurationMetadata } from './configurationMetadata';
import { DashboardMetadata } from './dashboardMetadata';
import { Tile } from './tile';

/**
* Configuration of a dashboard.
*/
export class Dashboard {
    'metadata'?: ConfigurationMetadata;
    /**
    * The ID of the dashboard.
    */
    'id'?: string;
    'dashboardMetadata': DashboardMetadata;
    /**
    * The list of tiles on the dashboard.
    */
    'tiles': Array<Tile>;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "metadata",
            "baseName": "metadata",
            "type": "ConfigurationMetadata"
        },
        {
            "name": "id",
            "baseName": "id",
            "type": "string"
        },
        {
            "name": "dashboardMetadata",
            "baseName": "dashboardMetadata",
            "type": "DashboardMetadata"
        },
        {
            "name": "tiles",
            "baseName": "tiles",
            "type": "Array<Tile>"
        }    ];

    static getAttributeTypeMap() {
        return Dashboard.attributeTypeMap;
    }
}

