/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { DashboardFilter } from './dashboardFilter';
import { SharingInfo } from './sharingInfo';

/**
* Parameters of a dashboard.
*/
export class DashboardMetadata {
    /**
    * The name of the dashboard.
    */
    'name': string;
    /**
    * The dashboard is shared (`true`) or private (`false`).
    */
    'shared'?: boolean;
    /**
    * The owner of the dashboard.
    */
    'owner'?: string;
    'sharingDetails'?: SharingInfo;
    'dashboardFilter'?: DashboardFilter;
    /**
    * A set of tags assigned to the dashboard.
    */
    'tags'?: Array<string>;
    /**
    * The dashboard is a preset (`true`)
    */
    'preset'?: boolean;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "name",
            "baseName": "name",
            "type": "string"
        },
        {
            "name": "shared",
            "baseName": "shared",
            "type": "boolean"
        },
        {
            "name": "owner",
            "baseName": "owner",
            "type": "string"
        },
        {
            "name": "sharingDetails",
            "baseName": "sharingDetails",
            "type": "SharingInfo"
        },
        {
            "name": "dashboardFilter",
            "baseName": "dashboardFilter",
            "type": "DashboardFilter"
        },
        {
            "name": "tags",
            "baseName": "tags",
            "type": "Array<string>"
        },
        {
            "name": "preset",
            "baseName": "preset",
            "type": "boolean"
        }    ];

    static getAttributeTypeMap() {
        return DashboardMetadata.attributeTypeMap;
    }
}

