/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { DashboardReportSubscription } from './dashboardReportSubscription';

/**
* Configuration of a dashboard report.   The dashboard report provides a public link to the associated dashboard with a custom reporting period: last week for weekly subscribers or last month for monthly subscribers.
*/
export class DashboardReport {
    /**
    * The ID of the report.
    */
    'id'?: string;
    'type': DashboardReport.TypeEnum;
    /**
    * The ID of the associated dashboard.
    */
    'dashboardId': string;
    /**
    * The email notifications for the dashboard report are enabled (`true`) or disabled (`false`).
    */
    'enabled'?: boolean;
    'subscriptions': DashboardReportSubscription;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "id",
            "baseName": "id",
            "type": "string"
        },
        {
            "name": "type",
            "baseName": "type",
            "type": "DashboardReport.TypeEnum"
        },
        {
            "name": "dashboardId",
            "baseName": "dashboardId",
            "type": "string"
        },
        {
            "name": "enabled",
            "baseName": "enabled",
            "type": "boolean"
        },
        {
            "name": "subscriptions",
            "baseName": "subscriptions",
            "type": "DashboardReportSubscription"
        }    ];

    static getAttributeTypeMap() {
        return DashboardReport.attributeTypeMap;
    }
}

export namespace DashboardReport {
    export enum TypeEnum {
        DASHBOARD = <any> 'DASHBOARD'
    }
}
