/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { ConfigurationMetadata } from './configurationMetadata';

export class DataPrivacyAndSecurity {
    'metadata'?: ConfigurationMetadata;
    /**
    * Mask IP addresses and GPS coordinates enabled/disabled.
    */
    'maskIpAddressesAndGpsCoordinates': boolean;
    /**
    * Mask user action names (Web applications only) enabled/disabled.
    */
    'maskUserActionNames': boolean;
    /**
    * Mask personal data in URIs enabled/disabled.
    */
    'maskPersonalDataInUris': boolean;
    /**
    * The audit logging is enabled (`true`) or disabled (`false`).
    */
    'logAuditEvents'?: boolean;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "metadata",
            "baseName": "metadata",
            "type": "ConfigurationMetadata"
        },
        {
            "name": "maskIpAddressesAndGpsCoordinates",
            "baseName": "maskIpAddressesAndGpsCoordinates",
            "type": "boolean"
        },
        {
            "name": "maskUserActionNames",
            "baseName": "maskUserActionNames",
            "type": "boolean"
        },
        {
            "name": "maskPersonalDataInUris",
            "baseName": "maskPersonalDataInUris",
            "type": "boolean"
        },
        {
            "name": "logAuditEvents",
            "baseName": "logAuditEvents",
            "type": "boolean"
        }    ];

    static getAttributeTypeMap() {
        return DataPrivacyAndSecurity.attributeTypeMap;
    }
}

