/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* Parameters of the failed database connections detection.   The alert is triggered when failed connections number exceeds **connectionFailsCount** during any **timePeriodMinutes** minutes period.
*/
export class DatabaseConnectionFailureDetectionConfig {
    /**
    * The detection is enabled (`true`) or disabled (`false`).
    */
    'enabled': boolean;
    /**
    * Number of failed database connections during any **timePeriodMinutes** minutes period to trigger an alert.
    */
    'connectionFailsCount'?: number;
    /**
    * The *X* minutes time period during which the **connectionFailsCount** is evaluated.
    */
    'timePeriodMinutes'?: number;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "enabled",
            "baseName": "enabled",
            "type": "boolean"
        },
        {
            "name": "connectionFailsCount",
            "baseName": "connectionFailsCount",
            "type": "number"
        },
        {
            "name": "timePeriodMinutes",
            "baseName": "timePeriodMinutes",
            "type": "number"
        }    ];

    static getAttributeTypeMap() {
        return DatabaseConnectionFailureDetectionConfig.attributeTypeMap;
    }
}

