/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { ComparisonBasic } from './comparisonBasic';
import { DcrumDecoderComparisonAllOf } from './dcrumDecoderComparisonAllOf';

/**
* Comparison for `DCRUM_DECODER_TYPE` attributes.
*/
export class DcrumDecoderComparison extends ComparisonBasic {
    /**
    * Operator of the comparison. You can reverse it by setting **negate** to `true`.   Possible values depend on the **type** of the comparison. Find the list of actual models in the description of the **type** field and check the description of the model you need.
    */
    'operator': DcrumDecoderComparison.OperatorEnum;
    /**
    * The value to compare to.
    */
    'value'?: DcrumDecoderComparison.ValueEnum;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "operator",
            "baseName": "operator",
            "type": "DcrumDecoderComparison.OperatorEnum"
        },
        {
            "name": "value",
            "baseName": "value",
            "type": "DcrumDecoderComparison.ValueEnum"
        }    ];

    static getAttributeTypeMap() {
        return super.getAttributeTypeMap().concat(DcrumDecoderComparison.attributeTypeMap);
    }
}

export namespace DcrumDecoderComparison {
    export enum OperatorEnum {
        EQUALS = <any> 'EQUALS',
        EXISTS = <any> 'EXISTS'
    }
    export enum ValueEnum {
        ALLOTHER = <any> 'ALL_OTHER',
        CITRIXAPPFLOW = <any> 'CITRIX_APPFLOW',
        CITRIXICA = <any> 'CITRIX_ICA',
        CITRIXICAOVERSSL = <any> 'CITRIX_ICA_OVER_SSL',
        DB2DRDA = <any> 'DB2_DRDA',
        HTTP = <any> 'HTTP',
        HTTPS = <any> 'HTTPS',
        HTTPEXPRESS = <any> 'HTTP_EXPRESS',
        INFORMIX = <any> 'INFORMIX',
        MYSQL = <any> 'MYSQL',
        ORACLE = <any> 'ORACLE',
        SAPGUI = <any> 'SAP_GUI',
        SAPGUIOVERHTTP = <any> 'SAP_GUI_OVER_HTTP',
        SAPGUIOVERHTTPS = <any> 'SAP_GUI_OVER_HTTPS',
        SAPHANADB = <any> 'SAP_HANA_DB',
        SAPRFC = <any> 'SAP_RFC',
        SSL = <any> 'SSL',
        TDS = <any> 'TDS'
    }
}
