/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* Configuration of a destination-based conversion goal.
*/
export class DestinationDetails {
    /**
    * The path to be reached to hit the conversion goal.
    */
    'urlOrPath': string;
    /**
    * The operator of the match.
    */
    'matchType'?: DestinationDetails.MatchTypeEnum;
    /**
    * The match is case-sensitive (`true`) or (`false`).
    */
    'caseSensitive'?: boolean;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "urlOrPath",
            "baseName": "urlOrPath",
            "type": "string"
        },
        {
            "name": "matchType",
            "baseName": "matchType",
            "type": "DestinationDetails.MatchTypeEnum"
        },
        {
            "name": "caseSensitive",
            "baseName": "caseSensitive",
            "type": "boolean"
        }    ];

    static getAttributeTypeMap() {
        return DestinationDetails.attributeTypeMap;
    }
}

export namespace DestinationDetails {
    export enum MatchTypeEnum {
        Begins = <any> 'Begins',
        Contains = <any> 'Contains',
        Ends = <any> 'Ends'
    }
}
