/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { MethodRule } from './methodRule';

export class DetectionRule {
    /**
    * The ID of the detection rule.
    */
    'id'?: string;
    /**
    * Rule enabled/disabled.
    */
    'enabled': boolean;
    /**
    * The PHP file containing the class or methods to instrument.   Required for PHP custom service.    Not applicable to Java and .NET.
    */
    'fileName'?: string;
    /**
    * Matcher applying to the file name. Default value is `ENDS_WITH` (if applicable).
    */
    'fileNameMatcher'?: DetectionRule.FileNameMatcherEnum;
    /**
    * The fully qualified class or interface to instrument.   Required for Java and .NET custom services.    Not applicable to PHP.
    */
    'className'?: string;
    /**
    * Matcher applying to the class name. `STARTS_WITH` can only be used if there is at least one annotation defined. Default value is `EQUALS`.
    */
    'matcher'?: DetectionRule.MatcherEnum;
    /**
    * List of methods to instrument.
    */
    'methodRules': Array<MethodRule>;
    /**
    * Additional annotations filter of the rule.   Only classes where all listed annotations are available in the class itself or any of its superclasses are instrumented.   Not applicable to PHP.
    */
    'annotations'?: Array<string>;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "id",
            "baseName": "id",
            "type": "string"
        },
        {
            "name": "enabled",
            "baseName": "enabled",
            "type": "boolean"
        },
        {
            "name": "fileName",
            "baseName": "fileName",
            "type": "string"
        },
        {
            "name": "fileNameMatcher",
            "baseName": "fileNameMatcher",
            "type": "DetectionRule.FileNameMatcherEnum"
        },
        {
            "name": "className",
            "baseName": "className",
            "type": "string"
        },
        {
            "name": "matcher",
            "baseName": "matcher",
            "type": "DetectionRule.MatcherEnum"
        },
        {
            "name": "methodRules",
            "baseName": "methodRules",
            "type": "Array<MethodRule>"
        },
        {
            "name": "annotations",
            "baseName": "annotations",
            "type": "Array<string>"
        }    ];

    static getAttributeTypeMap() {
        return DetectionRule.attributeTypeMap;
    }
}

export namespace DetectionRule {
    export enum FileNameMatcherEnum {
        ENDSWITH = <any> 'ENDS_WITH',
        EQUALS = <any> 'EQUALS',
        STARTSWITH = <any> 'STARTS_WITH'
    }
    export enum MatcherEnum {
        ENDSWITH = <any> 'ENDS_WITH',
        EQUALS = <any> 'EQUALS',
        STARTSWITH = <any> 'STARTS_WITH'
    }
}
