/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { Placeholder } from './placeholder';

/**
* Parameters of a definition of a calculated service metric.
*/
export class DimensionDefinition {
    /**
    * The name of the dimension.
    */
    'name': string;
    /**
    * The dimension value pattern.    You can define custom placeholders in the **placeholders** field and use them here.
    */
    'dimension': string;
    /**
    * The list of custom placeholders to be used in a dimension value pattern.
    */
    'placeholders'?: Array<Placeholder>;
    /**
    * The number of top values to be calculated.
    */
    'topX': number;
    /**
    * How to calculate the **topX** values.
    */
    'topXDirection': DimensionDefinition.TopXDirectionEnum;
    /**
    * The aggregation of the dimension.
    */
    'topXAggregation': DimensionDefinition.TopXAggregationEnum;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "name",
            "baseName": "name",
            "type": "string"
        },
        {
            "name": "dimension",
            "baseName": "dimension",
            "type": "string"
        },
        {
            "name": "placeholders",
            "baseName": "placeholders",
            "type": "Array<Placeholder>"
        },
        {
            "name": "topX",
            "baseName": "topX",
            "type": "number"
        },
        {
            "name": "topXDirection",
            "baseName": "topXDirection",
            "type": "DimensionDefinition.TopXDirectionEnum"
        },
        {
            "name": "topXAggregation",
            "baseName": "topXAggregation",
            "type": "DimensionDefinition.TopXAggregationEnum"
        }    ];

    static getAttributeTypeMap() {
        return DimensionDefinition.attributeTypeMap;
    }
}

export namespace DimensionDefinition {
    export enum TopXDirectionEnum {
        ASCENDING = <any> 'ASCENDING',
        DESCENDING = <any> 'DESCENDING'
    }
    export enum TopXAggregationEnum {
        AVERAGE = <any> 'AVERAGE',
        COUNT = <any> 'COUNT',
        MAX = <any> 'MAX',
        MIN = <any> 'MIN',
        OFINTERESTRATIO = <any> 'OF_INTEREST_RATIO',
        OTHERRATIO = <any> 'OTHER_RATIO',
        SINGLEVALUE = <any> 'SINGLE_VALUE',
        SUM = <any> 'SUM'
    }
}
