/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { ConfigurationMetadata } from './configurationMetadata';
import { DiskNameFilter } from './diskNameFilter';
import { TagFilter } from './tagFilter';

export class DiskEventAnomalyDetectionConfig {
    'metadata'?: ConfigurationMetadata;
    /**
    * The ID of the disk event rule.
    */
    'id'?: string;
    /**
    * The name of the disk event rule.
    */
    'name': string;
    /**
    * Disk event rule enabled/disabled.
    */
    'enabled': boolean;
    /**
    * The metric to monitor.
    */
    'metric': DiskEventAnomalyDetectionConfig.MetricEnum;
    /**
    * The threshold to trigger disk event.    * A percentage for `LowDiskSpace` or `LowInodes` metrics.   * In milliseconds for `ReadTimeExceeding` or `WriteTimeExceeding` metrics.
    */
    'threshold': number;
    /**
    * The number of samples to evaluate.
    */
    'samples': number;
    /**
    * The number of samples that must violate the threshold to trigger an event. Must not exceed the number of evaluated samples.
    */
    'violatingSamples': number;
    'diskNameFilter'?: DiskNameFilter;
    /**
    * Narrows the rule usage down to the hosts matching the specified tags.
    */
    'tagFilters'?: Array<TagFilter>;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "metadata",
            "baseName": "metadata",
            "type": "ConfigurationMetadata"
        },
        {
            "name": "id",
            "baseName": "id",
            "type": "string"
        },
        {
            "name": "name",
            "baseName": "name",
            "type": "string"
        },
        {
            "name": "enabled",
            "baseName": "enabled",
            "type": "boolean"
        },
        {
            "name": "metric",
            "baseName": "metric",
            "type": "DiskEventAnomalyDetectionConfig.MetricEnum"
        },
        {
            "name": "threshold",
            "baseName": "threshold",
            "type": "number"
        },
        {
            "name": "samples",
            "baseName": "samples",
            "type": "number"
        },
        {
            "name": "violatingSamples",
            "baseName": "violatingSamples",
            "type": "number"
        },
        {
            "name": "diskNameFilter",
            "baseName": "diskNameFilter",
            "type": "DiskNameFilter"
        },
        {
            "name": "tagFilters",
            "baseName": "tagFilters",
            "type": "Array<TagFilter>"
        }    ];

    static getAttributeTypeMap() {
        return DiskEventAnomalyDetectionConfig.attributeTypeMap;
    }
}

export namespace DiskEventAnomalyDetectionConfig {
    export enum MetricEnum {
        LOWDISKSPACE = <any> 'LOW_DISK_SPACE',
        LOWINODES = <any> 'LOW_INODES',
        READTIMEEXCEEDING = <any> 'READ_TIME_EXCEEDING',
        WRITETIMEEXCEEDING = <any> 'WRITE_TIME_EXCEEDING'
    }
}
