/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { EmailNotificationConfigAllOf } from './emailNotificationConfigAllOf';
import { NotificationConfig } from './notificationConfig';

/**
* Configuration of the email notification.
*/
export class EmailNotificationConfig extends NotificationConfig {
    /**
    * The subject of the email notifications.
    */
    'subject': string;
    /**
    * The template of the email notification.   You can use the following placeholders:  * `{ImpactedEntities}`: Details about the entities impacted by the problem in form of a JSON array.  * `{ImpactedEntity}`: The entity impacted by the problem or *X* impacted entities.  * `{PID}`: The ID of the reported problem.  * `{ProblemDetailsHTML}`: All problem event details, including root cause, as an HTML-formatted string.  * `{ProblemDetailsJSON}`: All problem event details, including root cause, as a JSON object.  * `{ProblemDetailsMarkdown}`: All problem event details, including root cause, as a [Markdown-formatted](https://www.markdownguide.org/cheat-sheet/) string.  * `{ProblemDetailsText}`: All problem event details, including root cause, as a text-formatted string.  * `{ProblemID}`: The display number of the reported problem.  * `{ProblemImpact}`: The [impact level](https://www.dynatrace.com/support/help/shortlink/impact-analysis) of the problem. Possible values are `APPLICATION`, `SERVICE`, and `INFRASTRUCTURE`.  * `{ProblemSeverity}`: The [severity level](https://www.dynatrace.com/support/help/shortlink/event-types) of the problem. Possible values are `AVAILABILITY`, `ERROR`, `PERFORMANCE`, `RESOURCE_CONTENTION`, and `CUSTOM_ALERT`.  * `{ProblemTitle}`: A short description of the problem.  * `{ProblemURL}`: The URL of the problem within Dynatrace.  * `{State}`: The state of the problem. Possible values are `OPEN` and `RESOLVED`. If the problem has been merged into another problem, it has the `MERGED` value.  * `{Tags}`: The list of tags that are defined for all impacted entities, separated by commas.  
    */
    'body': string;
    /**
    * The list of the email recipients.
    */
    'receivers': Array<string>;
    /**
    * The list of the email CC-recipients.
    */
    'ccReceivers'?: Array<string>;
    /**
    * Send (`true`) or doesn\'t send (`false`) an email, confirming problem resolution.
    */
    'shouldSendForResolvedProblems': boolean;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "subject",
            "baseName": "subject",
            "type": "string"
        },
        {
            "name": "body",
            "baseName": "body",
            "type": "string"
        },
        {
            "name": "receivers",
            "baseName": "receivers",
            "type": "Array<string>"
        },
        {
            "name": "ccReceivers",
            "baseName": "ccReceivers",
            "type": "Array<string>"
        },
        {
            "name": "shouldSendForResolvedProblems",
            "baseName": "shouldSendForResolvedProblems",
            "type": "boolean"
        }    ];

    static getAttributeTypeMap() {
        return super.getAttributeTypeMap().concat(EmailNotificationConfig.attributeTypeMap);
    }
}

export namespace EmailNotificationConfig {
}
