/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { CompareOperation } from './compareOperation';
import { EqualsCompareOperationAllOf } from './equalsCompareOperationAllOf';

/**
* The condition of the `EQUALS` type.   The condition checks whether the detected value equals the specified one.
*/
export class EqualsCompareOperation extends CompareOperation {
    /**
    * Inverts the operation of the condition. Set to `true` to turn **equals** into **does not equal**.    If not set, then `false` is used.
    */
    'negate'?: boolean;
    /**
    * The condition is case sensitive (`false`) or case insensitive (`true`).   If not set, then `false` is used, making the condition case sensitive.
    */
    'ignoreCase'?: boolean;
    /**
    * The value to compare to.   If several values are specified, the OR logic applies.
    */
    'values'?: Array<object>;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "negate",
            "baseName": "negate",
            "type": "boolean"
        },
        {
            "name": "ignoreCase",
            "baseName": "ignoreCase",
            "type": "boolean"
        },
        {
            "name": "values",
            "baseName": "values",
            "type": "Array<object>"
        }    ];

    static getAttributeTypeMap() {
        return super.getAttributeTypeMap().concat(EqualsCompareOperation.attributeTypeMap);
    }
}

export namespace EqualsCompareOperation {
}
