/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* In addition to the event handlers, events called using `addEventListener` or `attachEvent` can be captured. Be careful with this option! Event wrappers can conflict with the JavaScript code on a web page.
*/
export class EventWrapperSettings {
    /**
    * Click enabled/disabled.
    */
    'click': boolean;
    /**
    * MouseUp enabled/disabled.
    */
    'mouseUp': boolean;
    /**
    * Change enabled/disabled.
    */
    'change': boolean;
    /**
    * Blur enabled/disabled.
    */
    'blur': boolean;
    /**
    * TouchStart enabled/disabled.
    */
    'touchStart': boolean;
    /**
    * TouchEnd enabled/disabled.
    */
    'touchEnd': boolean;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "click",
            "baseName": "click",
            "type": "boolean"
        },
        {
            "name": "mouseUp",
            "baseName": "mouseUp",
            "type": "boolean"
        },
        {
            "name": "change",
            "baseName": "change",
            "type": "boolean"
        },
        {
            "name": "blur",
            "baseName": "blur",
            "type": "boolean"
        },
        {
            "name": "touchStart",
            "baseName": "touchStart",
            "type": "boolean"
        },
        {
            "name": "touchEnd",
            "baseName": "touchEnd",
            "type": "boolean"
        }    ];

    static getAttributeTypeMap() {
        return EventWrapperSettings.attributeTypeMap;
    }
}

