/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { ConfigurationMetadata } from './configurationMetadata';
import { ExtensionProperty } from './extensionProperty';

/**
* General configuration of a extension.
*/
export class Extension {
    /**
    * The ID of the extension, for example `custom.remote.python.demo`.
    */
    'id'?: string;
    /**
    * The name of the extension, displayed in Dynatrace.
    */
    'name'?: string;
    /**
    * The version of the extension, displayed in Dynatrace.
    */
    'version'?: string;
    /**
    * The type of the extension. It indicates the runtime environment of the extension (for example, ACTIVEGATE).
    */
    'type'?: Extension.TypeEnum;
    /**
    * The metricGroup of the extension used for grouping custom metrics into a hierarchical namespace.
    */
    'metricGroup'?: string;
    'metadata'?: ConfigurationMetadata;
    /**
    * A list of extension properties.
    */
    'properties'?: Array<ExtensionProperty>;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "id",
            "baseName": "id",
            "type": "string"
        },
        {
            "name": "name",
            "baseName": "name",
            "type": "string"
        },
        {
            "name": "version",
            "baseName": "version",
            "type": "string"
        },
        {
            "name": "type",
            "baseName": "type",
            "type": "Extension.TypeEnum"
        },
        {
            "name": "metricGroup",
            "baseName": "metricGroup",
            "type": "string"
        },
        {
            "name": "metadata",
            "baseName": "metadata",
            "type": "ConfigurationMetadata"
        },
        {
            "name": "properties",
            "baseName": "properties",
            "type": "Array<ExtensionProperty>"
        }    ];

    static getAttributeTypeMap() {
        return Extension.attributeTypeMap;
    }
}

export namespace Extension {
    export enum TypeEnum {
        ACTIVEGATE = <any> 'ACTIVEGATE',
        CODEMODULE = <any> 'CODEMODULE',
        JMX = <any> 'JMX',
        ONEAGENT = <any> 'ONEAGENT',
        PMI = <any> 'PMI',
        UNKNOWN = <any> 'UNKNOWN'
    }
}
