/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { EntityShortRepresentation } from './entityShortRepresentation';

export class ExtensionConfigurationDto {
    /**
    * The ID of the extension.
    */
    'extensionId'?: string;
    /**
    * The extension is enabled (`true`) or disabled (`false`).
    */
    'enabled': boolean;
    /**
    * Allows to skip current configuration and use global one.
    */
    'useGlobal': boolean;
    /**
    * The list of extension parameters.    Each parameter is a key-value pair.
    */
    'properties'?: { [key: string]: string; };
    /**
    * The ID of the host on which the extension runs.
    */
    'hostId'?: string;
    'activeGate'?: EntityShortRepresentation;
    /**
    * The ID of the endpoint.
    */
    'endpointId'?: string;
    /**
    * The name of the endpoint, displayed in Dynatrace.
    */
    'endpointName'?: string;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "extensionId",
            "baseName": "extensionId",
            "type": "string"
        },
        {
            "name": "enabled",
            "baseName": "enabled",
            "type": "boolean"
        },
        {
            "name": "useGlobal",
            "baseName": "useGlobal",
            "type": "boolean"
        },
        {
            "name": "properties",
            "baseName": "properties",
            "type": "{ [key: string]: string; }"
        },
        {
            "name": "hostId",
            "baseName": "hostId",
            "type": "string"
        },
        {
            "name": "activeGate",
            "baseName": "activeGate",
            "type": "EntityShortRepresentation"
        },
        {
            "name": "endpointId",
            "baseName": "endpointId",
            "type": "string"
        },
        {
            "name": "endpointName",
            "baseName": "endpointName",
            "type": "string"
        }    ];

    static getAttributeTypeMap() {
        return ExtensionConfigurationDto.attributeTypeMap;
    }
}

