/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* Parameters of failure rate increase auto-detection. Required if **detectionMode** is `DETECT_AUTOMATICALLY`. Not applicable otherwise.   The absolute and relative thresholds **both** must exceed to trigger an alert.   Example: If the expected error rate is 1.5%, and you set an absolute increase of 1%, and a relative increase of 50%, the thresholds will be:  Absolute: 1.5% + **1%** = 2.5%  Relative: 1.5% + 1.5% * **50%** = 2.25%
*/
export class FailureRateIncreaseAutodetectionConfig {
    /**
    * Absolute increase of failing service calls to trigger an alert, %.
    */
    'failingServiceCallPercentageIncreaseAbsolute': number;
    /**
    * Relative increase of failing service calls to trigger an alert, %.
    */
    'failingServiceCallPercentageIncreaseRelative': number;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "failingServiceCallPercentageIncreaseAbsolute",
            "baseName": "failingServiceCallPercentageIncreaseAbsolute",
            "type": "number"
        },
        {
            "name": "failingServiceCallPercentageIncreaseRelative",
            "baseName": "failingServiceCallPercentageIncreaseRelative",
            "type": "number"
        }    ];

    static getAttributeTypeMap() {
        return FailureRateIncreaseAutodetectionConfig.attributeTypeMap;
    }
}

