/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { FailureRateIncreaseAutodetectionConfig } from './failureRateIncreaseAutodetectionConfig';
import { FailureRateIncreaseThresholdConfig } from './failureRateIncreaseThresholdConfig';

/**
* Configuration of failure rate increase detection.
*/
export class FailureRateIncreaseDetectionConfig {
    /**
    * How to detect failure rate increase: automatically, or based on fixed thresholds, or do not detect.
    */
    'detectionMode': FailureRateIncreaseDetectionConfig.DetectionModeEnum;
    'automaticDetection'?: FailureRateIncreaseAutodetectionConfig;
    'thresholds'?: FailureRateIncreaseThresholdConfig;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "detectionMode",
            "baseName": "detectionMode",
            "type": "FailureRateIncreaseDetectionConfig.DetectionModeEnum"
        },
        {
            "name": "automaticDetection",
            "baseName": "automaticDetection",
            "type": "FailureRateIncreaseAutodetectionConfig"
        },
        {
            "name": "thresholds",
            "baseName": "thresholds",
            "type": "FailureRateIncreaseThresholdConfig"
        }    ];

    static getAttributeTypeMap() {
        return FailureRateIncreaseDetectionConfig.attributeTypeMap;
    }
}

export namespace FailureRateIncreaseDetectionConfig {
    export enum DetectionModeEnum {
        DETECTAUTOMATICALLY = <any> 'DETECT_AUTOMATICALLY',
        DETECTUSINGFIXEDTHRESHOLDS = <any> 'DETECT_USING_FIXED_THRESHOLDS',
        DONTDETECT = <any> 'DONT_DETECT'
    }
}
