/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* Fixed thresholds for failure rate increase detection.    Required if **detectionMode** is `DETECT_USING_FIXED_THRESHOLDS`. Not applicable otherwise.
*/
export class FailureRateIncreaseThresholdConfig {
    /**
    * Failure rate during any 5-minute period to trigger an alert, %.
    */
    'threshold': number;
    /**
    * Sensitivity of the threshold.   With `low` sensitivity, high statistical confidence is used. Brief violations (for example, due to a surge in load) won\'t trigger alerts.   With `high` sensitivity, no statistical confidence is used. Each violation triggers alert.
    */
    'sensitivity': FailureRateIncreaseThresholdConfig.SensitivityEnum;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "threshold",
            "baseName": "threshold",
            "type": "number"
        },
        {
            "name": "sensitivity",
            "baseName": "sensitivity",
            "type": "FailureRateIncreaseThresholdConfig.SensitivityEnum"
        }    ];

    static getAttributeTypeMap() {
        return FailureRateIncreaseThresholdConfig.attributeTypeMap;
    }
}

export namespace FailureRateIncreaseThresholdConfig {
    export enum SensitivityEnum {
        HIGH = <any> 'HIGH',
        LOW = <any> 'LOW',
        MEDIUM = <any> 'MEDIUM'
    }
}
