/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { ComparisonInfo } from './comparisonInfo';
import { FastStringComparisonInfoAllOf } from './fastStringComparisonInfoAllOf';

/**
* Comparison for `FAST_STRING` attributes.
*/
export class FastStringComparisonInfo extends ComparisonInfo {
    /**
    * Operator of the comparision. You can reverse it by setting **negate** to `true`.
    */
    'comparison': FastStringComparisonInfo.ComparisonEnum;
    /**
    * The value to compare to.
    */
    'value'?: string;
    /**
    * The comparison is case-sensitive (`true`) or not case-sensitive (`false`).
    */
    'caseSensitive'?: boolean;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "comparison",
            "baseName": "comparison",
            "type": "FastStringComparisonInfo.ComparisonEnum"
        },
        {
            "name": "value",
            "baseName": "value",
            "type": "string"
        },
        {
            "name": "caseSensitive",
            "baseName": "caseSensitive",
            "type": "boolean"
        }    ];

    static getAttributeTypeMap() {
        return super.getAttributeTypeMap().concat(FastStringComparisonInfo.attributeTypeMap);
    }
}

export namespace FastStringComparisonInfo {
    export enum ComparisonEnum {
        CONTAINS = <any> 'CONTAINS',
        EQUALS = <any> 'EQUALS'
    }
}
