/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { ConfigurationMetadata } from './configurationMetadata';

/**
* Parameters of the frequent issue detection. To learn more about it, see [Detection of frequent issues](https://www.dynatrace.com/support/help/shortlink/frequent-issues) help page. 
*/
export class FrequentIssueDetectionConfig {
    'metadata'?: ConfigurationMetadata;
    /**
    * The detection for applications is enabled (`true`) or disabled (`false`).
    */
    'frequentIssueDetectionApplicationEnabled': boolean;
    /**
    * The detection for services is enabled (`true`) or disabled (`false`).
    */
    'frequentIssueDetectionServiceEnabled': boolean;
    /**
    * The detection for infrastructure is enabled (`true`) or disabled (`false`).
    */
    'frequentIssueDetectionInfrastructureEnabled': boolean;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "metadata",
            "baseName": "metadata",
            "type": "ConfigurationMetadata"
        },
        {
            "name": "frequentIssueDetectionApplicationEnabled",
            "baseName": "frequentIssueDetectionApplicationEnabled",
            "type": "boolean"
        },
        {
            "name": "frequentIssueDetectionServiceEnabled",
            "baseName": "frequentIssueDetectionServiceEnabled",
            "type": "boolean"
        },
        {
            "name": "frequentIssueDetectionInfrastructureEnabled",
            "baseName": "frequentIssueDetectionInfrastructureEnabled",
            "type": "boolean"
        }    ];

    static getAttributeTypeMap() {
        return FrequentIssueDetectionConfig.attributeTypeMap;
    }
}

