/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { ApplicationId } from './applicationId';
import { ConditionsFullWebServiceAttributeTypeDto } from './conditionsFullWebServiceAttributeTypeDto';
import { ConfigurationMetadata } from './configurationMetadata';
import { ContextRoot } from './contextRoot';
import { ServerName } from './serverName';
import { WebServiceName } from './webServiceName';
import { WebServiceNameSpace } from './webServiceNameSpace';

/**
* The service detection rule of the `FULL_WEB_SERVICE` type.   If you have a condition with the **attributeType** set to `FRAMEWORK`, the **values** field from **compareOperations** is limited to the following possible values: * `AXIS`   * `CXF`   * `HESSIAN`   * `JAX_WS_RI`   * `JBOSS`   * `JERSEY`   * `PROGRESS`   * `RESTEASY`   * `RESTLET`   * `SPRING`   * `TIBCO`   * `WEBLOGIC`   * `WEBMETHODS`   * `WEBSPHERE`   * `WINK`
*/
export class FullWebServiceRule {
    /**
    * The type of the service detection rule.
    */
    'type': string;
    'metadata'?: ConfigurationMetadata;
    /**
    * Specifies the management zones of the process group for which this service detection rule should be created.
    */
    'managementZones'?: Array<string>;
    /**
    * The ID of the service detection rule.
    */
    'id'?: string;
    /**
    * The order of the rule in the rules list.    The rules are evaluated from top to bottom. The first matching rule applies.
    */
    'order'?: string;
    /**
    * The name of the rule.
    */
    'name': string;
    /**
    * A short description of the rule.
    */
    'description'?: string;
    /**
    * The rule is enabled(`true`) or disabled (`false`).
    */
    'enabled': boolean;
    /**
    * A list of conditions of the rule.   If several conditions are specified, the AND logic applies.
    */
    'conditions'?: Array<ConditionsFullWebServiceAttributeTypeDto>;
    /**
    * Detect the matching requests as full web services (`false`) or web request services (`true`).   Setting this field to `true` prevents detecting of matching requests as full web services. A web request service is created instead. If you need to further modify the resulting web request service, you need to create a separate rule of the `FULL_WEB_REQUEST` type.   Default is `false`, detecting matching requests as full web services.
    */
    'detectAsWebRequestService'?: boolean;
    'webServiceName'?: WebServiceName;
    'webServiceNameSpace'?: WebServiceNameSpace;
    'applicationId'?: ApplicationId;
    'contextRoot'?: ContextRoot;
    'serverName'?: ServerName;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "type",
            "baseName": "type",
            "type": "string"
        },
        {
            "name": "metadata",
            "baseName": "metadata",
            "type": "ConfigurationMetadata"
        },
        {
            "name": "managementZones",
            "baseName": "managementZones",
            "type": "Array<string>"
        },
        {
            "name": "id",
            "baseName": "id",
            "type": "string"
        },
        {
            "name": "order",
            "baseName": "order",
            "type": "string"
        },
        {
            "name": "name",
            "baseName": "name",
            "type": "string"
        },
        {
            "name": "description",
            "baseName": "description",
            "type": "string"
        },
        {
            "name": "enabled",
            "baseName": "enabled",
            "type": "boolean"
        },
        {
            "name": "conditions",
            "baseName": "conditions",
            "type": "Array<ConditionsFullWebServiceAttributeTypeDto>"
        },
        {
            "name": "detectAsWebRequestService",
            "baseName": "detectAsWebRequestService",
            "type": "boolean"
        },
        {
            "name": "webServiceName",
            "baseName": "webServiceName",
            "type": "WebServiceName"
        },
        {
            "name": "webServiceNameSpace",
            "baseName": "webServiceNameSpace",
            "type": "WebServiceNameSpace"
        },
        {
            "name": "applicationId",
            "baseName": "applicationId",
            "type": "ApplicationId"
        },
        {
            "name": "contextRoot",
            "baseName": "contextRoot",
            "type": "ContextRoot"
        },
        {
            "name": "serverName",
            "baseName": "serverName",
            "type": "ServerName"
        }    ];

    static getAttributeTypeMap() {
        return FullWebServiceRule.attributeTypeMap;
    }
}

