/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* Global event capture settings.
*/
export class GlobalEventCaptureSettings {
    /**
    * MouseUp enabled/disabled.
    */
    'mouseUp': boolean;
    /**
    * MouseDown enabled/disabled.
    */
    'mouseDown': boolean;
    /**
    * Click enabled/disabled.
    */
    'click': boolean;
    /**
    * DoubleClick enabled/disabled.
    */
    'doubleClick': boolean;
    /**
    * KeyUp enabled/disabled.
    */
    'keyUp': boolean;
    /**
    * KeyDown enabled/disabled.
    */
    'keyDown': boolean;
    /**
    * Scroll enabled/disabled.
    */
    'scroll': boolean;
    /**
    * Additional events to be captured globally as user input.   For example, DragStart or DragEnd.
    */
    'additionalEventCapturedAsUserInput': string;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "mouseUp",
            "baseName": "mouseUp",
            "type": "boolean"
        },
        {
            "name": "mouseDown",
            "baseName": "mouseDown",
            "type": "boolean"
        },
        {
            "name": "click",
            "baseName": "click",
            "type": "boolean"
        },
        {
            "name": "doubleClick",
            "baseName": "doubleClick",
            "type": "boolean"
        },
        {
            "name": "keyUp",
            "baseName": "keyUp",
            "type": "boolean"
        },
        {
            "name": "keyDown",
            "baseName": "keyDown",
            "type": "boolean"
        },
        {
            "name": "scroll",
            "baseName": "scroll",
            "type": "boolean"
        },
        {
            "name": "additionalEventCapturedAsUserInput",
            "baseName": "additionalEventCapturedAsUserInput",
            "type": "string"
        }    ];

    static getAttributeTypeMap() {
        return GlobalEventCaptureSettings.attributeTypeMap;
    }
}

