/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* Global Configuration of OneAgent and JMX extension
*/
export class GlobalExtensionConfiguration {
    /**
    * The ID of the extension.
    */
    'extensionId'?: string;
    /**
    * The extension is enabled (`true`) or disabled (`false`).
    */
    'enabled': boolean;
    /**
    * The plugin is enabled (`true`) or disabled (`false`) globally for hosts in infrastructure-only monitoring mode
    */
    'infraOnlyEnabled'?: boolean;
    /**
    * The list of configuration parameters.    Each parameter is a key-value pair.
    */
    'properties'?: { [key: string]: string; };

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "extensionId",
            "baseName": "extensionId",
            "type": "string"
        },
        {
            "name": "enabled",
            "baseName": "enabled",
            "type": "boolean"
        },
        {
            "name": "infraOnlyEnabled",
            "baseName": "infraOnlyEnabled",
            "type": "boolean"
        },
        {
            "name": "properties",
            "baseName": "properties",
            "type": "{ [key: string]: string; }"
        }    ];

    static getAttributeTypeMap() {
        return GlobalExtensionConfiguration.attributeTypeMap;
    }
}

