/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* Custom thresholds for guest CPU limit detection. If not set then the automatic mode is used.    **All** conditions must be fulfilled to trigger an alert.
*/
export class GuestCPULimitThresholds {
    /**
    * Hypervisor CPU usage is higher than *X*% in 3 out of 5 samples.
    */
    'hostCpuUsageMinPercentage': number;
    /**
    * VM CPU usage (VM CPU Usage Mhz / VM CPU limit in Mhz) is higher than *X*% in 3 out of 5 samples.
    */
    'vmCpuUsageMaxPercentage': number;
    /**
    * VM CPU ready is higher than *X*% occurred in 3 out of 5 samples.
    */
    'vmCpuReadyMaxPercentage': number;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "hostCpuUsageMinPercentage",
            "baseName": "hostCpuUsageMinPercentage",
            "type": "number"
        },
        {
            "name": "vmCpuUsageMaxPercentage",
            "baseName": "vmCpuUsageMaxPercentage",
            "type": "number"
        },
        {
            "name": "vmCpuReadyMaxPercentage",
            "baseName": "vmCpuReadyMaxPercentage",
            "type": "number"
        }    ];

    static getAttributeTypeMap() {
        return GuestCPULimitThresholds.attributeTypeMap;
    }
}

