/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* Custom thresholds for high GC activity. If not set, automatic mode is used.    Meeting **any** of these conditions triggers an alert.
*/
export class HighGcActivityThresholds {
    /**
    * GC time is higher than *X*% in 3 out of 5 samples.
    */
    'gcTimePercentage': number;
    /**
    * GC suspension is higher than *X*% in 3 out of 5 samples.
    */
    'gcSuspensionPercentage': number;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "gcTimePercentage",
            "baseName": "gcTimePercentage",
            "type": "number"
        },
        {
            "name": "gcSuspensionPercentage",
            "baseName": "gcSuspensionPercentage",
            "type": "number"
        }    ];

    static getAttributeTypeMap() {
        return HighGcActivityThresholds.attributeTypeMap;
    }
}

