/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* Custom thresholds for high memory usage. If not set then the automatic mode is used.    **Both** conditions must be met to trigger an alert.
*/
export class HighMemoryThresholds {
    /**
    * Memory page fault rate is higher than *X* faults per second on Windows.
    */
    'pageFaultsPerSecondWindows': number;
    /**
    * Memory usage is higher than *X*% on Windows.
    */
    'usedMemoryPercentageWindows': number;
    /**
    * Memory page fault rate is higher than *X* faults per second on Linux.
    */
    'pageFaultsPerSecondNonWindows': number;
    /**
    * Memory usage is higher than *X*% on Linux.
    */
    'usedMemoryPercentageNonWindows': number;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "pageFaultsPerSecondWindows",
            "baseName": "pageFaultsPerSecondWindows",
            "type": "number"
        },
        {
            "name": "usedMemoryPercentageWindows",
            "baseName": "usedMemoryPercentageWindows",
            "type": "number"
        },
        {
            "name": "pageFaultsPerSecondNonWindows",
            "baseName": "pageFaultsPerSecondNonWindows",
            "type": "number"
        },
        {
            "name": "usedMemoryPercentageNonWindows",
            "baseName": "usedMemoryPercentageNonWindows",
            "type": "number"
        }    ];

    static getAttributeTypeMap() {
        return HighMemoryThresholds.attributeTypeMap;
    }
}

