/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { EntityShortRepresentation } from './entityShortRepresentation';
import { HostGroup } from './hostGroup';
import { TagInfo } from './tagInfo';

/**
* Host details. Contains ID, name, host group, and tags.
*/
export class Host {
    /**
    * The name of the host
    */
    'name'?: string;
    /**
    * The ID of the host
    */
    'id'?: string;
    'hostGroup'?: HostGroup;
    /**
    * A list of tags of the host.
    */
    'tags'?: Array<TagInfo>;
    /**
    * A list of management zones to which the host belongs.
    */
    'managementZones'?: Array<EntityShortRepresentation>;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "name",
            "baseName": "name",
            "type": "string"
        },
        {
            "name": "id",
            "baseName": "id",
            "type": "string"
        },
        {
            "name": "hostGroup",
            "baseName": "hostGroup",
            "type": "HostGroup"
        },
        {
            "name": "tags",
            "baseName": "tags",
            "type": "Array<TagInfo>"
        },
        {
            "name": "managementZones",
            "baseName": "managementZones",
            "type": "Array<EntityShortRepresentation>"
        }    ];

    static getAttributeTypeMap() {
        return Host.attributeTypeMap;
    }
}

