/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { ConfigurationMetadata } from './configurationMetadata';
import { ConnectionLostDetectionConfig } from './connectionLostDetectionConfig';
import { DiskLowInodesDetectionConfig } from './diskLowInodesDetectionConfig';
import { DiskLowSpaceDetectionConfig } from './diskLowSpaceDetectionConfig';
import { DiskSlowWritesAndReadsDetectionConfig } from './diskSlowWritesAndReadsDetectionConfig';
import { HighCpuSaturationDetectionConfig } from './highCpuSaturationDetectionConfig';
import { HighGcActivityDetectionConfig } from './highGcActivityDetectionConfig';
import { HighMemoryDetectionConfig } from './highMemoryDetectionConfig';
import { HighNetworkDetectionConfig } from './highNetworkDetectionConfig';
import { NetworkDroppedPacketsDetectionConfig } from './networkDroppedPacketsDetectionConfig';
import { NetworkErrorsDetectionConfig } from './networkErrorsDetectionConfig';
import { NetworkHighRetransmissionDetectionConfig } from './networkHighRetransmissionDetectionConfig';
import { NetworkTcpProblemsDetectionConfig } from './networkTcpProblemsDetectionConfig';
import { OutOfMemoryDetectionConfig } from './outOfMemoryDetectionConfig';
import { OutOfThreadsDetectionConfig } from './outOfThreadsDetectionConfig';

/**
* Configuration of anomaly detection for hosts.
*/
export class HostsAnomalyDetectionConfig {
    'metadata'?: ConfigurationMetadata;
    'connectionLostDetection': ConnectionLostDetectionConfig;
    'highCpuSaturationDetection': HighCpuSaturationDetectionConfig;
    'highMemoryDetection': HighMemoryDetectionConfig;
    'highGcActivityDetection': HighGcActivityDetectionConfig;
    'outOfMemoryDetection': OutOfMemoryDetectionConfig;
    'outOfThreadsDetection': OutOfThreadsDetectionConfig;
    'networkDroppedPacketsDetection': NetworkDroppedPacketsDetectionConfig;
    'networkErrorsDetection': NetworkErrorsDetectionConfig;
    'highNetworkDetection': HighNetworkDetectionConfig;
    'networkTcpProblemsDetection': NetworkTcpProblemsDetectionConfig;
    'networkHighRetransmissionDetection': NetworkHighRetransmissionDetectionConfig;
    'diskLowSpaceDetection': DiskLowSpaceDetectionConfig;
    'diskSlowWritesAndReadsDetection': DiskSlowWritesAndReadsDetectionConfig;
    'diskLowInodesDetection': DiskLowInodesDetectionConfig;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "metadata",
            "baseName": "metadata",
            "type": "ConfigurationMetadata"
        },
        {
            "name": "connectionLostDetection",
            "baseName": "connectionLostDetection",
            "type": "ConnectionLostDetectionConfig"
        },
        {
            "name": "highCpuSaturationDetection",
            "baseName": "highCpuSaturationDetection",
            "type": "HighCpuSaturationDetectionConfig"
        },
        {
            "name": "highMemoryDetection",
            "baseName": "highMemoryDetection",
            "type": "HighMemoryDetectionConfig"
        },
        {
            "name": "highGcActivityDetection",
            "baseName": "highGcActivityDetection",
            "type": "HighGcActivityDetectionConfig"
        },
        {
            "name": "outOfMemoryDetection",
            "baseName": "outOfMemoryDetection",
            "type": "OutOfMemoryDetectionConfig"
        },
        {
            "name": "outOfThreadsDetection",
            "baseName": "outOfThreadsDetection",
            "type": "OutOfThreadsDetectionConfig"
        },
        {
            "name": "networkDroppedPacketsDetection",
            "baseName": "networkDroppedPacketsDetection",
            "type": "NetworkDroppedPacketsDetectionConfig"
        },
        {
            "name": "networkErrorsDetection",
            "baseName": "networkErrorsDetection",
            "type": "NetworkErrorsDetectionConfig"
        },
        {
            "name": "highNetworkDetection",
            "baseName": "highNetworkDetection",
            "type": "HighNetworkDetectionConfig"
        },
        {
            "name": "networkTcpProblemsDetection",
            "baseName": "networkTcpProblemsDetection",
            "type": "NetworkTcpProblemsDetectionConfig"
        },
        {
            "name": "networkHighRetransmissionDetection",
            "baseName": "networkHighRetransmissionDetection",
            "type": "NetworkHighRetransmissionDetectionConfig"
        },
        {
            "name": "diskLowSpaceDetection",
            "baseName": "diskLowSpaceDetection",
            "type": "DiskLowSpaceDetectionConfig"
        },
        {
            "name": "diskSlowWritesAndReadsDetection",
            "baseName": "diskSlowWritesAndReadsDetection",
            "type": "DiskSlowWritesAndReadsDetectionConfig"
        },
        {
            "name": "diskLowInodesDetection",
            "baseName": "diskLowInodesDetection",
            "type": "DiskLowInodesDetectionConfig"
        }    ];

    static getAttributeTypeMap() {
        return HostsAnomalyDetectionConfig.attributeTypeMap;
    }
}

