/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { ComparisonBasic } from './comparisonBasic';
import { HypervisorTypeComparisionAllOf } from './hypervisorTypeComparisionAllOf';

/**
* Comparison for `HYPERVISOR_TYPE` attributes.
*/
export class HypervisorTypeComparision extends ComparisonBasic {
    /**
    * Operator of the comparison. You can reverse it by setting **negate** to `true`.   Possible values depend on the **type** of the comparison. Find the list of actual models in the description of the **type** field and check the description of the model you need.
    */
    'operator': HypervisorTypeComparision.OperatorEnum;
    /**
    * The value to compare to.
    */
    'value'?: HypervisorTypeComparision.ValueEnum;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "operator",
            "baseName": "operator",
            "type": "HypervisorTypeComparision.OperatorEnum"
        },
        {
            "name": "value",
            "baseName": "value",
            "type": "HypervisorTypeComparision.ValueEnum"
        }    ];

    static getAttributeTypeMap() {
        return super.getAttributeTypeMap().concat(HypervisorTypeComparision.attributeTypeMap);
    }
}

export namespace HypervisorTypeComparision {
    export enum OperatorEnum {
        EQUALS = <any> 'EQUALS',
        EXISTS = <any> 'EXISTS'
    }
    export enum ValueEnum {
        HYPERV = <any> 'HYPER_V',
        KVM = <any> 'KVM',
        LPAR = <any> 'LPAR',
        QEMU = <any> 'QEMU',
        VIRTUALBOX = <any> 'VIRTUAL_BOX',
        VMWARE = <any> 'VMWARE',
        WPAR = <any> 'WPAR',
        XEN = <any> 'XEN'
    }
}
