/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { ComparisonInfo } from './comparisonInfo';
import { ESBInputNodeTypeComparisonInfoAllOf } from './eSBInputNodeTypeComparisonInfoAllOf';

/**
* Comparison for `IIB_INPUT_NODE_TYPE` attributes.
*/
export class IIBInputNodeTypeComparisonInfo extends ComparisonInfo {
    /**
    * Operator of the comparision. You can reverse it by setting **negate** to `true`.
    */
    'comparison': IIBInputNodeTypeComparisonInfo.ComparisonEnum;
    /**
    * The value to compare to.
    */
    'value'?: IIBInputNodeTypeComparisonInfo.ValueEnum;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "comparison",
            "baseName": "comparison",
            "type": "IIBInputNodeTypeComparisonInfo.ComparisonEnum"
        },
        {
            "name": "value",
            "baseName": "value",
            "type": "IIBInputNodeTypeComparisonInfo.ValueEnum"
        }    ];

    static getAttributeTypeMap() {
        return super.getAttributeTypeMap().concat(IIBInputNodeTypeComparisonInfo.attributeTypeMap);
    }
}

export namespace IIBInputNodeTypeComparisonInfo {
    export enum ComparisonEnum {
        EQUALS = <any> 'EQUALS',
        EXISTS = <any> 'EXISTS'
    }
    export enum ValueEnum {
        CALLABLEFLOWASYNCRESPONSENODE = <any> 'CALLABLE_FLOW_ASYNC_RESPONSE_NODE',
        CALLABLEFLOWINPUTNODE = <any> 'CALLABLE_FLOW_INPUT_NODE',
        DATABASEINPUTNODE = <any> 'DATABASE_INPUT_NODE',
        DOTNETINPUTNODE = <any> 'DOTNET_INPUT_NODE',
        EMAILINPUTNODE = <any> 'EMAIL_INPUT_NODE',
        EVENTINPUT = <any> 'EVENT_INPUT',
        EVENTINPUTNODE = <any> 'EVENT_INPUT_NODE',
        FILEINPUTNODE = <any> 'FILE_INPUT_NODE',
        FTEINPUTNODE = <any> 'FTE_INPUT_NODE',
        HTTPASYNCRESPONSE = <any> 'HTTP_ASYNC_RESPONSE',
        JDEDWARDSINPUTNODE = <any> 'JD_EDWARDS_INPUT_NODE',
        JMSCLIENTINPUTNODE = <any> 'JMS_CLIENT_INPUT_NODE',
        LABELNODE = <any> 'LABEL_NODE',
        MQINPUTNODE = <any> 'MQ_INPUT_NODE',
        PEOPLESOFTINPUTNODE = <any> 'PEOPLE_SOFT_INPUT_NODE',
        RESTASYNCRESPONSE = <any> 'REST_ASYNC_RESPONSE',
        RESTREQUEST = <any> 'REST_REQUEST',
        SAPINPUTNODE = <any> 'SAP_INPUT_NODE',
        SCAASYNCRESPONSENODE = <any> 'SCA_ASYNC_RESPONSE_NODE',
        SCAINPUTNODE = <any> 'SCA_INPUT_NODE',
        SIEBELINPUTNODE = <any> 'SIEBEL_INPUT_NODE',
        SOAPINPUTNODE = <any> 'SOAP_INPUT_NODE',
        TCPIPCLIENTINPUTNODE = <any> 'TCPIP_CLIENT_INPUT_NODE',
        TCPIPCLIENTREQUESTNODE = <any> 'TCPIP_CLIENT_REQUEST_NODE',
        TCPIPSERVERINPUTNODE = <any> 'TCPIP_SERVER_INPUT_NODE',
        TCPIPSERVERREQUESTNODE = <any> 'TCPIP_SERVER_REQUEST_NODE',
        TIMEOUTNOTIFICATIONNODE = <any> 'TIMEOUT_NOTIFICATION_NODE',
        WSINPUTNODE = <any> 'WS_INPUT_NODE'
    }
}
