/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { CompareOperation } from './compareOperation';
import { IpInRangeCompareOperationAllOf } from './ipInRangeCompareOperationAllOf';

/**
* The condition of the `IP_IN_RANGE` type.   The condition checks whether the IP address belongs to a specified range.
*/
export class IpInRangeCompareOperation extends CompareOperation {
    /**
    * Inverts the operation of the condition. Set to `true` to turn **IP is in range** into **IP is not in range**.    If not set, then `false` is used.
    */
    'negate'?: boolean;
    /**
    * The lower boundary of the IP range.
    */
    'lower': string;
    /**
    * The upper boundary of the IP range.
    */
    'upper': string;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "negate",
            "baseName": "negate",
            "type": "boolean"
        },
        {
            "name": "lower",
            "baseName": "lower",
            "type": "string"
        },
        {
            "name": "upper",
            "baseName": "upper",
            "type": "string"
        }    ];

    static getAttributeTypeMap() {
        return super.getAttributeTypeMap().concat(IpInRangeCompareOperation.attributeTypeMap);
    }
}

export namespace IpInRangeCompareOperation {
}
