/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* Rules for javascript injection
*/
export class JavaScriptInjectionRules {
    /**
    * The enable or disable rule of the java script injection.
    */
    'enabled': boolean;
    /**
    * The url operator of the java script injection.
    */
    'urlOperator': JavaScriptInjectionRules.UrlOperatorEnum;
    /**
    * The url pattern of the java script injection.
    */
    'urlPattern'?: string;
    /**
    * The url rule of the java script injection.
    */
    'rule': JavaScriptInjectionRules.RuleEnum;
    /**
    * The html pattern of the java script injection.
    */
    'htmlPattern'?: string;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "enabled",
            "baseName": "enabled",
            "type": "boolean"
        },
        {
            "name": "urlOperator",
            "baseName": "urlOperator",
            "type": "JavaScriptInjectionRules.UrlOperatorEnum"
        },
        {
            "name": "urlPattern",
            "baseName": "urlPattern",
            "type": "string"
        },
        {
            "name": "rule",
            "baseName": "rule",
            "type": "JavaScriptInjectionRules.RuleEnum"
        },
        {
            "name": "htmlPattern",
            "baseName": "htmlPattern",
            "type": "string"
        }    ];

    static getAttributeTypeMap() {
        return JavaScriptInjectionRules.attributeTypeMap;
    }
}

export namespace JavaScriptInjectionRules {
    export enum UrlOperatorEnum {
        ALLPAGES = <any> 'ALL_PAGES',
        CONTAINS = <any> 'CONTAINS',
        ENDSWITH = <any> 'ENDS_WITH',
        EQUALS = <any> 'EQUALS',
        STARTSWITH = <any> 'STARTS_WITH'
    }
    export enum RuleEnum {
        AFTERSPECIFICHTML = <any> 'AFTER_SPECIFIC_HTML',
        AUTOMATICINJECTION = <any> 'AUTOMATIC_INJECTION',
        BEFORESPECIFICHTML = <any> 'BEFORE_SPECIFIC_HTML',
        DONOTINJECT = <any> 'DO_NOT_INJECT'
    }
}
