/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { JiraNotificationConfigAllOf } from './jiraNotificationConfigAllOf';
import { NotificationConfig } from './notificationConfig';

/**
* Configuration of the Jira notification.
*/
export class JiraNotificationConfig extends NotificationConfig {
    /**
    * The username of the Jira profile.
    */
    'username': string;
    /**
    * The password for the Jira profile.
    */
    'password'?: string;
    /**
    * The URL of the Jira API endpoint.
    */
    'url': string;
    /**
    * The project key of the Jira issue to be created by this notification.
    */
    'projectKey': string;
    /**
    * The type of the Jira issue to be created by this notification.
    */
    'issueType': string;
    /**
    * The summary of the Jira issue to be created by this notification.   You can use the following placeholders:  * `{ImpactedEntity}`: The entity impacted by the problem or *X* impacted entities.  * `{PID}`: The ID of the reported problem.  * `{ProblemDetailsText}`: All problem event details, including root cause, as a text-formatted string.  * `{ProblemID}`: The display number of the reported problem.  * `{ProblemImpact}`: The [impact level](https://www.dynatrace.com/support/help/shortlink/impact-analysis) of the problem. Possible values are `APPLICATION`, `SERVICE`, and `INFRASTRUCTURE`.  * `{ProblemSeverity}`: The [severity level](https://www.dynatrace.com/support/help/shortlink/event-types) of the problem. Possible values are `AVAILABILITY`, `ERROR`, `PERFORMANCE`, `RESOURCE_CONTENTION`, and `CUSTOM_ALERT`.  * `{ProblemTitle}`: A short description of the problem.  * `{ProblemURL}`: The URL of the problem within Dynatrace.  * `{State}`: The state of the problem. Possible values are `OPEN` and `RESOLVED`. If the problem has been merged into another problem, it has the `MERGED` value.  * `{Tags}`: The list of tags that are defined for all impacted entities, separated by commas.  
    */
    'summary': string;
    /**
    * The description of the Jira issue to be created by this notification.    You can use same placeholders as in issue summary.
    */
    'description': string;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "username",
            "baseName": "username",
            "type": "string"
        },
        {
            "name": "password",
            "baseName": "password",
            "type": "string"
        },
        {
            "name": "url",
            "baseName": "url",
            "type": "string"
        },
        {
            "name": "projectKey",
            "baseName": "projectKey",
            "type": "string"
        },
        {
            "name": "issueType",
            "baseName": "issueType",
            "type": "string"
        },
        {
            "name": "summary",
            "baseName": "summary",
            "type": "string"
        },
        {
            "name": "description",
            "baseName": "description",
            "type": "string"
        }    ];

    static getAttributeTypeMap() {
        return super.getAttributeTypeMap().concat(JiraNotificationConfig.attributeTypeMap);
    }
}

export namespace JiraNotificationConfig {
}
