/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* The configuration of load spikes detection.
*/
export class LoadSpikeDetectionConfig {
    /**
    * The detection is enabled (`true`) or disabled (`false`).
    */
    'enabled': boolean;
    /**
    * Alert if the observed load is more than *X* % of the expected value.
    */
    'loadSpikePercent'?: number;
    /**
    * Alert if the service stays in abnormal state for at least *X* minutes.
    */
    'minAbnormalStateDurationInMinutes'?: number;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "enabled",
            "baseName": "enabled",
            "type": "boolean"
        },
        {
            "name": "loadSpikePercent",
            "baseName": "loadSpikePercent",
            "type": "number"
        },
        {
            "name": "minAbnormalStateDurationInMinutes",
            "baseName": "minAbnormalStateDurationInMinutes",
            "type": "number"
        }    ];

    static getAttributeTypeMap() {
        return LoadSpikeDetectionConfig.attributeTypeMap;
    }
}

