/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { PathDefinition } from './pathDefinition';

/**
* Configuration of the log filter for a custom log metric.   If several criteria are specified, the AND logic applies.
*/
export class LogSourceFilter {
    /**
    * A list of filtering criteria for log path.   If several criteria are specified, the OR logic applies.
    */
    'pathDefinitions'?: Array<PathDefinition>;
    /**
    * A list of Dynatrace entities, where the log can originate from. Specify Dynatrace entity IDs here.    Allowed types of entities are `PROCESS_GROUP` and `PROCESS_GROUP_INSTANCE`. You can\'t mix entity types.   If several entities are specified, the OR logic applies.   This field is mutually exclusive with the **osTypes** field.
    */
    'sourceEntities'?: Array<string>;
    /**
    * A list of hosts, where the log can originate from. Specify Dynatrace entity IDs here.   If several hosts are specified, the OR logic applies.
    */
    'hostFilters'?: Array<string>;
    /**
    * A list of operating system types, where the log can originate from.   If set, **only OS logs** are included in the result.   If several OS are specified, the OR logic applies.   This field is mutually exclusive with the **sourceEntities** field.
    */
    'osTypes'?: Array<LogSourceFilter.OsTypesEnum>;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "pathDefinitions",
            "baseName": "pathDefinitions",
            "type": "Array<PathDefinition>"
        },
        {
            "name": "sourceEntities",
            "baseName": "sourceEntities",
            "type": "Array<string>"
        },
        {
            "name": "hostFilters",
            "baseName": "hostFilters",
            "type": "Array<string>"
        },
        {
            "name": "osTypes",
            "baseName": "osTypes",
            "type": "Array<LogSourceFilter.OsTypesEnum>"
        }    ];

    static getAttributeTypeMap() {
        return LogSourceFilter.attributeTypeMap;
    }
}

export namespace LogSourceFilter {
    export enum OsTypesEnum {
        AIX = <any> 'AIX',
        DARWIN = <any> 'DARWIN',
        HPUX = <any> 'HPUX',
        LINUX = <any> 'LINUX',
        SOLARIS = <any> 'SOLARIS',
        WINDOWS = <any> 'WINDOWS',
        ZOS = <any> 'ZOS'
    }
}
