/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { ConfigurationMetadata } from './configurationMetadata';
import { Schedule } from './schedule';
import { Scope } from './scope';

/**
* Configuration of a maintenance window.
*/
export class MaintenanceWindow {
    'metadata'?: ConfigurationMetadata;
    /**
    * The ID of the maintenance window.
    */
    'id'?: string;
    /**
    * The name of the maintenance window, displayed in the UI.
    */
    'name': string;
    /**
    * A short description of the maintenance purpose.
    */
    'description': string;
    /**
    * The type of the maintenance: planned or unplanned.
    */
    'type': MaintenanceWindow.TypeEnum;
    /**
    * The type of suppression of alerting and problem detection during the maintenance.
    */
    'suppression': MaintenanceWindow.SuppressionEnum;
    'scope'?: Scope;
    'schedule': Schedule;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "metadata",
            "baseName": "metadata",
            "type": "ConfigurationMetadata"
        },
        {
            "name": "id",
            "baseName": "id",
            "type": "string"
        },
        {
            "name": "name",
            "baseName": "name",
            "type": "string"
        },
        {
            "name": "description",
            "baseName": "description",
            "type": "string"
        },
        {
            "name": "type",
            "baseName": "type",
            "type": "MaintenanceWindow.TypeEnum"
        },
        {
            "name": "suppression",
            "baseName": "suppression",
            "type": "MaintenanceWindow.SuppressionEnum"
        },
        {
            "name": "scope",
            "baseName": "scope",
            "type": "Scope"
        },
        {
            "name": "schedule",
            "baseName": "schedule",
            "type": "Schedule"
        }    ];

    static getAttributeTypeMap() {
        return MaintenanceWindow.attributeTypeMap;
    }
}

export namespace MaintenanceWindow {
    export enum TypeEnum {
        PLANNED = <any> 'PLANNED',
        UNPLANNED = <any> 'UNPLANNED'
    }
    export enum SuppressionEnum {
        DETECTPROBLEMSANDALERT = <any> 'DETECT_PROBLEMS_AND_ALERT',
        DETECTPROBLEMSDONTALERT = <any> 'DETECT_PROBLEMS_DONT_ALERT',
        DONTDETECTPROBLEMS = <any> 'DONT_DETECT_PROBLEMS'
    }
}
