/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { ConfigurationMetadata } from './configurationMetadata';
import { ManagementZoneRule } from './managementZoneRule';

/**
* The configuration of the management zone. It defines how the management zone applies.
*/
export class ManagementZone {
    'metadata'?: ConfigurationMetadata;
    /**
    * The ID of the management zone.
    */
    'id'?: string;
    /**
    * The name of the management zone.
    */
    'name': string;
    /**
    * A list of rules for management zone usage.   Each rule is evaluated independently of all other rules.
    */
    'rules'?: Array<ManagementZoneRule>;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "metadata",
            "baseName": "metadata",
            "type": "ConfigurationMetadata"
        },
        {
            "name": "id",
            "baseName": "id",
            "type": "string"
        },
        {
            "name": "name",
            "baseName": "name",
            "type": "string"
        },
        {
            "name": "rules",
            "baseName": "rules",
            "type": "Array<ManagementZoneRule>"
        }    ];

    static getAttributeTypeMap() {
        return ManagementZone.attributeTypeMap;
    }
}

