/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { EntityRuleEngineCondition } from './entityRuleEngineCondition';

/**
* The rule of the management zone usage. It defines how the management zone applies.   Each rule is evaluated independently of all other rules.
*/
export class ManagementZoneRule {
    /**
    * The type of Dynatrace entities the management zone can be applied to.
    */
    'type': ManagementZoneRule.TypeEnum;
    /**
    * The rule is enabled (`true`) or disabled (`false`).
    */
    'enabled': boolean;
    /**
    * How to apply the management zone to underlying entities:   * `SERVICE_TO_HOST_LIKE`: Apply to underlying hosts of matching services.  * `SERVICE_TO_PROCESS_GROUP_LIKE`: Apply to underlying process groups of matching services.  * `PROCESS_GROUP_TO_HOST`: Apply to underlying hosts of matching process groups.  * `PROCESS_GROUP_TO_SERVICE`: Apply to all services provided by matching process groups.  * `HOST_TO_PROCESS_GROUP_INSTANCE`: Apply to processes running on matching hosts.  * `CUSTOM_DEVICE_GROUP_TO_CUSTOM_DEVICE`: Apply to custom devices in matching custom device groups.  * `AZURE_TO_PG`: Apply to process groups connected to matching Azure entities.  * `AZURE_TO_SERVICE`: Apply to services provided by matching Azure entities.
    */
    'propagationTypes'?: Array<ManagementZoneRule.PropagationTypesEnum>;
    /**
    * A list of matching rules for the management zone.   The management zone applies only if **all** conditions are fulfilled.
    */
    'conditions': Array<EntityRuleEngineCondition>;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "type",
            "baseName": "type",
            "type": "ManagementZoneRule.TypeEnum"
        },
        {
            "name": "enabled",
            "baseName": "enabled",
            "type": "boolean"
        },
        {
            "name": "propagationTypes",
            "baseName": "propagationTypes",
            "type": "Array<ManagementZoneRule.PropagationTypesEnum>"
        },
        {
            "name": "conditions",
            "baseName": "conditions",
            "type": "Array<EntityRuleEngineCondition>"
        }    ];

    static getAttributeTypeMap() {
        return ManagementZoneRule.attributeTypeMap;
    }
}

export namespace ManagementZoneRule {
    export enum TypeEnum {
        APPMONSERVER = <any> 'APPMON_SERVER',
        APPMONSYSTEMPROFILE = <any> 'APPMON_SYSTEM_PROFILE',
        AWSACCOUNT = <any> 'AWS_ACCOUNT',
        AWSAPPLICATIONLOADBALANCER = <any> 'AWS_APPLICATION_LOAD_BALANCER',
        AWSAUTOSCALINGGROUP = <any> 'AWS_AUTO_SCALING_GROUP',
        AWSCLASSICLOADBALANCER = <any> 'AWS_CLASSIC_LOAD_BALANCER',
        AWSNETWORKLOADBALANCER = <any> 'AWS_NETWORK_LOAD_BALANCER',
        AWSRELATIONALDATABASESERVICE = <any> 'AWS_RELATIONAL_DATABASE_SERVICE',
        AZURE = <any> 'AZURE',
        BROWSERMONITOR = <any> 'BROWSER_MONITOR',
        CLOUDAPPLICATION = <any> 'CLOUD_APPLICATION',
        CLOUDAPPLICATIONNAMESPACE = <any> 'CLOUD_APPLICATION_NAMESPACE',
        CLOUDFOUNDRYFOUNDATION = <any> 'CLOUD_FOUNDRY_FOUNDATION',
        CUSTOMAPPLICATION = <any> 'CUSTOM_APPLICATION',
        CUSTOMDEVICE = <any> 'CUSTOM_DEVICE',
        CUSTOMDEVICEGROUP = <any> 'CUSTOM_DEVICE_GROUP',
        DATACENTERSERVICE = <any> 'DATA_CENTER_SERVICE',
        ENTERPRISEAPPLICATION = <any> 'ENTERPRISE_APPLICATION',
        ESXIHOST = <any> 'ESXI_HOST',
        EXTERNALMONITOR = <any> 'EXTERNAL_MONITOR',
        HOST = <any> 'HOST',
        HOSTGROUP = <any> 'HOST_GROUP',
        HTTPMONITOR = <any> 'HTTP_MONITOR',
        KUBERNETESCLUSTER = <any> 'KUBERNETES_CLUSTER',
        KUBERNETESNODE = <any> 'KUBERNETES_NODE',
        MOBILEAPPLICATION = <any> 'MOBILE_APPLICATION',
        OPENSTACKACCOUNT = <any> 'OPENSTACK_ACCOUNT',
        PROCESSGROUP = <any> 'PROCESS_GROUP',
        SERVICE = <any> 'SERVICE',
        WEBAPPLICATION = <any> 'WEB_APPLICATION'
    }
    export enum PropagationTypesEnum {
        AZURETOPG = <any> 'AZURE_TO_PG',
        AZURETOSERVICE = <any> 'AZURE_TO_SERVICE',
        CUSTOMDEVICEGROUPTOCUSTOMDEVICE = <any> 'CUSTOM_DEVICE_GROUP_TO_CUSTOM_DEVICE',
        HOSTTOPROCESSGROUPINSTANCE = <any> 'HOST_TO_PROCESS_GROUP_INSTANCE',
        PROCESSGROUPTOHOST = <any> 'PROCESS_GROUP_TO_HOST',
        PROCESSGROUPTOSERVICE = <any> 'PROCESS_GROUP_TO_SERVICE',
        SERVICETOHOSTLIKE = <any> 'SERVICE_TO_HOST_LIKE',
        SERVICETOPROCESSGROUPLIKE = <any> 'SERVICE_TO_PROCESS_GROUP_LIKE'
    }
}
