/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { MaskingRule } from './maskingRule';

/**
* Settings option in detail
*/
export class MaskingSettings {
    /**
    * Options like SAFE, SUPERSAFE etc.
    */
    'recordingMaskingSettings': MaskingSettings.RecordingMaskingSettingsEnum;
    /**
    * MaskingRule which decides how data is hidden.
    */
    'maskingRules'?: Array<MaskingRule>;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "recordingMaskingSettings",
            "baseName": "recordingMaskingSettings",
            "type": "MaskingSettings.RecordingMaskingSettingsEnum"
        },
        {
            "name": "maskingRules",
            "baseName": "maskingRules",
            "type": "Array<MaskingRule>"
        }    ];

    static getAttributeTypeMap() {
        return MaskingSettings.attributeTypeMap;
    }
}

export namespace MaskingSettings {
    export enum RecordingMaskingSettingsEnum {
        BLACKLIST = <any> 'BLACKLIST',
        SAFE = <any> 'SAFE',
        SUPERSAFE = <any> 'SUPERSAFE',
        WHITELIST = <any> 'WHITELIST'
    }
}
