/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* Configuration to capture meta data with the JavaScript agent.
*/
export class MetaDataCapturing {
    /**
    * The type of the meta data to capture.
    */
    'type': MetaDataCapturing.TypeEnum;
    /**
    * The name of the meta data to capture.
    */
    'capturingName': string;
    /**
    * Name for displaying the captured values in Dynatrace.
    */
    'name': string;
    /**
    * The unique id of the meta data to capture.
    */
    'uniqueId'?: number;
    /**
    * True if this metadata should be captured regardless of the privacy settings
    */
    'publicMetadata'?: boolean;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "type",
            "baseName": "type",
            "type": "MetaDataCapturing.TypeEnum"
        },
        {
            "name": "capturingName",
            "baseName": "capturingName",
            "type": "string"
        },
        {
            "name": "name",
            "baseName": "name",
            "type": "string"
        },
        {
            "name": "uniqueId",
            "baseName": "uniqueId",
            "type": "number"
        },
        {
            "name": "publicMetadata",
            "baseName": "publicMetadata",
            "type": "boolean"
        }    ];

    static getAttributeTypeMap() {
        return MetaDataCapturing.attributeTypeMap;
    }
}

export namespace MetaDataCapturing {
    export enum TypeEnum {
        COOKIE = <any> 'COOKIE',
        CSSSELECTOR = <any> 'CSS_SELECTOR',
        JAVASCRIPTFUNCTION = <any> 'JAVA_SCRIPT_FUNCTION',
        JAVASCRIPTVARIABLE = <any> 'JAVA_SCRIPT_VARIABLE',
        METATAG = <any> 'META_TAG',
        QUERYSTRING = <any> 'QUERY_STRING'
    }
}
