/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* Configuration of a method to be captured.
*/
export class MethodReference {
    /**
    * The visibility of the method to capture.
    */
    'visibility': MethodReference.VisibilityEnum;
    /**
    * The modifiers of the method to capture.
    */
    'modifiers': Array<MethodReference.ModifiersEnum>;
    /**
    * The class name where the method to capture resides.    Either this or the **fileName** must be set.
    */
    'className'?: string;
    /**
    * The file name where the method to capture resides.    Either this or **className** must be set.
    */
    'fileName'?: string;
    /**
    * The operator of the comparison.    If not set, `EQUALS` is used.
    */
    'fileNameMatcher'?: MethodReference.FileNameMatcherEnum;
    /**
    * The name of the method to capture.
    */
    'methodName': string;
    /**
    * The list of argument types.
    */
    'argumentTypes': Array<string>;
    /**
    * The return type.
    */
    'returnType': string;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "visibility",
            "baseName": "visibility",
            "type": "MethodReference.VisibilityEnum"
        },
        {
            "name": "modifiers",
            "baseName": "modifiers",
            "type": "Array<MethodReference.ModifiersEnum>"
        },
        {
            "name": "className",
            "baseName": "className",
            "type": "string"
        },
        {
            "name": "fileName",
            "baseName": "fileName",
            "type": "string"
        },
        {
            "name": "fileNameMatcher",
            "baseName": "fileNameMatcher",
            "type": "MethodReference.FileNameMatcherEnum"
        },
        {
            "name": "methodName",
            "baseName": "methodName",
            "type": "string"
        },
        {
            "name": "argumentTypes",
            "baseName": "argumentTypes",
            "type": "Array<string>"
        },
        {
            "name": "returnType",
            "baseName": "returnType",
            "type": "string"
        }    ];

    static getAttributeTypeMap() {
        return MethodReference.attributeTypeMap;
    }
}

export namespace MethodReference {
    export enum VisibilityEnum {
        INTERNAL = <any> 'INTERNAL',
        PACKAGEPROTECTED = <any> 'PACKAGE_PROTECTED',
        PRIVATE = <any> 'PRIVATE',
        PROTECTED = <any> 'PROTECTED',
        PUBLIC = <any> 'PUBLIC'
    }
    export enum ModifiersEnum {
        ABSTRACT = <any> 'ABSTRACT',
        EXTERN = <any> 'EXTERN',
        FINAL = <any> 'FINAL',
        NATIVE = <any> 'NATIVE',
        STATIC = <any> 'STATIC'
    }
    export enum FileNameMatcherEnum {
        ENDSWITH = <any> 'ENDS_WITH',
        EQUALS = <any> 'EQUALS',
        STARTSWITH = <any> 'STARTS_WITH'
    }
}
