/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* A single filter for the alerting scope.  This is the base version of the filter, depending on the type,  the actual JSON may contain additional fields.
*/
export class MetricEventAlertingScope {
    /**
    * Defines the actual set of fields depending on the value. See one of the following objects:   * `ENTITY_ID` -> EntityIdAlertingScope  * `MANAGEMENT_ZONE` -> ManagementZoneAlertingScope  * `TAG` -> TagFilterAlertingScope  * `NAME` -> NameAlertingScope  * `CUSTOM_DEVICE_GROUP_NAME` -> CustomDeviceGroupNameAlertingScope  * `HOST_GROUP_NAME` -> HostGroupNameAlertingScope  * `HOST_NAME` -> HostNameAlertingScope  * `PROCESS_GROUP_ID` -> ProcessGroupIdAlertingScope  * `PROCESS_GROUP_NAME` -> ProcessGroupNameAlertingScope  
    */
    'filterType': MetricEventAlertingScope.FilterTypeEnum;

    static discriminator: string | undefined = "filterType";

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "filterType",
            "baseName": "filterType",
            "type": "MetricEventAlertingScope.FilterTypeEnum"
        }    ];

    static getAttributeTypeMap() {
        return MetricEventAlertingScope.attributeTypeMap;
    }
}

export namespace MetricEventAlertingScope {
    export enum FilterTypeEnum {
        CUSTOMDEVICEGROUPNAME = <any> 'CUSTOM_DEVICE_GROUP_NAME',
        ENTITYID = <any> 'ENTITY_ID',
        HOSTGROUPNAME = <any> 'HOST_GROUP_NAME',
        HOSTNAME = <any> 'HOST_NAME',
        MANAGEMENTZONE = <any> 'MANAGEMENT_ZONE',
        NAME = <any> 'NAME',
        PROCESSGROUPID = <any> 'PROCESS_GROUP_ID',
        PROCESSGROUPNAME = <any> 'PROCESS_GROUP_NAME',
        TAG = <any> 'TAG'
    }
}
