/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { MetricEventAutoAdaptiveBaselineMonitoringStrategyAllOf } from './metricEventAutoAdaptiveBaselineMonitoringStrategyAllOf';
import { MetricEventMonitoringStrategy } from './metricEventMonitoringStrategy';

/**
* An auto-adaptive baseline strategy to detect anomalies within metrics that show a regular change over time, as the baseline is also updated automatically. An example is to detect an anomaly in the number of received network packets or within the number of user actions over time.
*/
export class MetricEventAutoAdaptiveBaselineMonitoringStrategy extends MetricEventMonitoringStrategy {
    /**
    * The number of one-minute samples that form the sliding evaluation window.
    */
    'samples': number;
    /**
    * The number of one-minute samples within the evaluation window that must violate the threshold to trigger an event
    */
    'violatingSamples': number;
    /**
    * The number of one-minute samples within the evaluation window that must go back to normal to close the event.
    */
    'dealertingSamples': number;
    /**
    * The condition for the **threshold** value check: above or below.
    */
    'alertCondition': MetricEventAutoAdaptiveBaselineMonitoringStrategy.AlertConditionEnum;
    /**
    * Defines the factor of how many signal fluctuations are valid. Values above the baseline plus the signal fluctuation times the number of tolerated signal fluctuations are alerted.
    */
    'numberOfSignalFluctuations': number;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "samples",
            "baseName": "samples",
            "type": "number"
        },
        {
            "name": "violatingSamples",
            "baseName": "violatingSamples",
            "type": "number"
        },
        {
            "name": "dealertingSamples",
            "baseName": "dealertingSamples",
            "type": "number"
        },
        {
            "name": "alertCondition",
            "baseName": "alertCondition",
            "type": "MetricEventAutoAdaptiveBaselineMonitoringStrategy.AlertConditionEnum"
        },
        {
            "name": "numberOfSignalFluctuations",
            "baseName": "numberOfSignalFluctuations",
            "type": "number"
        }    ];

    static getAttributeTypeMap() {
        return super.getAttributeTypeMap().concat(MetricEventAutoAdaptiveBaselineMonitoringStrategy.attributeTypeMap);
    }
}

export namespace MetricEventAutoAdaptiveBaselineMonitoringStrategy {
    export enum AlertConditionEnum {
        ABOVE = <any> 'ABOVE',
        BELOW = <any> 'BELOW'
    }
}
