/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

export class MetricEventAutoAdaptiveBaselineMonitoringStrategyAllOf {
    /**
    * The number of one-minute samples that form the sliding evaluation window.
    */
    'samples'?: number;
    /**
    * The number of one-minute samples within the evaluation window that must violate the threshold to trigger an event
    */
    'violatingSamples'?: number;
    /**
    * The number of one-minute samples within the evaluation window that must go back to normal to close the event.
    */
    'dealertingSamples'?: number;
    /**
    * The condition for the **threshold** value check: above or below.
    */
    'alertCondition'?: MetricEventAutoAdaptiveBaselineMonitoringStrategyAllOf.AlertConditionEnum;
    /**
    * Defines the factor of how many signal fluctuations are valid. Values above the baseline plus the signal fluctuation times the number of tolerated signal fluctuations are alerted.
    */
    'numberOfSignalFluctuations'?: number;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "samples",
            "baseName": "samples",
            "type": "number"
        },
        {
            "name": "violatingSamples",
            "baseName": "violatingSamples",
            "type": "number"
        },
        {
            "name": "dealertingSamples",
            "baseName": "dealertingSamples",
            "type": "number"
        },
        {
            "name": "alertCondition",
            "baseName": "alertCondition",
            "type": "MetricEventAutoAdaptiveBaselineMonitoringStrategyAllOf.AlertConditionEnum"
        },
        {
            "name": "numberOfSignalFluctuations",
            "baseName": "numberOfSignalFluctuations",
            "type": "number"
        }    ];

    static getAttributeTypeMap() {
        return MetricEventAutoAdaptiveBaselineMonitoringStrategyAllOf.attributeTypeMap;
    }
}

export namespace MetricEventAutoAdaptiveBaselineMonitoringStrategyAllOf {
    export enum AlertConditionEnum {
        ABOVE = <any> 'ABOVE',
        BELOW = <any> 'BELOW'
    }
}
