/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* A single filter for the metrics dimensions.  This is the base version of the filter, depending on the type,  the actual JSON may contain additional fields.
*/
export class MetricEventDimensions {
    /**
    * Defines the actual set of fields depending on the value. See one of the following objects:   * `ENTITY` -> MetricEventEntityDimensions  * `STRING` -> MetricEventStringDimensions  
    */
    'filterType': MetricEventDimensions.FilterTypeEnum;
    /**
    * The dimensions name. Sending this has no effect while creating a configuration, as only the *index* of the dimension is used here -> dimension names might change, indexes not.
    */
    'name'?: string;
    /**
    * The dimensions index on the metric.
    */
    'index'?: number;

    static discriminator: string | undefined = "filterType";

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "filterType",
            "baseName": "filterType",
            "type": "MetricEventDimensions.FilterTypeEnum"
        },
        {
            "name": "name",
            "baseName": "name",
            "type": "string"
        },
        {
            "name": "index",
            "baseName": "index",
            "type": "number"
        }    ];

    static getAttributeTypeMap() {
        return MetricEventDimensions.attributeTypeMap;
    }
}

export namespace MetricEventDimensions {
    export enum FilterTypeEnum {
        ENTITY = <any> 'ENTITY',
        STRING = <any> 'STRING'
    }
}
