/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* A monitoring strategy for a metric event config.  This is the base version of the monitoring strategy, depending on the type,  the actual JSON may contain additional fields.
*/
export class MetricEventMonitoringStrategy {
    /**
    * Defines the actual set of fields depending on the value. See one of the following objects:   * `STATIC_THRESHOLD` -> MetricEventStaticThresholdMonitoringStrategy  * `AUTO_ADAPTIVE_BASELINE` -> MetricEventAutoAdaptiveBaselineMonitoringStrategy  
    */
    'type': MetricEventMonitoringStrategy.TypeEnum;

    static discriminator: string | undefined = "type";

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "type",
            "baseName": "type",
            "type": "MetricEventMonitoringStrategy.TypeEnum"
        }    ];

    static getAttributeTypeMap() {
        return MetricEventMonitoringStrategy.attributeTypeMap;
    }
}

export namespace MetricEventMonitoringStrategy {
    export enum TypeEnum {
        AUTOADAPTIVEBASELINE = <any> 'AUTO_ADAPTIVE_BASELINE',
        STATICTHRESHOLD = <any> 'STATIC_THRESHOLD'
    }
}
