/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

export class MetricEventStaticThresholdMonitoringStrategyAllOf {
    /**
    * The number of one-minute samples that form the sliding evaluation window.
    */
    'samples'?: number;
    /**
    * The number of one-minute samples within the evaluation window that must violate the threshold to trigger an event
    */
    'violatingSamples'?: number;
    /**
    * The number of one-minute samples within the evaluation window that must go back to normal to close the event.
    */
    'dealertingSamples'?: number;
    /**
    * The condition for the **threshold** value check: above or below.
    */
    'alertCondition'?: MetricEventStaticThresholdMonitoringStrategyAllOf.AlertConditionEnum;
    /**
    * The value of the static threshold based on the specified unit.
    */
    'threshold'?: number;
    /**
    * The unit of the threshold, matching the metric definition.
    */
    'unit'?: MetricEventStaticThresholdMonitoringStrategyAllOf.UnitEnum;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "samples",
            "baseName": "samples",
            "type": "number"
        },
        {
            "name": "violatingSamples",
            "baseName": "violatingSamples",
            "type": "number"
        },
        {
            "name": "dealertingSamples",
            "baseName": "dealertingSamples",
            "type": "number"
        },
        {
            "name": "alertCondition",
            "baseName": "alertCondition",
            "type": "MetricEventStaticThresholdMonitoringStrategyAllOf.AlertConditionEnum"
        },
        {
            "name": "threshold",
            "baseName": "threshold",
            "type": "number"
        },
        {
            "name": "unit",
            "baseName": "unit",
            "type": "MetricEventStaticThresholdMonitoringStrategyAllOf.UnitEnum"
        }    ];

    static getAttributeTypeMap() {
        return MetricEventStaticThresholdMonitoringStrategyAllOf.attributeTypeMap;
    }
}

export namespace MetricEventStaticThresholdMonitoringStrategyAllOf {
    export enum AlertConditionEnum {
        ABOVE = <any> 'ABOVE',
        BELOW = <any> 'BELOW'
    }
    export enum UnitEnum {
        BIT = <any> 'BIT',
        BITPERHOUR = <any> 'BIT_PER_HOUR',
        BITPERMINUTE = <any> 'BIT_PER_MINUTE',
        BITPERSECOND = <any> 'BIT_PER_SECOND',
        BYTE = <any> 'BYTE',
        BYTEPERHOUR = <any> 'BYTE_PER_HOUR',
        BYTEPERMINUTE = <any> 'BYTE_PER_MINUTE',
        BYTEPERSECOND = <any> 'BYTE_PER_SECOND',
        CORES = <any> 'CORES',
        COUNT = <any> 'COUNT',
        DAY = <any> 'DAY',
        GIBIBYTE = <any> 'GIBI_BYTE',
        GIGA = <any> 'GIGA',
        GIGABYTE = <any> 'GIGA_BYTE',
        HOUR = <any> 'HOUR',
        KIBIBYTE = <any> 'KIBI_BYTE',
        KIBIBYTEPERHOUR = <any> 'KIBI_BYTE_PER_HOUR',
        KIBIBYTEPERMINUTE = <any> 'KIBI_BYTE_PER_MINUTE',
        KIBIBYTEPERSECOND = <any> 'KIBI_BYTE_PER_SECOND',
        KILO = <any> 'KILO',
        KILOBYTE = <any> 'KILO_BYTE',
        KILOBYTEPERHOUR = <any> 'KILO_BYTE_PER_HOUR',
        KILOBYTEPERMINUTE = <any> 'KILO_BYTE_PER_MINUTE',
        KILOBYTEPERSECOND = <any> 'KILO_BYTE_PER_SECOND',
        MEBIBYTE = <any> 'MEBI_BYTE',
        MEBIBYTEPERHOUR = <any> 'MEBI_BYTE_PER_HOUR',
        MEBIBYTEPERMINUTE = <any> 'MEBI_BYTE_PER_MINUTE',
        MEBIBYTEPERSECOND = <any> 'MEBI_BYTE_PER_SECOND',
        MEGA = <any> 'MEGA',
        MEGABYTE = <any> 'MEGA_BYTE',
        MEGABYTEPERHOUR = <any> 'MEGA_BYTE_PER_HOUR',
        MEGABYTEPERMINUTE = <any> 'MEGA_BYTE_PER_MINUTE',
        MEGABYTEPERSECOND = <any> 'MEGA_BYTE_PER_SECOND',
        MICROSECOND = <any> 'MICRO_SECOND',
        MILLICORES = <any> 'MILLI_CORES',
        MILLISECOND = <any> 'MILLI_SECOND',
        MILLISECONDPERMINUTE = <any> 'MILLI_SECOND_PER_MINUTE',
        MINUTE = <any> 'MINUTE',
        MONTH = <any> 'MONTH',
        NANOSECOND = <any> 'NANO_SECOND',
        NANOSECONDPERMINUTE = <any> 'NANO_SECOND_PER_MINUTE',
        NOTAPPLICABLE = <any> 'NOT_APPLICABLE',
        PERCENT = <any> 'PERCENT',
        PERHOUR = <any> 'PER_HOUR',
        PERMINUTE = <any> 'PER_MINUTE',
        PERSECOND = <any> 'PER_SECOND',
        PIXEL = <any> 'PIXEL',
        PROMILLE = <any> 'PROMILLE',
        RATIO = <any> 'RATIO',
        SECOND = <any> 'SECOND',
        STATE = <any> 'STATE',
        UNSPECIFIED = <any> 'UNSPECIFIED',
        WEEK = <any> 'WEEK',
        YEAR = <any> 'YEAR'
    }
}
