/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { ComparisonBasic } from './comparisonBasic';
import { MobilePlatformComparisonAllOf } from './mobilePlatformComparisonAllOf';

/**
* Comparison for `MOBILE_PLATFORM` attributes.
*/
export class MobilePlatformComparison extends ComparisonBasic {
    /**
    * Operator of the comparison. You can reverse it by setting **negate** to `true`.   Possible values depend on the **type** of the comparison. Find the list of actual models in the description of the **type** field and check the description of the model you need.
    */
    'operator': MobilePlatformComparison.OperatorEnum;
    /**
    * The value to compare to.
    */
    'value'?: MobilePlatformComparison.ValueEnum;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "operator",
            "baseName": "operator",
            "type": "MobilePlatformComparison.OperatorEnum"
        },
        {
            "name": "value",
            "baseName": "value",
            "type": "MobilePlatformComparison.ValueEnum"
        }    ];

    static getAttributeTypeMap() {
        return super.getAttributeTypeMap().concat(MobilePlatformComparison.attributeTypeMap);
    }
}

export namespace MobilePlatformComparison {
    export enum OperatorEnum {
        EQUALS = <any> 'EQUALS',
        EXISTS = <any> 'EXISTS'
    }
    export enum ValueEnum {
        ANDROID = <any> 'ANDROID',
        IOS = <any> 'IOS',
        LINUX = <any> 'LINUX',
        MACOS = <any> 'MAC_OS',
        OTHER = <any> 'OTHER',
        TVOS = <any> 'TVOS',
        WINDOWS = <any> 'WINDOWS'
    }
}
