/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { TagInfo } from './tagInfo';

/**
* A matching rule for Dynatrace entities.
*/
export class MonitoredEntityFilter {
    /**
    * The type of the Dynatrace entities (for example, hosts or services) you want to pick up by matching.
    */
    'type'?: MonitoredEntityFilter.TypeEnum;
    /**
    * The ID of a management zone to which the matched entities must belong.
    */
    'mzId'?: string;
    /**
    * The tag you want to use for matching.   You can use custom tags from the UI, AWS tags, Cloud Foundry tags, OpenShift/Kubernetes, and tags based on environment variables.
    */
    'tags': Array<TagInfo>;
    /**
    * The logic that applies when several tags are specified: AND/OR.   If not set, the OR logic is used.
    */
    'tagCombination'?: MonitoredEntityFilter.TagCombinationEnum;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "type",
            "baseName": "type",
            "type": "MonitoredEntityFilter.TypeEnum"
        },
        {
            "name": "mzId",
            "baseName": "mzId",
            "type": "string"
        },
        {
            "name": "tags",
            "baseName": "tags",
            "type": "Array<TagInfo>"
        },
        {
            "name": "tagCombination",
            "baseName": "tagCombination",
            "type": "MonitoredEntityFilter.TagCombinationEnum"
        }    ];

    static getAttributeTypeMap() {
        return MonitoredEntityFilter.attributeTypeMap;
    }
}

export namespace MonitoredEntityFilter {
    export enum TypeEnum {
        APPLICATION = <any> 'APPLICATION',
        APPLICATIONMETHOD = <any> 'APPLICATION_METHOD',
        APPLICATIONMETHODGROUP = <any> 'APPLICATION_METHOD_GROUP',
        APPMONSERVER = <any> 'APPMON_SERVER',
        APPMONSYSTEMPROFILE = <any> 'APPMON_SYSTEM_PROFILE',
        AUTOSCALINGGROUP = <any> 'AUTO_SCALING_GROUP',
        AUXILIARYSYNTHETICTEST = <any> 'AUXILIARY_SYNTHETIC_TEST',
        AWSAPPLICATIONLOADBALANCER = <any> 'AWS_APPLICATION_LOAD_BALANCER',
        AWSAVAILABILITYZONE = <any> 'AWS_AVAILABILITY_ZONE',
        AWSCREDENTIALS = <any> 'AWS_CREDENTIALS',
        AWSLAMBDAFUNCTION = <any> 'AWS_LAMBDA_FUNCTION',
        AWSNETWORKLOADBALANCER = <any> 'AWS_NETWORK_LOAD_BALANCER',
        AZUREAPIMANAGEMENTSERVICE = <any> 'AZURE_API_MANAGEMENT_SERVICE',
        AZUREAPPLICATIONGATEWAY = <any> 'AZURE_APPLICATION_GATEWAY',
        AZURECOSMOSDB = <any> 'AZURE_COSMOS_DB',
        AZURECREDENTIALS = <any> 'AZURE_CREDENTIALS',
        AZUREEVENTHUB = <any> 'AZURE_EVENT_HUB',
        AZUREEVENTHUBNAMESPACE = <any> 'AZURE_EVENT_HUB_NAMESPACE',
        AZUREFUNCTIONAPP = <any> 'AZURE_FUNCTION_APP',
        AZUREIOTHUB = <any> 'AZURE_IOT_HUB',
        AZURELOADBALANCER = <any> 'AZURE_LOAD_BALANCER',
        AZUREMGMTGROUP = <any> 'AZURE_MGMT_GROUP',
        AZUREREDISCACHE = <any> 'AZURE_REDIS_CACHE',
        AZUREREGION = <any> 'AZURE_REGION',
        AZURESERVICEBUSNAMESPACE = <any> 'AZURE_SERVICE_BUS_NAMESPACE',
        AZURESERVICEBUSQUEUE = <any> 'AZURE_SERVICE_BUS_QUEUE',
        AZURESERVICEBUSTOPIC = <any> 'AZURE_SERVICE_BUS_TOPIC',
        AZURESQLDATABASE = <any> 'AZURE_SQL_DATABASE',
        AZURESQLELASTICPOOL = <any> 'AZURE_SQL_ELASTIC_POOL',
        AZURESQLSERVER = <any> 'AZURE_SQL_SERVER',
        AZURESTORAGEACCOUNT = <any> 'AZURE_STORAGE_ACCOUNT',
        AZURESUBSCRIPTION = <any> 'AZURE_SUBSCRIPTION',
        AZURETENANT = <any> 'AZURE_TENANT',
        AZUREVM = <any> 'AZURE_VM',
        AZUREVMSCALESET = <any> 'AZURE_VM_SCALE_SET',
        AZUREWEBAPP = <any> 'AZURE_WEB_APP',
        CFAPPLICATION = <any> 'CF_APPLICATION',
        CFFOUNDATION = <any> 'CF_FOUNDATION',
        CINDERVOLUME = <any> 'CINDER_VOLUME',
        CLOUDAPPLICATION = <any> 'CLOUD_APPLICATION',
        CLOUDAPPLICATIONINSTANCE = <any> 'CLOUD_APPLICATION_INSTANCE',
        CLOUDAPPLICATIONNAMESPACE = <any> 'CLOUD_APPLICATION_NAMESPACE',
        CONTAINERGROUP = <any> 'CONTAINER_GROUP',
        CONTAINERGROUPINSTANCE = <any> 'CONTAINER_GROUP_INSTANCE',
        CUSTOMAPPLICATION = <any> 'CUSTOM_APPLICATION',
        CUSTOMDEVICE = <any> 'CUSTOM_DEVICE',
        CUSTOMDEVICEGROUP = <any> 'CUSTOM_DEVICE_GROUP',
        DCRUMAPPLICATION = <any> 'DCRUM_APPLICATION',
        DCRUMSERVICE = <any> 'DCRUM_SERVICE',
        DCRUMSERVICEINSTANCE = <any> 'DCRUM_SERVICE_INSTANCE',
        DEVICEAPPLICATIONMETHOD = <any> 'DEVICE_APPLICATION_METHOD',
        DISK = <any> 'DISK',
        DOCKERCONTAINERGROUP = <any> 'DOCKER_CONTAINER_GROUP',
        DOCKERCONTAINERGROUPINSTANCE = <any> 'DOCKER_CONTAINER_GROUP_INSTANCE',
        DYNAMODBTABLE = <any> 'DYNAMO_DB_TABLE',
        EBSVOLUME = <any> 'EBS_VOLUME',
        EC2INSTANCE = <any> 'EC2_INSTANCE',
        ELASTICLOADBALANCER = <any> 'ELASTIC_LOAD_BALANCER',
        ENVIRONMENT = <any> 'ENVIRONMENT',
        EXTERNALSYNTHETICTESTSTEP = <any> 'EXTERNAL_SYNTHETIC_TEST_STEP',
        GCPZONE = <any> 'GCP_ZONE',
        GEOLOCATION = <any> 'GEOLOCATION',
        GEOLOCSITE = <any> 'GEOLOC_SITE',
        GOOGLECOMPUTEENGINE = <any> 'GOOGLE_COMPUTE_ENGINE',
        HOST = <any> 'HOST',
        HOSTGROUP = <any> 'HOST_GROUP',
        HTTPCHECK = <any> 'HTTP_CHECK',
        HTTPCHECKSTEP = <any> 'HTTP_CHECK_STEP',
        HYPERVISOR = <any> 'HYPERVISOR',
        KUBERNETESCLUSTER = <any> 'KUBERNETES_CLUSTER',
        KUBERNETESNODE = <any> 'KUBERNETES_NODE',
        MOBILEAPPLICATION = <any> 'MOBILE_APPLICATION',
        NETWORKINTERFACE = <any> 'NETWORK_INTERFACE',
        NEUTRONSUBNET = <any> 'NEUTRON_SUBNET',
        OPENSTACKPROJECT = <any> 'OPENSTACK_PROJECT',
        OPENSTACKREGION = <any> 'OPENSTACK_REGION',
        OPENSTACKVM = <any> 'OPENSTACK_VM',
        OS = <any> 'OS',
        PROCESSGROUP = <any> 'PROCESS_GROUP',
        PROCESSGROUPINSTANCE = <any> 'PROCESS_GROUP_INSTANCE',
        RELATIONALDATABASESERVICE = <any> 'RELATIONAL_DATABASE_SERVICE',
        SERVICE = <any> 'SERVICE',
        SERVICEINSTANCE = <any> 'SERVICE_INSTANCE',
        SERVICEMETHOD = <any> 'SERVICE_METHOD',
        SERVICEMETHODGROUP = <any> 'SERVICE_METHOD_GROUP',
        SWIFTCONTAINER = <any> 'SWIFT_CONTAINER',
        SYNTHETICLOCATION = <any> 'SYNTHETIC_LOCATION',
        SYNTHETICTEST = <any> 'SYNTHETIC_TEST',
        SYNTHETICTESTSTEP = <any> 'SYNTHETIC_TEST_STEP',
        VIRTUALMACHINE = <any> 'VIRTUALMACHINE',
        VMWAREDATACENTER = <any> 'VMWARE_DATACENTER'
    }
    export enum TagCombinationEnum {
        AND = <any> 'AND',
        OR = <any> 'OR'
    }
}
