/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* Custom thresholds for dropped packets. If not set, automatic mode is used.    **All** of these conditions must be met to trigger an alert.
*/
export class NetworkDroppedPacketsThresholds {
    /**
    * Receive/transmit dropped packet percentage is higher than *X*% in 3 out of 5 samples.
    */
    'droppedPacketsPercentage': number;
    /**
    * Total receive/transmit packets rate is higher than *X* packets per second in 3 out of 5 samples.
    */
    'totalPacketsRate': number;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "droppedPacketsPercentage",
            "baseName": "droppedPacketsPercentage",
            "type": "number"
        },
        {
            "name": "totalPacketsRate",
            "baseName": "totalPacketsRate",
            "type": "number"
        }    ];

    static getAttributeTypeMap() {
        return NetworkDroppedPacketsThresholds.attributeTypeMap;
    }
}

