/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* Configuration of a notification. The actual set of fields depends on the `type` of the notification. See the [Notifications API - JSON models](https://www.dynatrace.com/support/help/shortlink/api-config-notifications-models) help topic for example models of every notification type.
*/
export class NotificationConfig {
    /**
    * The ID of the notification configuration.
    */
    'id'?: string;
    /**
    * The name of the notification configuration.
    */
    'name': string;
    /**
    * The ID of the associated alerting profile.
    */
    'alertingProfile': string;
    /**
    * The configuration is enabled (`true`) or disabled (`false`).
    */
    'active': boolean;
    /**
    * Defines the actual set of fields depending on the value. See one of the following objects:   * `EMAIL` -> EmailNotificationConfig  * `PAGER_DUTY` -> PagerDutyNotificationConfig  * `WEBHOOK` -> WebHookNotificationConfig  * `SLACK` -> SlackNotificationConfig  * `HIPCHAT` -> HipChatNotificationConfig  * `VICTOROPS` -> VictorOpsNotificationConfig  * `SERVICE_NOW` -> ServiceNowNotificationConfig  * `XMATTERS` -> XMattersNotificationConfig  * `ANSIBLETOWER` -> AnsibleTowerNotificationConfig  * `OPS_GENIE` -> OpsGenieNotificationConfig  * `JIRA` -> JiraNotificationConfig  * `TRELLO` -> TrelloNotificationConfig  
    */
    'type': NotificationConfig.TypeEnum;

    static discriminator: string | undefined = "type";

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "id",
            "baseName": "id",
            "type": "string"
        },
        {
            "name": "name",
            "baseName": "name",
            "type": "string"
        },
        {
            "name": "alertingProfile",
            "baseName": "alertingProfile",
            "type": "string"
        },
        {
            "name": "active",
            "baseName": "active",
            "type": "boolean"
        },
        {
            "name": "type",
            "baseName": "type",
            "type": "NotificationConfig.TypeEnum"
        }    ];

    static getAttributeTypeMap() {
        return NotificationConfig.attributeTypeMap;
    }
}

export namespace NotificationConfig {
    export enum TypeEnum {
        ANSIBLETOWER = <any> 'ANSIBLETOWER',
        EMAIL = <any> 'EMAIL',
        HIPCHAT = <any> 'HIPCHAT',
        JIRA = <any> 'JIRA',
        OPSGENIE = <any> 'OPS_GENIE',
        PAGERDUTY = <any> 'PAGER_DUTY',
        SERVICENOW = <any> 'SERVICE_NOW',
        SLACK = <any> 'SLACK',
        TRELLO = <any> 'TRELLO',
        VICTOROPS = <any> 'VICTOROPS',
        WEBHOOK = <any> 'WEBHOOK',
        XMATTERS = <any> 'XMATTERS'
    }
}
