/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { ComparisonInfo } from './comparisonInfo';
import { NumberRequestAttributeComparisonInfoAllOf } from './numberRequestAttributeComparisonInfoAllOf';
import { PropagationSource } from './propagationSource';

/**
* Comparison for `NUMBER_REQUEST_ATTRIBUTE` attributes, specifically of the generic **Number** type.
*/
export class NumberRequestAttributeComparisonInfo extends ComparisonInfo {
    /**
    * Operator of the comparision. You can reverse it by setting **negate** to `true`.
    */
    'comparison': NumberRequestAttributeComparisonInfo.ComparisonEnum;
    /**
    * The value to compare to.
    */
    'value'?: number;
    'requestAttribute': string;
    /**
    * If `true`, the request attribute is matched on child service calls.     Default is `false`.
    */
    'matchOnChildCalls'?: boolean;
    'source'?: PropagationSource;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "comparison",
            "baseName": "comparison",
            "type": "NumberRequestAttributeComparisonInfo.ComparisonEnum"
        },
        {
            "name": "value",
            "baseName": "value",
            "type": "number"
        },
        {
            "name": "requestAttribute",
            "baseName": "requestAttribute",
            "type": "string"
        },
        {
            "name": "matchOnChildCalls",
            "baseName": "matchOnChildCalls",
            "type": "boolean"
        },
        {
            "name": "source",
            "baseName": "source",
            "type": "PropagationSource"
        }    ];

    static getAttributeTypeMap() {
        return super.getAttributeTypeMap().concat(NumberRequestAttributeComparisonInfo.attributeTypeMap);
    }
}

export namespace NumberRequestAttributeComparisonInfo {
    export enum ComparisonEnum {
        EQUALS = <any> 'EQUALS',
        EXISTS = <any> 'EXISTS',
        GREATERTHAN = <any> 'GREATER_THAN',
        GREATERTHANOREQUAL = <any> 'GREATER_THAN_OR_EQUAL',
        LOWERTHAN = <any> 'LOWER_THAN',
        LOWERTHANOREQUAL = <any> 'LOWER_THAN_OR_EQUAL'
    }
}
