/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { ComparisonBasic } from './comparisonBasic';
import { OsArchitectureComparisonAllOf } from './osArchitectureComparisonAllOf';

/**
* Comparison for `OS_ARCHITECTURE` attributes.
*/
export class OsArchitectureComparison extends ComparisonBasic {
    /**
    * Operator of the comparison. You can reverse it by setting **negate** to `true`.   Possible values depend on the **type** of the comparison. Find the list of actual models in the description of the **type** field and check the description of the model you need.
    */
    'operator': OsArchitectureComparison.OperatorEnum;
    /**
    * The value to compare to.
    */
    'value'?: OsArchitectureComparison.ValueEnum;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "operator",
            "baseName": "operator",
            "type": "OsArchitectureComparison.OperatorEnum"
        },
        {
            "name": "value",
            "baseName": "value",
            "type": "OsArchitectureComparison.ValueEnum"
        }    ];

    static getAttributeTypeMap() {
        return super.getAttributeTypeMap().concat(OsArchitectureComparison.attributeTypeMap);
    }
}

export namespace OsArchitectureComparison {
    export enum OperatorEnum {
        EQUALS = <any> 'EQUALS',
        EXISTS = <any> 'EXISTS'
    }
    export enum ValueEnum {
        ARM = <any> 'ARM',
        IA64 = <any> 'IA64',
        PARISC = <any> 'PARISC',
        PPC = <any> 'PPC',
        PPCLE = <any> 'PPCLE',
        S390 = <any> 'S390',
        SPARC = <any> 'SPARC',
        X86 = <any> 'X86',
        ZOS = <any> 'ZOS'
    }
}
