/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { ComparisonBasic } from './comparisonBasic';
import { PaasTypeComparisonAllOf } from './paasTypeComparisonAllOf';

/**
* Comparison for `PAAS_TYPE` attributes.
*/
export class PaasTypeComparison extends ComparisonBasic {
    /**
    * Operator of the comparison. You can reverse it by setting **negate** to `true`.   Possible values depend on the **type** of the comparison. Find the list of actual models in the description of the **type** field and check the description of the model you need.
    */
    'operator': PaasTypeComparison.OperatorEnum;
    /**
    * The value to compare to.
    */
    'value'?: PaasTypeComparison.ValueEnum;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "operator",
            "baseName": "operator",
            "type": "PaasTypeComparison.OperatorEnum"
        },
        {
            "name": "value",
            "baseName": "value",
            "type": "PaasTypeComparison.ValueEnum"
        }    ];

    static getAttributeTypeMap() {
        return super.getAttributeTypeMap().concat(PaasTypeComparison.attributeTypeMap);
    }
}

export namespace PaasTypeComparison {
    export enum OperatorEnum {
        EQUALS = <any> 'EQUALS',
        EXISTS = <any> 'EXISTS'
    }
    export enum ValueEnum {
        AWSECSEC2 = <any> 'AWS_ECS_EC2',
        AWSECSFARGATE = <any> 'AWS_ECS_FARGATE',
        AWSLAMBDA = <any> 'AWS_LAMBDA',
        AZUREWEBSITES = <any> 'AZURE_WEBSITES',
        CLOUDFOUNDRY = <any> 'CLOUD_FOUNDRY',
        GOOGLEAPPENGINE = <any> 'GOOGLE_APP_ENGINE',
        HEROKU = <any> 'HEROKU',
        KUBERNETES = <any> 'KUBERNETES',
        OPENSHIFT = <any> 'OPENSHIFT'
    }
}
