/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { NotificationConfig } from './notificationConfig';
import { PagerDutyNotificationConfigAllOf } from './pagerDutyNotificationConfigAllOf';

/**
* Configuration of the PagerDuty notification.
*/
export class PagerDutyNotificationConfig extends NotificationConfig {
    /**
    * The name of the PagerDuty account.
    */
    'account': string;
    /**
    * The API key to access PagerDuty.
    */
    'serviceApiKey'?: string;
    /**
    * The name of the service.
    */
    'serviceName': string;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "account",
            "baseName": "account",
            "type": "string"
        },
        {
            "name": "serviceApiKey",
            "baseName": "serviceApiKey",
            "type": "string"
        },
        {
            "name": "serviceName",
            "baseName": "serviceName",
            "type": "string"
        }    ];

    static getAttributeTypeMap() {
        return super.getAttributeTypeMap().concat(PagerDutyNotificationConfig.attributeTypeMap);
    }
}

export namespace PagerDutyNotificationConfig {
}
