/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* A filtering criterion for log path.
*/
export class PathDefinition {
    /**
    * The path to the required log path.    If the **type** is set to `WILDCARD`, it may contain wildcard characters (`*`).
    */
    'definition': string;
    /**
    * The type of the log path **definition**: fixed or an expression with wildcards.
    */
    'type': PathDefinition.TypeEnum;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "definition",
            "baseName": "definition",
            "type": "string"
        },
        {
            "name": "type",
            "baseName": "type",
            "type": "PathDefinition.TypeEnum"
        }    ];

    static getAttributeTypeMap() {
        return PathDefinition.attributeTypeMap;
    }
}

export namespace PathDefinition {
    export enum TypeEnum {
        FIXED = <any> 'FIXED',
        WILDCARD = <any> 'WILDCARD'
    }
}
