/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { PropagationSource } from './propagationSource';

/**
* The custom placeholder to be used as a naming value pattern.    It enables you to extract a request attribute value or other request attribute and use it in the naming pattern.
*/
export class Placeholder {
    /**
    * The name of the placeholder. Use it in the naming pattern as `{name}`.
    */
    'name': string;
    /**
    * The attribute to extract from. You can only use attributes of the **string** type.
    */
    'attribute': Placeholder.AttributeEnum;
    /**
    * The type of extraction.    Defines either usage of regular expression (`regex`) or the position of request attribute value to be extracted.   When the **attribute** is `SERVICE_REQUEST_ATTRIBUTE` attribute and **aggregation** is `COUNT`, needs to be set to `ORIGINAL_TEXT`
    */
    'kind': Placeholder.KindEnum;
    /**
    * Depending on the **type** value:    * `REGEX_EXTRACTION`: The regular expression.   * `BETWEEN_DELIMITER`: The opening delimiter string to look for.   * All other values: The delimiter string to look for.
    */
    'delimiterOrRegex'?: string;
    /**
    * The closing delimiter string to look for.    Required if the **kind** value is `BETWEEN_DELIMITER`. Not applicable otherwise.
    */
    'endDelimiter'?: string;
    /**
    * The request attribute to extract from.    Required if the **kind** value is `SERVICE_REQUEST_ATTRIBUTE`. Not applicable otherwise.
    */
    'requestAttribute'?: string;
    /**
    * The format of the extracted string.
    */
    'normalization'?: Placeholder.NormalizationEnum;
    /**
    * If `true` request attribute will be taken from a child service call.    Only applicable for the `SERVICE_REQUEST_ATTRIBUTE` attribute. Defaults to `false`.
    */
    'useFromChildCalls'?: boolean;
    /**
    * Which value of the request attribute must be used when it occurs across multiple child requests.   Only applicable for the `SERVICE_REQUEST_ATTRIBUTE` attribute, when **useFromChildCalls** is `true`.   For the `COUNT` aggregation, the **kind** field is not applicable.
    */
    'aggregation'?: Placeholder.AggregationEnum;
    'source'?: PropagationSource;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "name",
            "baseName": "name",
            "type": "string"
        },
        {
            "name": "attribute",
            "baseName": "attribute",
            "type": "Placeholder.AttributeEnum"
        },
        {
            "name": "kind",
            "baseName": "kind",
            "type": "Placeholder.KindEnum"
        },
        {
            "name": "delimiterOrRegex",
            "baseName": "delimiterOrRegex",
            "type": "string"
        },
        {
            "name": "endDelimiter",
            "baseName": "endDelimiter",
            "type": "string"
        },
        {
            "name": "requestAttribute",
            "baseName": "requestAttribute",
            "type": "string"
        },
        {
            "name": "normalization",
            "baseName": "normalization",
            "type": "Placeholder.NormalizationEnum"
        },
        {
            "name": "useFromChildCalls",
            "baseName": "useFromChildCalls",
            "type": "boolean"
        },
        {
            "name": "aggregation",
            "baseName": "aggregation",
            "type": "Placeholder.AggregationEnum"
        },
        {
            "name": "source",
            "baseName": "source",
            "type": "PropagationSource"
        }    ];

    static getAttributeTypeMap() {
        return Placeholder.attributeTypeMap;
    }
}

export namespace Placeholder {
    export enum AttributeEnum {
        ACTORSYSTEM = <any> 'ACTOR_SYSTEM',
        AKKAACTORCLASSNAME = <any> 'AKKA_ACTOR_CLASS_NAME',
        AKKAACTORMESSAGETYPE = <any> 'AKKA_ACTOR_MESSAGE_TYPE',
        AKKAACTORPATH = <any> 'AKKA_ACTOR_PATH',
        AZUREFUNCTIONSFUNCTIONNAME = <any> 'AZURE_FUNCTIONS_FUNCTION_NAME',
        AZUREFUNCTIONSSITENAME = <any> 'AZURE_FUNCTIONS_SITE_NAME',
        CICSPROGRAMNAME = <any> 'CICS_PROGRAM_NAME',
        CICSSYSTEMID = <any> 'CICS_SYSTEM_ID',
        CICSTASKID = <any> 'CICS_TASK_ID',
        CICSTRANSACTIONID = <any> 'CICS_TRANSACTION_ID',
        CPUTIME = <any> 'CPU_TIME',
        CTGGATEWAYURL = <any> 'CTG_GATEWAY_URL',
        CTGPROGRAM = <any> 'CTG_PROGRAM',
        CTGSERVERNAME = <any> 'CTG_SERVER_NAME',
        CTGTRANSACTIONID = <any> 'CTG_TRANSACTION_ID',
        CUSTOMSERVICECLASS = <any> 'CUSTOMSERVICE_CLASS',
        CUSTOMSERVICEMETHOD = <any> 'CUSTOMSERVICE_METHOD',
        DATABASECHILDCALLCOUNT = <any> 'DATABASE_CHILD_CALL_COUNT',
        DATABASECHILDCALLTIME = <any> 'DATABASE_CHILD_CALL_TIME',
        ERRORCOUNT = <any> 'ERROR_COUNT',
        ESBAPPLICATIONNAME = <any> 'ESB_APPLICATION_NAME',
        ESBINPUTTYPE = <any> 'ESB_INPUT_TYPE',
        ESBLIBRARYNAME = <any> 'ESB_LIBRARY_NAME',
        ESBMESSAGEFLOWNAME = <any> 'ESB_MESSAGE_FLOW_NAME',
        EXCEPTIONCLASS = <any> 'EXCEPTION_CLASS',
        EXCEPTIONMESSAGE = <any> 'EXCEPTION_MESSAGE',
        FAILEDSTATE = <any> 'FAILED_STATE',
        FAILUREREASON = <any> 'FAILURE_REASON',
        FLAWSTATE = <any> 'FLAW_STATE',
        HTTPREQUESTMETHOD = <any> 'HTTP_REQUEST_METHOD',
        HTTPSTATUS = <any> 'HTTP_STATUS',
        HTTPSTATUSCLASS = <any> 'HTTP_STATUS_CLASS',
        IMSPROGRAMNAME = <any> 'IMS_PROGRAM_NAME',
        IMSTRANSACTIONID = <any> 'IMS_TRANSACTION_ID',
        IOTIME = <any> 'IO_TIME',
        LOCKTIME = <any> 'LOCK_TIME',
        MESSAGINGDESTINATIONTYPE = <any> 'MESSAGING_DESTINATION_TYPE',
        MESSAGINGISTEMPORARYQUEUE = <any> 'MESSAGING_IS_TEMPORARY_QUEUE',
        MESSAGINGQUEUENAME = <any> 'MESSAGING_QUEUE_NAME',
        MESSAGINGQUEUEVENDOR = <any> 'MESSAGING_QUEUE_VENDOR',
        NONDATABASECHILDCALLCOUNT = <any> 'NON_DATABASE_CHILD_CALL_COUNT',
        NONDATABASECHILDCALLTIME = <any> 'NON_DATABASE_CHILD_CALL_TIME',
        PROCESSGROUPNAME = <any> 'PROCESS_GROUP_NAME',
        PROCESSGROUPTAG = <any> 'PROCESS_GROUP_TAG',
        REMOTEENDPOINT = <any> 'REMOTE_ENDPOINT',
        REMOTEMETHOD = <any> 'REMOTE_METHOD',
        REMOTESERVICENAME = <any> 'REMOTE_SERVICE_NAME',
        REQUESTNAME = <any> 'REQUEST_NAME',
        REQUESTTYPE = <any> 'REQUEST_TYPE',
        RESPONSETIME = <any> 'RESPONSE_TIME',
        RESPONSETIMECLIENT = <any> 'RESPONSE_TIME_CLIENT',
        RMICLASS = <any> 'RMI_CLASS',
        RMIMETHOD = <any> 'RMI_METHOD',
        SERVICEDISPLAYNAME = <any> 'SERVICE_DISPLAY_NAME',
        SERVICENAME = <any> 'SERVICE_NAME',
        SERVICEPORT = <any> 'SERVICE_PORT',
        SERVICEPUBLICDOMAINNAME = <any> 'SERVICE_PUBLIC_DOMAIN_NAME',
        SERVICEREQUESTATTRIBUTE = <any> 'SERVICE_REQUEST_ATTRIBUTE',
        SERVICETAG = <any> 'SERVICE_TAG',
        SERVICETYPE = <any> 'SERVICE_TYPE',
        SERVICEWEBAPPLICATIONID = <any> 'SERVICE_WEB_APPLICATION_ID',
        SERVICEWEBCONTEXTROOT = <any> 'SERVICE_WEB_CONTEXT_ROOT',
        SERVICEWEBSERVERNAME = <any> 'SERVICE_WEB_SERVER_NAME',
        SERVICEWEBSERVICENAME = <any> 'SERVICE_WEB_SERVICE_NAME',
        SERVICEWEBSERVICENAMESPACE = <any> 'SERVICE_WEB_SERVICE_NAMESPACE',
        SUSPENSIONTIME = <any> 'SUSPENSION_TIME',
        TOTALPROCESSINGTIME = <any> 'TOTAL_PROCESSING_TIME',
        WAITTIME = <any> 'WAIT_TIME',
        WEBREQUESTQUERY = <any> 'WEBREQUEST_QUERY',
        WEBREQUESTURL = <any> 'WEBREQUEST_URL',
        WEBREQUESTURLHOST = <any> 'WEBREQUEST_URL_HOST',
        WEBREQUESTURLPATH = <any> 'WEBREQUEST_URL_PATH',
        WEBREQUESTURLPORT = <any> 'WEBREQUEST_URL_PORT',
        WEBSERVICEENDPOINT = <any> 'WEBSERVICE_ENDPOINT',
        WEBSERVICEMETHOD = <any> 'WEBSERVICE_METHOD',
        ZOSCALLTYPE = <any> 'ZOS_CALL_TYPE'
    }
    export enum KindEnum {
        AFTERDELIMITER = <any> 'AFTER_DELIMITER',
        BEFOREDELIMITER = <any> 'BEFORE_DELIMITER',
        BETWEENDELIMITER = <any> 'BETWEEN_DELIMITER',
        ORIGINALTEXT = <any> 'ORIGINAL_TEXT',
        REGEXEXTRACTION = <any> 'REGEX_EXTRACTION'
    }
    export enum NormalizationEnum {
        ORIGINAL = <any> 'ORIGINAL',
        TOLOWERCASE = <any> 'TO_LOWER_CASE',
        TOUPPERCASE = <any> 'TO_UPPER_CASE'
    }
    export enum AggregationEnum {
        COUNT = <any> 'COUNT',
        FIRST = <any> 'FIRST',
        LAST = <any> 'LAST'
    }
}
