/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { ConfigurationMetadata } from './configurationMetadata';
import { PluginProperty } from './pluginProperty';

/**
* General configuration of a plugin.
*/
export class Plugin {
    'metadata'?: ConfigurationMetadata;
    /**
    * The ID of the plugin, for example `custom.remote.python.demo`.
    */
    'id'?: string;
    /**
    * The name of the plugin, displayed in Dynatrace.
    */
    'name'?: string;
    /**
    * The version of the plugin, displayed in Dynatrace.
    */
    'version'?: string;
    /**
    * The type of the plugin. It indicates the runtime environment of the plugin (for example, ActiveGate).
    */
    'type'?: Plugin.TypeEnum;
    /**
    * The metric group of the plugin. All the metrics, captured by the plugin are children of this group.
    */
    'metricGroup'?: string;
    /**
    * A list of plugin properties.
    */
    'properties'?: Array<PluginProperty>;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "metadata",
            "baseName": "metadata",
            "type": "ConfigurationMetadata"
        },
        {
            "name": "id",
            "baseName": "id",
            "type": "string"
        },
        {
            "name": "name",
            "baseName": "name",
            "type": "string"
        },
        {
            "name": "version",
            "baseName": "version",
            "type": "string"
        },
        {
            "name": "type",
            "baseName": "type",
            "type": "Plugin.TypeEnum"
        },
        {
            "name": "metricGroup",
            "baseName": "metricGroup",
            "type": "string"
        },
        {
            "name": "properties",
            "baseName": "properties",
            "type": "Array<PluginProperty>"
        }    ];

    static getAttributeTypeMap() {
        return Plugin.attributeTypeMap;
    }
}

export namespace Plugin {
    export enum TypeEnum {
        ActiveGate = <any> 'ActiveGate',
        JMX = <any> 'JMX',
        OneAgent = <any> 'OneAgent',
        PMI = <any> 'PMI'
    }
}
