/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* The state of the plugin.
*/
export class PluginState {
    /**
    * The ID of the plugin.
    */
    'pluginId'?: string;
    /**
    * The version of the plugin (for example `1.0.0`).
    */
    'version'?: string;
    /**
    * The ID of the endpoint where the state is detected - Active Gate only.
    */
    'endpointId'?: string;
    /**
    * The state of the plugin.
    */
    'state'?: PluginState.StateEnum;
    /**
    * A short description of the state.
    */
    'stateDescription'?: string;
    /**
    * The timestamp when the state was detected, in UTC milliseconds.
    */
    'timestamp'?: number;
    /**
    * The ID of the host on which the plugin runs.
    */
    'hostId'?: string;
    /**
    * The ID of the entity on which the plugin is active.
    */
    'processId'?: string;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "pluginId",
            "baseName": "pluginId",
            "type": "string"
        },
        {
            "name": "version",
            "baseName": "version",
            "type": "string"
        },
        {
            "name": "endpointId",
            "baseName": "endpointId",
            "type": "string"
        },
        {
            "name": "state",
            "baseName": "state",
            "type": "PluginState.StateEnum"
        },
        {
            "name": "stateDescription",
            "baseName": "stateDescription",
            "type": "string"
        },
        {
            "name": "timestamp",
            "baseName": "timestamp",
            "type": "number"
        },
        {
            "name": "hostId",
            "baseName": "hostId",
            "type": "string"
        },
        {
            "name": "processId",
            "baseName": "processId",
            "type": "string"
        }    ];

    static getAttributeTypeMap() {
        return PluginState.attributeTypeMap;
    }
}

export namespace PluginState {
    export enum StateEnum {
        DISABLED = <any> 'DISABLED',
        ERRORAUTH = <any> 'ERROR_AUTH',
        ERRORCOMMUNICATIONFAILURE = <any> 'ERROR_COMMUNICATION_FAILURE',
        ERRORCONFIG = <any> 'ERROR_CONFIG',
        ERRORTIMEOUT = <any> 'ERROR_TIMEOUT',
        ERRORUNKNOWN = <any> 'ERROR_UNKNOWN',
        INCOMPATIBLE = <any> 'INCOMPATIBLE',
        LIMITREACHED = <any> 'LIMIT_REACHED',
        NOTHINGTOREPORT = <any> 'NOTHING_TO_REPORT',
        OK = <any> 'OK',
        STATETYPEUNKNOWN = <any> 'STATE_TYPE_UNKNOWN',
        UNINITIALIZED = <any> 'UNINITIALIZED',
        UNSUPPORTED = <any> 'UNSUPPORTED',
        WAITINGFORSTATE = <any> 'WAITING_FOR_STATE'
    }
}
