/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { ConditionKey } from './conditionKey';
import { ProcessMetadataConditionKeyAllOf } from './processMetadataConditionKeyAllOf';

/**
* The key for dynamic attributes of the `PROCESS_PREDEFINED_METADATA_KEY` type.
*/
export class ProcessMetadataConditionKey extends ConditionKey {
    /**
    * The key of the attribute, which need dynamic keys.   Not applicable otherwise, as the attibute itself acts as a key.
    */
    'dynamicKey': ProcessMetadataConditionKey.DynamicKeyEnum;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "dynamicKey",
            "baseName": "dynamicKey",
            "type": "ProcessMetadataConditionKey.DynamicKeyEnum"
        }    ];

    static getAttributeTypeMap() {
        return super.getAttributeTypeMap().concat(ProcessMetadataConditionKey.attributeTypeMap);
    }
}

export namespace ProcessMetadataConditionKey {
    export enum DynamicKeyEnum {
        AMAZONECRIMAGEACCOUNTID = <any> 'AMAZON_ECR_IMAGE_ACCOUNT_ID',
        AMAZONECRIMAGEREGION = <any> 'AMAZON_ECR_IMAGE_REGION',
        AMAZONLAMBDAFUNCTIONNAME = <any> 'AMAZON_LAMBDA_FUNCTION_NAME',
        AMAZONREGION = <any> 'AMAZON_REGION',
        APACHECONFIGPATH = <any> 'APACHE_CONFIG_PATH',
        APACHESPARKMASTERIPADDRESS = <any> 'APACHE_SPARK_MASTER_IP_ADDRESS',
        ASPDOTNETCOREAPPLICATIONPATH = <any> 'ASP_DOT_NET_CORE_APPLICATION_PATH',
        AWSECSCLUSTER = <any> 'AWS_ECS_CLUSTER',
        AWSECSCONTAINERNAME = <any> 'AWS_ECS_CONTAINERNAME',
        AWSECSFAMILY = <any> 'AWS_ECS_FAMILY',
        AWSECSREVISION = <any> 'AWS_ECS_REVISION',
        CASSANDRACLUSTERNAME = <any> 'CASSANDRA_CLUSTER_NAME',
        CATALINABASE = <any> 'CATALINA_BASE',
        CATALINAHOME = <any> 'CATALINA_HOME',
        CLOUDFOUNDRYAPPID = <any> 'CLOUD_FOUNDRY_APP_ID',
        CLOUDFOUNDRYAPPNAME = <any> 'CLOUD_FOUNDRY_APP_NAME',
        CLOUDFOUNDRYINSTANCEINDEX = <any> 'CLOUD_FOUNDRY_INSTANCE_INDEX',
        CLOUDFOUNDRYSPACEID = <any> 'CLOUD_FOUNDRY_SPACE_ID',
        CLOUDFOUNDRYSPACENAME = <any> 'CLOUD_FOUNDRY_SPACE_NAME',
        COLDFUSIONJVMCONFIGFILE = <any> 'COLDFUSION_JVM_CONFIG_FILE',
        COLDFUSIONSERVICENAME = <any> 'COLDFUSION_SERVICE_NAME',
        COMMANDLINEARGS = <any> 'COMMAND_LINE_ARGS',
        DOTNETCOMMAND = <any> 'DOTNET_COMMAND',
        DOTNETCOMMANDPATH = <any> 'DOTNET_COMMAND_PATH',
        DYNATRACECLUSTERID = <any> 'DYNATRACE_CLUSTER_ID',
        DYNATRACENODEID = <any> 'DYNATRACE_NODE_ID',
        ELASTICSEARCHCLUSTERNAME = <any> 'ELASTICSEARCH_CLUSTER_NAME',
        ELASTICSEARCHNODENAME = <any> 'ELASTICSEARCH_NODE_NAME',
        EQUINOXCONFIGPATH = <any> 'EQUINOX_CONFIG_PATH',
        EXENAME = <any> 'EXE_NAME',
        EXEPATH = <any> 'EXE_PATH',
        GLASSFISHDOMAINNAME = <any> 'GLASS_FISH_DOMAIN_NAME',
        GLASSFISHINSTANCENAME = <any> 'GLASS_FISH_INSTANCE_NAME',
        GOOGLEAPPENGINEINSTANCE = <any> 'GOOGLE_APP_ENGINE_INSTANCE',
        GOOGLEAPPENGINESERVICE = <any> 'GOOGLE_APP_ENGINE_SERVICE',
        GOOGLECLOUDPROJECT = <any> 'GOOGLE_CLOUD_PROJECT',
        HYBRISBINDIRECTORY = <any> 'HYBRIS_BIN_DIRECTORY',
        HYBRISCONFIGDIRECTORY = <any> 'HYBRIS_CONFIG_DIRECTORY',
        HYBRISDATADIRECTORY = <any> 'HYBRIS_DATA_DIRECTORY',
        IBMCICSREGION = <any> 'IBM_CICS_REGION',
        IBMCTGNAME = <any> 'IBM_CTG_NAME',
        IBMIMSCONNECTREGION = <any> 'IBM_IMS_CONNECT_REGION',
        IBMIMSCONTROLREGION = <any> 'IBM_IMS_CONTROL_REGION',
        IBMIMSMESSAGEPROCESSINGREGION = <any> 'IBM_IMS_MESSAGE_PROCESSING_REGION',
        IBMIMSSOAPGWNAME = <any> 'IBM_IMS_SOAP_GW_NAME',
        IBMINTEGRATIONNODENAME = <any> 'IBM_INTEGRATION_NODE_NAME',
        IBMINTEGRATIONSERVERNAME = <any> 'IBM_INTEGRATION_SERVER_NAME',
        IISAPPPOOL = <any> 'IIS_APP_POOL',
        IISROLENAME = <any> 'IIS_ROLE_NAME',
        JAVAJARFILE = <any> 'JAVA_JAR_FILE',
        JAVAJARPATH = <any> 'JAVA_JAR_PATH',
        JAVAMAINCLASS = <any> 'JAVA_MAIN_CLASS',
        JAVAMAINMODULE = <any> 'JAVA_MAIN_MODULE',
        JBOSSHOME = <any> 'JBOSS_HOME',
        JBOSSMODE = <any> 'JBOSS_MODE',
        JBOSSSERVERNAME = <any> 'JBOSS_SERVER_NAME',
        KUBERNETESBASEPODNAME = <any> 'KUBERNETES_BASE_POD_NAME',
        KUBERNETESCONTAINERNAME = <any> 'KUBERNETES_CONTAINER_NAME',
        KUBERNETESFULLPODNAME = <any> 'KUBERNETES_FULL_POD_NAME',
        KUBERNETESNAMESPACE = <any> 'KUBERNETES_NAMESPACE',
        KUBERNETESPODUID = <any> 'KUBERNETES_POD_UID',
        MSSQLINSTANCENAME = <any> 'MSSQL_INSTANCE_NAME',
        NODEJSAPPBASEDIRECTORY = <any> 'NODE_JS_APP_BASE_DIRECTORY',
        NODEJSAPPNAME = <any> 'NODE_JS_APP_NAME',
        NODEJSSCRIPTNAME = <any> 'NODE_JS_SCRIPT_NAME',
        ORACLESID = <any> 'ORACLE_SID',
        PGIDCALCINPUTKEYLINKAGE = <any> 'PG_ID_CALC_INPUT_KEY_LINKAGE',
        PHPSCRIPTPATH = <any> 'PHP_SCRIPT_PATH',
        PHPWORKINGDIRECTORY = <any> 'PHP_WORKING_DIRECTORY',
        RUBYAPPROOTPATH = <any> 'RUBY_APP_ROOT_PATH',
        RUBYSCRIPTPATH = <any> 'RUBY_SCRIPT_PATH',
        RULERESULT = <any> 'RULE_RESULT',
        SOFTWAREAGINSTALLROOT = <any> 'SOFTWAREAG_INSTALL_ROOT',
        SOFTWAREAGPRODUCTPROPNAME = <any> 'SOFTWAREAG_PRODUCTPROPNAME',
        SPRINGBOOTAPPNAME = <any> 'SPRINGBOOT_APP_NAME',
        SPRINGBOOTPROFILENAME = <any> 'SPRINGBOOT_PROFILE_NAME',
        SPRINGBOOTSTARTUPCLASS = <any> 'SPRINGBOOT_STARTUP_CLASS',
        TIBCOBUSINESSWORKSCEAPPNAME = <any> 'TIBCO_BUSINESSWORKS_CE_APP_NAME',
        TIBCOBUSINESSWORKSCEVERSION = <any> 'TIBCO_BUSINESSWORKS_CE_VERSION',
        TIBCOBUSINESSWORKSAPPNODENAME = <any> 'TIBCO_BUSINESS_WORKS_APP_NODE_NAME',
        TIBCOBUSINESSWORKSAPPSPACENAME = <any> 'TIBCO_BUSINESS_WORKS_APP_SPACE_NAME',
        TIBCOBUSINESSWORKSDOMAINNAME = <any> 'TIBCO_BUSINESS_WORKS_DOMAIN_NAME',
        TIBCOBUSINESSWORKSENGINEPROPERTYFILE = <any> 'TIBCO_BUSINESS_WORKS_ENGINE_PROPERTY_FILE',
        TIBCOBUSINESSWORKSENGINEPROPERTYFILEPATH = <any> 'TIBCO_BUSINESS_WORKS_ENGINE_PROPERTY_FILE_PATH',
        TIBCOBUSINESSWORKSHOME = <any> 'TIBCO_BUSINESS_WORKS_HOME',
        VARNISHINSTANCENAME = <any> 'VARNISH_INSTANCE_NAME',
        WEBLOGICCLUSTERNAME = <any> 'WEB_LOGIC_CLUSTER_NAME',
        WEBLOGICDOMAINNAME = <any> 'WEB_LOGIC_DOMAIN_NAME',
        WEBLOGICHOME = <any> 'WEB_LOGIC_HOME',
        WEBLOGICNAME = <any> 'WEB_LOGIC_NAME',
        WEBSPHERECELLNAME = <any> 'WEB_SPHERE_CELL_NAME',
        WEBSPHERECLUSTERNAME = <any> 'WEB_SPHERE_CLUSTER_NAME',
        WEBSPHERENODENAME = <any> 'WEB_SPHERE_NODE_NAME',
        WEBSPHERESERVERNAME = <any> 'WEB_SPHERE_SERVER_NAME'
    }
}
