/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { AliasQueue } from './aliasQueue';
import { ClusterQueue } from './clusterQueue';
import { RemoteQueue } from './remoteQueue';

/**
* Parameters of the queue manager.
*/
export class QueueManager {
    /**
    * The name of the queue manager.
    */
    'name': string;
    /**
    * The queue manager will have access to all cluster visible queues in these [clusters](https://www.ibm.com/support/knowledgecenter/en/SSFKSJ_7.5.0/com.ibm.mq.pro.doc/q002750_.htm).
    */
    'clusters': Array<string>;
    /**
    * The list of alias queues in the queue manager.
    */
    'aliasQueues': Array<AliasQueue>;
    /**
    * The list of remote queues in the queue manager.
    */
    'remoteQueues': Array<RemoteQueue>;
    /**
    * The list of cluster queues in the queue manager.
    */
    'clusterQueues': Array<ClusterQueue>;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "name",
            "baseName": "name",
            "type": "string"
        },
        {
            "name": "clusters",
            "baseName": "clusters",
            "type": "Array<string>"
        },
        {
            "name": "aliasQueues",
            "baseName": "aliasQueues",
            "type": "Array<AliasQueue>"
        },
        {
            "name": "remoteQueues",
            "baseName": "remoteQueues",
            "type": "Array<RemoteQueue>"
        },
        {
            "name": "clusterQueues",
            "baseName": "clusterQueues",
            "type": "Array<ClusterQueue>"
        }    ];

    static getAttributeTypeMap() {
        return QueueManager.attributeTypeMap;
    }
}

