/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* Custom thresholds for RDS running out of memory. If not set, automatic mode is used.    **All** conditions must be fulfilled to trigger an alert.
*/
export class RdsHighMemoryThresholds {
    /**
    * Freeable memory is lower than *X* Megabytes in 3 out of 5 samples.
    */
    'freeMemory': number;
    /**
    * Swap usage is higher than *X* Gigabytes in 3 out of 5 samples.
    */
    'swapUsage': number;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "freeMemory",
            "baseName": "freeMemory",
            "type": "number"
        },
        {
            "name": "swapUsage",
            "baseName": "swapUsage",
            "type": "number"
        }    ];

    static getAttributeTypeMap() {
        return RdsHighMemoryThresholds.attributeTypeMap;
    }
}

