/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* The recurrence of the maintenance window.
*/
export class Recurrence {
    /**
    * The day of the week for weekly maintenance.   The format is the full name of the day in upper case, for example `THURSDAY`.
    */
    'dayOfWeek'?: Recurrence.DayOfWeekEnum;
    /**
    * The day of the month for monthly maintenance.   The value of `31` is treated as the last day of the month for months that don\'t have a 31st day. The value of `30` is also treated as the last day of the month for February.
    */
    'dayOfMonth'?: number;
    /**
    * The start time of the maintenance window in HH:mm format.
    */
    'startTime': string;
    /**
    * The duration of the maintenance window in minutes.
    */
    'durationMinutes': number;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "dayOfWeek",
            "baseName": "dayOfWeek",
            "type": "Recurrence.DayOfWeekEnum"
        },
        {
            "name": "dayOfMonth",
            "baseName": "dayOfMonth",
            "type": "number"
        },
        {
            "name": "startTime",
            "baseName": "startTime",
            "type": "string"
        },
        {
            "name": "durationMinutes",
            "baseName": "durationMinutes",
            "type": "number"
        }    ];

    static getAttributeTypeMap() {
        return Recurrence.attributeTypeMap;
    }
}

export namespace Recurrence {
    export enum DayOfWeekEnum {
        FRIDAY = <any> 'FRIDAY',
        MONDAY = <any> 'MONDAY',
        SATURDAY = <any> 'SATURDAY',
        SUNDAY = <any> 'SUNDAY',
        THURSDAY = <any> 'THURSDAY',
        TUESDAY = <any> 'TUESDAY',
        WEDNESDAY = <any> 'WEDNESDAY'
    }
}
