/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* The short representation of a remote environment.
*/
export class RemoteEnvironmentConfigStub {
    /**
    * The network scope of the remote environment: * `EXTERNAL`: The remote environment is located in an another network.  * `INTERNAL`: The remote environment is located in the same network.  * `CLUSTER`: The remote environment is located in the same cluster.   Dynatrace SaaS can only use `EXTERNAL`.  If not set, `EXTERNAL` is used.
    */
    'networkScope'?: RemoteEnvironmentConfigStub.NetworkScopeEnum;
    /**
    * The display name of the remote environment.
    */
    'uri'?: string;
    'name'?: string;
    'id': string;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "networkScope",
            "baseName": "networkScope",
            "type": "RemoteEnvironmentConfigStub.NetworkScopeEnum"
        },
        {
            "name": "uri",
            "baseName": "uri",
            "type": "string"
        },
        {
            "name": "name",
            "baseName": "name",
            "type": "string"
        },
        {
            "name": "id",
            "baseName": "id",
            "type": "string"
        }    ];

    static getAttributeTypeMap() {
        return RemoteEnvironmentConfigStub.attributeTypeMap;
    }
}

export namespace RemoteEnvironmentConfigStub {
    export enum NetworkScopeEnum {
        CLUSTER = <any> 'CLUSTER',
        EXTERNAL = <any> 'EXTERNAL',
        INTERNAL = <any> 'INTERNAL'
    }
}
