/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { EntityShortRepresentation } from './entityShortRepresentation';

/**
* Configuration of a plugin endpoint.
*/
export class RemotePluginEndpoint {
    /**
    * The ID of the endpoint.
    */
    'id'?: string;
    /**
    * The ID of the plugin to which the endpoint belongs.
    */
    'pluginId'?: string;
    /**
    * The name of the endpoint, displayed in Dynatrace.
    */
    'name'?: string;
    /**
    * The endpoint is enabled (`true`) or disabled (`false`).
    */
    'enabled'?: boolean;
    /**
    * The list of endpoint parameters.    Each parameter is a property-value pair.
    */
    'properties'?: { [key: string]: string; };
    'activeGatePluginModule': EntityShortRepresentation;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "id",
            "baseName": "id",
            "type": "string"
        },
        {
            "name": "pluginId",
            "baseName": "pluginId",
            "type": "string"
        },
        {
            "name": "name",
            "baseName": "name",
            "type": "string"
        },
        {
            "name": "enabled",
            "baseName": "enabled",
            "type": "boolean"
        },
        {
            "name": "properties",
            "baseName": "properties",
            "type": "{ [key: string]: string; }"
        },
        {
            "name": "activeGatePluginModule",
            "baseName": "activeGatePluginModule",
            "type": "EntityShortRepresentation"
        }    ];

    static getAttributeTypeMap() {
        return RemotePluginEndpoint.attributeTypeMap;
    }
}

