/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* Define a local definition of a remote queue owned by another queue manager. The local definition can be made visible in one or more clusters.
*/
export class RemoteQueue {
    /**
    * The name of the local definition of the remote queue.
    */
    'localQueue': string;
    /**
    * The name of the remote queue.
    */
    'remoteQueue': string;
    /**
    * The name of the remote queue manager.
    */
    'remoteQueueManager': string;
    /**
    * The local definition of the remote queue is visible in these [clusters](https://www.ibm.com/support/knowledgecenter/en/SSFKSJ_7.5.0/com.ibm.mq.pro.doc/q002750_.htm). The queue manager must be part of these clusters.
    */
    'clusterVisibility': Array<string>;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "localQueue",
            "baseName": "localQueue",
            "type": "string"
        },
        {
            "name": "remoteQueue",
            "baseName": "remoteQueue",
            "type": "string"
        },
        {
            "name": "remoteQueueManager",
            "baseName": "remoteQueueManager",
            "type": "string"
        },
        {
            "name": "clusterVisibility",
            "baseName": "clusterVisibility",
            "type": "Array<string>"
        }    ];

    static getAttributeTypeMap() {
        return RemoteQueue.attributeTypeMap;
    }
}

