/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { RemoveNumbersTransformationAllOf } from './removeNumbersTransformationAllOf';
import { TransformationBase } from './transformationBase';

/**
* The transformation of the `REMOVE_NUMBERS` type.   The transformation removes any numbers from the detected value.
*/
export class RemoveNumbersTransformation extends TransformationBase {
    /**
    * Remove numbers that contain at least *X* digits.
    */
    'minDigitCount': number;
    /**
    * Remove (`true`) or keep (`false`) hexadecimal numbers.    If not set, then `false` is used, keeping hexadecimal numbers.
    */
    'includeHexNumbers'?: boolean;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "minDigitCount",
            "baseName": "minDigitCount",
            "type": "number"
        },
        {
            "name": "includeHexNumbers",
            "baseName": "includeHexNumbers",
            "type": "boolean"
        }    ];

    static getAttributeTypeMap() {
        return super.getAttributeTypeMap().concat(RemoveNumbersTransformation.attributeTypeMap);
    }
}

export namespace RemoveNumbersTransformation {
}
