/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { ReplaceBetweenTransformationAllOf } from './replaceBetweenTransformationAllOf';
import { TransformationBase } from './transformationBase';

/**
* The transformation of the `REPLACE_BETWEEN` type.   The transformation replaces the content in between specified delimiters with specified static value and removes everything outside them.
*/
export class ReplaceBetweenTransformation extends TransformationBase {
    /**
    * The starting delimiter. The transformation removes everything before it. The delimiter itself is not kept.
    */
    'after': string;
    /**
    * The ending delimiter. The transformation removes everything after it. The delimiter itself is not kept.
    */
    'before': string;
    /**
    * The value to be used instead of the detected value.
    */
    'replacement': string;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "after",
            "baseName": "after",
            "type": "string"
        },
        {
            "name": "before",
            "baseName": "before",
            "type": "string"
        },
        {
            "name": "replacement",
            "baseName": "replacement",
            "type": "string"
        }    ];

    static getAttributeTypeMap() {
        return super.getAttributeTypeMap().concat(ReplaceBetweenTransformation.attributeTypeMap);
    }
}

export namespace ReplaceBetweenTransformation {
}
