/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* Configuration of a report subscription.
*/
export class ReportSubscriptions {
    /**
    * The schedule of the subscription.    * Weekly subscribers receive the report every Monday at midnight.   * Monthly subscribers receive the report on the first Monday of the month at midnight.
    */
    'schedule': ReportSubscriptions.ScheduleEnum;
    /**
    * A list of the recipients.   You can specify email addresses or Dynatrace user IDs here.
    */
    'recipients': Array<string>;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "schedule",
            "baseName": "schedule",
            "type": "ReportSubscriptions.ScheduleEnum"
        },
        {
            "name": "recipients",
            "baseName": "recipients",
            "type": "Array<string>"
        }    ];

    static getAttributeTypeMap() {
        return ReportSubscriptions.attributeTypeMap;
    }
}

export namespace ReportSubscriptions {
    export enum ScheduleEnum {
        MONTH = <any> 'MONTH',
        WEEK = <any> 'WEEK'
    }
}
