/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { ConfigurationMetadata } from './configurationMetadata';
import { DataSource } from './dataSource';

export class RequestAttribute {
    'metadata'?: ConfigurationMetadata;
    /**
    * The ID of the request attribute.
    */
    'id'?: string;
    /**
    * The name of the request attribute.
    */
    'name': string;
    /**
    * The request attribute is enabled (`true`) or disabled (`false`).
    */
    'enabled': boolean;
    /**
    * The data type of the request attribute.
    */
    'dataType': RequestAttribute.DataTypeEnum;
    /**
    * The list of data sources.
    */
    'dataSources': Array<DataSource>;
    /**
    * String values transformation.    If the **dataType** is not `string`, set the `Original` here.
    */
    'normalization': RequestAttribute.NormalizationEnum;
    /**
    * Aggregation type for the request values.
    */
    'aggregation': RequestAttribute.AggregationEnum;
    /**
    * Confidential data flag. Set `true` to treat the captured data as confidential.
    */
    'confidential': boolean;
    /**
    * Personal data masking flag. Set `true` to skip masking.    Warning: This will potentially access personalized data.
    */
    'skipPersonalDataMasking': boolean;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "metadata",
            "baseName": "metadata",
            "type": "ConfigurationMetadata"
        },
        {
            "name": "id",
            "baseName": "id",
            "type": "string"
        },
        {
            "name": "name",
            "baseName": "name",
            "type": "string"
        },
        {
            "name": "enabled",
            "baseName": "enabled",
            "type": "boolean"
        },
        {
            "name": "dataType",
            "baseName": "dataType",
            "type": "RequestAttribute.DataTypeEnum"
        },
        {
            "name": "dataSources",
            "baseName": "dataSources",
            "type": "Array<DataSource>"
        },
        {
            "name": "normalization",
            "baseName": "normalization",
            "type": "RequestAttribute.NormalizationEnum"
        },
        {
            "name": "aggregation",
            "baseName": "aggregation",
            "type": "RequestAttribute.AggregationEnum"
        },
        {
            "name": "confidential",
            "baseName": "confidential",
            "type": "boolean"
        },
        {
            "name": "skipPersonalDataMasking",
            "baseName": "skipPersonalDataMasking",
            "type": "boolean"
        }    ];

    static getAttributeTypeMap() {
        return RequestAttribute.attributeTypeMap;
    }
}

export namespace RequestAttribute {
    export enum DataTypeEnum {
        DOUBLE = <any> 'DOUBLE',
        INTEGER = <any> 'INTEGER',
        STRING = <any> 'STRING'
    }
    export enum NormalizationEnum {
        ORIGINAL = <any> 'ORIGINAL',
        TOLOWERCASE = <any> 'TO_LOWER_CASE',
        TOUPPERCASE = <any> 'TO_UPPER_CASE'
    }
    export enum AggregationEnum {
        ALLDISTINCTVALUES = <any> 'ALL_DISTINCT_VALUES',
        AVERAGE = <any> 'AVERAGE',
        COUNTDISTINCTVALUES = <any> 'COUNT_DISTINCT_VALUES',
        COUNTVALUES = <any> 'COUNT_VALUES',
        FIRST = <any> 'FIRST',
        LAST = <any> 'LAST',
        MAXIMUM = <any> 'MAXIMUM',
        MINIMUM = <any> 'MINIMUM',
        SUM = <any> 'SUM'
    }
}
