/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { Condition } from './condition';
import { ConfigurationMetadata } from './configurationMetadata';
import { Placeholder } from './placeholder';

/**
* The request naming rule.
*/
export class RequestNaming {
    'metadata'?: ConfigurationMetadata;
    /**
    * The ID of the request naming rule.
    */
    'id'?: string;
    /**
    * The order string. Sorting request namings alphabetically by their order string determines their relative ordering.  Typically this is managed by Dynatrace internally and will not be present in GET responses nor used if present in PUT/POST requests, except where noted otherwise.
    */
    'order'?: string;
    /**
    * The rule is enabled (`true`) or disabled (`false`).
    */
    'enabled': boolean;
    /**
    * The name to be assigned to matching requests.
    */
    'namingPattern': string;
    /**
    * Specifies the management zones for which this rule should be applied.
    */
    'managementZones'?: Array<string>;
    /**
    * The set of conditions for the request naming rule usage.    You can specify several conditions. The request has to match **all** the specified conditions for the rule to trigger.
    */
    'conditions': Array<Condition>;
    /**
    * The list of custom placeholders to be used in the naming pattern.    It enables you to extract a request attribute value or other request attribute and use it in the request naming pattern.
    */
    'placeholders'?: Array<Placeholder>;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "metadata",
            "baseName": "metadata",
            "type": "ConfigurationMetadata"
        },
        {
            "name": "id",
            "baseName": "id",
            "type": "string"
        },
        {
            "name": "order",
            "baseName": "order",
            "type": "string"
        },
        {
            "name": "enabled",
            "baseName": "enabled",
            "type": "boolean"
        },
        {
            "name": "namingPattern",
            "baseName": "namingPattern",
            "type": "string"
        },
        {
            "name": "managementZones",
            "baseName": "managementZones",
            "type": "Array<string>"
        },
        {
            "name": "conditions",
            "baseName": "conditions",
            "type": "Array<Condition>"
        },
        {
            "name": "placeholders",
            "baseName": "placeholders",
            "type": "Array<Placeholder>"
        }    ];

    static getAttributeTypeMap() {
        return RequestNaming.attributeTypeMap;
    }
}

