/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { ConfigurationMetadata } from './configurationMetadata';

/**
* The resource naming rule.
*/
export class ResourceNaming {
    'metadata'?: ConfigurationMetadata;
    /**
    * The list of image extensions that will be renamed to `Image`.
    */
    'image': Array<string>;
    /**
    * The list of binary extensions that will be renamed to `Binary`.
    */
    'binary': Array<string>;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "metadata",
            "baseName": "metadata",
            "type": "ConfigurationMetadata"
        },
        {
            "name": "image",
            "baseName": "image",
            "type": "Array<string>"
        },
        {
            "name": "binary",
            "baseName": "binary",
            "type": "Array<string>"
        }    ];

    static getAttributeTypeMap() {
        return ResourceNaming.attributeTypeMap;
    }
}

