/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* Settings for resource timings capture.
*/
export class ResourceTimingSettings {
    /**
    * W3C resource timings for third party/CDN enabled/disabled.
    */
    'w3cResourceTimings': boolean;
    /**
    * Timing for JavaScript files and images on non-W3C supported browsers enabled/disabled.
    */
    'nonW3cResourceTimings': boolean;
    /**
    * Instrumentation delay for monitoring resource and image resource impact in browsers that don\'t offer W3C resource timings.   Valid values range from 0 to 9999.  Only effective if **nonW3cResourceTimings** is enabled.
    */
    'nonW3cResourceTimingsInstrumentationDelay': number;
    /**
    * Defines how detailed resource timings are captured.  Only effective if **w3cResourceTimings** or **nonW3cResourceTimings** is enabled.
    */
    'resourceTimingCaptureType': ResourceTimingSettings.ResourceTimingCaptureTypeEnum;
    /**
    * Limits the number of domains for which W3C resource timings are captured.  Only effective if **resourceTimingCaptureType** is `CAPTURE_LIMITED_SUMMARIES`.
    */
    'resourceTimingsDomainLimit': number;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "w3cResourceTimings",
            "baseName": "w3cResourceTimings",
            "type": "boolean"
        },
        {
            "name": "nonW3cResourceTimings",
            "baseName": "nonW3cResourceTimings",
            "type": "boolean"
        },
        {
            "name": "nonW3cResourceTimingsInstrumentationDelay",
            "baseName": "nonW3cResourceTimingsInstrumentationDelay",
            "type": "number"
        },
        {
            "name": "resourceTimingCaptureType",
            "baseName": "resourceTimingCaptureType",
            "type": "ResourceTimingSettings.ResourceTimingCaptureTypeEnum"
        },
        {
            "name": "resourceTimingsDomainLimit",
            "baseName": "resourceTimingsDomainLimit",
            "type": "number"
        }    ];

    static getAttributeTypeMap() {
        return ResourceTimingSettings.attributeTypeMap;
    }
}

export namespace ResourceTimingSettings {
    export enum ResourceTimingCaptureTypeEnum {
        ALLSUMMARIES = <any> 'CAPTURE_ALL_SUMMARIES',
        FULLDETAILS = <any> 'CAPTURE_FULL_DETAILS',
        LIMITEDSUMMARIES = <any> 'CAPTURE_LIMITED_SUMMARIES'
    }
}
