/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* Parameters of the response time degradation auto-detection. Required if the **detectionMode** is `DETECT_AUTOMATICALLY`. Not applicable otherwise.   Violation of **any** criterion triggers an alert.
*/
export class ResponseTimeDegradationAutodetectionConfig {
    /**
    * Alert if the response time degrades by more than *X* milliseconds.
    */
    'responseTimeDegradationMilliseconds': number;
    /**
    * Alert if the response time degrades by more than *X* %.
    */
    'responseTimeDegradationPercent': number;
    /**
    * Alert if the response time of the slowest 10% degrades by more than *X* milliseconds.
    */
    'slowestResponseTimeDegradationMilliseconds': number;
    /**
    * Alert if the response time of the slowest 10% degrades by more than *X* %.
    */
    'slowestResponseTimeDegradationPercent': number;
    /**
    * Minimal service load to detect response time degradation.    Response time degradation of services with smaller load won\'t trigger alerts.
    */
    'loadThreshold': ResponseTimeDegradationAutodetectionConfig.LoadThresholdEnum;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "responseTimeDegradationMilliseconds",
            "baseName": "responseTimeDegradationMilliseconds",
            "type": "number"
        },
        {
            "name": "responseTimeDegradationPercent",
            "baseName": "responseTimeDegradationPercent",
            "type": "number"
        },
        {
            "name": "slowestResponseTimeDegradationMilliseconds",
            "baseName": "slowestResponseTimeDegradationMilliseconds",
            "type": "number"
        },
        {
            "name": "slowestResponseTimeDegradationPercent",
            "baseName": "slowestResponseTimeDegradationPercent",
            "type": "number"
        },
        {
            "name": "loadThreshold",
            "baseName": "loadThreshold",
            "type": "ResponseTimeDegradationAutodetectionConfig.LoadThresholdEnum"
        }    ];

    static getAttributeTypeMap() {
        return ResponseTimeDegradationAutodetectionConfig.attributeTypeMap;
    }
}

export namespace ResponseTimeDegradationAutodetectionConfig {
    export enum LoadThresholdEnum {
        FIFTEENREQUESTSPERMINUTE = <any> 'FIFTEEN_REQUESTS_PER_MINUTE',
        FIVEREQUESTSPERMINUTE = <any> 'FIVE_REQUESTS_PER_MINUTE',
        ONEREQUESTPERMINUTE = <any> 'ONE_REQUEST_PER_MINUTE',
        TENREQUESTSPERMINUTE = <any> 'TEN_REQUESTS_PER_MINUTE'
    }
}
