/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { ResponseTimeDegradationAutodetectionConfig } from './responseTimeDegradationAutodetectionConfig';
import { ResponseTimeDegradationThresholdConfig } from './responseTimeDegradationThresholdConfig';

/**
* Configuration of response time degradation detection.
*/
export class ResponseTimeDegradationDetectionConfig {
    /**
    * How to detect response time degradation: automatically, or based on fixed thresholds, or do not detect.
    */
    'detectionMode': ResponseTimeDegradationDetectionConfig.DetectionModeEnum;
    'automaticDetection'?: ResponseTimeDegradationAutodetectionConfig;
    'thresholds'?: ResponseTimeDegradationThresholdConfig;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "detectionMode",
            "baseName": "detectionMode",
            "type": "ResponseTimeDegradationDetectionConfig.DetectionModeEnum"
        },
        {
            "name": "automaticDetection",
            "baseName": "automaticDetection",
            "type": "ResponseTimeDegradationAutodetectionConfig"
        },
        {
            "name": "thresholds",
            "baseName": "thresholds",
            "type": "ResponseTimeDegradationThresholdConfig"
        }    ];

    static getAttributeTypeMap() {
        return ResponseTimeDegradationDetectionConfig.attributeTypeMap;
    }
}

export namespace ResponseTimeDegradationDetectionConfig {
    export enum DetectionModeEnum {
        DETECTAUTOMATICALLY = <any> 'DETECT_AUTOMATICALLY',
        DETECTUSINGFIXEDTHRESHOLDS = <any> 'DETECT_USING_FIXED_THRESHOLDS',
        DONTDETECT = <any> 'DONT_DETECT'
    }
}
