/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* Fixed thresholds for response time degradation detection.    Required if **detectionMode** is `DETECT_USING_FIXED_THRESHOLDS`. Not applicable otherwise.
*/
export class ResponseTimeDegradationThresholdConfig {
    /**
    * Response time during any 5-minute period to trigger an alert, in milliseconds.
    */
    'responseTimeThresholdMilliseconds': number;
    /**
    * Response time of the 10% slowest during any 5-minute period to trigger an alert, in milliseconds.
    */
    'slowestResponseTimeThresholdMilliseconds': number;
    /**
    * Minimal service load to detect response time degradation.    Response time degradation of services with smaller load won\'t trigger alerts.
    */
    'loadThreshold': ResponseTimeDegradationThresholdConfig.LoadThresholdEnum;
    /**
    * Sensitivity of the threshold.   With `low` sensitivity, high statistical confidence is used. Brief violations (for example, due to a surge in load) won\'t trigger alerts.   With `high` sensitivity, no statistical confidence is used. Each violation triggers an alert.
    */
    'sensitivity': ResponseTimeDegradationThresholdConfig.SensitivityEnum;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "responseTimeThresholdMilliseconds",
            "baseName": "responseTimeThresholdMilliseconds",
            "type": "number"
        },
        {
            "name": "slowestResponseTimeThresholdMilliseconds",
            "baseName": "slowestResponseTimeThresholdMilliseconds",
            "type": "number"
        },
        {
            "name": "loadThreshold",
            "baseName": "loadThreshold",
            "type": "ResponseTimeDegradationThresholdConfig.LoadThresholdEnum"
        },
        {
            "name": "sensitivity",
            "baseName": "sensitivity",
            "type": "ResponseTimeDegradationThresholdConfig.SensitivityEnum"
        }    ];

    static getAttributeTypeMap() {
        return ResponseTimeDegradationThresholdConfig.attributeTypeMap;
    }
}

export namespace ResponseTimeDegradationThresholdConfig {
    export enum LoadThresholdEnum {
        FIFTEENREQUESTSPERMINUTE = <any> 'FIFTEEN_REQUESTS_PER_MINUTE',
        FIVEREQUESTSPERMINUTE = <any> 'FIVE_REQUESTS_PER_MINUTE',
        ONEREQUESTPERMINUTE = <any> 'ONE_REQUEST_PER_MINUTE',
        TENREQUESTSPERMINUTE = <any> 'TEN_REQUESTS_PER_MINUTE'
    }
    export enum SensitivityEnum {
        HIGH = <any> 'HIGH',
        LOW = <any> 'LOW',
        MEDIUM = <any> 'MEDIUM'
    }
}
