/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* The credentials for the role-based authentication.
*/
export class RoleBasedAuthentication {
    /**
    * The IAM role to be used by Dynatrace to get monitoring data.
    */
    'iamRole': string;
    /**
    * The ID of the Amazon account.
    */
    'accountId': string;
    /**
    * The external ID token for setting an IAM role.    You can obtain it with the `GET /aws/iamExternalId` request.
    */
    'externalId'?: string;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "iamRole",
            "baseName": "iamRole",
            "type": "string"
        },
        {
            "name": "accountId",
            "baseName": "accountId",
            "type": "string"
        },
        {
            "name": "externalId",
            "baseName": "externalId",
            "type": "string"
        }    ];

    static getAttributeTypeMap() {
        return RoleBasedAuthentication.attributeTypeMap;
    }
}

