/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { RumDimensionDefinition } from './rumDimensionDefinition';
import { RumMetricDefinition } from './rumMetricDefinition';
import { UserActionFilter } from './userActionFilter';

export class RumMetric {
    /**
    * The application identifier of the application where this RumMetric should belong to
    */
    'applicationIdentifier': string;
    /**
    * The name of the RumMetric config
    */
    'name': string;
    /**
    * The unique key of this RumMetric. Has to start with \"calc:apps.\"
    */
    'metricKey': string;
    /**
    * RumMetric enabled/disabled
    */
    'enabled': boolean;
    'metricDefinition': RumMetricDefinition;
    /**
    * Specifies the optional dimensions for this RumMetric.
    */
    'dimensions'?: Array<RumDimensionDefinition>;
    'userActionFilter'?: UserActionFilter;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "applicationIdentifier",
            "baseName": "applicationIdentifier",
            "type": "string"
        },
        {
            "name": "name",
            "baseName": "name",
            "type": "string"
        },
        {
            "name": "metricKey",
            "baseName": "metricKey",
            "type": "string"
        },
        {
            "name": "enabled",
            "baseName": "enabled",
            "type": "boolean"
        },
        {
            "name": "metricDefinition",
            "baseName": "metricDefinition",
            "type": "RumMetricDefinition"
        },
        {
            "name": "dimensions",
            "baseName": "dimensions",
            "type": "Array<RumDimensionDefinition>"
        },
        {
            "name": "userActionFilter",
            "baseName": "userActionFilter",
            "type": "UserActionFilter"
        }    ];

    static getAttributeTypeMap() {
        return RumMetric.attributeTypeMap;
    }
}

