/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* Specifies the metric definition for this RumMetric.
*/
export class RumMetricDefinition {
    /**
    * The type of metric this RumMetricDefinition holds
    */
    'metric': RumMetricDefinition.MetricEnum;
    /**
    * The key of the user action property. Only required if metric is set to \"DoubleProperty\" or \"LongProperty\"
    */
    'propertyKey'?: string;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "metric",
            "baseName": "metric",
            "type": "RumMetricDefinition.MetricEnum"
        },
        {
            "name": "propertyKey",
            "baseName": "propertyKey",
            "type": "string"
        }    ];

    static getAttributeTypeMap() {
        return RumMetricDefinition.attributeTypeMap;
    }
}

export namespace RumMetricDefinition {
    export enum MetricEnum {
        ApplicationCache = <any> 'ApplicationCache',
        Callback = <any> 'Callback',
        DNSLookup = <any> 'DNSLookup',
        DOMComplete = <any> 'DOMComplete',
        DOMContentLoaded = <any> 'DOMContentLoaded',
        DOMInteractive = <any> 'DOMInteractive',
        DoubleProperty = <any> 'DoubleProperty',
        ErrorCount = <any> 'ErrorCount',
        FirstContentfulPaint = <any> 'FirstContentfulPaint',
        FirstInputDelay = <any> 'FirstInputDelay',
        FirstInputStart = <any> 'FirstInputStart',
        FirstPaint = <any> 'FirstPaint',
        HTMLDownloaded = <any> 'HTMLDownloaded',
        LargestContentfulPaint = <any> 'LargestContentfulPaint',
        LoadEventEnd = <any> 'LoadEventEnd',
        LoadEventStart = <any> 'LoadEventStart',
        LongProperty = <any> 'LongProperty',
        NavigationStart = <any> 'NavigationStart',
        OnDOMContentLoaded = <any> 'OnDOMContentLoaded',
        OnLoad = <any> 'OnLoad',
        Processing = <any> 'Processing',
        RedirectTime = <any> 'RedirectTime',
        Request = <any> 'Request',
        RequestStart = <any> 'RequestStart',
        Response = <any> 'Response',
        SecureConnect = <any> 'SecureConnect',
        SpeedIndex = <any> 'SpeedIndex',
        TCPConnect = <any> 'TCPConnect',
        TimeToFirstByte = <any> 'TimeToFirstByte',
        UserActionDuration = <any> 'UserActionDuration',
        VisuallyComplete = <any> 'VisuallyComplete'
    }
}
