/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { Recurrence } from './recurrence';

/**
* The schedule of the maintenance window.
*/
export class Schedule {
    /**
    * The type of the schedule recurrence.
    */
    'recurrenceType': Schedule.RecurrenceTypeEnum;
    'recurrence'?: Recurrence;
    /**
    * The start date and time of the maintenance window validity period in yyyy-mm-dd HH:mm format.
    */
    'start': string;
    /**
    * The end date and time of the maintenance window validity period in yyyy-mm-dd HH:mm format.
    */
    'end': string;
    /**
    * The time zone of the start and end time. Default time zone is UTC.   You can use either UTC offset `UTC+01:00` format or the IANA Time Zone Database format (for example, `Europe/Vienna`).
    */
    'zoneId': string;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "recurrenceType",
            "baseName": "recurrenceType",
            "type": "Schedule.RecurrenceTypeEnum"
        },
        {
            "name": "recurrence",
            "baseName": "recurrence",
            "type": "Recurrence"
        },
        {
            "name": "start",
            "baseName": "start",
            "type": "string"
        },
        {
            "name": "end",
            "baseName": "end",
            "type": "string"
        },
        {
            "name": "zoneId",
            "baseName": "zoneId",
            "type": "string"
        }    ];

    static getAttributeTypeMap() {
        return Schedule.attributeTypeMap;
    }
}

export namespace Schedule {
    export enum RecurrenceTypeEnum {
        DAILY = <any> 'DAILY',
        MONTHLY = <any> 'MONTHLY',
        ONCE = <any> 'ONCE',
        WEEKLY = <any> 'WEEKLY'
    }
}
