/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { MonitoredEntityFilter } from './monitoredEntityFilter';

/**
* The scope of the maintenance window.    The scope restricts the alert/problem detection suppression to certain Dynatrace entities. It can contain a list of entities and/or matching rules for dynamic formation of the scope.    If no scope is specified, the alert/problem detection suppression applies to the entire environment.
*/
export class Scope {
    /**
    * A list of Dynatrace entities (for example, hosts or services) to be included in the scope.   Allowed values are Dynatrace entity IDs.
    */
    'entities': Array<string>;
    /**
    * A list of matching rules for dynamic scope formation.   If several rules are set, the OR logic applies.
    */
    'matches': Array<MonitoredEntityFilter>;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "entities",
            "baseName": "entities",
            "type": "Array<string>"
        },
        {
            "name": "matches",
            "baseName": "matches",
            "type": "Array<MonitoredEntityFilter>"
        }    ];

    static getAttributeTypeMap() {
        return Scope.attributeTypeMap;
    }
}

