/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* Conditions for data capturing.
*/
export class ScopeConditions {
    /**
    * Only applies to this service technology.
    */
    'serviceTechnology'?: ScopeConditions.ServiceTechnologyEnum;
    /**
    * Only applies to this process group. Note that this can\'t be transferred between different clusters or environments.
    */
    'processGroup'?: string;
    /**
    * Only applies to this host group.
    */
    'hostGroup'?: string;
    /**
    * Only apply to process groups matching this tag.
    */
    'tagOfProcessGroup'?: string;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "serviceTechnology",
            "baseName": "serviceTechnology",
            "type": "ScopeConditions.ServiceTechnologyEnum"
        },
        {
            "name": "processGroup",
            "baseName": "processGroup",
            "type": "string"
        },
        {
            "name": "hostGroup",
            "baseName": "hostGroup",
            "type": "string"
        },
        {
            "name": "tagOfProcessGroup",
            "baseName": "tagOfProcessGroup",
            "type": "string"
        }    ];

    static getAttributeTypeMap() {
        return ScopeConditions.attributeTypeMap;
    }
}

export namespace ScopeConditions {
    export enum ServiceTechnologyEnum {
        ACTIVEMQ = <any> 'ACTIVE_MQ',
        ACTIVEMQARTEMIS = <any> 'ACTIVE_MQ_ARTEMIS',
        ADONET = <any> 'ADO_NET',
        AIX = <any> 'AIX',
        AKKA = <any> 'AKKA',
        AMAZONREDSHIFT = <any> 'AMAZON_REDSHIFT',
        AMQP = <any> 'AMQP',
        APACHECAMEL = <any> 'APACHE_CAMEL',
        APACHECASSANDRA = <any> 'APACHE_CASSANDRA',
        APACHECOUCHDB = <any> 'APACHE_COUCH_DB',
        APACHEDERBY = <any> 'APACHE_DERBY',
        APACHEHTTPCLIENTASYNC = <any> 'APACHE_HTTP_CLIENT_ASYNC',
        APACHEHTTPCLIENTSYNC = <any> 'APACHE_HTTP_CLIENT_SYNC',
        APACHEHTTPSERVER = <any> 'APACHE_HTTP_SERVER',
        APACHEKAFKA = <any> 'APACHE_KAFKA',
        APACHESOLR = <any> 'APACHE_SOLR',
        APACHESTORM = <any> 'APACHE_STORM',
        APACHESYNAPSE = <any> 'APACHE_SYNAPSE',
        APACHETOMCAT = <any> 'APACHE_TOMCAT',
        APPARMOR = <any> 'APPARMOR',
        APPLICATIONINSIGHTSSDK = <any> 'APPLICATION_INSIGHTS_SDK',
        ASPDOTNET = <any> 'ASP_DOTNET',
        ASPDOTNETCORE = <any> 'ASP_DOTNET_CORE',
        ASPDOTNETCORESIGNALR = <any> 'ASP_DOTNET_CORE_SIGNALR',
        ASPDOTNETSIGNALR = <any> 'ASP_DOTNET_SIGNALR',
        AWSLAMBDA = <any> 'AWS_LAMBDA',
        AWSRDS = <any> 'AWS_RDS',
        AWSSERVICE = <any> 'AWS_SERVICE',
        AXIS = <any> 'AXIS',
        AZUREFUNCTIONS = <any> 'AZURE_FUNCTIONS',
        AZURESERVICEBUS = <any> 'AZURE_SERVICE_BUS',
        AZURESERVICEFABRIC = <any> 'AZURE_SERVICE_FABRIC',
        AZURESTORAGE = <any> 'AZURE_STORAGE',
        BOSHBPM = <any> 'BOSHBPM',
        CITRIX = <any> 'CITRIX',
        CITRIXCOMMON = <any> 'CITRIX_COMMON',
        CITRIXDESKTOPDELIVERYCONTROLLERS = <any> 'CITRIX_DESKTOP_DELIVERY_CONTROLLERS',
        CITRIXDIRECTOR = <any> 'CITRIX_DIRECTOR',
        CITRIXLICENSESERVER = <any> 'CITRIX_LICENSE_SERVER',
        CITRIXPROVISIONINGSERVICES = <any> 'CITRIX_PROVISIONING_SERVICES',
        CITRIXSTOREFRONT = <any> 'CITRIX_STOREFRONT',
        CITRIXVIRTUALDELIVERYAGENT = <any> 'CITRIX_VIRTUAL_DELIVERY_AGENT',
        CITRIXWORKSPACEENVIRONMENTMANAGEMENT = <any> 'CITRIX_WORKSPACE_ENVIRONMENT_MANAGEMENT',
        CLOUDFOUNDRY = <any> 'CLOUDFOUNDRY',
        CLOUDFOUNDRYAUCTIONEER = <any> 'CLOUDFOUNDRY_AUCTIONEER',
        CLOUDFOUNDRYBOSH = <any> 'CLOUDFOUNDRY_BOSH',
        CLOUDFOUNDRYGOROUTER = <any> 'CLOUDFOUNDRY_GOROUTER',
        COLDFUSION = <any> 'COLDFUSION',
        CONTAINERD = <any> 'CONTAINERD',
        COREDNS = <any> 'CORE_DNS',
        COUCHBASE = <any> 'COUCHBASE',
        CRIO = <any> 'CRIO',
        CXF = <any> 'CXF',
        DATASTAX = <any> 'DATASTAX',
        DB2 = <any> 'DB2',
        DIEGOCELL = <any> 'DIEGO_CELL',
        DOCKER = <any> 'DOCKER',
        DOTNET = <any> 'DOTNET',
        DOTNETREMOTING = <any> 'DOTNET_REMOTING',
        ELASTICSEARCH = <any> 'ELASTIC_SEARCH',
        ENVOY = <any> 'ENVOY',
        ERLANG = <any> 'ERLANG',
        ETCD = <any> 'ETCD',
        F5LTM = <any> 'F5_LTM',
        FSHARP = <any> 'FSHARP',
        GARDEN = <any> 'GARDEN',
        GLASSFISH = <any> 'GLASSFISH',
        GO = <any> 'GO',
        GRPC = <any> 'GRPC',
        GRSECURITY = <any> 'GRSECURITY',
        HADOOP = <any> 'HADOOP',
        HADOOPHDFS = <any> 'HADOOP_HDFS',
        HADOOPYARN = <any> 'HADOOP_YARN',
        HAPROXY = <any> 'HAPROXY',
        HEAT = <any> 'HEAT',
        HESSIAN = <any> 'HESSIAN',
        HORNETQ = <any> 'HORNET_Q',
        IBMCICSREGION = <any> 'IBM_CICS_REGION',
        IBMCICSTRANSACTIONGATEWAY = <any> 'IBM_CICS_TRANSACTION_GATEWAY',
        IBMIMSCONNECTREGION = <any> 'IBM_IMS_CONNECT_REGION',
        IBMIMSCONTROLREGION = <any> 'IBM_IMS_CONTROL_REGION',
        IBMIMSMESSAGEPROCESSINGREGION = <any> 'IBM_IMS_MESSAGE_PROCESSING_REGION',
        IBMIMSSOAPGATEWAY = <any> 'IBM_IMS_SOAP_GATEWAY',
        IBMINTEGRATIONBUS = <any> 'IBM_INTEGRATION_BUS',
        IBMMQ = <any> 'IBM_MQ',
        IBMMQCLIENT = <any> 'IBM_MQ_CLIENT',
        IBMWEBSHPREREAPPLICATIONSERVER = <any> 'IBM_WEBSHPRERE_APPLICATION_SERVER',
        IBMWEBSHPRERELIBERTY = <any> 'IBM_WEBSHPRERE_LIBERTY',
        IIS = <any> 'IIS',
        IISAPPPOOL = <any> 'IIS_APP_POOL',
        ISTIO = <any> 'ISTIO',
        JAVA = <any> 'JAVA',
        JAXWS = <any> 'JAX_WS',
        JBOSS = <any> 'JBOSS',
        JBOSSEAP = <any> 'JBOSS_EAP',
        JDKHTTPSERVER = <any> 'JDK_HTTP_SERVER',
        JERSEY = <any> 'JERSEY',
        JETTY = <any> 'JETTY',
        JRUBY = <any> 'JRUBY',
        JYTHON = <any> 'JYTHON',
        KUBERNETES = <any> 'KUBERNETES',
        LIBVIRT = <any> 'LIBVIRT',
        LINKERD = <any> 'LINKERD',
        MARIADB = <any> 'MARIADB',
        MEMCACHED = <any> 'MEMCACHED',
        MICROSOFTSQLSERVER = <any> 'MICROSOFT_SQL_SERVER',
        MONGODB = <any> 'MONGODB',
        MSSQLCLIENT = <any> 'MSSQL_CLIENT',
        MULEESB = <any> 'MULE_ESB',
        MYSQL = <any> 'MYSQL',
        MYSQLCONNECTOR = <any> 'MYSQL_CONNECTOR',
        NETFLIXSERVO = <any> 'NETFLIX_SERVO',
        NETTY = <any> 'NETTY',
        NGINX = <any> 'NGINX',
        NODEJS = <any> 'NODE_JS',
        ONEAGENTSDK = <any> 'ONEAGENT_SDK',
        OPENCENSUS = <any> 'OPENCENSUS',
        OPENSHIFT = <any> 'OPENSHIFT',
        OPENSTACKCOMPUTE = <any> 'OPENSTACK_COMPUTE',
        OPENSTACKCONTROLLER = <any> 'OPENSTACK_CONTROLLER',
        OPENTELEMETRY = <any> 'OPENTELEMETRY',
        OPENTRACING = <any> 'OPENTRACING',
        OPENLIBERTY = <any> 'OPEN_LIBERTY',
        ORACLEDATABASE = <any> 'ORACLE_DATABASE',
        ORACLEWEBLOGIC = <any> 'ORACLE_WEBLOGIC',
        OWIN = <any> 'OWIN',
        PERL = <any> 'PERL',
        PHP = <any> 'PHP',
        PHPFPM = <any> 'PHP_FPM',
        PLAY = <any> 'PLAY',
        POSTGRESQL = <any> 'POSTGRE_SQL',
        POSTGRESQLDOTNETDATAPROVIDER = <any> 'POSTGRE_SQL_DOTNET_DATA_PROVIDER',
        POWERDNS = <any> 'POWER_DNS',
        PROGRESS = <any> 'PROGRESS',
        PYTHON = <any> 'PYTHON',
        RABBITMQ = <any> 'RABBIT_MQ',
        REDIS = <any> 'REDIS',
        RESTEASY = <any> 'RESTEASY',
        RESTLET = <any> 'RESTLET',
        RIAK = <any> 'RIAK',
        RUBY = <any> 'RUBY',
        SAGWEBMETHODSIS = <any> 'SAG_WEBMETHODS_IS',
        SAP = <any> 'SAP',
        SAPHANADB = <any> 'SAP_HANADB',
        SAPHYBRIS = <any> 'SAP_HYBRIS',
        SAPMAXDB = <any> 'SAP_MAXDB',
        SAPSYBASE = <any> 'SAP_SYBASE',
        SCALA = <any> 'SCALA',
        SELINUX = <any> 'SELINUX',
        SHAREPOINT = <any> 'SHAREPOINT',
        SPARK = <any> 'SPARK',
        SPRING = <any> 'SPRING',
        SQLITE = <any> 'SQLITE',
        THRIFT = <any> 'THRIFT',
        TIBCO = <any> 'TIBCO',
        TIBCOBUSINESSWORKS = <any> 'TIBCO_BUSINESS_WORKS',
        TIBCOEMS = <any> 'TIBCO_EMS',
        VARNISHCACHE = <any> 'VARNISH_CACHE',
        VIM2 = <any> 'VIM2',
        VIRTUALMACHINEKVM = <any> 'VIRTUAL_MACHINE_KVM',
        VIRTUALMACHINEQEMU = <any> 'VIRTUAL_MACHINE_QEMU',
        WILDFLY = <any> 'WILDFLY',
        WINDOWSCONTAINERS = <any> 'WINDOWS_CONTAINERS',
        WINK = <any> 'WINK',
        ZEROMQ = <any> 'ZERO_MQ'
    }
}
