/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { ComparisonInfo } from './comparisonInfo';
import { ServiceTypeComparisonInfoAllOf } from './serviceTypeComparisonInfoAllOf';

/**
* Comparison for `SERVICE_TYPE` attributes.
*/
export class ServiceTypeComparisonInfo extends ComparisonInfo {
    /**
    * Operator of the comparision. You can reverse it by setting **negate** to `true`.
    */
    'comparison': ServiceTypeComparisonInfo.ComparisonEnum;
    /**
    * The value to compare to.
    */
    'value'?: ServiceTypeComparisonInfo.ValueEnum;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "comparison",
            "baseName": "comparison",
            "type": "ServiceTypeComparisonInfo.ComparisonEnum"
        },
        {
            "name": "value",
            "baseName": "value",
            "type": "ServiceTypeComparisonInfo.ValueEnum"
        }    ];

    static getAttributeTypeMap() {
        return super.getAttributeTypeMap().concat(ServiceTypeComparisonInfo.attributeTypeMap);
    }
}

export namespace ServiceTypeComparisonInfo {
    export enum ComparisonEnum {
        EQUALS = <any> 'EQUALS',
        EXISTS = <any> 'EXISTS'
    }
    export enum ValueEnum {
        BACKGROUNDACTIVITY = <any> 'BACKGROUND_ACTIVITY',
        CICSSERVICE = <any> 'CICS_SERVICE',
        CUSTOMSERVICE = <any> 'CUSTOM_SERVICE',
        DATABASESERVICE = <any> 'DATABASE_SERVICE',
        ENTERPRISESERVICEBUSSERVICE = <any> 'ENTERPRISE_SERVICE_BUS_SERVICE',
        EXTERNAL = <any> 'EXTERNAL',
        IBMINTEGRATIONBUSSERVICE = <any> 'IBM_INTEGRATION_BUS_SERVICE',
        IMSSERVICE = <any> 'IMS_SERVICE',
        MESSAGINGSERVICE = <any> 'MESSAGING_SERVICE',
        QUEUELISTENERSERVICE = <any> 'QUEUE_LISTENER_SERVICE',
        RMISERVICE = <any> 'RMI_SERVICE',
        RPCSERVICE = <any> 'RPC_SERVICE',
        WEBREQUESTSERVICE = <any> 'WEB_REQUEST_SERVICE',
        WEBSERVICE = <any> 'WEB_SERVICE'
    }
}
