/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* The value to compare to.
*/
export class SimpleHostTech {
    /**
    * Predefined technology, if technology is not predefined, then the verbatim type must be set
    */
    'type'?: SimpleHostTech.TypeEnum;
    /**
    * Non-predefined technology, use for custom technologies.
    */
    'verbatimType'?: string;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "type",
            "baseName": "type",
            "type": "SimpleHostTech.TypeEnum"
        },
        {
            "name": "verbatimType",
            "baseName": "verbatimType",
            "type": "string"
        }    ];

    static getAttributeTypeMap() {
        return SimpleHostTech.attributeTypeMap;
    }
}

export namespace SimpleHostTech {
    export enum TypeEnum {
        APPARMOR = <any> 'APPARMOR',
        BOSH = <any> 'BOSH',
        BOSHBPM = <any> 'BOSHBPM',
        CLOUDFOUNDRY = <any> 'CLOUDFOUNDRY',
        CONTAINERD = <any> 'CONTAINERD',
        CRIO = <any> 'CRIO',
        DIEGOCELL = <any> 'DIEGO_CELL',
        DOCKER = <any> 'DOCKER',
        GARDEN = <any> 'GARDEN',
        GRSECURITY = <any> 'GRSECURITY',
        KUBERNETES = <any> 'KUBERNETES',
        OPENSHIFT = <any> 'OPENSHIFT',
        OPENSTACKCOMPUTE = <any> 'OPENSTACK_COMPUTE',
        OPENSTACKCONTROLLER = <any> 'OPENSTACK_CONTROLLER',
        SELINUX = <any> 'SELINUX'
    }
}
