/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* Custom thresholds for slow running physical storage device. If not set then the automatic mode is used.    Fulfillment of **any** condition triggers an alert.
*/
export class SlowPhysicalStorageThresholds {
    /**
    * Read/write latency is higher than *X* milliseconds in 4 out of 5 samples.
    */
    'avgReadWriteLatency': number;
    /**
    * Peak value for read/write latency is higher than *X* milliseconds in 4 out of 5 samples.
    */
    'peakReadWriteLatency': number;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "avgReadWriteLatency",
            "baseName": "avgReadWriteLatency",
            "type": "number"
        },
        {
            "name": "peakReadWriteLatency",
            "baseName": "peakReadWriteLatency",
            "type": "number"
        }    ];

    static getAttributeTypeMap() {
        return SlowPhysicalStorageThresholds.attributeTypeMap;
    }
}

