/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { ComparisonInfo } from './comparisonInfo';
import { PropagationSource } from './propagationSource';
import { StringRequestAttributeComparisonInfoAllOf } from './stringRequestAttributeComparisonInfoAllOf';

/**
* Comparison for `STRING_REQUEST_ATTRIBUTE` attributes, specifically of the **String** type.
*/
export class StringRequestAttributeComparisonInfo extends ComparisonInfo {
    /**
    * Operator of the comparision. You can reverse it by setting **negate** to `true`.
    */
    'comparison': StringRequestAttributeComparisonInfo.ComparisonEnum;
    /**
    * The value to compare to.
    */
    'value'?: string;
    'requestAttribute': string;
    /**
    * The comparison is case-sensitive (`true`) or not case-sensitive (`false`).
    */
    'caseSensitive'?: boolean;
    /**
    * If `true`, the request attribute is matched on child service calls.    Default is `false`.
    */
    'matchOnChildCalls'?: boolean;
    'source'?: PropagationSource;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "comparison",
            "baseName": "comparison",
            "type": "StringRequestAttributeComparisonInfo.ComparisonEnum"
        },
        {
            "name": "value",
            "baseName": "value",
            "type": "string"
        },
        {
            "name": "requestAttribute",
            "baseName": "requestAttribute",
            "type": "string"
        },
        {
            "name": "caseSensitive",
            "baseName": "caseSensitive",
            "type": "boolean"
        },
        {
            "name": "matchOnChildCalls",
            "baseName": "matchOnChildCalls",
            "type": "boolean"
        },
        {
            "name": "source",
            "baseName": "source",
            "type": "PropagationSource"
        }    ];

    static getAttributeTypeMap() {
        return super.getAttributeTypeMap().concat(StringRequestAttributeComparisonInfo.attributeTypeMap);
    }
}

export namespace StringRequestAttributeComparisonInfo {
    export enum ComparisonEnum {
        BEGINSWITH = <any> 'BEGINS_WITH',
        CONTAINS = <any> 'CONTAINS',
        ENDSWITH = <any> 'ENDS_WITH',
        EQUALS = <any> 'EQUALS',
        EXISTS = <any> 'EXISTS',
        REGEXMATCHES = <any> 'REGEX_MATCHES'
    }
}
