/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { AppIdentifier } from './appIdentifier';

export class SymbolFile {
    /**
    * The name of the application this file belongs to
    */
    'applicationName'?: string;
    /**
    * The size of the file in KB
    */
    'size'?: number;
    'appId'?: AppIdentifier;
    /**
    * The timestamp of the upload time of the file, in UTC milliseconds
    */
    'uploadTimestamp'?: number;
    /**
    * Is the file pinned and therefore cannot be deleted.
    */
    'pinned'?: boolean;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "applicationName",
            "baseName": "applicationName",
            "type": "string"
        },
        {
            "name": "size",
            "baseName": "size",
            "type": "number"
        },
        {
            "name": "appId",
            "baseName": "appId",
            "type": "AppIdentifier"
        },
        {
            "name": "uploadTimestamp",
            "baseName": "uploadTimestamp",
            "type": "number"
        },
        {
            "name": "pinned",
            "baseName": "pinned",
            "type": "boolean"
        }    ];

    static getAttributeTypeMap() {
        return SymbolFile.attributeTypeMap;
    }
}

