/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* Filter of the calculated synthetic metric.
*/
export class SyntheticMetricFilter {
    /**
    * Only user actions of the specified type are included in the metric calculation.
    */
    'actionType'?: SyntheticMetricFilter.ActionTypeEnum;
    /**
    * The execution status of the monitors to be included in the metric calculation:   * `true`: Only failed executions are included.    * `false`: All executions are included.
    */
    'hasError'?: boolean;
    /**
    * Only executions finished with the specified error code are included in the metric calculation.
    */
    'errorCode'?: number;
    /**
    * Only the specified browser clickpath event is included in the metric calculation.    Specify the Dynatrace entity ID of the event here. You can fetch the list of clickpath events of the monitor with the [GET a synthetic monitor](https://www.dynatrace.com/support/help/shortlink/api-synthetic-monitors-get-monitor) request from the Environment API
    */
    'event'?: string;
    /**
    * Only executions from the specified location are included in the metric calculation.    Specify the Dynatrace entity ID of the location here. You can fetch the list of locations the monitor is running from with the [GET a synthetic monitor](https://www.dynatrace.com/support/help/shortlink/api-synthetic-monitors-get-monitor) request from the Environment API.
    */
    'location'?: string;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "actionType",
            "baseName": "actionType",
            "type": "SyntheticMetricFilter.ActionTypeEnum"
        },
        {
            "name": "hasError",
            "baseName": "hasError",
            "type": "boolean"
        },
        {
            "name": "errorCode",
            "baseName": "errorCode",
            "type": "number"
        },
        {
            "name": "event",
            "baseName": "event",
            "type": "string"
        },
        {
            "name": "location",
            "baseName": "location",
            "type": "string"
        }    ];

    static getAttributeTypeMap() {
        return SyntheticMetricFilter.attributeTypeMap;
    }
}

export namespace SyntheticMetricFilter {
    export enum ActionTypeEnum {
        Custom = <any> 'Custom',
        Load = <any> 'Load',
        Xhr = <any> 'Xhr'
    }
}
