/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { TakeSegmentsTransformationAllOf } from './takeSegmentsTransformationAllOf';
import { TransformationBase } from './transformationBase';

/**
* The transformation of the `TAKE_SEGMENTS` type.   The transformation splits the detected value into an array and keeps the specified number of first or last elements.
*/
export class TakeSegmentsTransformation extends TransformationBase {
    /**
    * The number of elements to be kept.
    */
    'segmentCount': number;
    /**
    * The delimiter for splitting the detected value. The delimiter itself is not kept.
    */
    'delimiter': string;
    /**
    * Keeps the first (`false`) or last (`true`) elements.    If not set, then `false` is used, keeping the first elements.
    */
    'takeFromEnd'?: boolean;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "segmentCount",
            "baseName": "segmentCount",
            "type": "number"
        },
        {
            "name": "delimiter",
            "baseName": "delimiter",
            "type": "string"
        },
        {
            "name": "takeFromEnd",
            "baseName": "takeFromEnd",
            "type": "boolean"
        }    ];

    static getAttributeTypeMap() {
        return super.getAttributeTypeMap().concat(TakeSegmentsTransformation.attributeTypeMap);
    }
}

export namespace TakeSegmentsTransformation {
}
