/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { TileBounds } from './tileBounds';
import { TileFilter } from './tileFilter';

/**
* Configuration of a tile.   The actual set of fields depends on the type of the tile. See the description of the **tileType** field.
*/
export class Tile {
    /**
    * The name of the tile.
    */
    'name': string;
    /**
    * Defines the actual set of fields depending on the value. See one of the following objects:   * `CUSTOM_CHARTING` -> CustomChartingTile  * `DTAQL` -> UserSessionQueryTile  * `MARKDOWN` -> MarkdownTile  * `HOSTS` -> FilterableEntityTile  * `APPLICATIONS` -> FilterableEntityTile  * `SERVICES` -> FilterableEntityTile  * `DATABASES_OVERVIEW` -> FilterableEntityTile  * `SYNTHETIC_TESTS` -> FilterableEntityTile  * `APPLICATION_WORLDMAP` -> AssignedEntitiesWithMetricTile  * `RESOURCES` -> AssignedEntitiesWithMetricTile  * `THIRD_PARTY_MOST_ACTIVE` -> AssignedEntitiesWithMetricTile  * `UEM_CONVERSIONS_PER_GOAL` -> AssignedEntitiesWithMetricTile  * `HOST` -> AssignedEntitiesWithMetricTile  * `PROCESS_GROUPS_ONE` -> AssignedEntitiesWithMetricTile  * `SYNTHETIC_SINGLE_WEBCHECK` -> SyntheticSingleWebcheckTile  * `APPLICATION` -> AssignedEntitiesTile  * `VIRTUALIZATION` -> AssignedEntitiesTile  * `AWS` -> AssignedEntitiesTile  * `SERVICE_VERSATILE` -> AssignedEntitiesTile  * `SESSION_METRICS` -> AssignedEntitiesTile  * `USERS` -> AssignedEntitiesTile  * `UEM_KEY_USER_ACTIONS` -> AssignedEntitiesTile  * `BOUNCE_RATE` -> AssignedEntitiesTile  * `UEM_CONVERSIONS_OVERALL` -> AssignedEntitiesTile  * `UEM_JSERRORS_OVERALL` -> AssignedEntitiesTile  * `MOBILE_APPLICATION` -> AssignedEntitiesTile  * `SYNTHETIC_SINGLE_EXT_TEST` -> AssignedEntitiesTile  * `SYNTHETIC_HTTP_MONITOR` -> AssignedEntitiesTile  * `DATABASE` -> AssignedEntitiesTile  * `CUSTOM_APPLICATION` -> AssignedEntitiesTile  * `APPLICATION_METHOD` -> AssignedEntitiesTile  * `LOG_ANALYTICS` -> AssignedEntitiesTile  * `OPENSTACK` -> AssignedEntitiesTile  * `OPENSTACK_PROJECT` -> AssignedEntitiesTile  * `OPENSTACK_AV_ZONE` -> AssignedEntitiesTile  * `DEVICE_APPLICATION_METHOD` -> AssignedEntitiesTile  * `DEM_KEY_USER_ACTION` -> AssignedEntitiesTile  
    */
    'tileType': Tile.TileTypeEnum;
    /**
    * The tile is configured and ready to use (`true`) or just placed on the dashboard (`false`).
    */
    'configured'?: boolean;
    'bounds': TileBounds;
    'tileFilter'?: TileFilter;

    static discriminator: string | undefined = "tileType";

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "name",
            "baseName": "name",
            "type": "string"
        },
        {
            "name": "tileType",
            "baseName": "tileType",
            "type": "Tile.TileTypeEnum"
        },
        {
            "name": "configured",
            "baseName": "configured",
            "type": "boolean"
        },
        {
            "name": "bounds",
            "baseName": "bounds",
            "type": "TileBounds"
        },
        {
            "name": "tileFilter",
            "baseName": "tileFilter",
            "type": "TileFilter"
        }    ];

    static getAttributeTypeMap() {
        return Tile.attributeTypeMap;
    }
}

export namespace Tile {
    export enum TileTypeEnum {
        APPLICATION = <any> 'APPLICATION',
        APPLICATIONS = <any> 'APPLICATIONS',
        APPLICATIONMETHOD = <any> 'APPLICATION_METHOD',
        APPLICATIONWORLDMAP = <any> 'APPLICATION_WORLDMAP',
        AWS = <any> 'AWS',
        BOUNCERATE = <any> 'BOUNCE_RATE',
        CUSTOMAPPLICATION = <any> 'CUSTOM_APPLICATION',
        CUSTOMCHARTING = <any> 'CUSTOM_CHARTING',
        DATABASE = <any> 'DATABASE',
        DATABASESOVERVIEW = <any> 'DATABASES_OVERVIEW',
        DEMKEYUSERACTION = <any> 'DEM_KEY_USER_ACTION',
        DEVICEAPPLICATIONMETHOD = <any> 'DEVICE_APPLICATION_METHOD',
        DTAQL = <any> 'DTAQL',
        HOST = <any> 'HOST',
        HOSTS = <any> 'HOSTS',
        LOGANALYTICS = <any> 'LOG_ANALYTICS',
        MARKDOWN = <any> 'MARKDOWN',
        MOBILEAPPLICATION = <any> 'MOBILE_APPLICATION',
        OPENSTACK = <any> 'OPENSTACK',
        OPENSTACKAVZONE = <any> 'OPENSTACK_AV_ZONE',
        OPENSTACKPROJECT = <any> 'OPENSTACK_PROJECT',
        PROCESSGROUPSONE = <any> 'PROCESS_GROUPS_ONE',
        RESOURCES = <any> 'RESOURCES',
        SERVICES = <any> 'SERVICES',
        SERVICEVERSATILE = <any> 'SERVICE_VERSATILE',
        SESSIONMETRICS = <any> 'SESSION_METRICS',
        SYNTHETICHTTPMONITOR = <any> 'SYNTHETIC_HTTP_MONITOR',
        SYNTHETICSINGLEEXTTEST = <any> 'SYNTHETIC_SINGLE_EXT_TEST',
        SYNTHETICSINGLEWEBCHECK = <any> 'SYNTHETIC_SINGLE_WEBCHECK',
        SYNTHETICTESTS = <any> 'SYNTHETIC_TESTS',
        THIRDPARTYMOSTACTIVE = <any> 'THIRD_PARTY_MOST_ACTIVE',
        UEMCONVERSIONSOVERALL = <any> 'UEM_CONVERSIONS_OVERALL',
        UEMCONVERSIONSPERGOAL = <any> 'UEM_CONVERSIONS_PER_GOAL',
        UEMJSERRORSOVERALL = <any> 'UEM_JSERRORS_OVERALL',
        UEMKEYUSERACTIONS = <any> 'UEM_KEY_USER_ACTIONS',
        USERS = <any> 'USERS',
        VIRTUALIZATION = <any> 'VIRTUALIZATION'
    }
}
