/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* The position and size of a tile.
*/
export class TileBounds {
    /**
    * The vertical distance from the top left corner of the dashboard to the top left corner of the tile, in pixels.
    */
    'top'?: number;
    /**
    * The horizontal distance from the top left corner of the dashboard to the top left corner of the tile, in pixels.
    */
    'left'?: number;
    /**
    * The width of the tile, in pixels.
    */
    'width'?: number;
    /**
    * The height of the tile, in pixels.
    */
    'height'?: number;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "top",
            "baseName": "top",
            "type": "number"
        },
        {
            "name": "left",
            "baseName": "left",
            "type": "number"
        },
        {
            "name": "width",
            "baseName": "width",
            "type": "number"
        },
        {
            "name": "height",
            "baseName": "height",
            "type": "number"
        }    ];

    static getAttributeTypeMap() {
        return TileBounds.attributeTypeMap;
    }
}

