/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* Settings for timed action capture.
*/
export class TimeoutSettings {
    /**
    * Timed action support enabled/disabled.   Enable to detect actions that trigger sending of XHRs via *setTimout* methods.
    */
    'timedActionSupport': boolean;
    /**
    * Defines how deep temporary actions may cascade. 0 disables temporary actions completely. Recommended value if enabled is 3.
    */
    'temporaryActionLimit': number;
    /**
    * The total timeout of all cascaded timeouts that should still be able to create a temporary action
    */
    'temporaryActionTotalTimeout': number;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "timedActionSupport",
            "baseName": "timedActionSupport",
            "type": "boolean"
        },
        {
            "name": "temporaryActionLimit",
            "baseName": "temporaryActionLimit",
            "type": "number"
        },
        {
            "name": "temporaryActionTotalTimeout",
            "baseName": "temporaryActionTotalTimeout",
            "type": "number"
        }    ];

    static getAttributeTypeMap() {
        return TimeoutSettings.attributeTypeMap;
    }
}

