/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* Configuration of transformation of the detected value.   If several transformations are specified, they are handled sequentially from top to bottom. Each transformation is applied to the result of the preceding transformation. For example, the second transformation is applied to the result of the first transformation.   The actual set of fields depends on the `type` of the transformation.
*/
export class TransformationBase {
    /**
    * Defines the actual set of fields depending on the value. See one of the following objects:   * `BEFORE` -> BeforeTransformation  * `AFTER` -> AfterTransformation  * `BETWEEN` -> BetweenTransformation  * `REPLACE_BETWEEN` -> ReplaceBetweenTransformation  * `REMOVE_NUMBERS` -> RemoveNumbersTransformation  * `REMOVE_CREDIT_CARDS` -> RemoveCreditCardNumbersTransformation  * `REMOVE_IBANS` -> RemoveIBANsTransformation  * `REMOVE_IPS` -> RemoveIPsTransformation  * `SPLIT_SELECT` -> SplitSelectTransformation  * `TAKE_SEGMENTS` -> TakeSegmentsTransformation  
    */
    'type': TransformationBase.TypeEnum;

    static discriminator: string | undefined = "type";

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "type",
            "baseName": "type",
            "type": "TransformationBase.TypeEnum"
        }    ];

    static getAttributeTypeMap() {
        return TransformationBase.attributeTypeMap;
    }
}

export namespace TransformationBase {
    export enum TypeEnum {
        AFTER = <any> 'AFTER',
        BEFORE = <any> 'BEFORE',
        BETWEEN = <any> 'BETWEEN',
        REMOVECREDITCARDS = <any> 'REMOVE_CREDIT_CARDS',
        REMOVEIBANS = <any> 'REMOVE_IBANS',
        REMOVEIPS = <any> 'REMOVE_IPS',
        REMOVENUMBERS = <any> 'REMOVE_NUMBERS',
        REPLACEBETWEEN = <any> 'REPLACE_BETWEEN',
        SPLITSELECT = <any> 'SPLIT_SELECT',
        TAKESEGMENTS = <any> 'TAKE_SEGMENTS'
    }
}
