/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { NotificationConfig } from './notificationConfig';
import { TrelloNotificationConfigAllOf } from './trelloNotificationConfigAllOf';

/**
* Configuration of the Trello notification.
*/
export class TrelloNotificationConfig extends NotificationConfig {
    /**
    * The application key for the Trello account.
    */
    'applicationKey': string;
    /**
    * The application token for the Trello account.
    */
    'authorizationToken'?: string;
    /**
    * The Trello board to which the card should be assigned.
    */
    'boardId': string;
    /**
    * The Trello list to which the card should be assigned.
    */
    'listId': string;
    /**
    * The Trello list to which the card of the resolved problem should be assigned.
    */
    'resolvedListId': string;
    /**
    * The text of the generated Trello card.   You can use the following placeholders:  * `{ImpactedEntity}`: The entity impacted by the problem or *X* impacted entities.  * `{PID}`: The ID of the reported problem.  * `{ProblemDetailsMarkdown}`: All problem event details, including root cause, as a [Markdown-formatted](https://www.markdownguide.org/cheat-sheet/) string.  * `{ProblemID}`: The display number of the reported problem.  * `{ProblemImpact}`: The [impact level](https://www.dynatrace.com/support/help/shortlink/impact-analysis) of the problem. Possible values are `APPLICATION`, `SERVICE`, and `INFRASTRUCTURE`.  * `{ProblemSeverity}`: The [severity level](https://www.dynatrace.com/support/help/shortlink/event-types) of the problem. Possible values are `AVAILABILITY`, `ERROR`, `PERFORMANCE`, `RESOURCE_CONTENTION`, and `CUSTOM_ALERT`.  * `{ProblemTitle}`: A short description of the problem.  * `{ProblemURL}`: The URL of the problem within Dynatrace.  * `{State}`: The state of the problem. Possible values are `OPEN` and `RESOLVED`. If the problem has been merged into another problem, it has the `MERGED` value.  * `{Tags}`: The list of tags that are defined for all impacted entities, separated by commas.  
    */
    'text': string;
    /**
    * The description of the Trello card.    You can use same placeholders as in card text.
    */
    'description': string;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "applicationKey",
            "baseName": "applicationKey",
            "type": "string"
        },
        {
            "name": "authorizationToken",
            "baseName": "authorizationToken",
            "type": "string"
        },
        {
            "name": "boardId",
            "baseName": "boardId",
            "type": "string"
        },
        {
            "name": "listId",
            "baseName": "listId",
            "type": "string"
        },
        {
            "name": "resolvedListId",
            "baseName": "resolvedListId",
            "type": "string"
        },
        {
            "name": "text",
            "baseName": "text",
            "type": "string"
        },
        {
            "name": "description",
            "baseName": "description",
            "type": "string"
        }    ];

    static getAttributeTypeMap() {
        return super.getAttributeTypeMap().concat(TrelloNotificationConfig.attributeTypeMap);
    }
}

export namespace TrelloNotificationConfig {
}
