/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { UniversalTagKey } from './universalTagKey';

/**
* Use only request attributes from services that have this tag. Use either this or `managementZone`
*/
export class UniversalTag {
    'tagKey'?: UniversalTagKey;
    /**
    * The value of the tag. Not applicable to custom tags.   If a tag does have a separate key and value (in the textual representation they are split by the colon ‘:’), this field is set with the actual value. Key-value pairs can occur for automatically imported tags and tags set by rules if extractors are used.
    */
    'value'?: string;
    /**
    * The key of the tag. For custom tags, put the tag value here.  The key allows categorization of multiple tags. It is possible that there are multiple values for a single key which will all be represented as standalone tags. Therefore, the key does not have the semantic of a map key but is more like a key of a key-value tuple. In some cases, for example custom tags, the key represents the actual tag value and the value field is not set – those are called valueless tags.
    */
    'key': string;
    /**
    * The origin of the tag, such as AWS or Cloud Foundry. For custom tags use the `CONTEXTLESS` value.   The context is set for tags that are automatically imported by OneAgent (for example, from the AWS console or environment variables). It’s useful for determining the origin of tags when not manually defined, and it also helps to prevent clashes with other existing tags. If the tag is not automatically imported, `CONTEXTLESS` set.
    */
    'context'?: UniversalTag.ContextEnum;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "tagKey",
            "baseName": "tagKey",
            "type": "UniversalTagKey"
        },
        {
            "name": "value",
            "baseName": "value",
            "type": "string"
        },
        {
            "name": "key",
            "baseName": "key",
            "type": "string"
        },
        {
            "name": "context",
            "baseName": "context",
            "type": "UniversalTag.ContextEnum"
        }    ];

    static getAttributeTypeMap() {
        return UniversalTag.attributeTypeMap;
    }
}

export namespace UniversalTag {
    export enum ContextEnum {
        AWS = <any> 'AWS',
        AWSGENERIC = <any> 'AWS_GENERIC',
        AZURE = <any> 'AZURE',
        CLOUDFOUNDRY = <any> 'CLOUD_FOUNDRY',
        CONTEXTLESS = <any> 'CONTEXTLESS',
        ENVIRONMENT = <any> 'ENVIRONMENT',
        GOOGLECOMPUTEENGINE = <any> 'GOOGLE_COMPUTE_ENGINE',
        KUBERNETES = <any> 'KUBERNETES'
    }
}
