/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* Defines userAction and session custom defined properties settings of an application.
*/
export class UserActionAndSessionProperties {
    /**
    * uniqueId, unique among all userTags and properties of this application
    */
    'uniqueId': number;
    /**
    * key of the property
    */
    'key': string;
    /**
    * display name of the property
    */
    'displayName'?: string;
    /**
    * Data Type of the property
    */
    'type': UserActionAndSessionProperties.TypeEnum;
    /**
    * Origin of the property
    */
    'origin': UserActionAndSessionProperties.OriginEnum;
    /**
    * if it\'s of type metaData, metaData id of the property
    */
    'metadataId'?: number;
    /**
    * if it\'s of type requestAttribute, UUID of the property
    */
    'serverSideRequestAttribute'?: string;
    /**
    * aggregation of the property
    */
    'aggregation'?: UserActionAndSessionProperties.AggregationEnum;
    /**
    * set to true, if it\'s to be stored as userAction
    */
    'storeAsUserActionProperty'?: boolean;
    /**
    * set to true, if it\'s to be stored as session property
    */
    'storeAsSessionProperty'?: boolean;
    /**
    * Cleanup rule of this property
    */
    'cleanupRule'?: string;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "uniqueId",
            "baseName": "uniqueId",
            "type": "number"
        },
        {
            "name": "key",
            "baseName": "key",
            "type": "string"
        },
        {
            "name": "displayName",
            "baseName": "displayName",
            "type": "string"
        },
        {
            "name": "type",
            "baseName": "type",
            "type": "UserActionAndSessionProperties.TypeEnum"
        },
        {
            "name": "origin",
            "baseName": "origin",
            "type": "UserActionAndSessionProperties.OriginEnum"
        },
        {
            "name": "metadataId",
            "baseName": "metadataId",
            "type": "number"
        },
        {
            "name": "serverSideRequestAttribute",
            "baseName": "serverSideRequestAttribute",
            "type": "string"
        },
        {
            "name": "aggregation",
            "baseName": "aggregation",
            "type": "UserActionAndSessionProperties.AggregationEnum"
        },
        {
            "name": "storeAsUserActionProperty",
            "baseName": "storeAsUserActionProperty",
            "type": "boolean"
        },
        {
            "name": "storeAsSessionProperty",
            "baseName": "storeAsSessionProperty",
            "type": "boolean"
        },
        {
            "name": "cleanupRule",
            "baseName": "cleanupRule",
            "type": "string"
        }    ];

    static getAttributeTypeMap() {
        return UserActionAndSessionProperties.attributeTypeMap;
    }
}

export namespace UserActionAndSessionProperties {
    export enum TypeEnum {
        DATE = <any> 'DATE',
        DOUBLE = <any> 'DOUBLE',
        LONG = <any> 'LONG',
        LONGSTRING = <any> 'LONG_STRING',
        STRING = <any> 'STRING'
    }
    export enum OriginEnum {
        JAVASCRIPTAPI = <any> 'JAVASCRIPT_API',
        METADATA = <any> 'META_DATA',
        SERVERSIDEREQUESTATTRIBUTE = <any> 'SERVER_SIDE_REQUEST_ATTRIBUTE'
    }
    export enum AggregationEnum {
        FIRST = <any> 'FIRST',
        LAST = <any> 'LAST'
    }
}
