/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* Configuration of a user action-based conversion goal.
*/
export class UserActionDetails {
    /**
    * The value to be matched to hit the conversion goal.
    */
    'value'?: string;
    /**
    * The match is case-sensitive (`true`) or (`false`).
    */
    'caseSensitive'?: boolean;
    /**
    * The operator of the match.
    */
    'matchType'?: UserActionDetails.MatchTypeEnum;
    /**
    * The type of the entity to which the rule applies.
    */
    'matchEntity'?: UserActionDetails.MatchEntityEnum;
    /**
    * Type of the action to which the rule applies.
    */
    'actionType'?: UserActionDetails.ActionTypeEnum;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "value",
            "baseName": "value",
            "type": "string"
        },
        {
            "name": "caseSensitive",
            "baseName": "caseSensitive",
            "type": "boolean"
        },
        {
            "name": "matchType",
            "baseName": "matchType",
            "type": "UserActionDetails.MatchTypeEnum"
        },
        {
            "name": "matchEntity",
            "baseName": "matchEntity",
            "type": "UserActionDetails.MatchEntityEnum"
        },
        {
            "name": "actionType",
            "baseName": "actionType",
            "type": "UserActionDetails.ActionTypeEnum"
        }    ];

    static getAttributeTypeMap() {
        return UserActionDetails.attributeTypeMap;
    }
}

export namespace UserActionDetails {
    export enum MatchTypeEnum {
        Begins = <any> 'Begins',
        Contains = <any> 'Contains',
        Ends = <any> 'Ends'
    }
    export enum MatchEntityEnum {
        ActionName = <any> 'ActionName',
        CssSelector = <any> 'CssSelector',
        JavaScriptVariable = <any> 'JavaScriptVariable',
        MetaTag = <any> 'MetaTag',
        PagePath = <any> 'PagePath',
        PageTitle = <any> 'PageTitle',
        PageUrl = <any> 'PageUrl',
        UrlAnchor = <any> 'UrlAnchor',
        XhrUrl = <any> 'XhrUrl'
    }
    export enum ActionTypeEnum {
        Custom = <any> 'Custom',
        Load = <any> 'Load',
        Xhr = <any> 'Xhr'
    }
}
