/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { UserActionPropertyFilter } from './userActionPropertyFilter';

/**
* An optional filter. Only user actions matching this filter are used for metric calculation.
*/
export class UserActionFilter {
    /**
    * Filter by user actions with an action duration >= this value
    */
    'actionDurationFromMilliseconds'?: number;
    /**
    * Filter by user actions with an action duration <= this value
    */
    'actionDurationToMilliseconds'?: number;
    /**
    * Filter by LoadActions
    */
    'loadAction'?: boolean;
    /**
    * Filter by XhrActions
    */
    'xhrAction'?: boolean;
    /**
    * Filter by CustomActions
    */
    'customAction'?: boolean;
    /**
    * Filter by Apdex
    */
    'apdex'?: UserActionFilter.ApdexEnum;
    /**
    * Filter by domain
    */
    'domain'?: string;
    /**
    * Filter by userAction name
    */
    'userActionName'?: string;
    /**
    * Filter by realUsers
    */
    'realUser'?: boolean;
    /**
    * Filter by robots
    */
    'robot'?: boolean;
    /**
    * Filter by synthetic
    */
    'synthetic'?: boolean;
    /**
    * Filter by browser family
    */
    'browserFamily'?: string;
    /**
    * Filter by browser family
    */
    'browserType'?: string;
    /**
    * Filter by browser version
    */
    'browserVersion'?: string;
    /**
    * Filter by custom errors
    */
    'hasCustomErrors'?: boolean;
    /**
    * Filter by any error
    */
    'hasAnyError'?: boolean;
    /**
    * Filter by http errors
    */
    'hasHttpErrors'?: boolean;
    /**
    * Filter by javascript errors
    */
    'hasJavascriptErrors'?: boolean;
    /**
    * Filter by city
    */
    'city'?: string;
    /**
    * Filter by continent
    */
    'continent'?: string;
    /**
    * Filter by country
    */
    'country'?: string;
    /**
    * Filter by region
    */
    'region'?: string;
    /**
    * Filter by ip
    */
    'ip'?: string;
    /**
    * Filter by ipV6Traffic
    */
    'ipV6Traffic'?: boolean;
    /**
    * Filter by osFamily
    */
    'osFamily'?: string;
    /**
    * Filter by osVersion
    */
    'osVersion'?: string;
    /**
    * Filter by user action properties
    */
    'userActionProperties'?: Array<UserActionPropertyFilter>;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "actionDurationFromMilliseconds",
            "baseName": "actionDurationFromMilliseconds",
            "type": "number"
        },
        {
            "name": "actionDurationToMilliseconds",
            "baseName": "actionDurationToMilliseconds",
            "type": "number"
        },
        {
            "name": "loadAction",
            "baseName": "loadAction",
            "type": "boolean"
        },
        {
            "name": "xhrAction",
            "baseName": "xhrAction",
            "type": "boolean"
        },
        {
            "name": "customAction",
            "baseName": "customAction",
            "type": "boolean"
        },
        {
            "name": "apdex",
            "baseName": "apdex",
            "type": "UserActionFilter.ApdexEnum"
        },
        {
            "name": "domain",
            "baseName": "domain",
            "type": "string"
        },
        {
            "name": "userActionName",
            "baseName": "userActionName",
            "type": "string"
        },
        {
            "name": "realUser",
            "baseName": "realUser",
            "type": "boolean"
        },
        {
            "name": "robot",
            "baseName": "robot",
            "type": "boolean"
        },
        {
            "name": "synthetic",
            "baseName": "synthetic",
            "type": "boolean"
        },
        {
            "name": "browserFamily",
            "baseName": "browserFamily",
            "type": "string"
        },
        {
            "name": "browserType",
            "baseName": "browserType",
            "type": "string"
        },
        {
            "name": "browserVersion",
            "baseName": "browserVersion",
            "type": "string"
        },
        {
            "name": "hasCustomErrors",
            "baseName": "hasCustomErrors",
            "type": "boolean"
        },
        {
            "name": "hasAnyError",
            "baseName": "hasAnyError",
            "type": "boolean"
        },
        {
            "name": "hasHttpErrors",
            "baseName": "hasHttpErrors",
            "type": "boolean"
        },
        {
            "name": "hasJavascriptErrors",
            "baseName": "hasJavascriptErrors",
            "type": "boolean"
        },
        {
            "name": "city",
            "baseName": "city",
            "type": "string"
        },
        {
            "name": "continent",
            "baseName": "continent",
            "type": "string"
        },
        {
            "name": "country",
            "baseName": "country",
            "type": "string"
        },
        {
            "name": "region",
            "baseName": "region",
            "type": "string"
        },
        {
            "name": "ip",
            "baseName": "ip",
            "type": "string"
        },
        {
            "name": "ipV6Traffic",
            "baseName": "ipV6Traffic",
            "type": "boolean"
        },
        {
            "name": "osFamily",
            "baseName": "osFamily",
            "type": "string"
        },
        {
            "name": "osVersion",
            "baseName": "osVersion",
            "type": "string"
        },
        {
            "name": "userActionProperties",
            "baseName": "userActionProperties",
            "type": "Array<UserActionPropertyFilter>"
        }    ];

    static getAttributeTypeMap() {
        return UserActionFilter.attributeTypeMap;
    }
}

export namespace UserActionFilter {
    export enum ApdexEnum {
        Frustrated = <any> 'Frustrated',
        Satisfied = <any> 'Satisfied',
        Tolerating = <any> 'Tolerating',
        Unknown = <any> 'Unknown'
    }
}
