/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { UserActionNamingPlaceholderProcessingStep } from './userActionNamingPlaceholderProcessingStep';

/**
* The placeholder settings.
*/
export class UserActionNamingPlaceholder {
    /**
    * Placeholder name.
    */
    'name': string;
    /**
    * Input.
    */
    'input': UserActionNamingPlaceholder.InputEnum;
    /**
    * Part.
    */
    'processingPart': UserActionNamingPlaceholder.ProcessingPartEnum;
    /**
    * Processing actions.
    */
    'processingSteps'?: Array<UserActionNamingPlaceholderProcessingStep>;
    /**
    * Id of the metadata.
    */
    'metadataId'?: number;
    /**
    * Use the element identifier that was selected by Dynatrace.
    */
    'useGuessedElementIdentifier': boolean;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "name",
            "baseName": "name",
            "type": "string"
        },
        {
            "name": "input",
            "baseName": "input",
            "type": "UserActionNamingPlaceholder.InputEnum"
        },
        {
            "name": "processingPart",
            "baseName": "processingPart",
            "type": "UserActionNamingPlaceholder.ProcessingPartEnum"
        },
        {
            "name": "processingSteps",
            "baseName": "processingSteps",
            "type": "Array<UserActionNamingPlaceholderProcessingStep>"
        },
        {
            "name": "metadataId",
            "baseName": "metadataId",
            "type": "number"
        },
        {
            "name": "useGuessedElementIdentifier",
            "baseName": "useGuessedElementIdentifier",
            "type": "boolean"
        }    ];

    static getAttributeTypeMap() {
        return UserActionNamingPlaceholder.attributeTypeMap;
    }
}

export namespace UserActionNamingPlaceholder {
    export enum InputEnum {
        ELEMENTIDENTIFIER = <any> 'ELEMENT_IDENTIFIER',
        INPUTTYPE = <any> 'INPUT_TYPE',
        METADATA = <any> 'METADATA',
        PAGETITLE = <any> 'PAGE_TITLE',
        PAGEURL = <any> 'PAGE_URL',
        SOURCEURL = <any> 'SOURCE_URL',
        TOPXHRURL = <any> 'TOP_XHR_URL',
        XHRURL = <any> 'XHR_URL'
    }
    export enum ProcessingPartEnum {
        ALL = <any> 'ALL',
        ANCHOR = <any> 'ANCHOR',
        PATH = <any> 'PATH'
    }
}
