/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* The processing step settings.
*/
export class UserActionNamingPlaceholderProcessingStep {
    /**
    * An action to be taken by the processing:   * `SUBSTRING`: Extracts the string between **patternBefore** and **patternAfter**.  * `REPLACEMENT`: Replaces the string between **patternBefore** and **patternAfter** with the specified **replacement**. * `REPLACE_WITH_PATTERN`: Replaces the **patternToReplace** with the specified **replacement**.  * `EXTRACT_BY_REGULAR_EXPRESSION`: Extracts the part of the string that matches the **regularExpression**.  * `REPLACE_WITH_REGULAR_EXPRESSION`: Replaces all occurrences that match **regularExpression** with the specified **replacement**.  * `REPLACE_IDS`: Replaces all IDs and UUIDs with the specified **replacement**.
    */
    'type': UserActionNamingPlaceholderProcessingStep.TypeEnum;
    /**
    * The pattern before the required value. It will be removed.
    */
    'patternBefore'?: string;
    /**
    * The required occurrence of **patternBefore**.
    */
    'patternBeforeSearchType'?: UserActionNamingPlaceholderProcessingStep.PatternBeforeSearchTypeEnum;
    /**
    * The pattern after the required value. It will be removed.
    */
    'patternAfter'?: string;
    /**
    * The required occurrence of **patternAfter**.
    */
    'patternAfterSearchType'?: UserActionNamingPlaceholderProcessingStep.PatternAfterSearchTypeEnum;
    /**
    * Replacement for the original value.
    */
    'replacement'?: string;
    /**
    * The pattern to be replaced.    Only applicable if the **type** is `REPLACE_WITH_PATTERN`.
    */
    'patternToReplace'?: string;
    /**
    * A regular expression for the string to be extracted or replaced.    Only applicable if the **type** is `EXTRACT_BY_REGULAR_EXPRESSION` or `REPLACE_WITH_REGULAR_EXPRESSION`.
    */
    'regularExpression'?: string;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "type",
            "baseName": "type",
            "type": "UserActionNamingPlaceholderProcessingStep.TypeEnum"
        },
        {
            "name": "patternBefore",
            "baseName": "patternBefore",
            "type": "string"
        },
        {
            "name": "patternBeforeSearchType",
            "baseName": "patternBeforeSearchType",
            "type": "UserActionNamingPlaceholderProcessingStep.PatternBeforeSearchTypeEnum"
        },
        {
            "name": "patternAfter",
            "baseName": "patternAfter",
            "type": "string"
        },
        {
            "name": "patternAfterSearchType",
            "baseName": "patternAfterSearchType",
            "type": "UserActionNamingPlaceholderProcessingStep.PatternAfterSearchTypeEnum"
        },
        {
            "name": "replacement",
            "baseName": "replacement",
            "type": "string"
        },
        {
            "name": "patternToReplace",
            "baseName": "patternToReplace",
            "type": "string"
        },
        {
            "name": "regularExpression",
            "baseName": "regularExpression",
            "type": "string"
        }    ];

    static getAttributeTypeMap() {
        return UserActionNamingPlaceholderProcessingStep.attributeTypeMap;
    }
}

export namespace UserActionNamingPlaceholderProcessingStep {
    export enum TypeEnum {
        EXTRACTBYREGULAREXPRESSION = <any> 'EXTRACT_BY_REGULAR_EXPRESSION',
        REPLACEMENT = <any> 'REPLACEMENT',
        REPLACEIDS = <any> 'REPLACE_IDS',
        REPLACEWITHPATTERN = <any> 'REPLACE_WITH_PATTERN',
        REPLACEWITHREGULAREXPRESSION = <any> 'REPLACE_WITH_REGULAR_EXPRESSION',
        SUBSTRING = <any> 'SUBSTRING'
    }
    export enum PatternBeforeSearchTypeEnum {
        FIRST = <any> 'FIRST',
        LAST = <any> 'LAST'
    }
    export enum PatternAfterSearchTypeEnum {
        FIRST = <any> 'FIRST',
        LAST = <any> 'LAST'
    }
}
