/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* The settings of conditions for user action naming.
*/
export class UserActionNamingRuleCondition {
    /**
    * Must be a defined placeholder wrapped in curly braces
    */
    'operand1': string;
    /**
    * Must be null if operator is \"IS_EMPTY\", a regex if operator is \"MATCHES_REGULAR_ERPRESSION\". In all other cases the value can be a freetext or a placeholder wrapped in curly braces
    */
    'operand2'?: string;
    /**
    * The operator of the condition
    */
    'operator': UserActionNamingRuleCondition.OperatorEnum;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "operand1",
            "baseName": "operand1",
            "type": "string"
        },
        {
            "name": "operand2",
            "baseName": "operand2",
            "type": "string"
        },
        {
            "name": "operator",
            "baseName": "operator",
            "type": "UserActionNamingRuleCondition.OperatorEnum"
        }    ];

    static getAttributeTypeMap() {
        return UserActionNamingRuleCondition.attributeTypeMap;
    }
}

export namespace UserActionNamingRuleCondition {
    export enum OperatorEnum {
        CONTAINS = <any> 'CONTAINS',
        ENDSWITH = <any> 'ENDS_WITH',
        EQUALS = <any> 'EQUALS',
        ISEMPTY = <any> 'IS_EMPTY',
        ISNOTEMPTY = <any> 'IS_NOT_EMPTY',
        MATCHESREGULAREXPRESSION = <any> 'MATCHES_REGULAR_EXPRESSION',
        NOTCONTAINS = <any> 'NOT_CONTAINS',
        NOTENDSWITH = <any> 'NOT_ENDS_WITH',
        NOTEQUALS = <any> 'NOT_EQUALS',
        NOTMATCHESREGULAREXPRESSION = <any> 'NOT_MATCHES_REGULAR_EXPRESSION',
        NOTSTARTSWITH = <any> 'NOT_STARTS_WITH',
        STARTSWITH = <any> 'STARTS_WITH'
    }
}
