/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { UserActionNamingPlaceholder } from './userActionNamingPlaceholder';
import { UserActionNamingRule } from './userActionNamingRule';

/**
* The settings of user action naming.
*/
export class UserActionNamingSettings {
    /**
    * User action placeholders.
    */
    'placeholders'?: Array<UserActionNamingPlaceholder>;
    /**
    * User action naming rules for loading actions.
    */
    'loadActionNamingRules'?: Array<UserActionNamingRule>;
    /**
    * User action naming rules for xhr actions.
    */
    'xhrActionNamingRules'?: Array<UserActionNamingRule>;
    /**
    * User action naming rules for custom actions.
    */
    'customActionNamingRules'?: Array<UserActionNamingRule>;
    /**
    * Case insensitive naming.
    */
    'ignoreCase'?: boolean;
    /**
    * Deactivate this setting if different domains should not result in separate user actions.
    */
    'splitUserActionsByDomain'?: boolean;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "placeholders",
            "baseName": "placeholders",
            "type": "Array<UserActionNamingPlaceholder>"
        },
        {
            "name": "loadActionNamingRules",
            "baseName": "loadActionNamingRules",
            "type": "Array<UserActionNamingRule>"
        },
        {
            "name": "xhrActionNamingRules",
            "baseName": "xhrActionNamingRules",
            "type": "Array<UserActionNamingRule>"
        },
        {
            "name": "customActionNamingRules",
            "baseName": "customActionNamingRules",
            "type": "Array<UserActionNamingRule>"
        },
        {
            "name": "ignoreCase",
            "baseName": "ignoreCase",
            "type": "boolean"
        },
        {
            "name": "splitUserActionsByDomain",
            "baseName": "splitUserActionsByDomain",
            "type": "boolean"
        }    ];

    static getAttributeTypeMap() {
        return UserActionNamingSettings.attributeTypeMap;
    }
}

