/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { Tile } from './tile';
import { TileBounds } from './tileBounds';
import { TileFilter } from './tileFilter';
import { UserSessionQueryTileAllOf } from './userSessionQueryTileAllOf';
import { UserSessionQueryTileConfiguration } from './userSessionQueryTileConfiguration';

/**
* Configuration of a User session query tile.
*/
export class UserSessionQueryTile extends Tile {
    /**
    * The name of the tile, set by user.
    */
    'customName': string;
    /**
    * A [user session query](https://www.dynatrace.com/support/help/shortlink/usql-info) executed by the tile.
    */
    'query': string;
    /**
    * The visualization of the tile.
    */
    'type': UserSessionQueryTile.TypeEnum;
    /**
    * The comparison timeframe of the query.    If specified, you additionally get the results of the same query with the specified time shift.
    */
    'timeFrameShift'?: string;
    'visualizationConfig'?: UserSessionQueryTileConfiguration;
    /**
    * The limit of the results, if not set will use the default value of the system
    */
    'limit'?: number;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "customName",
            "baseName": "customName",
            "type": "string"
        },
        {
            "name": "query",
            "baseName": "query",
            "type": "string"
        },
        {
            "name": "type",
            "baseName": "type",
            "type": "UserSessionQueryTile.TypeEnum"
        },
        {
            "name": "timeFrameShift",
            "baseName": "timeFrameShift",
            "type": "string"
        },
        {
            "name": "visualizationConfig",
            "baseName": "visualizationConfig",
            "type": "UserSessionQueryTileConfiguration"
        },
        {
            "name": "limit",
            "baseName": "limit",
            "type": "number"
        }    ];

    static getAttributeTypeMap() {
        return super.getAttributeTypeMap().concat(UserSessionQueryTile.attributeTypeMap);
    }
}

export namespace UserSessionQueryTile {
    export enum TypeEnum {
        COLUMNCHART = <any> 'COLUMN_CHART',
        FUNNEL = <any> 'FUNNEL',
        LINECHART = <any> 'LINE_CHART',
        PIECHART = <any> 'PIE_CHART',
        SINGLEVALUE = <any> 'SINGLE_VALUE',
        TABLE = <any> 'TABLE'
    }
}
