/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { ConfigurationMetadata } from './configurationMetadata';
import { DroppedPacketsDetectionConfig } from './droppedPacketsDetectionConfig';
import { EsxiHighCpuSaturationConfig } from './esxiHighCpuSaturationConfig';
import { EsxiHighMemoryDetectionConfig } from './esxiHighMemoryDetectionConfig';
import { GuestCPULimitReachedConfig } from './guestCPULimitReachedConfig';
import { LowDatastoreSpaceDetectionConfig } from './lowDatastoreSpaceDetectionConfig';
import { OverloadedStorageDetectionConfig } from './overloadedStorageDetectionConfig';
import { SlowPhysicalStorageDetectionConfig } from './slowPhysicalStorageDetectionConfig';
import { UndersizedStorageDetectionConfig } from './undersizedStorageDetectionConfig';

/**
* The configuration of the anomaly detection for VMware.
*/
export class VMwareAnomalyDetectionConfig {
    'metadata'?: ConfigurationMetadata;
    'esxiHighCpuSaturation': EsxiHighCpuSaturationConfig;
    'guestCpuLimitReached'?: GuestCPULimitReachedConfig;
    'esxiHighMemoryDetection': EsxiHighMemoryDetectionConfig;
    'overloadedStorageDetection': OverloadedStorageDetectionConfig;
    'undersizedStorageDetection': UndersizedStorageDetectionConfig;
    'slowPhysicalStorageDetection': SlowPhysicalStorageDetectionConfig;
    'droppedPacketsDetection': DroppedPacketsDetectionConfig;
    'lowDatastoreSpaceDetection': LowDatastoreSpaceDetectionConfig;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "metadata",
            "baseName": "metadata",
            "type": "ConfigurationMetadata"
        },
        {
            "name": "esxiHighCpuSaturation",
            "baseName": "esxiHighCpuSaturation",
            "type": "EsxiHighCpuSaturationConfig"
        },
        {
            "name": "guestCpuLimitReached",
            "baseName": "guestCpuLimitReached",
            "type": "GuestCPULimitReachedConfig"
        },
        {
            "name": "esxiHighMemoryDetection",
            "baseName": "esxiHighMemoryDetection",
            "type": "EsxiHighMemoryDetectionConfig"
        },
        {
            "name": "overloadedStorageDetection",
            "baseName": "overloadedStorageDetection",
            "type": "OverloadedStorageDetectionConfig"
        },
        {
            "name": "undersizedStorageDetection",
            "baseName": "undersizedStorageDetection",
            "type": "UndersizedStorageDetectionConfig"
        },
        {
            "name": "slowPhysicalStorageDetection",
            "baseName": "slowPhysicalStorageDetection",
            "type": "SlowPhysicalStorageDetectionConfig"
        },
        {
            "name": "droppedPacketsDetection",
            "baseName": "droppedPacketsDetection",
            "type": "DroppedPacketsDetectionConfig"
        },
        {
            "name": "lowDatastoreSpaceDetection",
            "baseName": "lowDatastoreSpaceDetection",
            "type": "LowDatastoreSpaceDetectionConfig"
        }    ];

    static getAttributeTypeMap() {
        return VMwareAnomalyDetectionConfig.attributeTypeMap;
    }
}

