/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* IBM integration bus label node name condition for which the value is captured.
*/
export class ValueCondition {
    /**
    * Operator comparing the extracted value to the comparison value.
    */
    'operator': ValueCondition.OperatorEnum;
    /**
    * Negate the comparison.
    */
    'negate': boolean;
    /**
    * The value to compare to.
    */
    'value': string;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "operator",
            "baseName": "operator",
            "type": "ValueCondition.OperatorEnum"
        },
        {
            "name": "negate",
            "baseName": "negate",
            "type": "boolean"
        },
        {
            "name": "value",
            "baseName": "value",
            "type": "string"
        }    ];

    static getAttributeTypeMap() {
        return ValueCondition.attributeTypeMap;
    }
}

export namespace ValueCondition {
    export enum OperatorEnum {
        BEGINSWITH = <any> 'BEGINS_WITH',
        CONTAINS = <any> 'CONTAINS',
        ENDSWITH = <any> 'ENDS_WITH',
        EQUALS = <any> 'EQUALS'
    }
}
