/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { ExtractSubstring } from './extractSubstring';
import { ValueCondition } from './valueCondition';

/**
* Process values as specified.
*/
export class ValueProcessing {
    'valueCondition'?: ValueCondition;
    /**
    * Extract value from captured data per regex.
    */
    'valueExtractorRegex'?: string;
    /**
    * Split (preprocessed) string values at this separator.
    */
    'splitAt'?: string;
    /**
    * Prune Whitespaces. Defaults to false.
    */
    'trim': boolean;
    'extractSubstring'?: ExtractSubstring;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "valueCondition",
            "baseName": "valueCondition",
            "type": "ValueCondition"
        },
        {
            "name": "valueExtractorRegex",
            "baseName": "valueExtractorRegex",
            "type": "string"
        },
        {
            "name": "splitAt",
            "baseName": "splitAt",
            "type": "string"
        },
        {
            "name": "trim",
            "baseName": "trim",
            "type": "boolean"
        },
        {
            "name": "extractSubstring",
            "baseName": "extractSubstring",
            "type": "ExtractSubstring"
        }    ];

    static getAttributeTypeMap() {
        return ValueProcessing.attributeTypeMap;
    }
}

