/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* Settings for VisuallyComplete2
*/
export class VisuallyComplete2Settings {
    /**
    * A RegularExpression used to exclude images and iframes from being detected by the VC module.
    */
    'imageUrlBlacklist'?: string;
    /**
    * Query selector for mutation nodes to ignore in VC and SI calculation
    */
    'mutationBlacklist'?: string;
    /**
    * Determines the time in ms VC waits after an action closes to start calculation. Defaults to 50.
    */
    'mutationTimeout'?: number;
    /**
    * The time in ms the VC module waits for no mutations happening on the page after the load action. Defaults to 1000.
    */
    'inactivityTimeout'?: number;
    /**
    * Minimum visible area in pixels of elements to be counted towards VC and SI. Defaults to 50.
    */
    'threshold'?: number;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "imageUrlBlacklist",
            "baseName": "imageUrlBlacklist",
            "type": "string"
        },
        {
            "name": "mutationBlacklist",
            "baseName": "mutationBlacklist",
            "type": "string"
        },
        {
            "name": "mutationTimeout",
            "baseName": "mutationTimeout",
            "type": "number"
        },
        {
            "name": "inactivityTimeout",
            "baseName": "inactivityTimeout",
            "type": "number"
        },
        {
            "name": "threshold",
            "baseName": "threshold",
            "type": "number"
        }    ];

    static getAttributeTypeMap() {
        return VisuallyComplete2Settings.attributeTypeMap;
    }
}

