/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* These settings influence the monitoring data you receive for 3rd party, CDN, and 1st party resources.
*/
export class WaterfallSettings {
    /**
    * Warn about uncompressed resources larger than *X* bytes.
    */
    'uncompressedResourcesThreshold': number;
    /**
    * Warn about resources larger than *X* bytes.
    */
    'resourcesThreshold': number;
    /**
    * Warn about resources with a lower browser cache rate above *X*%.
    */
    'resourceBrowserCachingThreshold': number;
    /**
    * Warn about slow 1st party resources with a response time above *X* ms.
    */
    'slowFirstPartyResourcesThreshold': number;
    /**
    * Warn about slow 3rd party resources with a response time above *X* ms.
    */
    'slowThirdPartyResourcesThreshold': number;
    /**
    * Warn about slow CDN resources with a response time above *X* ms.
    */
    'slowCdnResourcesThreshold': number;
    /**
    * Warn if Speed index exceeds *X* % of Visually complete.
    */
    'speedIndexVisuallyCompleteRatioThreshold': number;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "uncompressedResourcesThreshold",
            "baseName": "uncompressedResourcesThreshold",
            "type": "number"
        },
        {
            "name": "resourcesThreshold",
            "baseName": "resourcesThreshold",
            "type": "number"
        },
        {
            "name": "resourceBrowserCachingThreshold",
            "baseName": "resourceBrowserCachingThreshold",
            "type": "number"
        },
        {
            "name": "slowFirstPartyResourcesThreshold",
            "baseName": "slowFirstPartyResourcesThreshold",
            "type": "number"
        },
        {
            "name": "slowThirdPartyResourcesThreshold",
            "baseName": "slowThirdPartyResourcesThreshold",
            "type": "number"
        },
        {
            "name": "slowCdnResourcesThreshold",
            "baseName": "slowCdnResourcesThreshold",
            "type": "number"
        },
        {
            "name": "speedIndexVisuallyCompleteRatioThreshold",
            "baseName": "speedIndexVisuallyCompleteRatioThreshold",
            "type": "number"
        }    ];

    static getAttributeTypeMap() {
        return WaterfallSettings.attributeTypeMap;
    }
}

