/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';

/**
* Browser exclusion rules for the browsers that are to be excluded.
*/
export class WebApplicationConfigBrowserRestriction {
    /**
    * The version of the browser that is used.
    */
    'browserVersion'?: string;
    /**
    * The type of the browser that is used.
    */
    'browserType': WebApplicationConfigBrowserRestriction.BrowserTypeEnum;
    /**
    * The platform on which the browser is being used.
    */
    'platform'?: WebApplicationConfigBrowserRestriction.PlatformEnum;
    /**
    * Compares different browsers together.
    */
    'comparator'?: WebApplicationConfigBrowserRestriction.ComparatorEnum;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "browserVersion",
            "baseName": "browserVersion",
            "type": "string"
        },
        {
            "name": "browserType",
            "baseName": "browserType",
            "type": "WebApplicationConfigBrowserRestriction.BrowserTypeEnum"
        },
        {
            "name": "platform",
            "baseName": "platform",
            "type": "WebApplicationConfigBrowserRestriction.PlatformEnum"
        },
        {
            "name": "comparator",
            "baseName": "comparator",
            "type": "WebApplicationConfigBrowserRestriction.ComparatorEnum"
        }    ];

    static getAttributeTypeMap() {
        return WebApplicationConfigBrowserRestriction.attributeTypeMap;
    }
}

export namespace WebApplicationConfigBrowserRestriction {
    export enum BrowserTypeEnum {
        ANDROIDWEBKIT = <any> 'ANDROID_WEBKIT',
        BOTSSPIDERS = <any> 'BOTS_SPIDERS',
        CHROME = <any> 'CHROME',
        EDGE = <any> 'EDGE',
        FIREFOX = <any> 'FIREFOX',
        INTERNETEXPLORER = <any> 'INTERNET_EXPLORER',
        OPERA = <any> 'OPERA',
        SAFARI = <any> 'SAFARI'
    }
    export enum PlatformEnum {
        ALL = <any> 'ALL',
        DESKTOP = <any> 'DESKTOP',
        MOBILE = <any> 'MOBILE'
    }
    export enum ComparatorEnum {
        EQUALS = <any> 'EQUALS',
        GREATERTHANOREQUAL = <any> 'GREATER_THAN_OR_EQUAL',
        LOWERTHANOREQUAL = <any> 'LOWER_THAN_OR_EQUAL'
    }
}
