/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { WebApplicationConfigBrowserRestriction } from './webApplicationConfigBrowserRestriction';

/**
* Settings for restricting certain browser type, version, platform and, comparator. It also restricts the mode.
*/
export class WebApplicationConfigBrowserRestrictionSettings {
    /**
    * The mode of the list of browser restrictions.
    */
    'mode': WebApplicationConfigBrowserRestrictionSettings.ModeEnum;
    /**
    * A list of browser restrictions.
    */
    'browserRestrictions'?: Array<WebApplicationConfigBrowserRestriction>;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "mode",
            "baseName": "mode",
            "type": "WebApplicationConfigBrowserRestrictionSettings.ModeEnum"
        },
        {
            "name": "browserRestrictions",
            "baseName": "browserRestrictions",
            "type": "Array<WebApplicationConfigBrowserRestriction>"
        }    ];

    static getAttributeTypeMap() {
        return WebApplicationConfigBrowserRestrictionSettings.attributeTypeMap;
    }
}

export namespace WebApplicationConfigBrowserRestrictionSettings {
    export enum ModeEnum {
        EXCLUDE = <any> 'EXCLUDE',
        INCLUDE = <any> 'INCLUDE'
    }
}
