/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { IpAddressRange } from './ipAddressRange';

/**
* Settings for restricting certain ip addresses and for introducing subnet mask. It also restricts the mode.
*/
export class WebApplicationConfigIpAddressRestrictionSettings {
    /**
    * The mode of the list of ip address restrictions.
    */
    'mode': WebApplicationConfigIpAddressRestrictionSettings.ModeEnum;
    'ipAddressRestrictions'?: Array<IpAddressRange>;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "mode",
            "baseName": "mode",
            "type": "WebApplicationConfigIpAddressRestrictionSettings.ModeEnum"
        },
        {
            "name": "ipAddressRestrictions",
            "baseName": "ipAddressRestrictions",
            "type": "Array<IpAddressRange>"
        }    ];

    static getAttributeTypeMap() {
        return WebApplicationConfigIpAddressRestrictionSettings.attributeTypeMap;
    }
}

export namespace WebApplicationConfigIpAddressRestrictionSettings {
    export enum ModeEnum {
        EXCLUDE = <any> 'EXCLUDE',
        INCLUDE = <any> 'INCLUDE'
    }
}
