/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { TransformationBase } from './transformationBase';

/**
* The contribution to the service ID calculation from the detected web service name space.    You have two mutually exclusive options:  * Override the detected value with a specified static value. Specify the new value in the **valueOverride** field.  * Dynamically transform the detected value. Specify the transformation parameters in the **transformations** field.
*/
export class WebServiceNameSpace {
    /**
    * Transformations to be applied to the detected value.
    */
    'transformations'?: Array<TransformationBase>;
    /**
    * The value to be used instead of the detected value.
    */
    'valueOverride'?: string;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "transformations",
            "baseName": "transformations",
            "type": "Array<TransformationBase>"
        },
        {
            "name": "valueOverride",
            "baseName": "valueOverride",
            "type": "string"
        }    ];

    static getAttributeTypeMap() {
        return WebServiceNameSpace.attributeTypeMap;
    }
}

