/**
 * Dynatrace Configuration API
 * Documentation of the Dynatrace Configuration API. Refer to the [help page](https://www.dynatrace.com/support/help/shortlink/config-api) to read about use-cases and examples.  Notes about compatibility: * Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this. * We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from '../api';
import { ComparisonInfo } from './comparisonInfo';
import { ZosComparisonInfoAllOf } from './zosComparisonInfoAllOf';

/**
* Comparison for `ZOS_CALL_TYPE` attributes.
*/
export class ZosComparisonInfo extends ComparisonInfo {
    /**
    * Operator of the comparision. You can reverse it by setting **negate** to `true`.
    */
    'comparison': ZosComparisonInfo.ComparisonEnum;
    /**
    * The value to compare to.
    */
    'value'?: ZosComparisonInfo.ValueEnum;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "comparison",
            "baseName": "comparison",
            "type": "ZosComparisonInfo.ComparisonEnum"
        },
        {
            "name": "value",
            "baseName": "value",
            "type": "ZosComparisonInfo.ValueEnum"
        }    ];

    static getAttributeTypeMap() {
        return super.getAttributeTypeMap().concat(ZosComparisonInfo.attributeTypeMap);
    }
}

export namespace ZosComparisonInfo {
    export enum ComparisonEnum {
        EQUALS = <any> 'EQUALS',
        EXISTS = <any> 'EXISTS'
    }
    export enum ValueEnum {
        CTG = <any> 'CTG',
        DPL = <any> 'DPL',
        EXPLICITADK = <any> 'EXPLICIT_ADK',
        IMSCONNECT = <any> 'IMS_CONNECT',
        IMSCONNECTAPI = <any> 'IMS_CONNECT_API',
        IMSITRA = <any> 'IMS_ITRA',
        IMSMSC = <any> 'IMS_MSC',
        IMSPGMSWITCH = <any> 'IMS_PGM_SWITCH',
        IMSSHAREDQUEUES = <any> 'IMS_SHARED_QUEUES',
        IMSTRANSEXEC = <any> 'IMS_TRANS_EXEC',
        MQ = <any> 'MQ',
        SOAP = <any> 'SOAP',
        START = <any> 'START',
        TX = <any> 'TX',
        UNKNOWN = <any> 'UNKNOWN'
    }
}
